/* WindowManager.c generated by valac 0.56.18, the Vala compiler
 * generated from WindowManager.vala, do not modify */

/**/
/*  Copyright (C) 2012-2014 Tom Beckmann, Rico Tzschichholz*/
/*                2025 elementary, Inc.*/
/**/
/*  This program is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  This program is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include <meta/meta-plugin.h>
#include "gala.h"
#include <glib-object.h>
#include <clutter/clutter.h>
#include <meta/meta-background-group.h>
#include <gio/gio.h>
#include <gee.h>
#include <meta/meta-window-actor.h>
#include <glib.h>
#include <meta/window.h>
#include <meta/compositor.h>
#include <mtk/mtk.h>
#include <meta/common.h>
#include <meta/keybindings.h>
#include <meta/meta-close-dialog.h>
#include <meta/meta-inhibit-shortcuts-dialog.h>
#include <stdlib.h>
#include <string.h>
#include <meta/display.h>
#include <meta/meta-background.h>
#include <meta/util.h>
#include <cogl/cogl.h>
#include <meta/types.h>
#include <meta/meta-background-actor.h>
#include <float.h>
#include <math.h>
#include <meta/prefs.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>
#include <systemd/sd-daemon.h>
#include <atk-bridge.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <meta/meta-x11-display.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define GALA_WINDOW_MANAGER_GALA_OPEN_MULTITASKING_VIEW "dbus-send --session --dest=org.pantheon.gala --print-reply /org/panthe" \
"on/gala org.pantheon.gala.PerformAction int32:1"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_MANAGER_GALA (gala_window_manager_gala_get_type ())
#define GALA_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala))
#define GALA_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))
#define GALA_IS_WINDOW_MANAGER_GALA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_IS_WINDOW_MANAGER_GALA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_MANAGER_GALA))
#define GALA_WINDOW_MANAGER_GALA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGalaClass))

typedef struct _GalaWindowManagerGala GalaWindowManagerGala;
typedef struct _GalaWindowManagerGalaClass GalaWindowManagerGalaClass;
typedef struct _GalaWindowManagerGalaPrivate GalaWindowManagerGalaPrivate;

#define GALA_TYPE_ACTOR_TARGET (gala_actor_target_get_type ())
#define GALA_ACTOR_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ACTOR_TARGET, GalaActorTarget))
#define GALA_ACTOR_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ACTOR_TARGET, GalaActorTargetClass))
#define GALA_IS_ACTOR_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ACTOR_TARGET))
#define GALA_IS_ACTOR_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ACTOR_TARGET))
#define GALA_ACTOR_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ACTOR_TARGET, GalaActorTargetClass))

typedef struct _GalaActorTarget GalaActorTarget;
typedef struct _GalaActorTargetClass GalaActorTargetClass;

#define GALA_TYPE_MULTITASKING_VIEW (gala_multitasking_view_get_type ())
#define GALA_MULTITASKING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingView))
#define GALA_MULTITASKING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingViewClass))
#define GALA_IS_MULTITASKING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_MULTITASKING_VIEW))
#define GALA_IS_MULTITASKING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_MULTITASKING_VIEW))
#define GALA_MULTITASKING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_MULTITASKING_VIEW, GalaMultitaskingViewClass))

typedef struct _GalaMultitaskingView GalaMultitaskingView;
typedef struct _GalaMultitaskingViewClass GalaMultitaskingViewClass;

#define GALA_TYPE_POINTER_LOCATOR (gala_pointer_locator_get_type ())
#define GALA_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocator))
#define GALA_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))
#define GALA_IS_POINTER_LOCATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_POINTER_LOCATOR))
#define GALA_IS_POINTER_LOCATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_POINTER_LOCATOR))
#define GALA_POINTER_LOCATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_POINTER_LOCATOR, GalaPointerLocatorClass))

typedef struct _GalaPointerLocator GalaPointerLocator;
typedef struct _GalaPointerLocatorClass GalaPointerLocatorClass;

#define GALA_TYPE_SYSTEM_BACKGROUND (gala_system_background_get_type ())
#define GALA_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackground))
#define GALA_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackgroundClass))
#define GALA_IS_SYSTEM_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SYSTEM_BACKGROUND))
#define GALA_IS_SYSTEM_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SYSTEM_BACKGROUND))
#define GALA_SYSTEM_BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SYSTEM_BACKGROUND, GalaSystemBackgroundClass))

typedef struct _GalaSystemBackground GalaSystemBackground;
typedef struct _GalaSystemBackgroundClass GalaSystemBackgroundClass;

#define GALA_TYPE_WINDOW_SWITCHER (gala_window_switcher_get_type ())
#define GALA_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcher))
#define GALA_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))
#define GALA_IS_WINDOW_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_IS_WINDOW_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_SWITCHER))
#define GALA_WINDOW_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_SWITCHER, GalaWindowSwitcherClass))

typedef struct _GalaWindowSwitcher GalaWindowSwitcher;
typedef struct _GalaWindowSwitcherClass GalaWindowSwitcherClass;

#define GALA_TYPE_SCREEN_SAVER_MANAGER (gala_screen_saver_manager_get_type ())
#define GALA_SCREEN_SAVER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SCREEN_SAVER_MANAGER, GalaScreenSaverManager))
#define GALA_SCREEN_SAVER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SCREEN_SAVER_MANAGER, GalaScreenSaverManagerClass))
#define GALA_IS_SCREEN_SAVER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SCREEN_SAVER_MANAGER))
#define GALA_IS_SCREEN_SAVER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SCREEN_SAVER_MANAGER))
#define GALA_SCREEN_SAVER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SCREEN_SAVER_MANAGER, GalaScreenSaverManagerClass))

typedef struct _GalaScreenSaverManager GalaScreenSaverManager;
typedef struct _GalaScreenSaverManagerClass GalaScreenSaverManagerClass;

#define GALA_TYPE_HOT_CORNER_MANAGER (gala_hot_corner_manager_get_type ())
#define GALA_HOT_CORNER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_HOT_CORNER_MANAGER, GalaHotCornerManager))
#define GALA_HOT_CORNER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_HOT_CORNER_MANAGER, GalaHotCornerManagerClass))
#define GALA_IS_HOT_CORNER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_HOT_CORNER_MANAGER))
#define GALA_IS_HOT_CORNER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_HOT_CORNER_MANAGER))
#define GALA_HOT_CORNER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_HOT_CORNER_MANAGER, GalaHotCornerManagerClass))

typedef struct _GalaHotCornerManager GalaHotCornerManager;
typedef struct _GalaHotCornerManagerClass GalaHotCornerManagerClass;

#define GALA_TYPE_KEYBOARD_MANAGER (gala_keyboard_manager_get_type ())
#define GALA_KEYBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManager))
#define GALA_KEYBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManagerClass))
#define GALA_IS_KEYBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_KEYBOARD_MANAGER))
#define GALA_IS_KEYBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_KEYBOARD_MANAGER))
#define GALA_KEYBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_KEYBOARD_MANAGER, GalaKeyboardManagerClass))

typedef struct _GalaKeyboardManager GalaKeyboardManager;
typedef struct _GalaKeyboardManagerClass GalaKeyboardManagerClass;

#define GALA_TYPE_WINDOW_TRACKER (gala_window_tracker_get_type ())
#define GALA_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTracker))
#define GALA_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))
#define GALA_IS_WINDOW_TRACKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_TRACKER))
#define GALA_IS_WINDOW_TRACKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_TRACKER))
#define GALA_WINDOW_TRACKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_TRACKER, GalaWindowTrackerClass))

typedef struct _GalaWindowTracker GalaWindowTracker;
typedef struct _GalaWindowTrackerClass GalaWindowTrackerClass;

#define GALA_TYPE_NOTIFICATIONS_MANAGER (gala_notifications_manager_get_type ())
#define GALA_NOTIFICATIONS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_NOTIFICATIONS_MANAGER, GalaNotificationsManager))
#define GALA_NOTIFICATIONS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_NOTIFICATIONS_MANAGER, GalaNotificationsManagerClass))
#define GALA_IS_NOTIFICATIONS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_NOTIFICATIONS_MANAGER))
#define GALA_IS_NOTIFICATIONS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_NOTIFICATIONS_MANAGER))
#define GALA_NOTIFICATIONS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_NOTIFICATIONS_MANAGER, GalaNotificationsManagerClass))

typedef struct _GalaNotificationsManager GalaNotificationsManager;
typedef struct _GalaNotificationsManagerClass GalaNotificationsManagerClass;

#define GALA_TYPE_SCREENSHOT_MANAGER (gala_screenshot_manager_get_type ())
#define GALA_SCREENSHOT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SCREENSHOT_MANAGER, GalaScreenshotManager))
#define GALA_SCREENSHOT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SCREENSHOT_MANAGER, GalaScreenshotManagerClass))
#define GALA_IS_SCREENSHOT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SCREENSHOT_MANAGER))
#define GALA_IS_SCREENSHOT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SCREENSHOT_MANAGER))
#define GALA_SCREENSHOT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SCREENSHOT_MANAGER, GalaScreenshotManagerClass))

typedef struct _GalaScreenshotManager GalaScreenshotManager;
typedef struct _GalaScreenshotManagerClass GalaScreenshotManagerClass;

#define GALA_TYPE_ZOOM (gala_zoom_get_type ())
#define GALA_ZOOM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ZOOM, GalaZoom))
#define GALA_ZOOM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ZOOM, GalaZoomClass))
#define GALA_IS_ZOOM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ZOOM))
#define GALA_IS_ZOOM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ZOOM))
#define GALA_ZOOM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ZOOM, GalaZoomClass))

typedef struct _GalaZoom GalaZoom;
typedef struct _GalaZoomClass GalaZoomClass;

#define GALA_TYPE_DAEMON_MANAGER (gala_daemon_manager_get_type ())
#define GALA_DAEMON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DAEMON_MANAGER, GalaDaemonManager))
#define GALA_DAEMON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DAEMON_MANAGER, GalaDaemonManagerClass))
#define GALA_IS_DAEMON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DAEMON_MANAGER))
#define GALA_IS_DAEMON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DAEMON_MANAGER))
#define GALA_DAEMON_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DAEMON_MANAGER, GalaDaemonManagerClass))

typedef struct _GalaDaemonManager GalaDaemonManager;
typedef struct _GalaDaemonManagerClass GalaDaemonManagerClass;

#define GALA_TYPE_NOTIFICATION_STACK (gala_notification_stack_get_type ())
#define GALA_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack))
#define GALA_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))
#define GALA_IS_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_IS_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_NOTIFICATION_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))

typedef struct _GalaNotificationStack GalaNotificationStack;
typedef struct _GalaNotificationStackClass GalaNotificationStackClass;
enum  {
	GALA_WINDOW_MANAGER_GALA_0_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_SHELL_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_MULTITASKING_VIEW_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_WINDOW_OVERVIEW_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY,
	GALA_WINDOW_MANAGER_GALA_NUM_PROPERTIES
};
static GParamSpec* gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GalaWindowManagerGalaStartX11ServicesData GalaWindowManagerGalaStartX11ServicesData;
typedef struct _Block12Data Block12Data;
#define __vala_CoglColor_free0(var) ((var == NULL) ? NULL : (var = (_vala_CoglColor_free (var), NULL)))

#define GALA_TYPE_BACKGROUND_CONTAINER (gala_background_container_get_type ())
#define GALA_BACKGROUND_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainer))
#define GALA_BACKGROUND_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainerClass))
#define GALA_IS_BACKGROUND_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_BACKGROUND_CONTAINER))
#define GALA_IS_BACKGROUND_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_BACKGROUND_CONTAINER))
#define GALA_BACKGROUND_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainerClass))

typedef struct _GalaBackgroundContainer GalaBackgroundContainer;
typedef struct _GalaBackgroundContainerClass GalaBackgroundContainerClass;

#define GALA_TYPE_PLUGIN_MANAGER (gala_plugin_manager_get_type ())
#define GALA_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManager))
#define GALA_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))
#define GALA_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_PLUGIN_MANAGER))
#define GALA_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_PLUGIN_MANAGER, GalaPluginManagerClass))

typedef struct _GalaPluginManager GalaPluginManager;
typedef struct _GalaPluginManagerClass GalaPluginManagerClass;

#define GALA_TYPE_WINDOW_OVERVIEW (gala_window_overview_get_type ())
#define GALA_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverview))
#define GALA_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))
#define GALA_IS_WINDOW_OVERVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_IS_WINDOW_OVERVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_OVERVIEW))
#define GALA_WINDOW_OVERVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_OVERVIEW, GalaWindowOverviewClass))

typedef struct _GalaWindowOverview GalaWindowOverview;
typedef struct _GalaWindowOverviewClass GalaWindowOverviewClass;

#define GALA_TYPE_DWELL_CLICK_TIMER (gala_dwell_click_timer_get_type ())
#define GALA_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimer))
#define GALA_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))
#define GALA_IS_DWELL_CLICK_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_IS_DWELL_CLICK_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_DWELL_CLICK_TIMER))
#define GALA_DWELL_CLICK_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_DWELL_CLICK_TIMER, GalaDwellClickTimerClass))

typedef struct _GalaDwellClickTimer GalaDwellClickTimer;
typedef struct _GalaDwellClickTimerClass GalaDwellClickTimerClass;

#define GALA_TYPE_SESSION_LOCKER (gala_session_locker_get_type ())
#define GALA_SESSION_LOCKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SESSION_LOCKER, GalaSessionLocker))
#define GALA_SESSION_LOCKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SESSION_LOCKER, GalaSessionLockerClass))
#define GALA_IS_SESSION_LOCKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SESSION_LOCKER))
#define GALA_IS_SESSION_LOCKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SESSION_LOCKER))
#define GALA_SESSION_LOCKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SESSION_LOCKER, GalaSessionLockerClass))

typedef struct _GalaSessionLocker GalaSessionLocker;
typedef struct _GalaSessionLockerClass GalaSessionLockerClass;

#define GALA_TYPE_SUPER_SCROLL_ACTION (gala_super_scroll_action_get_type ())
#define GALA_SUPER_SCROLL_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SUPER_SCROLL_ACTION, GalaSuperScrollAction))
#define GALA_SUPER_SCROLL_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SUPER_SCROLL_ACTION, GalaSuperScrollActionClass))
#define GALA_IS_SUPER_SCROLL_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SUPER_SCROLL_ACTION))
#define GALA_IS_SUPER_SCROLL_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SUPER_SCROLL_ACTION))
#define GALA_SUPER_SCROLL_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SUPER_SCROLL_ACTION, GalaSuperScrollActionClass))

typedef struct _GalaSuperScrollAction GalaSuperScrollAction;
typedef struct _GalaSuperScrollActionClass GalaSuperScrollActionClass;
typedef void (*GalaInternalUtilsWindowActorReadyCallback) (MetaWindowActor* window_actor, gpointer user_data);
typedef enum  {
	GALA_INPUT_AREA_NONE,
	GALA_INPUT_AREA_FULLSCREEN,
	GALA_INPUT_AREA_DEFAULT
} GalaInputArea;

#define GALA_TYPE_INPUT_AREA (gala_input_area_get_type ())
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;
typedef struct _Block15Data Block15Data;
typedef struct _Block16Data Block16Data;

#define GALA_TYPE_SHELL_CLIENTS_MANAGER (gala_shell_clients_manager_get_type ())
#define GALA_SHELL_CLIENTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_SHELL_CLIENTS_MANAGER, GalaShellClientsManager))
#define GALA_SHELL_CLIENTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_SHELL_CLIENTS_MANAGER, GalaShellClientsManagerClass))
#define GALA_IS_SHELL_CLIENTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_SHELL_CLIENTS_MANAGER))
#define GALA_IS_SHELL_CLIENTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_SHELL_CLIENTS_MANAGER))
#define GALA_SHELL_CLIENTS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_SHELL_CLIENTS_MANAGER, GalaShellClientsManagerClass))

typedef struct _GalaShellClientsManager GalaShellClientsManager;
typedef struct _GalaShellClientsManagerClass GalaShellClientsManagerClass;
typedef struct _Block17Data Block17Data;
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;
typedef struct _Block20Data Block20Data;
typedef struct _Block21Data Block21Data;
typedef struct _Block22Data Block22Data;
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
typedef struct _Block31Data Block31Data;

#define GALA_WINDOW_LISTENER_TYPE_WINDOW_GEOMETRY (gala_window_listener_window_geometry_get_type ())
typedef struct _GalaWindowListenerWindowGeometry GalaWindowListenerWindowGeometry;

#define GALA_TYPE_WINDOW_LISTENER (gala_window_listener_get_type ())
#define GALA_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListener))
#define GALA_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))
#define GALA_IS_WINDOW_LISTENER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_LISTENER))
#define GALA_IS_WINDOW_LISTENER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_LISTENER))
#define GALA_WINDOW_LISTENER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_LISTENER, GalaWindowListenerClass))

typedef struct _GalaWindowListener GalaWindowListener;
typedef struct _GalaWindowListenerClass GalaWindowListenerClass;
#define _gala_window_listener_window_geometry_free0(var) ((var == NULL) ? NULL : (var = (gala_window_listener_window_geometry_free (var), NULL)))

#define GALA_TYPE_ACCESS_DIALOG (gala_access_dialog_get_type ())
#define GALA_ACCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_ACCESS_DIALOG, GalaAccessDialog))
#define GALA_ACCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_ACCESS_DIALOG, GalaAccessDialogClass))
#define GALA_IS_ACCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_ACCESS_DIALOG))
#define GALA_IS_ACCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_ACCESS_DIALOG))
#define GALA_ACCESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_ACCESS_DIALOG, GalaAccessDialogClass))

typedef struct _GalaAccessDialog GalaAccessDialog;
typedef struct _GalaAccessDialogClass GalaAccessDialogClass;
typedef struct _Block32Data Block32Data;

#define GALA_TYPE_CLOSE_DIALOG (gala_close_dialog_get_type ())
#define GALA_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_CLOSE_DIALOG, GalaCloseDialog))
#define GALA_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_CLOSE_DIALOG, GalaCloseDialogClass))
#define GALA_IS_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_CLOSE_DIALOG))
#define GALA_IS_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_CLOSE_DIALOG))
#define GALA_CLOSE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_CLOSE_DIALOG, GalaCloseDialogClass))

typedef struct _GalaCloseDialog GalaCloseDialog;
typedef struct _GalaCloseDialogClass GalaCloseDialogClass;

#define GALA_TYPE_INHIBIT_SHORTCUTS_DIALOG (gala_inhibit_shortcuts_dialog_get_type ())
#define GALA_INHIBIT_SHORTCUTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_INHIBIT_SHORTCUTS_DIALOG, GalaInhibitShortcutsDialog))
#define GALA_INHIBIT_SHORTCUTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_INHIBIT_SHORTCUTS_DIALOG, GalaInhibitShortcutsDialogClass))
#define GALA_IS_INHIBIT_SHORTCUTS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_INHIBIT_SHORTCUTS_DIALOG))
#define GALA_IS_INHIBIT_SHORTCUTS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_INHIBIT_SHORTCUTS_DIALOG))
#define GALA_INHIBIT_SHORTCUTS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_INHIBIT_SHORTCUTS_DIALOG, GalaInhibitShortcutsDialogClass))

typedef struct _GalaInhibitShortcutsDialog GalaInhibitShortcutsDialog;
typedef struct _GalaInhibitShortcutsDialogClass GalaInhibitShortcutsDialogClass;

struct _GalaWindowManagerGala {
	MetaPlugin parent_instance;
	GalaWindowManagerGalaPrivate * priv;
};

struct _GalaWindowManagerGalaClass {
	MetaPluginClass parent_class;
};

struct _GalaWindowManagerGalaPrivate {
	ClutterActor* _ui_group;
	ClutterStage* _stage;
	ClutterActor* _window_group;
	ClutterActor* _top_window_group;
	ClutterActor* _shell_group;
	MetaBackgroundGroup* _background_group;
	GalaMultitaskingView* _multitasking_view;
	GalaPointerLocator* _pointer_locator;
	GalaSystemBackground* system_background;
	GalaWindowSwitcher* window_switcher;
	GalaActivatableComponent* _window_overview;
	GalaScreenSaverManager* _screensaver;
	GalaHotCornerManager* hot_corner_manager;
	GalaKeyboardManager* keyboard_manager;
	GalaWindowTracker* _window_tracker;
	GalaNotificationsManager* notifications_manager;
	GalaScreenshotManager* screenshot_manager;
	GalaZoom* zoom;
	ClutterActor* tile_preview;
	GalaDaemonManager* daemon_manager;
	GalaNotificationStack* notification_stack;
	GeeLinkedList* modal_stack;
	GeeHashSet* minimizing;
	GeeHashSet* maximizing;
	GeeHashSet* unmaximizing;
	GeeHashSet* mapping;
	GeeHashSet* destroying;
	GeeHashSet* unminimizing;
	GHashTable* ws_assoc;
	MetaSizeChange* which_change;
	MtkRectangle old_rect_size_change;
	ClutterActor* latest_window_snapshot;
	GSettings* behavior_settings;
	GSettings* new_behavior_settings;
};

struct _GalaWindowManagerGalaStartX11ServicesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GalaWindowManagerGala* self;
	GTask* task;
	GDBusConnection* session_bus;
	GDBusConnection* _tmp0_;
	GDBusConnection* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariantType* _tmp4_;
	GVariantType* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GError* e;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error1_;
	GError* _inner_error0_;
};

struct _Block12Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaDisplay* display;
};

struct _Block13Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	guint fade_out_duration;
	gdouble* op_keyframes;
	gint op_keyframes_length1;
	gint _op_keyframes_size_;
	GValue* opacity;
	gint opacity_length1;
	gint _opacity_size_;
	MetaX11Display* x11display;
	Window bottom_xwin;
};

struct _Block14Data {
	int _ref_count_;
	Block13Data * _data13_;
	MetaWindowActor* actor;
};

struct _Block15Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* transient_actor;
};

struct _Block16Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	GalaModalProxy* proxy;
	gulong handler;
	MetaWindow* window;
	MetaGrabOp op;
};

struct _Block17Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* actor;
};

struct _Block18Data {
	int _ref_count_;
	Block17Data * _data17_;
	gulong minimize_handler_id;
};

struct _Block19Data {
	int _ref_count_;
	Block17Data * _data17_;
	gulong minimize_handler_id;
};

struct _Block20Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	gulong maximize_old_handler_id;
	gulong handler_id;
	MetaWindowActor* actor;
};

struct _Block21Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindowActor* actor;
};

struct _Block22Data {
	int _ref_count_;
	Block21Data * _data21_;
	gulong unminimize_handler_id;
};

struct _Block23Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindow* window;
	MetaWindowActor* actor;
};

struct _Block24Data {
	int _ref_count_;
	Block23Data * _data23_;
	gulong map_handler_id;
};

struct _Block25Data {
	int _ref_count_;
	Block23Data * _data23_;
	gulong map_handler_id;
};

struct _Block26Data {
	int _ref_count_;
	Block23Data * _data23_;
	gulong map_handler_id;
};

struct _Block27Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	MetaWindow* window;
	MetaWindowActor* actor;
};

struct _Block28Data {
	int _ref_count_;
	Block27Data * _data27_;
	gulong destroy_handler_id;
};

struct _Block29Data {
	int _ref_count_;
	Block27Data * _data27_;
	gulong destroy_handler_id;
};

struct _Block30Data {
	int _ref_count_;
	Block27Data * _data27_;
	gulong destroy_handler_id;
};

struct _Block31Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	gulong unmaximize_old_handler_id;
	gulong handler_id;
	MetaWindowActor* actor;
};

struct _GalaWindowListenerWindowGeometry {
	MtkRectangle inner;
	MtkRectangle outer;
};

struct _Block32Data {
	int _ref_count_;
	GalaWindowManagerGala* self;
	gint timeout;
	guint dialog_timeout_id;
	GalaAccessDialog* dialog;
};

static gint GalaWindowManagerGala_private_offset;
static gpointer gala_window_manager_gala_parent_class = NULL;
static GalaWindowManagerIface * gala_window_manager_gala_gala_window_manager_parent_iface = NULL;

VALA_EXTERN GType gala_window_manager_gala_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowManagerGala, g_object_unref)
VALA_EXTERN GType gala_actor_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaActorTarget, g_object_unref)
VALA_EXTERN GType gala_multitasking_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaMultitaskingView, g_object_unref)
VALA_EXTERN GType gala_pointer_locator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPointerLocator, g_object_unref)
VALA_EXTERN GType gala_system_background_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSystemBackground, g_object_unref)
VALA_EXTERN GType gala_window_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowSwitcher, g_object_unref)
VALA_EXTERN GType gala_screen_saver_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaScreenSaverManager, g_object_unref)
VALA_EXTERN guint gala_screen_saver_manager_register_object (void* object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error);
VALA_EXTERN GType gala_hot_corner_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaHotCornerManager, g_object_unref)
VALA_EXTERN GType gala_keyboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaKeyboardManager, g_object_unref)
VALA_EXTERN GType gala_window_tracker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowTracker, g_object_unref)
VALA_EXTERN GType gala_notifications_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaNotificationsManager, g_object_unref)
VALA_EXTERN GType gala_screenshot_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaScreenshotManager, g_object_unref)
VALA_EXTERN guint gala_screenshot_manager_register_object (void* object,
                                               GDBusConnection* connection,
                                               const gchar* path,
                                               GError** error);
VALA_EXTERN GType gala_zoom_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaZoom, g_object_unref)
VALA_EXTERN GType gala_daemon_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDaemonManager, g_object_unref)
VALA_EXTERN GType gala_notification_stack_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaNotificationStack, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static void gala_window_manager_gala_real_start (MetaPlugin* base);
VALA_EXTERN void gala_shell_clients_manager_init (GalaWindowManager* wm);
VALA_EXTERN GalaDaemonManager* gala_daemon_manager_new (MetaDisplay* display);
VALA_EXTERN GalaDaemonManager* gala_daemon_manager_construct (GType object_type,
                                                  MetaDisplay* display);
static void gala_window_manager_gala_show_stage (GalaWindowManagerGala* self);
static void gala_window_manager_gala_init_a11y (GalaWindowManagerGala* self);
VALA_EXTERN void gala_access_dialog_watch_portal (void);
static void __lambda171_ (GalaWindowManagerGala* self);
static void ___lambda171__meta_display_gl_video_memory_purged (MetaDisplay* _sender,
                                                        gpointer self);
static gboolean ___lambda172_ (GalaWindowManagerGala* self,
                        GTask* task);
static void gala_window_manager_gala_start_x11_services (GalaWindowManagerGala* self,
                                                  GTask* task,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void gala_window_manager_gala_start_x11_services_finish (GalaWindowManagerGala* self,
                                                         GAsyncResult* _res_);
static gboolean ____lambda172__meta_display_init_xserver (MetaDisplay* _sender,
                                                   GTask* object,
                                                   gpointer self);
static void gala_window_manager_gala_start_x11_services_data_free (gpointer _data);
static gboolean gala_window_manager_gala_start_x11_services_co (GalaWindowManagerGalaStartX11ServicesData* _data_);
static void gala_window_manager_gala_start_x11_services_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN GalaNotificationsManager* gala_notifications_manager_new (void);
VALA_EXTERN GalaNotificationsManager* gala_notifications_manager_construct (GType object_type);
VALA_EXTERN GalaScreenshotManager* gala_screenshot_manager_new (GalaWindowManager* wm,
                                                    GalaNotificationsManager* notifications_manager);
VALA_EXTERN GalaScreenshotManager* gala_screenshot_manager_construct (GType object_type,
                                                          GalaWindowManager* wm,
                                                          GalaNotificationsManager* notifications_manager);
VALA_EXTERN void gala_dbus_init (GalaWindowManagerGala* _wm,
                     GalaNotificationsManager* notifications_manager,
                     GalaScreenshotManager* screenshot_manager);
VALA_EXTERN void gala_window_listener_init (MetaDisplay* display);
VALA_EXTERN GalaKeyboardManager* gala_keyboard_manager_new (MetaDisplay* display);
VALA_EXTERN GalaKeyboardManager* gala_keyboard_manager_construct (GType object_type,
                                                      MetaDisplay* display);
VALA_EXTERN GalaWindowTracker* gala_window_tracker_new (void);
VALA_EXTERN GalaWindowTracker* gala_window_tracker_construct (GType object_type);
static void gala_window_manager_gala_set_window_tracker (GalaWindowManagerGala* self,
                                                  GalaWindowTracker* value);
VALA_EXTERN void gala_window_state_saver_init (GalaWindowTracker* window_tracker);
VALA_EXTERN GalaWindowTracker* gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self);
VALA_EXTERN void gala_window_tracker_init (GalaWindowTracker* self,
                               MetaDisplay* display);
VALA_EXTERN GalaNotificationStack* gala_notification_stack_new (MetaDisplay* display);
VALA_EXTERN GalaNotificationStack* gala_notification_stack_construct (GType object_type,
                                                          MetaDisplay* display);
static CoglColor* _vala_CoglColor_copy (CoglColor* self);
static void _vala_CoglColor_free (CoglColor* self);
static gboolean __lambda142_ (GalaWindowManagerGala* self);
VALA_EXTERN void gala_workspace_manager_init (GalaWindowManager* wm);
static gboolean ___lambda142__gsource_func (gpointer self);
VALA_EXTERN GalaSystemBackground* gala_system_background_new (MetaDisplay* display);
VALA_EXTERN GalaSystemBackground* gala_system_background_construct (GType object_type,
                                                        MetaDisplay* display);
VALA_EXTERN MetaBackgroundActor* gala_system_background_get_background_actor (GalaSystemBackground* self);
static void gala_window_manager_gala_update_ui_group_size (GalaWindowManagerGala* self);
VALA_EXTERN GalaBackgroundContainer* gala_background_container_new (MetaDisplay* display);
VALA_EXTERN GalaBackgroundContainer* gala_background_container_construct (GType object_type,
                                                              MetaDisplay* display);
VALA_EXTERN GType gala_background_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaBackgroundContainer, g_object_unref)
VALA_EXTERN void gala_daemon_manager_show_background_menu (GalaDaemonManager* self,
                                               gint x,
                                               gint y,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
VALA_EXTERN void gala_daemon_manager_show_background_menu_finish (GalaDaemonManager* self,
                                                      GAsyncResult* _res_);
static void _gala_daemon_manager_show_background_menu_gala_background_container_show_background_menu (GalaBackgroundContainer* _sender,
                                                                                               gint x,
                                                                                               gint y,
                                                                                               gpointer self);
VALA_EXTERN GType gala_plugin_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaPluginManager, g_object_unref)
VALA_EXTERN GalaPluginManager* gala_plugin_manager_get_default (void);
VALA_EXTERN void gala_plugin_manager_initialize (GalaPluginManager* self,
                                     GalaWindowManager* _wm);
static void gala_window_manager_gala_update_input_area (GalaWindowManagerGala* self);
static void _gala_window_manager_gala_update_input_area_gala_plugin_manager_regions_changed (GalaPluginManager* _sender,
                                                                                      gpointer self);
VALA_EXTERN GalaMultitaskingView* gala_multitasking_view_new (GalaWindowManagerGala* wm);
VALA_EXTERN GalaMultitaskingView* gala_multitasking_view_construct (GType object_type,
                                                        GalaWindowManagerGala* wm);
VALA_EXTERN void gala_window_manager_gala_set_multitasking_view (GalaWindowManagerGala* self,
                                                     GalaMultitaskingView* value);
VALA_EXTERN GalaMultitaskingView* gala_window_manager_gala_get_multitasking_view (GalaWindowManagerGala* self);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_switcher_provider (GalaPluginManager* self);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowSwitcher* gala_window_switcher_construct (GType object_type,
                                                    GalaWindowManager* wm);
VALA_EXTERN void gala_window_switcher_handle_switch_windows (MetaDisplay* display,
                                                 MetaWindow* window,
                                                 ClutterKeyEvent* event,
                                                 MetaKeyBinding* binding,
                                                 GalaWindowSwitcher* self);
static void _gala_window_switcher_handle_switch_windows_meta_key_handler_func (MetaDisplay* display,
                                                                        MetaWindow* window,
                                                                        const ClutterEvent* event,
                                                                        MetaKeyBinding* binding,
                                                                        gpointer self);
VALA_EXTERN const gchar* gala_plugin_manager_get_window_overview_provider (GalaPluginManager* self);
VALA_EXTERN GalaPlugin* gala_plugin_manager_get_plugin (GalaPluginManager* self,
                                            const gchar* id);
static void gala_window_manager_gala_set_window_overview (GalaWindowManagerGala* self,
                                                   GalaActivatableComponent* value);
VALA_EXTERN GalaWindowOverview* gala_window_overview_new (GalaWindowManager* wm);
VALA_EXTERN GalaWindowOverview* gala_window_overview_construct (GType object_type,
                                                    GalaWindowManager* wm);
VALA_EXTERN GType gala_window_overview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowOverview, g_object_unref)
VALA_EXTERN GalaActivatableComponent* gala_window_manager_gala_get_window_overview (GalaWindowManagerGala* self);
static void gala_window_manager_gala_set_shell_group (GalaWindowManagerGala* self,
                                               ClutterActor* value);
VALA_EXTERN ClutterActor* gala_window_manager_gala_get_shell_group (GalaWindowManagerGala* self);
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_new (MetaDisplay* display);
VALA_EXTERN GalaPointerLocator* gala_pointer_locator_construct (GType object_type,
                                                    MetaDisplay* display);
static void gala_window_manager_gala_set_pointer_locator (GalaWindowManagerGala* self,
                                                   GalaPointerLocator* value);
VALA_EXTERN GalaPointerLocator* gala_window_manager_gala_get_pointer_locator (GalaWindowManagerGala* self);
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_new (MetaDisplay* display);
VALA_EXTERN GalaDwellClickTimer* gala_dwell_click_timer_construct (GType object_type,
                                                       MetaDisplay* display);
VALA_EXTERN GType gala_dwell_click_timer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaDwellClickTimer, g_object_unref)
VALA_EXTERN GType gala_session_locker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSessionLocker, g_object_unref)
VALA_EXTERN GalaSessionLocker* gala_session_locker_new (GalaWindowManager* wm);
VALA_EXTERN GalaSessionLocker* gala_session_locker_construct (GType object_type,
                                                  GalaWindowManager* wm);
VALA_EXTERN GalaScreenSaverManager* gala_screen_saver_manager_new (GalaSessionLocker* session_locker);
VALA_EXTERN GalaScreenSaverManager* gala_screen_saver_manager_construct (GType object_type,
                                                             GalaSessionLocker* session_locker);
static void gala_window_manager_gala_set_screensaver (GalaWindowManagerGala* self,
                                               GalaScreenSaverManager* value);
VALA_EXTERN GalaScreenSaverManager* gala_window_manager_gala_get_screensaver (GalaWindowManagerGala* self);
static void _gala_window_manager_gala_update_input_area_gala_screen_saver_manager_active_changed (GalaScreenSaverManager* _sender,
                                                                                           gboolean new_value,
                                                                                           gpointer self);
VALA_EXTERN void gala_filter_manager_init (GalaWindowManager* wm);
static void gala_window_manager_gala_handle_switch_to_workspace_end (MetaDisplay* display,
                                                              MetaWindow* window,
                                                              ClutterKeyEvent* event,
                                                              MetaKeyBinding* binding,
                                                              GalaWindowManagerGala* self);
static void _gala_window_manager_gala_handle_switch_to_workspace_end_meta_key_handler_func (MetaDisplay* display,
                                                                                     MetaWindow* window,
                                                                                     const ClutterEvent* event,
                                                                                     MetaKeyBinding* binding,
                                                                                     gpointer self);
static void gala_window_manager_gala_handle_move_to_workspace_end (MetaDisplay* display,
                                                            MetaWindow* window,
                                                            ClutterKeyEvent* event,
                                                            MetaKeyBinding* binding,
                                                            GalaWindowManagerGala* self);
static void _gala_window_manager_gala_handle_move_to_workspace_end_meta_key_handler_func (MetaDisplay* display,
                                                                                   MetaWindow* window,
                                                                                   const ClutterEvent* event,
                                                                                   MetaKeyBinding* binding,
                                                                                   gpointer self);
static void gala_window_manager_gala_handle_cycle_workspaces (MetaDisplay* display,
                                                       MetaWindow* window,
                                                       ClutterKeyEvent* event,
                                                       MetaKeyBinding* binding,
                                                       GalaWindowManagerGala* self);
static void _gala_window_manager_gala_handle_cycle_workspaces_meta_key_handler_func (MetaDisplay* display,
                                                                              MetaWindow* window,
                                                                              const ClutterEvent* event,
                                                                              MetaKeyBinding* binding,
                                                                              gpointer self);
static void gala_window_manager_gala_handle_applications_menu (MetaDisplay* display,
                                                        MetaWindow* window,
                                                        ClutterKeyEvent* event,
                                                        MetaKeyBinding* binding,
                                                        GalaWindowManagerGala* self);
static void _gala_window_manager_gala_handle_applications_menu_meta_key_handler_func (MetaDisplay* display,
                                                                               MetaWindow* window,
                                                                               const ClutterEvent* event,
                                                                               MetaKeyBinding* binding,
                                                                               gpointer self);
static void __lambda157_ (GalaWindowManagerGala* self);
static void ___lambda157__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda158_ (GalaWindowManagerGala* self);
static void ___lambda158__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda159_ (GalaWindowManagerGala* self);
static void ___lambda159__meta_display_overlay_key (MetaDisplay* _sender,
                                             gpointer self);
static void __lambda160_ (GalaWindowManagerGala* self);
static void ___lambda160__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda161_ (GalaWindowManagerGala* self);
static void ___lambda161__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda162_ (GalaWindowManagerGala* self);
static void ___lambda162__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void gala_window_manager_gala_handle_switch_to_workspace (MetaDisplay* display,
                                                          MetaWindow* window,
                                                          ClutterKeyEvent* event,
                                                          MetaKeyBinding* binding,
                                                          GalaWindowManagerGala* self);
static void _gala_window_manager_gala_handle_switch_to_workspace_meta_key_handler_func (MetaDisplay* display,
                                                                                 MetaWindow* window,
                                                                                 const ClutterEvent* event,
                                                                                 MetaKeyBinding* binding,
                                                                                 gpointer self);
static void __lambda163_ (GalaWindowManagerGala* self);
static void ___lambda163__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void __lambda164_ (GalaWindowManagerGala* self);
static void ___lambda164__meta_key_handler_func (MetaDisplay* display,
                                          MetaWindow* window,
                                          const ClutterEvent* event,
                                          MetaKeyBinding* binding,
                                          gpointer self);
static void gala_window_manager_gala_handle_move_to_workspace (MetaDisplay* display,
                                                        MetaWindow* window,
                                                        ClutterKeyEvent* event,
                                                        MetaKeyBinding* binding,
                                                        GalaWindowManagerGala* self);
static void _gala_window_manager_gala_handle_move_to_workspace_meta_key_handler_func (MetaDisplay* display,
                                                                               MetaWindow* window,
                                                                               const ClutterEvent* event,
                                                                               MetaKeyBinding* binding,
                                                                               gpointer self);
static void _gala_window_manager_gala_update_ui_group_size_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                           gpointer self);
VALA_EXTERN GalaHotCornerManager* gala_hot_corner_manager_new (GalaWindowManager* wm,
                                                   GSettings* behavior_settings,
                                                   GSettings* new_behavior_settings);
VALA_EXTERN GalaHotCornerManager* gala_hot_corner_manager_construct (GType object_type,
                                                         GalaWindowManager* wm,
                                                         GSettings* behavior_settings,
                                                         GSettings* new_behavior_settings);
static void _gala_window_manager_gala_update_input_area_gala_hot_corner_manager_on_configured (GalaHotCornerManager* _sender,
                                                                                        gpointer self);
VALA_EXTERN void gala_hot_corner_manager_configure (GalaHotCornerManager* self);
VALA_EXTERN GalaZoom* gala_zoom_new (GalaWindowManager* wm);
VALA_EXTERN GalaZoom* gala_zoom_construct (GType object_type,
                               GalaWindowManager* wm);
VALA_EXTERN GType gala_super_scroll_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaSuperScrollAction, g_object_unref)
VALA_EXTERN GalaSuperScrollAction* gala_super_scroll_action_new (MetaDisplay* display);
VALA_EXTERN GalaSuperScrollAction* gala_super_scroll_action_construct (GType object_type,
                                                           MetaDisplay* display);
static gboolean gala_window_manager_gala_handle_super_scroll (GalaWindowManagerGala* self,
                                                       guint32 timestamp,
                                                       gdouble dx,
                                                       gdouble dy);
static gboolean _gala_window_manager_gala_handle_super_scroll_gala_super_scroll_action_triggered (GalaSuperScrollAction* _sender,
                                                                                           guint32 timestamp,
                                                                                           gdouble dx,
                                                                                           gdouble dy,
                                                                                           gpointer self);
static void __lambda165_ (GalaWindowManagerGala* self,
                   MetaWindow* window);
VALA_EXTERN void gala_internal_utils_wait_for_window_actor_visible (MetaWindow* window,
                                                        GalaInternalUtilsWindowActorReadyCallback callback,
                                                        gpointer callback_target,
                                                        GDestroyNotify callback_target_destroy_notify);
static void gala_window_manager_gala_check_shell_window (GalaWindowManagerGala* self,
                                                  MetaWindowActor* actor);
static void _gala_window_manager_gala_check_shell_window_gala_internal_utils_window_actor_ready_callback (MetaWindowActor* window_actor,
                                                                                                   gpointer self);
static void ___lambda165__meta_display_window_created (MetaDisplay* _sender,
                                                MetaWindow* object,
                                                gpointer self);
VALA_EXTERN void gala_plugin_manager_load_waiting_plugins (GalaPluginManager* self);
static gboolean __lambda166_ (Block12Data* _data12_);
static gboolean ___lambda166__gsource_func (gpointer self);
static void gala_window_manager_gala_real_launch_action (GalaWindowManager* base,
                                                  const gchar* action_key);
VALA_EXTERN void gala_internal_utils_bell_notify (MetaDisplay* display);
static void gala_window_manager_gala_real_switch_to_next_workspace (GalaWindowManager* base,
                                                             MetaMotionDirection direction,
                                                             guint32 timestamp);
VALA_EXTERN void gala_multitasking_view_switch_to_next_workspace (GalaMultitaskingView* self,
                                                      MetaMotionDirection direction);
VALA_EXTERN gboolean gala_screen_saver_manager_get_active (GalaScreenSaverManager* self,
                                               GError** error);
VALA_EXTERN GType gala_input_area_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gala_internal_utils_set_input_area (MetaDisplay* display,
                                         GalaInputArea area);
static void gala_window_manager_gala_show_bottom_stack_window (GalaWindowManagerGala* self,
                                                        MetaWindow* bottom_window);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void _vala_GValue_array_free (GValue * array,
                              gssize array_length);
static void block13_data_unref (void * _userdata_);
static void gala_window_manager_gala_animate_bottom_window_scale (GalaWindowManagerGala* self,
                                                           MetaWindowActor* actor);
static void __lambda173_ (Block13Data* _data13_,
                   MetaWindow* window);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
VALA_EXTERN gboolean gala_internal_utils_get_window_is_normal (MetaWindow* window);
static gboolean ___lambda174_ (Block14Data* _data14_);
static gboolean ____lambda174__gsource_func (gpointer self);
static gboolean ___lambda175_ (Block14Data* _data14_);
static gboolean ____lambda175__gsource_func (gpointer self);
static void ___lambda173__gfunc (gconstpointer data,
                          gpointer self);
static void gala_window_manager_gala_real_move_window (GalaWindowManager* base,
                                                MetaWindow* window,
                                                MetaWorkspace* workspace,
                                                guint32 timestamp);
VALA_EXTERN void gala_multitasking_view_move_window (GalaMultitaskingView* self,
                                         MetaWindow* window,
                                         MetaWorkspace* workspace);
static GalaModalProxy* gala_window_manager_gala_real_push_modal (GalaWindowManager* base,
                                                          ClutterActor* actor);
static void gala_window_manager_gala_real_pop_modal (GalaWindowManager* base,
                                              GalaModalProxy* proxy);
static gboolean gala_window_manager_gala_real_is_modal (GalaWindowManager* base);
static gboolean gala_window_manager_gala_real_modal_proxy_valid (GalaWindowManager* base,
                                                          GalaModalProxy* proxy);
static void gala_window_manager_gala_dim_parent_window (GalaWindowManagerGala* self,
                                                 MetaWindow* window);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void __lambda176_ (Block15Data* _data15_);
static void ___lambda176__meta_window_unmanaged (MetaWindow* _sender,
                                          gpointer self);
static void gala_window_manager_gala_set_grab_trigger (GalaWindowManagerGala* self,
                                                MetaWindow* window,
                                                MetaGrabOp op);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static gboolean __lambda177_ (Block16Data* _data16_,
                       ClutterEvent* event);
static gboolean ___lambda177__clutter_actor_captured_event (ClutterActor* _sender,
                                                     ClutterEvent* event,
                                                     gpointer self);
static void gala_window_manager_gala_real_perform_action (GalaWindowManager* base,
                                                   GalaActionType type);
VALA_EXTERN void gala_screenshot_manager_handle_screenshot_current_window_shortcut (GalaScreenshotManager* self,
                                                                        gboolean clipboard,
                                                                        GAsyncReadyCallback _callback_,
                                                                        gpointer _user_data_);
VALA_EXTERN void gala_screenshot_manager_handle_screenshot_current_window_shortcut_finish (GalaScreenshotManager* self,
                                                                               GAsyncResult* _res_);
static void gala_window_manager_gala_real_show_window_menu (MetaPlugin* base,
                                                     MetaWindow* window,
                                                     MetaWindowMenuType menu,
                                                     gint x,
                                                     gint y);
VALA_EXTERN gboolean gala_notification_stack_is_notification (MetaWindow* window);
VALA_EXTERN void gala_daemon_manager_show_window_menu (GalaDaemonManager* self,
                                           GalaWindowFlags flags,
                                           gint x,
                                           gint y,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void gala_daemon_manager_show_window_menu_finish (GalaDaemonManager* self,
                                                  GAsyncResult* _res_);
static void gala_window_manager_gala_real_show_tile_preview (MetaPlugin* base,
                                                      MetaWindow* window,
                                                      MtkRectangle* tile_rect,
                                                      gint tile_monitor_number);
static void gala_window_manager_gala_real_hide_tile_preview (MetaPlugin* base);
static void gala_window_manager_gala_real_show_window_menu_for_rect (MetaPlugin* base,
                                                              MetaWindow* window,
                                                              MetaWindowMenuType menu,
                                                              MtkRectangle* rect);
VALA_EXTERN GType gala_shell_clients_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaShellClientsManager, g_object_unref)
VALA_EXTERN GalaShellClientsManager* gala_shell_clients_manager_get_instance (void);
VALA_EXTERN gboolean gala_shell_clients_manager_is_positioned_window (GalaShellClientsManager* self,
                                                          MetaWindow* window);
VALA_EXTERN void gala_internal_utils_clutter_actor_reparent (ClutterActor* actor,
                                                 ClutterActor* new_parent);
VALA_EXTERN void gala_notification_stack_show_notification (GalaNotificationStack* self,
                                                MetaWindowActor* notification);
static void gala_window_manager_gala_real_size_change (MetaPlugin* base,
                                                MetaWindowActor* actor,
                                                MetaSizeChange which_change_local,
                                                MtkRectangle* old_frame_rect,
                                                MtkRectangle* old_buffer_rect);
static MetaSizeChange* _meta_size_change_dup (MetaSizeChange* self);
static void gala_window_manager_gala_real_size_changed (MetaPlugin* base,
                                                 MetaWindowActor* actor);
static void gala_window_manager_gala_maximize (GalaWindowManagerGala* self,
                                        MetaWindowActor* actor,
                                        gint ex,
                                        gint ey,
                                        gint ew,
                                        gint eh);
static void gala_window_manager_gala_unmaximize (GalaWindowManagerGala* self,
                                          MetaWindowActor* actor,
                                          gint ex,
                                          gint ey,
                                          gint ew,
                                          gint eh);
static void gala_window_manager_gala_real_minimize (MetaPlugin* base,
                                             MetaWindowActor* actor);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void ___lambda183_ (Block18Data* _data18_);
static void ____lambda183__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void ___lambda184_ (Block19Data* _data19_);
static void ____lambda184__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static void gala_window_manager_gala_move_window_to_next_ws (GalaWindowManagerGala* self,
                                                      MetaWindow* window);
static gboolean ___lambda178_ (Block20Data* _data20_);
static gboolean ____lambda178__gsource_func (gpointer self);
static void __lambda179_ (Block20Data* _data20_,
                   ClutterActor* snapshot,
                   const gchar* name,
                   gboolean is_finished);
static void ___lambda179__clutter_actor_transition_stopped (ClutterActor* _sender,
                                                     const gchar* name,
                                                     gboolean is_finished,
                                                     gpointer self);
static void __lambda180_ (Block20Data* _data20_);
static void ___lambda180__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                        gpointer self);
static void gala_window_manager_gala_real_unminimize (MetaPlugin* base,
                                               MetaWindowActor* actor);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void ___lambda185_ (Block22Data* _data22_);
static void ____lambda185__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void gala_window_manager_gala_real_map (MetaPlugin* base,
                                        MetaWindowActor* actor);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
VALA_EXTERN void gala_window_state_saver_on_map (MetaWindow* window);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void ___lambda186_ (Block24Data* _data24_);
static void ____lambda186__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void ___lambda187_ (Block25Data* _data25_);
static void ____lambda187__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
static void ___lambda188_ (Block26Data* _data26_);
static void ____lambda188__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static void gala_window_manager_gala_real_destroy (MetaPlugin* base,
                                            MetaWindowActor* actor);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
VALA_EXTERN void gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                                   MetaWindowActor* notification);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void ____lambda189_ (Block28Data* _data28_);
static void _____lambda189__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                          gpointer self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void ___lambda190_ (Block29Data* _data29_);
static void ____lambda190__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static void ___lambda191_ (Block30Data* _data30_);
static void ____lambda191__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                         gpointer self);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void gala_window_manager_gala_move_window_to_old_ws (GalaWindowManagerGala* self,
                                                     MetaWindow* window);
VALA_EXTERN GType gala_window_listener_window_geometry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GalaWindowListenerWindowGeometry* gala_window_listener_window_geometry_dup (const GalaWindowListenerWindowGeometry* self);
VALA_EXTERN void gala_window_listener_window_geometry_free (GalaWindowListenerWindowGeometry* self);
VALA_EXTERN GType gala_window_listener_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowListener, g_object_unref)
VALA_EXTERN GalaWindowListener* gala_window_listener_get_default (void);
VALA_EXTERN GalaWindowListenerWindowGeometry* gala_window_listener_get_unmaximized_state_geometry (GalaWindowListener* self,
                                                                                       MetaWindow* window);
static void __lambda181_ (Block31Data* _data31_,
                   ClutterActor* snapshot,
                   const gchar* name,
                   gboolean is_finished);
static void ___lambda181__clutter_actor_transition_stopped (ClutterActor* _sender,
                                                     const gchar* name,
                                                     gboolean is_finished,
                                                     gpointer self);
static void __lambda182_ (Block31Data* _data31_);
static void ___lambda182__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                        gpointer self);
VALA_EXTERN void gala_internal_utils_insert_workspace_with_window (gint index,
                                                       MetaWindow* new_window);
static void _gala_window_manager_gala_move_window_to_old_ws_meta_window_unmanaged (MetaWindow* _sender,
                                                                            gpointer self);
static gboolean gala_window_manager_gala_end_animation (GalaWindowManagerGala* self,
                                                 GeeHashSet** list,
                                                 MetaWindowActor* actor);
static void gala_window_manager_gala_real_kill_window_effects (MetaPlugin* base,
                                                        MetaWindowActor* actor);
static void gala_window_manager_gala_real_switch_workspace (MetaPlugin* base,
                                                     gint from,
                                                     gint to,
                                                     MetaMotionDirection direction);
static void gala_window_manager_gala_real_kill_switch_workspace (MetaPlugin* base);
VALA_EXTERN void gala_multitasking_view_kill_switch_workspace (GalaMultitaskingView* self);
static void gala_window_manager_gala_real_locate_pointer (MetaPlugin* base);
VALA_EXTERN void gala_pointer_locator_show_ripple (GalaPointerLocator* self);
static gboolean gala_window_manager_gala_real_keybinding_filter (MetaPlugin* base,
                                                          MetaKeyBinding* binding);
static gboolean gala_window_manager_gala_real_filter_action (GalaWindowManager* base,
                                                      GalaGestureAction action);
static void gala_window_manager_gala_real_confirm_display_change (MetaPlugin* base);
VALA_EXTERN GType gala_access_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaAccessDialog, g_object_unref)
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
VALA_EXTERN GalaAccessDialog* gala_access_dialog_new (const gchar* title,
                                          const gchar* body,
                                          const gchar* icon);
VALA_EXTERN GalaAccessDialog* gala_access_dialog_construct (GType object_type,
                                                const gchar* title,
                                                const gchar* body,
                                                const gchar* icon);
VALA_EXTERN void gala_access_dialog_set_accept_label (GalaAccessDialog* self,
                                          const gchar* value);
VALA_EXTERN void gala_access_dialog_set_deny_label (GalaAccessDialog* self,
                                        const gchar* value);
static void __lambda192_ (Block32Data* _data32_);
static gboolean __lambda193_ (Block32Data* _data32_);
VALA_EXTERN void gala_access_dialog_close (GalaAccessDialog* self);
static gboolean ___lambda193__gsource_func (gpointer self);
static void ___lambda192__gala_access_dialog_show (GalaAccessDialog* _sender,
                                            gpointer self);
static void __lambda194_ (Block32Data* _data32_,
                   guint res);
static void ___lambda194__gala_access_dialog_response (GalaAccessDialog* _sender,
                                                guint response,
                                                gpointer self);
static MetaCloseDialog* gala_window_manager_gala_real_create_close_dialog (MetaPlugin* base,
                                                                    MetaWindow* window);
VALA_EXTERN GalaApp* gala_window_tracker_get_app_for_window (GalaWindowTracker* self,
                                                 MetaWindow* window);
VALA_EXTERN GalaCloseDialog* gala_close_dialog_new (GalaApp* app,
                                        MetaWindow* window);
VALA_EXTERN GalaCloseDialog* gala_close_dialog_construct (GType object_type,
                                              GalaApp* app,
                                              MetaWindow* window);
VALA_EXTERN GType gala_close_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaCloseDialog, g_object_unref)
static MetaInhibitShortcutsDialog* gala_window_manager_gala_real_create_inhibit_shortcuts_dialog (MetaPlugin* base,
                                                                                           MetaWindow* window);
VALA_EXTERN GalaInhibitShortcutsDialog* gala_inhibit_shortcuts_dialog_new (GalaApp* app,
                                                               MetaWindow* window);
VALA_EXTERN GalaInhibitShortcutsDialog* gala_inhibit_shortcuts_dialog_construct (GType object_type,
                                                                     GalaApp* app,
                                                                     MetaWindow* window);
VALA_EXTERN GType gala_inhibit_shortcuts_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaInhibitShortcutsDialog, g_object_unref)
VALA_EXTERN GalaWindowManagerGala* gala_window_manager_gala_new (void);
VALA_EXTERN GalaWindowManagerGala* gala_window_manager_gala_construct (GType object_type);
static GObject * gala_window_manager_gala_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void gala_window_manager_gala_finalize (GObject * obj);
static GType gala_window_manager_gala_get_type_once (void);
static void _vala_gala_window_manager_gala_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_gala_window_manager_gala_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
gala_window_manager_gala_get_instance_private (GalaWindowManagerGala* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowManagerGala_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 104 "../src/WindowManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1290 "WindowManager.c"
}

static void
__lambda171_ (GalaWindowManagerGala* self)
{
#line 137 "../src/WindowManager.vala"
	meta_background_refresh_all ();
#line 1298 "WindowManager.c"
}

static void
___lambda171__meta_display_gl_video_memory_purged (MetaDisplay* _sender,
                                                   gpointer self)
{
#line 136 "../src/WindowManager.vala"
	__lambda171_ ((GalaWindowManagerGala*) self);
#line 1307 "WindowManager.c"
}

static gboolean
___lambda172_ (GalaWindowManagerGala* self,
               GTask* task)
{
	gboolean result;
#line 142 "../src/WindowManager.vala"
	g_return_val_if_fail (task != NULL, FALSE);
#line 143 "../src/WindowManager.vala"
	gala_window_manager_gala_start_x11_services (self, task, NULL, NULL);
#line 144 "../src/WindowManager.vala"
	result = TRUE;
#line 144 "../src/WindowManager.vala"
	return result;
#line 1323 "WindowManager.c"
}

static gboolean
____lambda172__meta_display_init_xserver (MetaDisplay* _sender,
                                          GTask* object,
                                          gpointer self)
{
	gboolean result;
	result = ___lambda172_ ((GalaWindowManagerGala*) self, object);
#line 142 "../src/WindowManager.vala"
	return result;
#line 1335 "WindowManager.c"
}

static void
gala_window_manager_gala_real_start (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	MetaDisplay* _tmp0_;
	GalaDaemonManager* _tmp1_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp2_;
	MetaDisplay* _tmp3_;
#line 125 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 126 "../src/WindowManager.vala"
	gala_shell_clients_manager_init ((GalaWindowManager*) self);
#line 127 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 127 "../src/WindowManager.vala"
	_tmp1_ = gala_daemon_manager_new (_tmp0_);
#line 127 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->daemon_manager);
#line 127 "../src/WindowManager.vala"
	self->priv->daemon_manager = _tmp1_;
#line 129 "../src/WindowManager.vala"
	gala_window_manager_gala_show_stage (self);
#line 131 "../src/WindowManager.vala"
	gala_window_manager_gala_init_a11y (self);
#line 133 "../src/WindowManager.vala"
	gala_access_dialog_watch_portal ();
#line 135 "../src/WindowManager.vala"
	_tmp2_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 135 "../src/WindowManager.vala"
	display = _tmp2_;
#line 136 "../src/WindowManager.vala"
	_tmp3_ = display;
#line 136 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp3_, "gl-video-memory-purged", (GCallback) ___lambda171__meta_display_gl_video_memory_purged, self, 0);
#line 141 "../src/WindowManager.vala"
	if (meta_is_wayland_compositor ()) {
#line 1375 "WindowManager.c"
		MetaDisplay* _tmp4_;
#line 142 "../src/WindowManager.vala"
		_tmp4_ = display;
#line 142 "../src/WindowManager.vala"
		g_signal_connect_object (_tmp4_, "init-xserver", (GCallback) ____lambda172__meta_display_init_xserver, self, 0);
#line 1381 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_start_x11_services_data_free (gpointer _data)
{
	GalaWindowManagerGalaStartX11ServicesData* _data_;
	_data_ = _data;
#line 20 "../src/WindowManager.vala"
	_g_object_unref0 (_data_->task);
#line 20 "../src/WindowManager.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/WindowManager.vala"
	g_slice_free (GalaWindowManagerGalaStartX11ServicesData, _data_);
#line 1396 "WindowManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 20 "../src/WindowManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1404 "WindowManager.c"
}

static void
gala_window_manager_gala_start_x11_services (GalaWindowManagerGala* self,
                                             GTask* task,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GalaWindowManagerGalaStartX11ServicesData* _data_;
	GalaWindowManagerGala* _tmp0_;
	GTask* _tmp1_;
#line 20 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/WindowManager.vala"
	g_return_if_fail (task != NULL);
#line 20 "../src/WindowManager.vala"
	_data_ = g_slice_new0 (GalaWindowManagerGalaStartX11ServicesData);
#line 20 "../src/WindowManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/WindowManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gala_window_manager_gala_start_x11_services_data_free);
#line 20 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/WindowManager.vala"
	_data_->self = _tmp0_;
#line 20 "../src/WindowManager.vala"
	_tmp1_ = _g_object_ref0 (task);
#line 20 "../src/WindowManager.vala"
	_g_object_unref0 (_data_->task);
#line 20 "../src/WindowManager.vala"
	_data_->task = _tmp1_;
#line 20 "../src/WindowManager.vala"
	gala_window_manager_gala_start_x11_services_co (_data_);
#line 1438 "WindowManager.c"
}

static void
gala_window_manager_gala_start_x11_services_finish (GalaWindowManagerGala* self,
                                                    GAsyncResult* _res_)
{
	GalaWindowManagerGalaStartX11ServicesData* _data_;
#line 20 "../src/WindowManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1448 "WindowManager.c"
}

static void
gala_window_manager_gala_start_x11_services_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GalaWindowManagerGalaStartX11ServicesData* _data_;
#line 153 "../src/WindowManager.vala"
	_data_ = _user_data_;
#line 153 "../src/WindowManager.vala"
	_data_->_source_object_ = source_object;
#line 153 "../src/WindowManager.vala"
	_data_->_res_ = _res_;
#line 153 "../src/WindowManager.vala"
	gala_window_manager_gala_start_x11_services_co (_data_);
#line 1465 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_start_x11_services_co (GalaWindowManagerGalaStartX11ServicesData* _data_)
{
#line 151 "../src/WindowManager.vala"
	switch (_data_->_state_) {
#line 151 "../src/WindowManager.vala"
		case 0:
#line 1475 "WindowManager.c"
		goto _state_0;
#line 151 "../src/WindowManager.vala"
		case 1:
#line 1479 "WindowManager.c"
		goto _state_1;
#line 151 "../src/WindowManager.vala"
		case 2:
#line 1483 "WindowManager.c"
		goto _state_2;
		default:
#line 151 "../src/WindowManager.vala"
		g_assert_not_reached ();
#line 1488 "WindowManager.c"
	}
	_state_0:
	{
#line 153 "../src/WindowManager.vala"
		_data_->_state_ = 1;
#line 153 "../src/WindowManager.vala"
		g_bus_get (G_BUS_TYPE_SESSION, NULL, gala_window_manager_gala_start_x11_services_ready, _data_);
#line 153 "../src/WindowManager.vala"
		return FALSE;
#line 1498 "WindowManager.c"
		_state_1:
#line 153 "../src/WindowManager.vala"
		_data_->_tmp0_ = g_bus_get_finish (_data_->_res_, &_data_->_inner_error0_);
#line 153 "../src/WindowManager.vala"
		_data_->session_bus = _data_->_tmp0_;
#line 153 "../src/WindowManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1506 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 154 "../src/WindowManager.vala"
		_data_->_tmp1_ = _data_->session_bus;
#line 154 "../src/WindowManager.vala"
		_data_->_tmp2_ = g_variant_new ("(ss)", "gnome-session-x11-services-ready.target", "fail", NULL);
#line 154 "../src/WindowManager.vala"
		g_variant_ref_sink (_data_->_tmp2_);
#line 154 "../src/WindowManager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 154 "../src/WindowManager.vala"
		_data_->_tmp4_ = g_variant_type_new ("(o)");
#line 154 "../src/WindowManager.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 154 "../src/WindowManager.vala"
		_data_->_state_ = 2;
#line 154 "../src/WindowManager.vala"
		g_dbus_connection_call (_data_->_tmp1_, "org.freedesktop.systemd1", "/org/freedesktop/systemd1", "org.freedesktop.systemd1.Manager", "StartUnit", _data_->_tmp3_, _data_->_tmp5_, G_DBUS_CALL_FLAGS_NONE, -1, NULL, gala_window_manager_gala_start_x11_services_ready, _data_);
#line 154 "../src/WindowManager.vala"
		return FALSE;
#line 1527 "WindowManager.c"
		_state_2:
#line 154 "../src/WindowManager.vala"
		_data_->_tmp6_ = g_dbus_connection_call_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 154 "../src/WindowManager.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 154 "../src/WindowManager.vala"
		_g_variant_unref0 (_data_->_tmp7_);
#line 154 "../src/WindowManager.vala"
		_g_variant_type_free0 (_data_->_tmp5_);
#line 154 "../src/WindowManager.vala"
		_g_variant_unref0 (_data_->_tmp3_);
#line 154 "../src/WindowManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 154 "../src/WindowManager.vala"
			_g_object_unref0 (_data_->session_bus);
#line 1543 "WindowManager.c"
			goto __catch0_g_error;
		}
#line 152 "../src/WindowManager.vala"
		_g_object_unref0 (_data_->session_bus);
#line 1548 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 152 "../src/WindowManager.vala"
		_data_->e = _data_->_inner_error0_;
#line 152 "../src/WindowManager.vala"
		_data_->_inner_error0_ = NULL;
#line 165 "../src/WindowManager.vala"
		_data_->_tmp8_ = _data_->e;
#line 165 "../src/WindowManager.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 165 "../src/WindowManager.vala"
		g_critical ("WindowManager.vala:165: %s", _data_->_tmp9_);
#line 152 "../src/WindowManager.vala"
		_g_error_free0 (_data_->e);
#line 1565 "WindowManager.c"
	}
	__finally0:
	{
#line 167 "../src/WindowManager.vala"
		g_task_return_boolean (_data_->task, TRUE);
#line 1571 "WindowManager.c"
	}
#line 152 "../src/WindowManager.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 152 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 152 "../src/WindowManager.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 152 "../src/WindowManager.vala"
		g_object_unref (_data_->_async_result);
#line 152 "../src/WindowManager.vala"
		return FALSE;
#line 1583 "WindowManager.c"
	}
#line 151 "../src/WindowManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 151 "../src/WindowManager.vala"
	if (_data_->_state_ != 0) {
#line 151 "../src/WindowManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 151 "../src/WindowManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1593 "WindowManager.c"
		}
	}
#line 151 "../src/WindowManager.vala"
	g_object_unref (_data_->_async_result);
#line 151 "../src/WindowManager.vala"
	return FALSE;
#line 1600 "WindowManager.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 172 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 172 "../src/WindowManager.vala"
	return _data12_;
#line 1610 "WindowManager.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 172 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 1620 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 172 "../src/WindowManager.vala"
		self = _data12_->self;
#line 172 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 172 "../src/WindowManager.vala"
		g_slice_free (Block12Data, _data12_);
#line 1628 "WindowManager.c"
	}
}

static CoglColor*
_vala_CoglColor_copy (CoglColor* self)
{
#line 819 "mutter-cogl-16.vapi"
	return g_boxed_copy (cogl_color_get_type (), self);
#line 1637 "WindowManager.c"
}

static gpointer
__vala_CoglColor_copy0 (gpointer self)
{
#line 819 "mutter-cogl-16.vapi"
	return self ? _vala_CoglColor_copy (self) : NULL;
#line 1645 "WindowManager.c"
}

static CoglColor*
_vala_cogl_color_from_string (const gchar* str)
{
	CoglColor color = {0};
	CoglColor _tmp0_ = {0};
	CoglColor* result;
#line 816 "mutter-cogl-16.vapi"
	g_return_val_if_fail (str != NULL, NULL);
#line 817 "mutter-cogl-16.vapi"
	color = _tmp0_;
#line 818 "mutter-cogl-16.vapi"
	if (cogl_color_from_string (&color, str)) {
#line 1660 "WindowManager.c"
		CoglColor* _tmp1_;
#line 819 "mutter-cogl-16.vapi"
		_tmp1_ = __vala_CoglColor_copy0 (&color);
#line 819 "mutter-cogl-16.vapi"
		result = _tmp1_;
#line 819 "mutter-cogl-16.vapi"
		return result;
#line 1668 "WindowManager.c"
	}
#line 821 "mutter-cogl-16.vapi"
	result = NULL;
#line 821 "mutter-cogl-16.vapi"
	return result;
#line 1674 "WindowManager.c"
}

static void
_vala_CoglColor_free (CoglColor* self)
{
#line 195 "../src/WindowManager.vala"
	g_boxed_free (cogl_color_get_type (), self);
#line 1682 "WindowManager.c"
}

static gboolean
__lambda142_ (GalaWindowManagerGala* self)
{
	gboolean result;
#line 202 "../src/WindowManager.vala"
	gala_workspace_manager_init ((GalaWindowManager*) self);
#line 203 "../src/WindowManager.vala"
	result = FALSE;
#line 203 "../src/WindowManager.vala"
	return result;
#line 1695 "WindowManager.c"
}

static gboolean
___lambda142__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda142_ ((GalaWindowManagerGala*) self);
#line 201 "../src/WindowManager.vala"
	return result;
#line 1705 "WindowManager.c"
}

static void
_gala_daemon_manager_show_background_menu_gala_background_container_show_background_menu (GalaBackgroundContainer* _sender,
                                                                                          gint x,
                                                                                          gint y,
                                                                                          gpointer self)
{
#line 242 "../src/WindowManager.vala"
	gala_daemon_manager_show_background_menu ((GalaDaemonManager*) self, x, y, NULL, NULL);
#line 1716 "WindowManager.c"
}

static void
_gala_window_manager_gala_update_input_area_gala_plugin_manager_regions_changed (GalaPluginManager* _sender,
                                                                                 gpointer self)
{
#line 257 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area ((GalaWindowManagerGala*) self);
#line 1725 "WindowManager.c"
}

static void
_gala_window_switcher_handle_switch_windows_meta_key_handler_func (MetaDisplay* display,
                                                                   MetaWindow* window,
                                                                   const ClutterEvent* event,
                                                                   MetaKeyBinding* binding,
                                                                   gpointer self)
{
#line 266 "../src/WindowManager.vala"
	gala_window_switcher_handle_switch_windows (display, window, event, binding, (GalaWindowSwitcher*) self);
#line 1737 "WindowManager.c"
}

static void
_gala_window_manager_gala_update_input_area_gala_screen_saver_manager_active_changed (GalaScreenSaverManager* _sender,
                                                                                      gboolean new_value,
                                                                                      gpointer self)
{
#line 300 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area ((GalaWindowManagerGala*) self);
#line 1747 "WindowManager.c"
}

static void
_gala_window_manager_gala_handle_switch_to_workspace_end_meta_key_handler_func (MetaDisplay* display,
                                                                                MetaWindow* window,
                                                                                const ClutterEvent* event,
                                                                                MetaKeyBinding* binding,
                                                                                gpointer self)
{
#line 307 "../src/WindowManager.vala"
	gala_window_manager_gala_handle_switch_to_workspace_end (display, window, event, binding, (GalaWindowManagerGala*) self);
#line 1759 "WindowManager.c"
}

static void
_gala_window_manager_gala_handle_move_to_workspace_end_meta_key_handler_func (MetaDisplay* display,
                                                                              MetaWindow* window,
                                                                              const ClutterEvent* event,
                                                                              MetaKeyBinding* binding,
                                                                              gpointer self)
{
#line 309 "../src/WindowManager.vala"
	gala_window_manager_gala_handle_move_to_workspace_end (display, window, event, binding, (GalaWindowManagerGala*) self);
#line 1771 "WindowManager.c"
}

static void
_gala_window_manager_gala_handle_cycle_workspaces_meta_key_handler_func (MetaDisplay* display,
                                                                         MetaWindow* window,
                                                                         const ClutterEvent* event,
                                                                         MetaKeyBinding* binding,
                                                                         gpointer self)
{
#line 311 "../src/WindowManager.vala"
	gala_window_manager_gala_handle_cycle_workspaces (display, window, event, binding, (GalaWindowManagerGala*) self);
#line 1783 "WindowManager.c"
}

static void
_gala_window_manager_gala_handle_applications_menu_meta_key_handler_func (MetaDisplay* display,
                                                                          MetaWindow* window,
                                                                          const ClutterEvent* event,
                                                                          MetaKeyBinding* binding,
                                                                          gpointer self)
{
#line 313 "../src/WindowManager.vala"
	gala_window_manager_gala_handle_applications_menu (display, window, event, binding, (GalaWindowManagerGala*) self);
#line 1795 "WindowManager.c"
}

static void
__lambda157_ (GalaWindowManagerGala* self)
{
	GalaMultitaskingView* _tmp0_;
#line 316 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_multitasking_view;
#line 316 "../src/WindowManager.vala"
	if (gala_activatable_component_is_opened ((GalaActivatableComponent*) _tmp0_)) {
#line 1806 "WindowManager.c"
		GalaMultitaskingView* _tmp1_;
#line 317 "../src/WindowManager.vala"
		_tmp1_ = self->priv->_multitasking_view;
#line 317 "../src/WindowManager.vala"
		gala_activatable_component_close ((GalaActivatableComponent*) _tmp1_, NULL);
#line 1812 "WindowManager.c"
	} else {
		GalaMultitaskingView* _tmp2_;
#line 319 "../src/WindowManager.vala"
		_tmp2_ = self->priv->_multitasking_view;
#line 319 "../src/WindowManager.vala"
		gala_activatable_component_open ((GalaActivatableComponent*) _tmp2_, NULL);
#line 1819 "WindowManager.c"
	}
}

static void
___lambda157__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 315 "../src/WindowManager.vala"
	__lambda157_ ((GalaWindowManagerGala*) self);
#line 1832 "WindowManager.c"
}

static void
__lambda158_ (GalaWindowManagerGala* self)
{
	GalaActivatableComponent* _tmp0_;
#line 324 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_overview;
#line 324 "../src/WindowManager.vala"
	if (gala_activatable_component_is_opened (_tmp0_)) {
#line 1843 "WindowManager.c"
		GalaActivatableComponent* _tmp1_;
#line 325 "../src/WindowManager.vala"
		_tmp1_ = self->priv->_window_overview;
#line 325 "../src/WindowManager.vala"
		gala_activatable_component_close (_tmp1_, NULL);
#line 1849 "WindowManager.c"
	} else {
		GalaActivatableComponent* _tmp2_;
#line 327 "../src/WindowManager.vala"
		_tmp2_ = self->priv->_window_overview;
#line 327 "../src/WindowManager.vala"
		gala_activatable_component_open (_tmp2_, NULL);
#line 1856 "WindowManager.c"
	}
}

static void
___lambda158__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 323 "../src/WindowManager.vala"
	__lambda158_ ((GalaWindowManagerGala*) self);
#line 1869 "WindowManager.c"
}

static void
__lambda159_ (GalaWindowManagerGala* self)
{
#line 332 "../src/WindowManager.vala"
	gala_window_manager_launch_action ((GalaWindowManager*) self, GALA_ACTION_KEYS_OVERLAY_ACTION);
#line 1877 "WindowManager.c"
}

static void
___lambda159__meta_display_overlay_key (MetaDisplay* _sender,
                                        gpointer self)
{
#line 331 "../src/WindowManager.vala"
	__lambda159_ ((GalaWindowManagerGala*) self);
#line 1886 "WindowManager.c"
}

static void
__lambda160_ (GalaWindowManagerGala* self)
{
#line 336 "../src/WindowManager.vala"
	gala_window_manager_launch_action ((GalaWindowManager*) self, GALA_ACTION_KEYS_TOGGLE_RECORDING_ACTION);
#line 1894 "WindowManager.c"
}

static void
___lambda160__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 335 "../src/WindowManager.vala"
	__lambda160_ ((GalaWindowManagerGala*) self);
#line 1906 "WindowManager.c"
}

static void
__lambda161_ (GalaWindowManagerGala* self)
{
}

static void
___lambda161__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 339 "../src/WindowManager.vala"
	__lambda161_ ((GalaWindowManagerGala*) self);
#line 1923 "WindowManager.c"
}

static void
__lambda162_ (GalaWindowManagerGala* self)
{
}

static void
___lambda162__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 340 "../src/WindowManager.vala"
	__lambda162_ ((GalaWindowManagerGala*) self);
#line 1940 "WindowManager.c"
}

static void
_gala_window_manager_gala_handle_switch_to_workspace_meta_key_handler_func (MetaDisplay* display,
                                                                            MetaWindow* window,
                                                                            const ClutterEvent* event,
                                                                            MetaKeyBinding* binding,
                                                                            gpointer self)
{
#line 341 "../src/WindowManager.vala"
	gala_window_manager_gala_handle_switch_to_workspace (display, window, event, binding, (GalaWindowManagerGala*) self);
#line 1952 "WindowManager.c"
}

static void
__lambda163_ (GalaWindowManagerGala* self)
{
}

static void
___lambda163__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 344 "../src/WindowManager.vala"
	__lambda163_ ((GalaWindowManagerGala*) self);
#line 1969 "WindowManager.c"
}

static void
__lambda164_ (GalaWindowManagerGala* self)
{
}

static void
___lambda164__meta_key_handler_func (MetaDisplay* display,
                                     MetaWindow* window,
                                     const ClutterEvent* event,
                                     MetaKeyBinding* binding,
                                     gpointer self)
{
#line 345 "../src/WindowManager.vala"
	__lambda164_ ((GalaWindowManagerGala*) self);
#line 1986 "WindowManager.c"
}

static void
_gala_window_manager_gala_handle_move_to_workspace_meta_key_handler_func (MetaDisplay* display,
                                                                          MetaWindow* window,
                                                                          const ClutterEvent* event,
                                                                          MetaKeyBinding* binding,
                                                                          gpointer self)
{
#line 346 "../src/WindowManager.vala"
	gala_window_manager_gala_handle_move_to_workspace (display, window, event, binding, (GalaWindowManagerGala*) self);
#line 1998 "WindowManager.c"
}

static void
_gala_window_manager_gala_update_ui_group_size_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                      gpointer self)
{
#line 355 "../src/WindowManager.vala"
	gala_window_manager_gala_update_ui_group_size ((GalaWindowManagerGala*) self);
#line 2007 "WindowManager.c"
}

static void
_gala_window_manager_gala_update_input_area_gala_hot_corner_manager_on_configured (GalaHotCornerManager* _sender,
                                                                                   gpointer self)
{
#line 358 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area ((GalaWindowManagerGala*) self);
#line 2016 "WindowManager.c"
}

static gboolean
_gala_window_manager_gala_handle_super_scroll_gala_super_scroll_action_triggered (GalaSuperScrollAction* _sender,
                                                                                  guint32 timestamp,
                                                                                  gdouble dx,
                                                                                  gdouble dy,
                                                                                  gpointer self)
{
	gboolean result;
	result = gala_window_manager_gala_handle_super_scroll ((GalaWindowManagerGala*) self, timestamp, dx, dy);
#line 366 "../src/WindowManager.vala"
	return result;
#line 2030 "WindowManager.c"
}

static void
_gala_window_manager_gala_check_shell_window_gala_internal_utils_window_actor_ready_callback (MetaWindowActor* window_actor,
                                                                                              gpointer self)
{
#line 369 "../src/WindowManager.vala"
	gala_window_manager_gala_check_shell_window ((GalaWindowManagerGala*) self, window_actor);
#line 2039 "WindowManager.c"
}

static void
__lambda165_ (GalaWindowManagerGala* self,
              MetaWindow* window)
{
#line 369 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 369 "../src/WindowManager.vala"
	gala_internal_utils_wait_for_window_actor_visible (window, _gala_window_manager_gala_check_shell_window_gala_internal_utils_window_actor_ready_callback, g_object_ref (self), g_object_unref);
#line 2050 "WindowManager.c"
}

static void
___lambda165__meta_display_window_created (MetaDisplay* _sender,
                                           MetaWindow* object,
                                           gpointer self)
{
#line 369 "../src/WindowManager.vala"
	__lambda165_ ((GalaWindowManagerGala*) self, object);
#line 2060 "WindowManager.c"
}

static gboolean
__lambda166_ (Block12Data* _data12_)
{
	GalaWindowManagerGala* self;
	MetaDisplay* _tmp0_;
	MetaContext* _tmp1_;
	gboolean result;
#line 377 "../src/WindowManager.vala"
	self = _data12_->self;
#line 380 "../src/WindowManager.vala"
	sd_notify ((int) TRUE, "READY=1");
#line 382 "../src/WindowManager.vala"
	_tmp0_ = _data12_->display;
#line 382 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_context (_tmp0_);
#line 382 "../src/WindowManager.vala"
	meta_context_notify_ready (_tmp1_);
#line 383 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 383 "../src/WindowManager.vala"
	return result;
#line 2084 "WindowManager.c"
}

static gboolean
___lambda166__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda166_ (self);
#line 377 "../src/WindowManager.vala"
	return result;
#line 2094 "WindowManager.c"
}

static void
gala_window_manager_gala_show_stage (GalaWindowManagerGala* self)
{
	Block12Data* _data12_;
	MetaDisplay* _tmp0_;
	GalaNotificationsManager* _tmp1_;
	GalaNotificationsManager* _tmp2_;
	GalaScreenshotManager* _tmp3_;
	GalaNotificationsManager* _tmp4_;
	GalaScreenshotManager* _tmp5_;
	MetaDisplay* _tmp6_;
	MetaDisplay* _tmp7_;
	GalaKeyboardManager* _tmp8_;
	GalaWindowTracker* _tmp9_;
	GalaWindowTracker* _tmp10_;
	GalaWindowTracker* _tmp11_;
	GalaWindowTracker* _tmp12_;
	MetaDisplay* _tmp13_;
	MetaDisplay* _tmp14_;
	GalaNotificationStack* _tmp15_;
	MetaDisplay* _tmp16_;
	MetaCompositor* _tmp17_;
	ClutterStage* _tmp18_;
	GSettings* background_settings = NULL;
	GSettings* _tmp19_;
	gchar* color = NULL;
	GSettings* _tmp20_;
	gchar* _tmp21_;
	ClutterStage* _tmp22_;
	ClutterStage* _tmp23_;
	const gchar* _tmp24_;
	CoglColor* _tmp25_;
	CoglColor* _tmp26_;
	CoglColor _tmp27_;
	MetaLaters* laters = NULL;
	MetaDisplay* _tmp28_;
	MetaCompositor* _tmp29_;
	MetaLaters* _tmp30_;
	MetaLaters* _tmp31_;
	MetaDisplay* _tmp32_;
	GalaSystemBackground* _tmp33_;
	GalaSystemBackground* _tmp34_;
	MetaBackgroundActor* _tmp35_;
	MetaBackgroundActor* _tmp36_;
	ClutterStage* _tmp37_;
	ClutterStage* _tmp38_;
	ClutterBindConstraint* _tmp39_;
	ClutterBindConstraint* _tmp40_;
	ClutterStage* _tmp41_;
	ClutterStage* _tmp42_;
	GalaSystemBackground* _tmp43_;
	MetaBackgroundActor* _tmp44_;
	MetaBackgroundActor* _tmp45_;
	ClutterActor* _tmp46_;
	ClutterActor* _tmp47_;
	ClutterStage* _tmp48_;
	ClutterStage* _tmp49_;
	ClutterActor* _tmp50_;
	ClutterActor* _tmp51_;
	MetaDisplay* _tmp52_;
	MetaCompositor* _tmp53_;
	ClutterActor* _tmp54_;
	ClutterStage* _tmp55_;
	ClutterStage* _tmp56_;
	ClutterActor* _tmp57_;
	ClutterActor* _tmp58_;
	ClutterActor* _tmp59_;
	ClutterActor* _tmp60_;
	ClutterActor* _tmp61_;
	ClutterActor* _tmp62_;
	MetaDisplay* _tmp63_;
	GalaBackgroundContainer* _tmp64_;
	GalaBackgroundContainer* _tmp65_;
	MetaBackgroundGroup* _tmp66_;
	MetaBackgroundGroup* _tmp67_;
	GalaDaemonManager* _tmp68_;
	ClutterActor* _tmp69_;
	ClutterActor* _tmp70_;
	MetaBackgroundGroup* _tmp71_;
	MetaBackgroundGroup* _tmp72_;
	ClutterActor* _tmp73_;
	ClutterActor* _tmp74_;
	MetaBackgroundGroup* _tmp75_;
	MetaBackgroundGroup* _tmp76_;
	MetaDisplay* _tmp77_;
	MetaCompositor* _tmp78_;
	ClutterActor* _tmp79_;
	ClutterStage* _tmp80_;
	ClutterStage* _tmp81_;
	ClutterActor* _tmp82_;
	ClutterActor* _tmp83_;
	ClutterActor* _tmp84_;
	ClutterActor* _tmp85_;
	ClutterActor* _tmp86_;
	ClutterActor* _tmp87_;
	GalaPluginManager* plugin_manager = NULL;
	GalaPluginManager* _tmp88_;
	GalaPluginManager* _tmp89_;
	GalaPluginManager* _tmp90_;
	GalaMultitaskingView* _tmp91_;
	GalaMultitaskingView* _tmp92_;
	ClutterActor* _tmp93_;
	ClutterActor* _tmp94_;
	GalaMultitaskingView* _tmp95_;
	GalaPluginManager* _tmp96_;
	const gchar* _tmp97_;
	const gchar* _tmp98_;
	gboolean _tmp109_ = FALSE;
	GalaPluginManager* _tmp110_;
	const gchar* _tmp111_;
	const gchar* _tmp112_;
	ClutterActor* _tmp125_;
	ClutterActor* _tmp126_;
	ClutterActor* _tmp127_;
	ClutterActor* _tmp128_;
	ClutterActor* _tmp129_;
	ClutterActor* feedback_group = NULL;
	MetaDisplay* _tmp130_;
	MetaCompositor* _tmp131_;
	ClutterActor* _tmp132_;
	ClutterActor* _tmp133_;
	ClutterStage* _tmp134_;
	ClutterStage* _tmp135_;
	ClutterActor* _tmp136_;
	ClutterActor* _tmp137_;
	ClutterActor* _tmp138_;
	ClutterActor* _tmp139_;
	MetaDisplay* _tmp140_;
	GalaPointerLocator* _tmp141_;
	GalaPointerLocator* _tmp142_;
	ClutterActor* _tmp143_;
	ClutterActor* _tmp144_;
	GalaPointerLocator* _tmp145_;
	ClutterActor* _tmp146_;
	ClutterActor* _tmp147_;
	MetaDisplay* _tmp148_;
	GalaDwellClickTimer* _tmp149_;
	GalaDwellClickTimer* _tmp150_;
	GalaSessionLocker* session_locker = NULL;
	GalaSessionLocker* _tmp151_;
	ClutterActor* _tmp152_;
	ClutterActor* _tmp153_;
	GalaSessionLocker* _tmp154_;
	GalaSessionLocker* _tmp155_;
	GalaScreenSaverManager* _tmp156_;
	GalaScreenSaverManager* _tmp157_;
	GalaScreenSaverManager* _tmp158_;
	GSettings* keybinding_settings = NULL;
	GSettings* _tmp159_;
	MetaDisplay* _tmp160_;
	GSettings* _tmp161_;
	MetaDisplay* _tmp162_;
	GSettings* _tmp163_;
	MetaDisplay* _tmp164_;
	GSettings* _tmp165_;
	MetaDisplay* _tmp166_;
	GSettings* _tmp167_;
	MetaDisplay* _tmp168_;
	GSettings* _tmp169_;
	MetaDisplay* _tmp170_;
	GSettings* _tmp171_;
	MetaDisplay* _tmp172_;
	GSettings* _tmp173_;
	MetaDisplay* _tmp174_;
	GSettings* _tmp175_;
	MetaDisplay* _tmp176_;
	GSettings* _tmp177_;
	MetaDisplay* _tmp178_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp185_;
	MetaContext* _tmp186_;
	MetaBackend* _tmp187_;
	MetaMonitorManager* _tmp188_;
	GSettings* _tmp189_;
	GSettings* _tmp190_;
	GalaHotCornerManager* _tmp191_;
	GalaHotCornerManager* _tmp192_;
	GalaHotCornerManager* _tmp193_;
	GalaZoom* _tmp194_;
	GalaSuperScrollAction* scroll_action = NULL;
	MetaDisplay* _tmp195_;
	GalaSuperScrollAction* _tmp196_;
	ClutterStage* _tmp197_;
	ClutterStage* _tmp198_;
	MetaDisplay* _tmp199_;
	ClutterStage* _tmp200_;
	ClutterStage* _tmp201_;
	GalaPluginManager* _tmp202_;
#line 172 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/WindowManager.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 172 "../src/WindowManager.vala"
	_data12_->_ref_count_ = 1;
#line 172 "../src/WindowManager.vala"
	_data12_->self = g_object_ref (self);
#line 173 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 173 "../src/WindowManager.vala"
	_data12_->display = _tmp0_;
#line 175 "../src/WindowManager.vala"
	_tmp1_ = gala_notifications_manager_new ();
#line 175 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->notifications_manager);
#line 175 "../src/WindowManager.vala"
	self->priv->notifications_manager = _tmp1_;
#line 176 "../src/WindowManager.vala"
	_tmp2_ = self->priv->notifications_manager;
#line 176 "../src/WindowManager.vala"
	_tmp3_ = gala_screenshot_manager_new ((GalaWindowManager*) self, _tmp2_);
#line 176 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->screenshot_manager);
#line 176 "../src/WindowManager.vala"
	self->priv->screenshot_manager = _tmp3_;
#line 177 "../src/WindowManager.vala"
	_tmp4_ = self->priv->notifications_manager;
#line 177 "../src/WindowManager.vala"
	_tmp5_ = self->priv->screenshot_manager;
#line 177 "../src/WindowManager.vala"
	gala_dbus_init (self, _tmp4_, _tmp5_);
#line 179 "../src/WindowManager.vala"
	_tmp6_ = _data12_->display;
#line 179 "../src/WindowManager.vala"
	gala_window_listener_init (_tmp6_);
#line 180 "../src/WindowManager.vala"
	_tmp7_ = _data12_->display;
#line 180 "../src/WindowManager.vala"
	_tmp8_ = gala_keyboard_manager_new (_tmp7_);
#line 180 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->keyboard_manager);
#line 180 "../src/WindowManager.vala"
	self->priv->keyboard_manager = _tmp8_;
#line 181 "../src/WindowManager.vala"
	_tmp9_ = gala_window_tracker_new ();
#line 181 "../src/WindowManager.vala"
	_tmp10_ = _tmp9_;
#line 181 "../src/WindowManager.vala"
	gala_window_manager_gala_set_window_tracker (self, _tmp10_);
#line 181 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp10_);
#line 182 "../src/WindowManager.vala"
	_tmp11_ = self->priv->_window_tracker;
#line 182 "../src/WindowManager.vala"
	gala_window_state_saver_init (_tmp11_);
#line 183 "../src/WindowManager.vala"
	_tmp12_ = self->priv->_window_tracker;
#line 183 "../src/WindowManager.vala"
	_tmp13_ = _data12_->display;
#line 183 "../src/WindowManager.vala"
	gala_window_tracker_init (_tmp12_, _tmp13_);
#line 185 "../src/WindowManager.vala"
	_tmp14_ = _data12_->display;
#line 185 "../src/WindowManager.vala"
	_tmp15_ = gala_notification_stack_new (_tmp14_);
#line 185 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->notification_stack);
#line 185 "../src/WindowManager.vala"
	self->priv->notification_stack = _tmp15_;
#line 188 "../src/WindowManager.vala"
	_tmp16_ = _data12_->display;
#line 188 "../src/WindowManager.vala"
	_tmp17_ = meta_display_get_compositor (_tmp16_);
#line 188 "../src/WindowManager.vala"
	_tmp18_ = meta_compositor_get_stage (_tmp17_);
#line 188 "../src/WindowManager.vala"
	gala_window_manager_set_stage ((GalaWindowManager*) self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, clutter_stage_get_type ()) ? ((ClutterStage*) _tmp18_) : NULL);
#line 192 "../src/WindowManager.vala"
	_tmp19_ = g_settings_new ("org.gnome.desktop.background");
#line 192 "../src/WindowManager.vala"
	background_settings = _tmp19_;
#line 193 "../src/WindowManager.vala"
	_tmp20_ = background_settings;
#line 193 "../src/WindowManager.vala"
	_tmp21_ = g_settings_get_string (_tmp20_, "primary-color");
#line 193 "../src/WindowManager.vala"
	color = _tmp21_;
#line 195 "../src/WindowManager.vala"
	_tmp22_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 195 "../src/WindowManager.vala"
	_tmp23_ = _tmp22_;
#line 195 "../src/WindowManager.vala"
	_tmp24_ = color;
#line 195 "../src/WindowManager.vala"
	_tmp25_ = _vala_cogl_color_from_string (_tmp24_);
#line 195 "../src/WindowManager.vala"
	_tmp26_ = _tmp25_;
#line 195 "../src/WindowManager.vala"
	_tmp27_ = *_tmp26_;
#line 195 "../src/WindowManager.vala"
	clutter_actor_set_background_color ((ClutterActor*) _tmp23_, &_tmp27_);
#line 195 "../src/WindowManager.vala"
	__vala_CoglColor_free0 (_tmp26_);
#line 200 "../src/WindowManager.vala"
	_tmp28_ = _data12_->display;
#line 200 "../src/WindowManager.vala"
	_tmp29_ = meta_display_get_compositor (_tmp28_);
#line 200 "../src/WindowManager.vala"
	_tmp30_ = meta_compositor_get_laters (_tmp29_);
#line 200 "../src/WindowManager.vala"
	laters = _tmp30_;
#line 201 "../src/WindowManager.vala"
	_tmp31_ = laters;
#line 201 "../src/WindowManager.vala"
	meta_laters_add (_tmp31_, META_LATER_BEFORE_REDRAW, ___lambda142__gsource_func, g_object_ref (self), g_object_unref);
#line 223 "../src/WindowManager.vala"
	_tmp32_ = _data12_->display;
#line 223 "../src/WindowManager.vala"
	_tmp33_ = gala_system_background_new (_tmp32_);
#line 223 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->system_background);
#line 223 "../src/WindowManager.vala"
	self->priv->system_background = _tmp33_;
#line 225 "../src/WindowManager.vala"
	_tmp34_ = self->priv->system_background;
#line 225 "../src/WindowManager.vala"
	_tmp35_ = gala_system_background_get_background_actor (_tmp34_);
#line 225 "../src/WindowManager.vala"
	_tmp36_ = _tmp35_;
#line 225 "../src/WindowManager.vala"
	_tmp37_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 225 "../src/WindowManager.vala"
	_tmp38_ = _tmp37_;
#line 225 "../src/WindowManager.vala"
	_tmp39_ = (ClutterBindConstraint*) clutter_bind_constraint_new ((ClutterActor*) _tmp38_, CLUTTER_BIND_ALL, (gfloat) 0);
#line 225 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp39_);
#line 225 "../src/WindowManager.vala"
	_tmp40_ = _tmp39_;
#line 225 "../src/WindowManager.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp36_, (ClutterConstraint*) _tmp40_);
#line 225 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp40_);
#line 227 "../src/WindowManager.vala"
	_tmp41_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 227 "../src/WindowManager.vala"
	_tmp42_ = _tmp41_;
#line 227 "../src/WindowManager.vala"
	_tmp43_ = self->priv->system_background;
#line 227 "../src/WindowManager.vala"
	_tmp44_ = gala_system_background_get_background_actor (_tmp43_);
#line 227 "../src/WindowManager.vala"
	_tmp45_ = _tmp44_;
#line 227 "../src/WindowManager.vala"
	clutter_actor_insert_child_below ((ClutterActor*) _tmp42_, (ClutterActor*) _tmp45_, NULL);
#line 229 "../src/WindowManager.vala"
	_tmp46_ = clutter_actor_new ();
#line 229 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp46_);
#line 229 "../src/WindowManager.vala"
	_tmp47_ = _tmp46_;
#line 229 "../src/WindowManager.vala"
	gala_window_manager_set_ui_group ((GalaWindowManager*) self, _tmp47_);
#line 229 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp47_);
#line 230 "../src/WindowManager.vala"
	gala_window_manager_gala_update_ui_group_size (self);
#line 231 "../src/WindowManager.vala"
	_tmp48_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 231 "../src/WindowManager.vala"
	_tmp49_ = _tmp48_;
#line 231 "../src/WindowManager.vala"
	_tmp50_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 231 "../src/WindowManager.vala"
	_tmp51_ = _tmp50_;
#line 231 "../src/WindowManager.vala"
	clutter_actor_add_child ((ClutterActor*) _tmp49_, _tmp51_);
#line 234 "../src/WindowManager.vala"
	_tmp52_ = _data12_->display;
#line 234 "../src/WindowManager.vala"
	_tmp53_ = meta_display_get_compositor (_tmp52_);
#line 234 "../src/WindowManager.vala"
	_tmp54_ = meta_compositor_get_window_group (_tmp53_);
#line 234 "../src/WindowManager.vala"
	gala_window_manager_set_window_group ((GalaWindowManager*) self, _tmp54_);
#line 238 "../src/WindowManager.vala"
	_tmp55_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 238 "../src/WindowManager.vala"
	_tmp56_ = _tmp55_;
#line 238 "../src/WindowManager.vala"
	_tmp57_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 238 "../src/WindowManager.vala"
	_tmp58_ = _tmp57_;
#line 238 "../src/WindowManager.vala"
	clutter_actor_remove_child ((ClutterActor*) _tmp56_, _tmp58_);
#line 239 "../src/WindowManager.vala"
	_tmp59_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 239 "../src/WindowManager.vala"
	_tmp60_ = _tmp59_;
#line 239 "../src/WindowManager.vala"
	_tmp61_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 239 "../src/WindowManager.vala"
	_tmp62_ = _tmp61_;
#line 239 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp60_, _tmp62_);
#line 241 "../src/WindowManager.vala"
	_tmp63_ = _data12_->display;
#line 241 "../src/WindowManager.vala"
	_tmp64_ = gala_background_container_new (_tmp63_);
#line 241 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp64_);
#line 241 "../src/WindowManager.vala"
	_tmp65_ = _tmp64_;
#line 241 "../src/WindowManager.vala"
	gala_window_manager_set_background_group ((GalaWindowManager*) self, (MetaBackgroundGroup*) _tmp65_);
#line 241 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp65_);
#line 242 "../src/WindowManager.vala"
	_tmp66_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 242 "../src/WindowManager.vala"
	_tmp67_ = _tmp66_;
#line 242 "../src/WindowManager.vala"
	_tmp68_ = self->priv->daemon_manager;
#line 242 "../src/WindowManager.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, GALA_TYPE_BACKGROUND_CONTAINER, GalaBackgroundContainer), "show-background-menu", (GCallback) _gala_daemon_manager_show_background_menu_gala_background_container_show_background_menu, _tmp68_, 0);
#line 243 "../src/WindowManager.vala"
	_tmp69_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 243 "../src/WindowManager.vala"
	_tmp70_ = _tmp69_;
#line 243 "../src/WindowManager.vala"
	_tmp71_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 243 "../src/WindowManager.vala"
	_tmp72_ = _tmp71_;
#line 243 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp70_, (ClutterActor*) _tmp72_);
#line 244 "../src/WindowManager.vala"
	_tmp73_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 244 "../src/WindowManager.vala"
	_tmp74_ = _tmp73_;
#line 244 "../src/WindowManager.vala"
	_tmp75_ = gala_window_manager_get_background_group ((GalaWindowManager*) self);
#line 244 "../src/WindowManager.vala"
	_tmp76_ = _tmp75_;
#line 244 "../src/WindowManager.vala"
	clutter_actor_set_child_below_sibling (_tmp74_, (ClutterActor*) _tmp76_, NULL);
#line 247 "../src/WindowManager.vala"
	_tmp77_ = _data12_->display;
#line 247 "../src/WindowManager.vala"
	_tmp78_ = meta_display_get_compositor (_tmp77_);
#line 247 "../src/WindowManager.vala"
	_tmp79_ = meta_compositor_get_top_window_group (_tmp78_);
#line 247 "../src/WindowManager.vala"
	gala_window_manager_set_top_window_group ((GalaWindowManager*) self, _tmp79_);
#line 251 "../src/WindowManager.vala"
	_tmp80_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 251 "../src/WindowManager.vala"
	_tmp81_ = _tmp80_;
#line 251 "../src/WindowManager.vala"
	_tmp82_ = gala_window_manager_get_top_window_group ((GalaWindowManager*) self);
#line 251 "../src/WindowManager.vala"
	_tmp83_ = _tmp82_;
#line 251 "../src/WindowManager.vala"
	clutter_actor_remove_child ((ClutterActor*) _tmp81_, _tmp83_);
#line 252 "../src/WindowManager.vala"
	_tmp84_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 252 "../src/WindowManager.vala"
	_tmp85_ = _tmp84_;
#line 252 "../src/WindowManager.vala"
	_tmp86_ = gala_window_manager_get_top_window_group ((GalaWindowManager*) self);
#line 252 "../src/WindowManager.vala"
	_tmp87_ = _tmp86_;
#line 252 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp85_, _tmp87_);
#line 255 "../src/WindowManager.vala"
	_tmp88_ = gala_plugin_manager_get_default ();
#line 255 "../src/WindowManager.vala"
	plugin_manager = _tmp88_;
#line 256 "../src/WindowManager.vala"
	_tmp89_ = plugin_manager;
#line 256 "../src/WindowManager.vala"
	gala_plugin_manager_initialize (_tmp89_, (GalaWindowManager*) self);
#line 257 "../src/WindowManager.vala"
	_tmp90_ = plugin_manager;
#line 257 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp90_, "regions-changed", (GCallback) _gala_window_manager_gala_update_input_area_gala_plugin_manager_regions_changed, self, 0);
#line 259 "../src/WindowManager.vala"
	_tmp91_ = gala_multitasking_view_new (self);
#line 259 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp91_);
#line 259 "../src/WindowManager.vala"
	_tmp92_ = _tmp91_;
#line 259 "../src/WindowManager.vala"
	gala_window_manager_gala_set_multitasking_view (self, _tmp92_);
#line 259 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp92_);
#line 260 "../src/WindowManager.vala"
	_tmp93_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 260 "../src/WindowManager.vala"
	_tmp94_ = _tmp93_;
#line 260 "../src/WindowManager.vala"
	_tmp95_ = self->priv->_multitasking_view;
#line 260 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp94_, (ClutterActor*) _tmp95_);
#line 262 "../src/WindowManager.vala"
	_tmp96_ = plugin_manager;
#line 262 "../src/WindowManager.vala"
	_tmp97_ = gala_plugin_manager_get_window_switcher_provider (_tmp96_);
#line 262 "../src/WindowManager.vala"
	_tmp98_ = _tmp97_;
#line 262 "../src/WindowManager.vala"
	if (_tmp98_ == NULL) {
#line 2597 "WindowManager.c"
		GalaWindowSwitcher* _tmp99_;
		ClutterActor* _tmp100_;
		ClutterActor* _tmp101_;
		GalaWindowSwitcher* _tmp102_;
		GalaWindowSwitcher* _tmp103_;
		GalaWindowSwitcher* _tmp104_;
		GalaWindowSwitcher* _tmp105_;
		GalaWindowSwitcher* _tmp106_;
		GalaWindowSwitcher* _tmp107_;
		GalaWindowSwitcher* _tmp108_;
#line 263 "../src/WindowManager.vala"
		_tmp99_ = gala_window_switcher_new ((GalaWindowManager*) self);
#line 263 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp99_);
#line 263 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->window_switcher);
#line 263 "../src/WindowManager.vala"
		self->priv->window_switcher = _tmp99_;
#line 264 "../src/WindowManager.vala"
		_tmp100_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 264 "../src/WindowManager.vala"
		_tmp101_ = _tmp100_;
#line 264 "../src/WindowManager.vala"
		_tmp102_ = self->priv->window_switcher;
#line 264 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp101_, (ClutterActor*) _tmp102_);
#line 266 "../src/WindowManager.vala"
		_tmp103_ = self->priv->window_switcher;
#line 266 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-applications", _gala_window_switcher_handle_switch_windows_meta_key_handler_func, g_object_ref (_tmp103_), g_object_unref);
#line 267 "../src/WindowManager.vala"
		_tmp104_ = self->priv->window_switcher;
#line 267 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-applications-backward", _gala_window_switcher_handle_switch_windows_meta_key_handler_func, g_object_ref (_tmp104_), g_object_unref);
#line 268 "../src/WindowManager.vala"
		_tmp105_ = self->priv->window_switcher;
#line 268 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-windows", _gala_window_switcher_handle_switch_windows_meta_key_handler_func, g_object_ref (_tmp105_), g_object_unref);
#line 269 "../src/WindowManager.vala"
		_tmp106_ = self->priv->window_switcher;
#line 269 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-windows-backward", _gala_window_switcher_handle_switch_windows_meta_key_handler_func, g_object_ref (_tmp106_), g_object_unref);
#line 270 "../src/WindowManager.vala"
		_tmp107_ = self->priv->window_switcher;
#line 270 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-group", _gala_window_switcher_handle_switch_windows_meta_key_handler_func, g_object_ref (_tmp107_), g_object_unref);
#line 271 "../src/WindowManager.vala"
		_tmp108_ = self->priv->window_switcher;
#line 271 "../src/WindowManager.vala"
		meta_keybindings_set_custom_handler ("switch-group-backward", _gala_window_switcher_handle_switch_windows_meta_key_handler_func, g_object_ref (_tmp108_), g_object_unref);
#line 2648 "WindowManager.c"
	}
#line 274 "../src/WindowManager.vala"
	_tmp110_ = plugin_manager;
#line 274 "../src/WindowManager.vala"
	_tmp111_ = gala_plugin_manager_get_window_overview_provider (_tmp110_);
#line 274 "../src/WindowManager.vala"
	_tmp112_ = _tmp111_;
#line 274 "../src/WindowManager.vala"
	if (_tmp112_ == NULL) {
#line 274 "../src/WindowManager.vala"
		_tmp109_ = TRUE;
#line 2660 "WindowManager.c"
	} else {
		GalaPluginManager* _tmp113_;
		GalaPluginManager* _tmp114_;
		const gchar* _tmp115_;
		const gchar* _tmp116_;
		GalaPlugin* _tmp117_;
		GalaActivatableComponent* _tmp118_;
		GalaActivatableComponent* _tmp119_;
#line 275 "../src/WindowManager.vala"
		_tmp113_ = plugin_manager;
#line 275 "../src/WindowManager.vala"
		_tmp114_ = plugin_manager;
#line 275 "../src/WindowManager.vala"
		_tmp115_ = gala_plugin_manager_get_window_overview_provider (_tmp114_);
#line 275 "../src/WindowManager.vala"
		_tmp116_ = _tmp115_;
#line 275 "../src/WindowManager.vala"
		_tmp117_ = gala_plugin_manager_get_plugin (_tmp113_, _tmp116_);
#line 275 "../src/WindowManager.vala"
		_tmp118_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp117_, GALA_TYPE_ACTIVATABLE_COMPONENT) ? ((GalaActivatableComponent*) _tmp117_) : NULL;
#line 275 "../src/WindowManager.vala"
		if (_tmp118_ == NULL) {
#line 275 "../src/WindowManager.vala"
			_g_object_unref0 (_tmp117_);
#line 2685 "WindowManager.c"
		}
#line 275 "../src/WindowManager.vala"
		_tmp119_ = _tmp118_;
#line 275 "../src/WindowManager.vala"
		gala_window_manager_gala_set_window_overview (self, _tmp119_);
#line 275 "../src/WindowManager.vala"
		_tmp109_ = _tmp119_ == NULL;
#line 275 "../src/WindowManager.vala"
		_g_object_unref0 (_tmp119_);
#line 2695 "WindowManager.c"
	}
#line 274 "../src/WindowManager.vala"
	if (_tmp109_) {
#line 2699 "WindowManager.c"
		GalaWindowOverview* _tmp120_;
		GalaWindowOverview* _tmp121_;
		ClutterActor* _tmp122_;
		ClutterActor* _tmp123_;
		GalaActivatableComponent* _tmp124_;
#line 277 "../src/WindowManager.vala"
		_tmp120_ = gala_window_overview_new ((GalaWindowManager*) self);
#line 277 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp120_);
#line 277 "../src/WindowManager.vala"
		_tmp121_ = _tmp120_;
#line 277 "../src/WindowManager.vala"
		gala_window_manager_gala_set_window_overview (self, (GalaActivatableComponent*) _tmp121_);
#line 277 "../src/WindowManager.vala"
		_g_object_unref0 (_tmp121_);
#line 278 "../src/WindowManager.vala"
		_tmp122_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 278 "../src/WindowManager.vala"
		_tmp123_ = _tmp122_;
#line 278 "../src/WindowManager.vala"
		_tmp124_ = self->priv->_window_overview;
#line 278 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp123_, G_TYPE_CHECK_INSTANCE_CAST (_tmp124_, clutter_actor_get_type (), ClutterActor));
#line 2723 "WindowManager.c"
	}
#line 282 "../src/WindowManager.vala"
	_tmp125_ = clutter_actor_new ();
#line 282 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp125_);
#line 282 "../src/WindowManager.vala"
	_tmp126_ = _tmp125_;
#line 282 "../src/WindowManager.vala"
	gala_window_manager_gala_set_shell_group (self, _tmp126_);
#line 282 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp126_);
#line 283 "../src/WindowManager.vala"
	_tmp127_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 283 "../src/WindowManager.vala"
	_tmp128_ = _tmp127_;
#line 283 "../src/WindowManager.vala"
	_tmp129_ = self->priv->_shell_group;
#line 283 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp128_, _tmp129_);
#line 285 "../src/WindowManager.vala"
	_tmp130_ = _data12_->display;
#line 285 "../src/WindowManager.vala"
	_tmp131_ = meta_display_get_compositor (_tmp130_);
#line 285 "../src/WindowManager.vala"
	_tmp132_ = meta_compositor_get_feedback_group (_tmp131_);
#line 285 "../src/WindowManager.vala"
	_tmp133_ = _g_object_ref0 (_tmp132_);
#line 285 "../src/WindowManager.vala"
	feedback_group = _tmp133_;
#line 286 "../src/WindowManager.vala"
	_tmp134_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 286 "../src/WindowManager.vala"
	_tmp135_ = _tmp134_;
#line 286 "../src/WindowManager.vala"
	_tmp136_ = feedback_group;
#line 286 "../src/WindowManager.vala"
	clutter_actor_remove_child ((ClutterActor*) _tmp135_, _tmp136_);
#line 287 "../src/WindowManager.vala"
	_tmp137_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 287 "../src/WindowManager.vala"
	_tmp138_ = _tmp137_;
#line 287 "../src/WindowManager.vala"
	_tmp139_ = feedback_group;
#line 287 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp138_, _tmp139_);
#line 289 "../src/WindowManager.vala"
	_tmp140_ = _data12_->display;
#line 289 "../src/WindowManager.vala"
	_tmp141_ = gala_pointer_locator_new (_tmp140_);
#line 289 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp141_);
#line 289 "../src/WindowManager.vala"
	_tmp142_ = _tmp141_;
#line 289 "../src/WindowManager.vala"
	gala_window_manager_gala_set_pointer_locator (self, _tmp142_);
#line 289 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp142_);
#line 290 "../src/WindowManager.vala"
	_tmp143_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 290 "../src/WindowManager.vala"
	_tmp144_ = _tmp143_;
#line 290 "../src/WindowManager.vala"
	_tmp145_ = self->priv->_pointer_locator;
#line 290 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp144_, (ClutterActor*) _tmp145_);
#line 291 "../src/WindowManager.vala"
	_tmp146_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 291 "../src/WindowManager.vala"
	_tmp147_ = _tmp146_;
#line 291 "../src/WindowManager.vala"
	_tmp148_ = _data12_->display;
#line 291 "../src/WindowManager.vala"
	_tmp149_ = gala_dwell_click_timer_new (_tmp148_);
#line 291 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp149_);
#line 291 "../src/WindowManager.vala"
	_tmp150_ = _tmp149_;
#line 291 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp147_, (ClutterActor*) _tmp150_);
#line 291 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp150_);
#line 293 "../src/WindowManager.vala"
	_tmp151_ = gala_session_locker_new ((GalaWindowManager*) self);
#line 293 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp151_);
#line 293 "../src/WindowManager.vala"
	session_locker = _tmp151_;
#line 294 "../src/WindowManager.vala"
	_tmp152_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 294 "../src/WindowManager.vala"
	_tmp153_ = _tmp152_;
#line 294 "../src/WindowManager.vala"
	_tmp154_ = session_locker;
#line 294 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp153_, (ClutterActor*) _tmp154_);
#line 296 "../src/WindowManager.vala"
	_tmp155_ = session_locker;
#line 296 "../src/WindowManager.vala"
	_tmp156_ = gala_screen_saver_manager_new (_tmp155_);
#line 296 "../src/WindowManager.vala"
	_tmp157_ = _tmp156_;
#line 296 "../src/WindowManager.vala"
	gala_window_manager_gala_set_screensaver (self, _tmp157_);
#line 296 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp157_);
#line 300 "../src/WindowManager.vala"
	_tmp158_ = self->priv->_screensaver;
#line 300 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp158_, "active-changed", (GCallback) _gala_window_manager_gala_update_input_area_gala_screen_saver_manager_active_changed, self, 0);
#line 302 "../src/WindowManager.vala"
	gala_filter_manager_init ((GalaWindowManager*) self);
#line 305 "../src/WindowManager.vala"
	_tmp159_ = g_settings_new ("io.elementary.desktop.wm.keybindings");
#line 305 "../src/WindowManager.vala"
	keybinding_settings = _tmp159_;
#line 307 "../src/WindowManager.vala"
	_tmp160_ = _data12_->display;
#line 307 "../src/WindowManager.vala"
	_tmp161_ = keybinding_settings;
#line 307 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp160_, "switch-to-workspace-first", _tmp161_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_window_manager_gala_handle_switch_to_workspace_end_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 308 "../src/WindowManager.vala"
	_tmp162_ = _data12_->display;
#line 308 "../src/WindowManager.vala"
	_tmp163_ = keybinding_settings;
#line 308 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp162_, "switch-to-workspace-last", _tmp163_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_window_manager_gala_handle_switch_to_workspace_end_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 309 "../src/WindowManager.vala"
	_tmp164_ = _data12_->display;
#line 309 "../src/WindowManager.vala"
	_tmp165_ = keybinding_settings;
#line 309 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp164_, "move-to-workspace-first", _tmp165_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_window_manager_gala_handle_move_to_workspace_end_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 310 "../src/WindowManager.vala"
	_tmp166_ = _data12_->display;
#line 310 "../src/WindowManager.vala"
	_tmp167_ = keybinding_settings;
#line 310 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp166_, "move-to-workspace-last", _tmp167_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_window_manager_gala_handle_move_to_workspace_end_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 311 "../src/WindowManager.vala"
	_tmp168_ = _data12_->display;
#line 311 "../src/WindowManager.vala"
	_tmp169_ = keybinding_settings;
#line 311 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp168_, "cycle-workspaces-next", _tmp169_, META_KEY_BINDING_NONE, _gala_window_manager_gala_handle_cycle_workspaces_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 312 "../src/WindowManager.vala"
	_tmp170_ = _data12_->display;
#line 312 "../src/WindowManager.vala"
	_tmp171_ = keybinding_settings;
#line 312 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp170_, "cycle-workspaces-previous", _tmp171_, META_KEY_BINDING_NONE, _gala_window_manager_gala_handle_cycle_workspaces_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 313 "../src/WindowManager.vala"
	_tmp172_ = _data12_->display;
#line 313 "../src/WindowManager.vala"
	_tmp173_ = keybinding_settings;
#line 313 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp172_, "panel-main-menu", _tmp173_, META_KEY_BINDING_IGNORE_AUTOREPEAT, _gala_window_manager_gala_handle_applications_menu_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 315 "../src/WindowManager.vala"
	_tmp174_ = _data12_->display;
#line 315 "../src/WindowManager.vala"
	_tmp175_ = keybinding_settings;
#line 315 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp174_, "toggle-multitasking-view", _tmp175_, META_KEY_BINDING_IGNORE_AUTOREPEAT, ___lambda157__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 323 "../src/WindowManager.vala"
	_tmp176_ = _data12_->display;
#line 323 "../src/WindowManager.vala"
	_tmp177_ = keybinding_settings;
#line 323 "../src/WindowManager.vala"
	meta_display_add_keybinding (_tmp176_, "expose-all-windows", _tmp177_, META_KEY_BINDING_IGNORE_AUTOREPEAT, ___lambda158__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 331 "../src/WindowManager.vala"
	_tmp178_ = _data12_->display;
#line 331 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp178_, "overlay-key", (GCallback) ___lambda159__meta_display_overlay_key, self, 0);
#line 335 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("toggle-recording", ___lambda160__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 339 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-up", ___lambda161__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 340 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-down", ___lambda162__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 341 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-left", _gala_window_manager_gala_handle_switch_to_workspace_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 342 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("switch-to-workspace-right", _gala_window_manager_gala_handle_switch_to_workspace_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 344 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-up", ___lambda163__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 345 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-down", ___lambda164__meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 346 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-left", _gala_window_manager_gala_handle_move_to_workspace_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 347 "../src/WindowManager.vala"
	meta_keybindings_set_custom_handler ("move-to-workspace-right", _gala_window_manager_gala_handle_move_to_workspace_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 2915 "WindowManager.c"
	{
		gint i = 0;
#line 349 "../src/WindowManager.vala"
		i = 1;
#line 2920 "WindowManager.c"
		{
			gboolean _tmp179_ = FALSE;
#line 349 "../src/WindowManager.vala"
			_tmp179_ = TRUE;
#line 349 "../src/WindowManager.vala"
			while (TRUE) {
#line 2927 "WindowManager.c"
				gchar* _tmp181_;
				gchar* _tmp182_;
				gchar* _tmp183_;
				gchar* _tmp184_;
#line 349 "../src/WindowManager.vala"
				if (!_tmp179_) {
#line 2934 "WindowManager.c"
					gint _tmp180_;
#line 349 "../src/WindowManager.vala"
					_tmp180_ = i;
#line 349 "../src/WindowManager.vala"
					i = _tmp180_ + 1;
#line 2940 "WindowManager.c"
				}
#line 349 "../src/WindowManager.vala"
				_tmp179_ = FALSE;
#line 349 "../src/WindowManager.vala"
				if (!(i < 13)) {
#line 349 "../src/WindowManager.vala"
					break;
#line 2948 "WindowManager.c"
				}
#line 350 "../src/WindowManager.vala"
				_tmp181_ = g_strdup_printf ("switch-to-workspace-%d", i);
#line 350 "../src/WindowManager.vala"
				_tmp182_ = _tmp181_;
#line 350 "../src/WindowManager.vala"
				meta_keybindings_set_custom_handler (_tmp182_, _gala_window_manager_gala_handle_switch_to_workspace_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 350 "../src/WindowManager.vala"
				_g_free0 (_tmp182_);
#line 351 "../src/WindowManager.vala"
				_tmp183_ = g_strdup_printf ("move-to-workspace-%d", i);
#line 351 "../src/WindowManager.vala"
				_tmp184_ = _tmp183_;
#line 351 "../src/WindowManager.vala"
				meta_keybindings_set_custom_handler (_tmp184_, _gala_window_manager_gala_handle_move_to_workspace_meta_key_handler_func, g_object_ref (self), g_object_unref);
#line 351 "../src/WindowManager.vala"
				_g_free0 (_tmp184_);
#line 2966 "WindowManager.c"
			}
		}
	}
#line 354 "../src/WindowManager.vala"
	_tmp185_ = _data12_->display;
#line 354 "../src/WindowManager.vala"
	_tmp186_ = meta_display_get_context (_tmp185_);
#line 354 "../src/WindowManager.vala"
	_tmp187_ = meta_context_get_backend (_tmp186_);
#line 354 "../src/WindowManager.vala"
	_tmp188_ = meta_backend_get_monitor_manager (_tmp187_);
#line 354 "../src/WindowManager.vala"
	monitor_manager = _tmp188_;
#line 355 "../src/WindowManager.vala"
	g_signal_connect_object (monitor_manager, "monitors-changed", (GCallback) _gala_window_manager_gala_update_ui_group_size_meta_monitor_manager_monitors_changed, self, 0);
#line 357 "../src/WindowManager.vala"
	_tmp189_ = self->priv->behavior_settings;
#line 357 "../src/WindowManager.vala"
	_tmp190_ = self->priv->new_behavior_settings;
#line 357 "../src/WindowManager.vala"
	_tmp191_ = gala_hot_corner_manager_new ((GalaWindowManager*) self, _tmp189_, _tmp190_);
#line 357 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->hot_corner_manager);
#line 357 "../src/WindowManager.vala"
	self->priv->hot_corner_manager = _tmp191_;
#line 358 "../src/WindowManager.vala"
	_tmp192_ = self->priv->hot_corner_manager;
#line 358 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp192_, "on-configured", (GCallback) _gala_window_manager_gala_update_input_area_gala_hot_corner_manager_on_configured, self, 0);
#line 359 "../src/WindowManager.vala"
	_tmp193_ = self->priv->hot_corner_manager;
#line 359 "../src/WindowManager.vala"
	gala_hot_corner_manager_configure (_tmp193_);
#line 361 "../src/WindowManager.vala"
	_tmp194_ = gala_zoom_new ((GalaWindowManager*) self);
#line 361 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->zoom);
#line 361 "../src/WindowManager.vala"
	self->priv->zoom = _tmp194_;
#line 363 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area (self);
#line 365 "../src/WindowManager.vala"
	_tmp195_ = _data12_->display;
#line 365 "../src/WindowManager.vala"
	_tmp196_ = gala_super_scroll_action_new (_tmp195_);
#line 365 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp196_);
#line 365 "../src/WindowManager.vala"
	scroll_action = _tmp196_;
#line 366 "../src/WindowManager.vala"
	g_signal_connect_object (scroll_action, "triggered", (GCallback) _gala_window_manager_gala_handle_super_scroll_gala_super_scroll_action_triggered, self, 0);
#line 367 "../src/WindowManager.vala"
	_tmp197_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 367 "../src/WindowManager.vala"
	_tmp198_ = _tmp197_;
#line 367 "../src/WindowManager.vala"
	clutter_actor_add_action_full ((ClutterActor*) _tmp198_, "wm-super-scroll-action", CLUTTER_PHASE_CAPTURE, (ClutterAction*) scroll_action);
#line 369 "../src/WindowManager.vala"
	_tmp199_ = _data12_->display;
#line 369 "../src/WindowManager.vala"
	g_signal_connect_object (_tmp199_, "window-created", (GCallback) ___lambda165__meta_display_window_created, self, 0);
#line 373 "../src/WindowManager.vala"
	_tmp200_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 373 "../src/WindowManager.vala"
	_tmp201_ = _tmp200_;
#line 373 "../src/WindowManager.vala"
	clutter_actor_show ((ClutterActor*) _tmp201_);
#line 375 "../src/WindowManager.vala"
	_tmp202_ = plugin_manager;
#line 375 "../src/WindowManager.vala"
	gala_plugin_manager_load_waiting_plugins (_tmp202_);
#line 377 "../src/WindowManager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda166__gsource_func, block12_data_ref (_data12_), block12_data_unref);
#line 172 "../src/WindowManager.vala"
	_g_object_unref0 (scroll_action);
#line 172 "../src/WindowManager.vala"
	_g_object_unref0 (keybinding_settings);
#line 172 "../src/WindowManager.vala"
	_g_object_unref0 (session_locker);
#line 172 "../src/WindowManager.vala"
	_g_object_unref0 (feedback_group);
#line 172 "../src/WindowManager.vala"
	_g_free0 (color);
#line 172 "../src/WindowManager.vala"
	_g_object_unref0 (background_settings);
#line 172 "../src/WindowManager.vala"
	block12_data_unref (_data12_);
#line 172 "../src/WindowManager.vala"
	_data12_ = NULL;
#line 3056 "WindowManager.c"
}

static void
gala_window_manager_gala_init_a11y (GalaWindowManagerGala* self)
{
	gchar** args = NULL;
	gchar** _tmp0_;
	gint args_length1;
	gint _args_size_;
	gchar** _args = NULL;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gint _args_length1;
	gint __args_size_;
#line 387 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 388 "../src/WindowManager.vala"
	if (!clutter_get_accessibility_enabled ()) {
#line 389 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:389: Clutter has no accessibility enabled");
#line 390 "../src/WindowManager.vala"
		return;
#line 3079 "WindowManager.c"
	}
#line 393 "../src/WindowManager.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 393 "../src/WindowManager.vala"
	args = _tmp0_;
#line 393 "../src/WindowManager.vala"
	args_length1 = 0;
#line 393 "../src/WindowManager.vala"
	_args_size_ = args_length1;
#line 394 "../src/WindowManager.vala"
	_tmp1_ = args;
#line 394 "../src/WindowManager.vala"
	_tmp1__length1 = args_length1;
#line 394 "../src/WindowManager.vala"
	_args = _tmp1_;
#line 394 "../src/WindowManager.vala"
	_args_length1 = _tmp1__length1;
#line 394 "../src/WindowManager.vala"
	__args_size_ = _args_length1;
#line 395 "../src/WindowManager.vala"
	atk_bridge_adaptor_init ((gint*) (&_args_length1), &_args);
#line 395 "../src/WindowManager.vala"
	__args_size_ = _args_length1;
#line 387 "../src/WindowManager.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 3105 "WindowManager.c"
}

static void
gala_window_manager_gala_update_ui_group_size (GalaWindowManagerGala* self)
{
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	gint max_width = 0;
	gint max_height = 0;
	gint num_monitors = 0;
	MetaDisplay* _tmp1_;
	ClutterActor* _tmp12_;
	ClutterActor* _tmp13_;
#line 398 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 399 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 399 "../src/WindowManager.vala"
	display = _tmp0_;
#line 401 "../src/WindowManager.vala"
	max_width = 0;
#line 402 "../src/WindowManager.vala"
	max_height = 0;
#line 404 "../src/WindowManager.vala"
	_tmp1_ = display;
#line 404 "../src/WindowManager.vala"
	num_monitors = meta_display_get_n_monitors (_tmp1_);
#line 3133 "WindowManager.c"
	{
		gint i = 0;
#line 405 "../src/WindowManager.vala"
		i = 0;
#line 3138 "WindowManager.c"
		{
			gboolean _tmp2_ = FALSE;
#line 405 "../src/WindowManager.vala"
			_tmp2_ = TRUE;
#line 405 "../src/WindowManager.vala"
			while (TRUE) {
#line 3145 "WindowManager.c"
				MtkRectangle geom = {0};
				MetaDisplay* _tmp4_;
				MtkRectangle _tmp5_ = {0};
				gint total_width = 0;
				MtkRectangle _tmp6_;
				MtkRectangle _tmp7_;
				gint total_height = 0;
				MtkRectangle _tmp8_;
				MtkRectangle _tmp9_;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
#line 405 "../src/WindowManager.vala"
				if (!_tmp2_) {
#line 3159 "WindowManager.c"
					gint _tmp3_;
#line 405 "../src/WindowManager.vala"
					_tmp3_ = i;
#line 405 "../src/WindowManager.vala"
					i = _tmp3_ + 1;
#line 3165 "WindowManager.c"
				}
#line 405 "../src/WindowManager.vala"
				_tmp2_ = FALSE;
#line 405 "../src/WindowManager.vala"
				if (!(i < num_monitors)) {
#line 405 "../src/WindowManager.vala"
					break;
#line 3173 "WindowManager.c"
				}
#line 406 "../src/WindowManager.vala"
				_tmp4_ = display;
#line 406 "../src/WindowManager.vala"
				meta_display_get_monitor_geometry (_tmp4_, i, &_tmp5_);
#line 406 "../src/WindowManager.vala"
				geom = _tmp5_;
#line 407 "../src/WindowManager.vala"
				_tmp6_ = geom;
#line 407 "../src/WindowManager.vala"
				_tmp7_ = geom;
#line 407 "../src/WindowManager.vala"
				total_width = _tmp6_.x + _tmp7_.width;
#line 408 "../src/WindowManager.vala"
				_tmp8_ = geom;
#line 408 "../src/WindowManager.vala"
				_tmp9_ = geom;
#line 408 "../src/WindowManager.vala"
				total_height = _tmp8_.y + _tmp9_.height;
#line 410 "../src/WindowManager.vala"
				if (max_width > total_width) {
#line 410 "../src/WindowManager.vala"
					_tmp10_ = max_width;
#line 3197 "WindowManager.c"
				} else {
#line 410 "../src/WindowManager.vala"
					_tmp10_ = total_width;
#line 3201 "WindowManager.c"
				}
#line 410 "../src/WindowManager.vala"
				max_width = _tmp10_;
#line 411 "../src/WindowManager.vala"
				if (max_height > total_height) {
#line 411 "../src/WindowManager.vala"
					_tmp11_ = max_height;
#line 3209 "WindowManager.c"
				} else {
#line 411 "../src/WindowManager.vala"
					_tmp11_ = total_height;
#line 3213 "WindowManager.c"
				}
#line 411 "../src/WindowManager.vala"
				max_height = _tmp11_;
#line 3217 "WindowManager.c"
			}
		}
	}
#line 414 "../src/WindowManager.vala"
	_tmp12_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 414 "../src/WindowManager.vala"
	_tmp13_ = _tmp12_;
#line 414 "../src/WindowManager.vala"
	clutter_actor_set_size (_tmp13_, (gfloat) max_width, (gfloat) max_height);
#line 3227 "WindowManager.c"
}

static void
gala_window_manager_gala_real_launch_action (GalaWindowManager* base,
                                             const gchar* action_key)
{
	GalaWindowManagerGala * self;
	GError* _inner_error0_ = NULL;
#line 417 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 417 "../src/WindowManager.vala"
	g_return_if_fail (action_key != NULL);
#line 3240 "WindowManager.c"
	{
		gchar* action = NULL;
		GSettings* _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 419 "../src/WindowManager.vala"
		_tmp0_ = self->priv->behavior_settings;
#line 419 "../src/WindowManager.vala"
		_tmp1_ = g_settings_get_string (_tmp0_, action_key);
#line 419 "../src/WindowManager.vala"
		action = _tmp1_;
#line 420 "../src/WindowManager.vala"
		_tmp2_ = action;
#line 420 "../src/WindowManager.vala"
		if (_tmp2_ != NULL) {
#line 3256 "WindowManager.c"
			const gchar* _tmp3_;
#line 421 "../src/WindowManager.vala"
			_tmp3_ = action;
#line 421 "../src/WindowManager.vala"
			g_spawn_command_line_async (_tmp3_, &_inner_error0_);
#line 421 "../src/WindowManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 421 "../src/WindowManager.vala"
				_g_free0 (action);
#line 3266 "WindowManager.c"
				goto __catch0_g_error;
			}
		}
#line 418 "../src/WindowManager.vala"
		_g_free0 (action);
#line 3272 "WindowManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 418 "../src/WindowManager.vala"
		e = _inner_error0_;
#line 418 "../src/WindowManager.vala"
		_inner_error0_ = NULL;
#line 424 "../src/WindowManager.vala"
		_tmp4_ = e;
#line 424 "../src/WindowManager.vala"
		_tmp5_ = _tmp4_->message;
#line 424 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:424: %s", _tmp5_);
#line 418 "../src/WindowManager.vala"
		_g_error_free0 (e);
#line 3292 "WindowManager.c"
	}
	__finally0:
#line 418 "../src/WindowManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 418 "../src/WindowManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 418 "../src/WindowManager.vala"
		g_clear_error (&_inner_error0_);
#line 418 "../src/WindowManager.vala"
		return;
#line 3303 "WindowManager.c"
	}
}

static gboolean
gala_window_manager_gala_handle_super_scroll (GalaWindowManagerGala* self,
                                              guint32 timestamp,
                                              gdouble dx,
                                              gdouble dy)
{
	GSettings* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble d = 0.0;
	gboolean result;
#line 429 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 430 "../src/WindowManager.vala"
	_tmp0_ = self->priv->behavior_settings;
#line 430 "../src/WindowManager.vala"
	if (g_settings_get_enum (_tmp0_, "super-scroll-action") != 1) {
#line 431 "../src/WindowManager.vala"
		result = CLUTTER_EVENT_PROPAGATE;
#line 431 "../src/WindowManager.vala"
		return result;
#line 3327 "WindowManager.c"
	}
#line 434 "../src/WindowManager.vala"
	if (fabs (dx) > fabs (dy)) {
#line 434 "../src/WindowManager.vala"
		_tmp1_ = dx;
#line 3333 "WindowManager.c"
	} else {
#line 434 "../src/WindowManager.vala"
		_tmp1_ = dy;
#line 3337 "WindowManager.c"
	}
#line 434 "../src/WindowManager.vala"
	d = _tmp1_;
#line 436 "../src/WindowManager.vala"
	if (d > ((gdouble) 0)) {
#line 437 "../src/WindowManager.vala"
		gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, META_MOTION_RIGHT, timestamp);
#line 3345 "WindowManager.c"
	} else {
#line 438 "../src/WindowManager.vala"
		if (d < ((gdouble) 0)) {
#line 439 "../src/WindowManager.vala"
			gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, META_MOTION_LEFT, timestamp);
#line 3351 "WindowManager.c"
		}
	}
#line 442 "../src/WindowManager.vala"
	result = CLUTTER_EVENT_STOP;
#line 442 "../src/WindowManager.vala"
	return result;
#line 3358 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_cycle_workspaces (MetaDisplay* display,
                                                  MetaWindow* window,
                                                  ClutterKeyEvent* event,
                                                  MetaKeyBinding* binding,
                                                  GalaWindowManagerGala* self)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	gint direction = 0;
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp2_;
	gint active_workspace_index = 0;
	MetaWorkspaceManager* _tmp3_;
	gint index = 0;
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 446 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 448 "../src/WindowManager.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 448 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp1_, "cycle-workspaces-next") == 0) {
#line 448 "../src/WindowManager.vala"
		_tmp0_ = 1;
#line 3388 "WindowManager.c"
	} else {
#line 448 "../src/WindowManager.vala"
		_tmp0_ = -1;
#line 3392 "WindowManager.c"
	}
#line 448 "../src/WindowManager.vala"
	direction = _tmp0_;
#line 449 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (display);
#line 449 "../src/WindowManager.vala"
	manager = _tmp2_;
#line 450 "../src/WindowManager.vala"
	_tmp3_ = manager;
#line 450 "../src/WindowManager.vala"
	active_workspace_index = meta_workspace_manager_get_active_workspace_index (_tmp3_);
#line 451 "../src/WindowManager.vala"
	index = active_workspace_index + direction;
#line 453 "../src/WindowManager.vala"
	if (index < 0) {
#line 3408 "WindowManager.c"
		MetaWorkspaceManager* _tmp4_;
#line 454 "../src/WindowManager.vala"
		_tmp4_ = manager;
#line 454 "../src/WindowManager.vala"
		index = meta_workspace_manager_get_n_workspaces (_tmp4_) - 2;
#line 3414 "WindowManager.c"
	} else {
		MetaWorkspaceManager* _tmp5_;
#line 455 "../src/WindowManager.vala"
		_tmp5_ = manager;
#line 455 "../src/WindowManager.vala"
		if (index > (meta_workspace_manager_get_n_workspaces (_tmp5_) - 2)) {
#line 456 "../src/WindowManager.vala"
			index = 0;
#line 3423 "WindowManager.c"
		}
	}
#line 459 "../src/WindowManager.vala"
	if (active_workspace_index != index) {
#line 3428 "WindowManager.c"
		guint32 _tmp6_ = 0U;
		guint32 timestamp = 0U;
		MetaWorkspaceManager* _tmp7_;
		MetaWorkspace* _tmp8_;
#line 460 "../src/WindowManager.vala"
		if (event != NULL) {
#line 460 "../src/WindowManager.vala"
			_tmp6_ = clutter_event_get_time ((ClutterEvent*) event);
#line 3437 "WindowManager.c"
		} else {
#line 460 "../src/WindowManager.vala"
			_tmp6_ = (guint32) META_CURRENT_TIME;
#line 3441 "WindowManager.c"
		}
#line 460 "../src/WindowManager.vala"
		timestamp = _tmp6_;
#line 461 "../src/WindowManager.vala"
		_tmp7_ = manager;
#line 461 "../src/WindowManager.vala"
		_tmp8_ = meta_workspace_manager_get_workspace_by_index (_tmp7_, index);
#line 461 "../src/WindowManager.vala"
		meta_workspace_activate (_tmp8_, timestamp);
#line 3451 "WindowManager.c"
	} else {
#line 463 "../src/WindowManager.vala"
		gala_internal_utils_bell_notify (display);
#line 3455 "WindowManager.c"
	}
}

static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 3470 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_move_to_workspace (MetaDisplay* display,
                                                   MetaWindow* window,
                                                   ClutterKeyEvent* event,
                                                   MetaKeyBinding* binding,
                                                   GalaWindowManagerGala* self)
{
	const gchar* name = NULL;
	const gchar* _tmp0_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaWorkspaceManager* _tmp1_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* _tmp3_;
	MetaWorkspace* target_workspace = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	MetaWorkspace* _tmp20_;
#line 468 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 468 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 468 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 470 "../src/WindowManager.vala"
	if (window == NULL) {
#line 471 "../src/WindowManager.vala"
		return;
#line 3501 "WindowManager.c"
	}
#line 474 "../src/WindowManager.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 474 "../src/WindowManager.vala"
	name = _tmp0_;
#line 475 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_workspace_manager (display);
#line 475 "../src/WindowManager.vala"
	workspace_manager = _tmp1_;
#line 476 "../src/WindowManager.vala"
	_tmp2_ = workspace_manager;
#line 476 "../src/WindowManager.vala"
	_tmp3_ = meta_workspace_manager_get_active_workspace (_tmp2_);
#line 476 "../src/WindowManager.vala"
	active_workspace = _tmp3_;
#line 477 "../src/WindowManager.vala"
	target_workspace = NULL;
#line 479 "../src/WindowManager.vala"
	_tmp5_ = name;
#line 479 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp5_, "move-to-workspace-left") == 0) {
#line 479 "../src/WindowManager.vala"
		_tmp4_ = TRUE;
#line 3525 "WindowManager.c"
	} else {
		const gchar* _tmp6_;
#line 479 "../src/WindowManager.vala"
		_tmp6_ = name;
#line 479 "../src/WindowManager.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, "move-to-workspace-right") == 0;
#line 3532 "WindowManager.c"
	}
#line 479 "../src/WindowManager.vala"
	if (_tmp4_) {
#line 3536 "WindowManager.c"
		MetaMotionDirection _tmp7_ = 0;
		const gchar* _tmp8_;
		MetaMotionDirection direction = 0;
		MetaWorkspace* _tmp9_;
		MetaWorkspace* _tmp10_;
#line 480 "../src/WindowManager.vala"
		_tmp8_ = name;
#line 480 "../src/WindowManager.vala"
		if (g_strcmp0 (_tmp8_, "move-to-workspace-left") == 0) {
#line 480 "../src/WindowManager.vala"
			_tmp7_ = META_MOTION_LEFT;
#line 3548 "WindowManager.c"
		} else {
#line 480 "../src/WindowManager.vala"
			_tmp7_ = META_MOTION_RIGHT;
#line 3552 "WindowManager.c"
		}
#line 480 "../src/WindowManager.vala"
		direction = _tmp7_;
#line 481 "../src/WindowManager.vala"
		_tmp9_ = active_workspace;
#line 481 "../src/WindowManager.vala"
		_tmp10_ = meta_workspace_get_neighbor (_tmp9_, direction);
#line 481 "../src/WindowManager.vala"
		target_workspace = _tmp10_;
#line 3562 "WindowManager.c"
	} else {
		gint workspace_number = 0;
		const gchar* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		const gchar* _tmp14_;
		gint workspace_index = 0;
		MetaWorkspaceManager* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		MetaWorkspaceManager* _tmp18_;
		MetaWorkspace* _tmp19_;
#line 483 "../src/WindowManager.vala"
		_tmp11_ = name;
#line 483 "../src/WindowManager.vala"
		_tmp12_ = strlen ("move-to-workspace-");
#line 483 "../src/WindowManager.vala"
		_tmp13_ = _tmp12_;
#line 483 "../src/WindowManager.vala"
		_tmp14_ = string_offset (_tmp11_, (glong) _tmp13_);
#line 483 "../src/WindowManager.vala"
		workspace_number = atoi (_tmp14_) - 1;
#line 484 "../src/WindowManager.vala"
		_tmp15_ = workspace_manager;
#line 484 "../src/WindowManager.vala"
		_tmp16_ = meta_workspace_manager_get_n_workspaces (_tmp15_);
#line 484 "../src/WindowManager.vala"
		_tmp17_ = _tmp16_;
#line 484 "../src/WindowManager.vala"
		workspace_index = CLAMP (workspace_number, 0, _tmp17_ - 1);
#line 486 "../src/WindowManager.vala"
		_tmp18_ = workspace_manager;
#line 486 "../src/WindowManager.vala"
		_tmp19_ = meta_workspace_manager_get_workspace_by_index (_tmp18_, workspace_index);
#line 486 "../src/WindowManager.vala"
		target_workspace = _tmp19_;
#line 3599 "WindowManager.c"
	}
#line 489 "../src/WindowManager.vala"
	_tmp20_ = target_workspace;
#line 489 "../src/WindowManager.vala"
	if (_tmp20_ != NULL) {
#line 3605 "WindowManager.c"
		guint32 _tmp21_ = 0U;
		guint32 timestamp = 0U;
		MetaWorkspace* _tmp22_;
#line 490 "../src/WindowManager.vala"
		if (event != NULL) {
#line 490 "../src/WindowManager.vala"
			_tmp21_ = clutter_event_get_time ((ClutterEvent*) event);
#line 3613 "WindowManager.c"
		} else {
#line 490 "../src/WindowManager.vala"
			_tmp21_ = (guint32) META_CURRENT_TIME;
#line 3617 "WindowManager.c"
		}
#line 490 "../src/WindowManager.vala"
		timestamp = _tmp21_;
#line 491 "../src/WindowManager.vala"
		_tmp22_ = target_workspace;
#line 491 "../src/WindowManager.vala"
		gala_window_manager_move_window ((GalaWindowManager*) self, window, _tmp22_, timestamp);
#line 3625 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_handle_move_to_workspace_end (MetaDisplay* display,
                                                       MetaWindow* window,
                                                       ClutterKeyEvent* event,
                                                       MetaKeyBinding* binding,
                                                       GalaWindowManagerGala* self)
{
	guint32 _tmp0_ = 0U;
	guint32 timestamp = 0U;
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp1_;
	gint _tmp2_ = 0;
	const gchar* _tmp3_;
	gint index = 0;
	MetaWorkspace* workspace = NULL;
	MetaWorkspaceManager* _tmp5_;
	MetaWorkspace* _tmp6_;
	MetaWorkspace* _tmp7_;
	MetaWorkspace* _tmp8_;
#line 496 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 496 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 496 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 498 "../src/WindowManager.vala"
	if (window == NULL) {
#line 499 "../src/WindowManager.vala"
		return;
#line 3658 "WindowManager.c"
	}
#line 502 "../src/WindowManager.vala"
	if (event != NULL) {
#line 502 "../src/WindowManager.vala"
		_tmp0_ = clutter_event_get_time ((ClutterEvent*) event);
#line 3664 "WindowManager.c"
	} else {
#line 502 "../src/WindowManager.vala"
		_tmp0_ = (guint32) META_CURRENT_TIME;
#line 3668 "WindowManager.c"
	}
#line 502 "../src/WindowManager.vala"
	timestamp = _tmp0_;
#line 503 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_workspace_manager (display);
#line 503 "../src/WindowManager.vala"
	manager = _tmp1_;
#line 504 "../src/WindowManager.vala"
	_tmp3_ = meta_key_binding_get_name (binding);
#line 504 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp3_, "move-to-workspace-first") == 0) {
#line 504 "../src/WindowManager.vala"
		_tmp2_ = 0;
#line 3682 "WindowManager.c"
	} else {
		MetaWorkspaceManager* _tmp4_;
#line 504 "../src/WindowManager.vala"
		_tmp4_ = manager;
#line 504 "../src/WindowManager.vala"
		_tmp2_ = meta_workspace_manager_get_n_workspaces (_tmp4_) - 1;
#line 3689 "WindowManager.c"
	}
#line 504 "../src/WindowManager.vala"
	index = _tmp2_;
#line 505 "../src/WindowManager.vala"
	_tmp5_ = manager;
#line 505 "../src/WindowManager.vala"
	_tmp6_ = meta_workspace_manager_get_workspace_by_index (_tmp5_, index);
#line 505 "../src/WindowManager.vala"
	workspace = _tmp6_;
#line 506 "../src/WindowManager.vala"
	_tmp7_ = workspace;
#line 506 "../src/WindowManager.vala"
	meta_window_change_workspace (window, _tmp7_);
#line 507 "../src/WindowManager.vala"
	_tmp8_ = workspace;
#line 507 "../src/WindowManager.vala"
	meta_workspace_activate_with_focus (_tmp8_, window, timestamp);
#line 3707 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_switch_to_workspace (MetaDisplay* display,
                                                     MetaWindow* window,
                                                     ClutterKeyEvent* event,
                                                     MetaKeyBinding* binding,
                                                     GalaWindowManagerGala* self)
{
	guint32 _tmp0_ = 0U;
	guint32 timestamp = 0U;
	const gchar* name = NULL;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 511 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 511 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 511 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 513 "../src/WindowManager.vala"
	if (event != NULL) {
#line 513 "../src/WindowManager.vala"
		_tmp0_ = clutter_event_get_time ((ClutterEvent*) event);
#line 3733 "WindowManager.c"
	} else {
#line 513 "../src/WindowManager.vala"
		_tmp0_ = (guint32) META_CURRENT_TIME;
#line 3737 "WindowManager.c"
	}
#line 513 "../src/WindowManager.vala"
	timestamp = _tmp0_;
#line 514 "../src/WindowManager.vala"
	_tmp1_ = meta_key_binding_get_name (binding);
#line 514 "../src/WindowManager.vala"
	name = _tmp1_;
#line 516 "../src/WindowManager.vala"
	_tmp3_ = name;
#line 516 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp3_, "switch-to-workspace-left") == 0) {
#line 516 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 3751 "WindowManager.c"
	} else {
		const gchar* _tmp4_;
#line 516 "../src/WindowManager.vala"
		_tmp4_ = name;
#line 516 "../src/WindowManager.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "switch-to-workspace-right") == 0;
#line 3758 "WindowManager.c"
	}
#line 516 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 3762 "WindowManager.c"
		MetaMotionDirection _tmp5_ = 0;
		const gchar* _tmp6_;
		MetaMotionDirection direction = 0;
#line 517 "../src/WindowManager.vala"
		_tmp6_ = name;
#line 517 "../src/WindowManager.vala"
		if (g_strcmp0 (_tmp6_, "switch-to-workspace-left") == 0) {
#line 517 "../src/WindowManager.vala"
			_tmp5_ = META_MOTION_LEFT;
#line 3772 "WindowManager.c"
		} else {
#line 517 "../src/WindowManager.vala"
			_tmp5_ = META_MOTION_RIGHT;
#line 3776 "WindowManager.c"
		}
#line 517 "../src/WindowManager.vala"
		direction = _tmp5_;
#line 518 "../src/WindowManager.vala"
		gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, direction, timestamp);
#line 3782 "WindowManager.c"
	} else {
		MetaWorkspaceManager* workspace_manager = NULL;
		MetaDisplay* _tmp7_;
		MetaWorkspaceManager* _tmp8_;
		gint workspace_number = 0;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp12_;
		gint workspace_index = 0;
		MetaWorkspaceManager* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		MetaWorkspace* workspace = NULL;
		MetaWorkspaceManager* _tmp16_;
		MetaWorkspace* _tmp17_;
		MetaWorkspace* _tmp18_;
		MetaWorkspace* _tmp19_;
		MetaWorkspace* _tmp20_;
#line 520 "../src/WindowManager.vala"
		_tmp7_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 520 "../src/WindowManager.vala"
		_tmp8_ = meta_display_get_workspace_manager (_tmp7_);
#line 520 "../src/WindowManager.vala"
		workspace_manager = _tmp8_;
#line 522 "../src/WindowManager.vala"
		_tmp9_ = name;
#line 522 "../src/WindowManager.vala"
		_tmp10_ = strlen ("switch-to-workspace-");
#line 522 "../src/WindowManager.vala"
		_tmp11_ = _tmp10_;
#line 522 "../src/WindowManager.vala"
		_tmp12_ = string_offset (_tmp9_, (glong) _tmp11_);
#line 522 "../src/WindowManager.vala"
		workspace_number = atoi (_tmp12_) - 1;
#line 523 "../src/WindowManager.vala"
		_tmp13_ = workspace_manager;
#line 523 "../src/WindowManager.vala"
		_tmp14_ = meta_workspace_manager_get_n_workspaces (_tmp13_);
#line 523 "../src/WindowManager.vala"
		_tmp15_ = _tmp14_;
#line 523 "../src/WindowManager.vala"
		workspace_index = CLAMP (workspace_number, 0, _tmp15_ - 1);
#line 525 "../src/WindowManager.vala"
		_tmp16_ = workspace_manager;
#line 525 "../src/WindowManager.vala"
		_tmp17_ = meta_workspace_manager_get_workspace_by_index (_tmp16_, workspace_index);
#line 525 "../src/WindowManager.vala"
		_tmp18_ = _g_object_ref0 (_tmp17_);
#line 525 "../src/WindowManager.vala"
		workspace = _tmp18_;
#line 526 "../src/WindowManager.vala"
		_tmp19_ = workspace;
#line 526 "../src/WindowManager.vala"
		if (_tmp19_ == NULL) {
#line 527 "../src/WindowManager.vala"
			_g_object_unref0 (workspace);
#line 527 "../src/WindowManager.vala"
			return;
#line 3842 "WindowManager.c"
		}
#line 530 "../src/WindowManager.vala"
		_tmp20_ = workspace;
#line 530 "../src/WindowManager.vala"
		meta_workspace_activate (_tmp20_, timestamp);
#line 516 "../src/WindowManager.vala"
		_g_object_unref0 (workspace);
#line 3850 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_handle_switch_to_workspace_end (MetaDisplay* display,
                                                         MetaWindow* window,
                                                         ClutterKeyEvent* event,
                                                         MetaKeyBinding* binding,
                                                         GalaWindowManagerGala* self)
{
	MetaWorkspaceManager* manager = NULL;
	MetaWorkspaceManager* _tmp0_;
	gint _tmp1_ = 0;
	const gchar* _tmp2_;
	gint index = 0;
	guint32 _tmp6_ = 0U;
	MetaWorkspaceManager* _tmp7_;
	MetaWorkspace* _tmp8_;
#line 535 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 535 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 535 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 537 "../src/WindowManager.vala"
	_tmp0_ = meta_display_get_workspace_manager (display);
#line 537 "../src/WindowManager.vala"
	manager = _tmp0_;
#line 538 "../src/WindowManager.vala"
	_tmp2_ = meta_key_binding_get_name (binding);
#line 538 "../src/WindowManager.vala"
	if (g_strcmp0 (_tmp2_, "switch-to-workspace-first") == 0) {
#line 538 "../src/WindowManager.vala"
		_tmp1_ = 0;
#line 3885 "WindowManager.c"
	} else {
		MetaWorkspaceManager* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 538 "../src/WindowManager.vala"
		_tmp3_ = manager;
#line 538 "../src/WindowManager.vala"
		_tmp4_ = meta_workspace_manager_get_n_workspaces (_tmp3_);
#line 538 "../src/WindowManager.vala"
		_tmp5_ = _tmp4_;
#line 538 "../src/WindowManager.vala"
		_tmp1_ = _tmp5_ - 1;
#line 3898 "WindowManager.c"
	}
#line 538 "../src/WindowManager.vala"
	index = _tmp1_;
#line 539 "../src/WindowManager.vala"
	if (event != NULL) {
#line 539 "../src/WindowManager.vala"
		_tmp6_ = clutter_event_get_time ((ClutterEvent*) event);
#line 3906 "WindowManager.c"
	} else {
#line 539 "../src/WindowManager.vala"
		_tmp6_ = (guint32) META_CURRENT_TIME;
#line 3910 "WindowManager.c"
	}
#line 539 "../src/WindowManager.vala"
	_tmp7_ = manager;
#line 539 "../src/WindowManager.vala"
	_tmp8_ = meta_workspace_manager_get_workspace_by_index (_tmp7_, index);
#line 539 "../src/WindowManager.vala"
	meta_workspace_activate (_tmp8_, _tmp6_);
#line 3918 "WindowManager.c"
}

static void
gala_window_manager_gala_handle_applications_menu (MetaDisplay* display,
                                                   MetaWindow* window,
                                                   ClutterKeyEvent* event,
                                                   MetaKeyBinding* binding,
                                                   GalaWindowManagerGala* self)
{
#line 543 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 543 "../src/WindowManager.vala"
	g_return_if_fail (display != NULL);
#line 543 "../src/WindowManager.vala"
	g_return_if_fail (binding != NULL);
#line 545 "../src/WindowManager.vala"
	gala_window_manager_launch_action ((GalaWindowManager*) self, GALA_ACTION_KEYS_PANEL_MAIN_MENU_ACTION);
#line 3936 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_switch_to_next_workspace (GalaWindowManager* base,
                                                        MetaMotionDirection direction,
                                                        guint32 timestamp)
{
	GalaWindowManagerGala * self;
	GalaMultitaskingView* _tmp0_;
#line 551 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 552 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_multitasking_view;
#line 552 "../src/WindowManager.vala"
	gala_multitasking_view_switch_to_next_workspace (_tmp0_, direction);
#line 3955 "WindowManager.c"
}

static void
gala_window_manager_gala_update_input_area (GalaWindowManagerGala* self)
{
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	GalaScreenSaverManager* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 555 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 556 "../src/WindowManager.vala"
	display = _tmp0_;
#line 558 "../src/WindowManager.vala"
	_tmp1_ = self->priv->_screensaver;
#line 558 "../src/WindowManager.vala"
	if (_tmp1_ != NULL) {
#line 3975 "WindowManager.c"
		{
			gboolean _tmp2_ = FALSE;
			GalaScreenSaverManager* _tmp3_;
#line 560 "../src/WindowManager.vala"
			_tmp3_ = self->priv->_screensaver;
#line 560 "../src/WindowManager.vala"
			_tmp2_ = gala_screen_saver_manager_get_active (_tmp3_, &_inner_error0_);
#line 560 "../src/WindowManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3985 "WindowManager.c"
				goto __catch0_g_error;
			}
#line 560 "../src/WindowManager.vala"
			if (_tmp2_) {
#line 3990 "WindowManager.c"
				MetaDisplay* _tmp4_;
#line 561 "../src/WindowManager.vala"
				_tmp4_ = display;
#line 561 "../src/WindowManager.vala"
				gala_internal_utils_set_input_area (_tmp4_, GALA_INPUT_AREA_NONE);
#line 562 "../src/WindowManager.vala"
				return;
#line 3998 "WindowManager.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 559 "../src/WindowManager.vala"
			g_clear_error (&_inner_error0_);
#line 4006 "WindowManager.c"
		}
		__finally0:
#line 559 "../src/WindowManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 559 "../src/WindowManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 559 "../src/WindowManager.vala"
			g_clear_error (&_inner_error0_);
#line 559 "../src/WindowManager.vala"
			return;
#line 4017 "WindowManager.c"
		}
	}
#line 572 "../src/WindowManager.vala"
	if (gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 4022 "WindowManager.c"
		MetaDisplay* _tmp5_;
#line 573 "../src/WindowManager.vala"
		_tmp5_ = display;
#line 573 "../src/WindowManager.vala"
		gala_internal_utils_set_input_area (_tmp5_, GALA_INPUT_AREA_FULLSCREEN);
#line 4028 "WindowManager.c"
	} else {
		MetaDisplay* _tmp6_;
#line 575 "../src/WindowManager.vala"
		_tmp6_ = display;
#line 575 "../src/WindowManager.vala"
		gala_internal_utils_set_input_area (_tmp6_, GALA_INPUT_AREA_DEFAULT);
#line 4035 "WindowManager.c"
	}
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 578 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 578 "../src/WindowManager.vala"
	return _data13_;
#line 4046 "WindowManager.c"
}

static void
_vala_GValue_array_free (GValue * array,
                         gssize array_length)
{
#line 578 "../src/WindowManager.vala"
	if (array != NULL) {
#line 4055 "WindowManager.c"
		gssize i;
#line 578 "../src/WindowManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 578 "../src/WindowManager.vala"
			g_value_unset (&array[i]);
#line 4061 "WindowManager.c"
		}
	}
#line 578 "../src/WindowManager.vala"
	g_free (array);
#line 4066 "WindowManager.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 578 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 4076 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 578 "../src/WindowManager.vala"
		self = _data13_->self;
#line 578 "../src/WindowManager.vala"
		_data13_->opacity = (_vala_GValue_array_free (_data13_->opacity, _data13_->opacity_length1), NULL);
#line 578 "../src/WindowManager.vala"
		_data13_->op_keyframes = (g_free (_data13_->op_keyframes), NULL);
#line 578 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 578 "../src/WindowManager.vala"
		g_slice_free (Block13Data, _data13_);
#line 4088 "WindowManager.c"
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 600 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 600 "../src/WindowManager.vala"
	return _data14_;
#line 4099 "WindowManager.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 600 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 4109 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 600 "../src/WindowManager.vala"
		self = _data14_->_data13_->self;
#line 600 "../src/WindowManager.vala"
		block13_data_unref (_data14_->_data13_);
#line 600 "../src/WindowManager.vala"
		_data14_->_data13_ = NULL;
#line 600 "../src/WindowManager.vala"
		g_slice_free (Block14Data, _data14_);
#line 4119 "WindowManager.c"
	}
}

static gboolean
___lambda174_ (Block14Data* _data14_)
{
	Block13Data* _data13_;
	GalaWindowManagerGala* self;
	MetaWindowActor* _tmp0_;
	GValue* _tmp1_;
	gint _tmp1__length1;
	GValue _tmp2_;
	gboolean result;
#line 626 "../src/WindowManager.vala"
	_data13_ = _data14_->_data13_;
#line 626 "../src/WindowManager.vala"
	self = _data13_->self;
#line 627 "../src/WindowManager.vala"
	_tmp0_ = _data14_->actor;
#line 627 "../src/WindowManager.vala"
	_tmp1_ = _data13_->opacity;
#line 627 "../src/WindowManager.vala"
	_tmp1__length1 = _data13_->opacity_length1;
#line 627 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_[0];
#line 627 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp0_, g_value_get_uint (&_tmp2_));
#line 628 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 628 "../src/WindowManager.vala"
	return result;
#line 4151 "WindowManager.c"
}

static gboolean
____lambda174__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda174_ (self);
#line 626 "../src/WindowManager.vala"
	return result;
#line 4161 "WindowManager.c"
}

static gboolean
___lambda175_ (Block14Data* _data14_)
{
	Block13Data* _data13_;
	GalaWindowManagerGala* self;
	MetaWindowActor* _tmp0_;
	gboolean result;
#line 631 "../src/WindowManager.vala"
	_data13_ = _data14_->_data13_;
#line 631 "../src/WindowManager.vala"
	self = _data13_->self;
#line 632 "../src/WindowManager.vala"
	_tmp0_ = _data14_->actor;
#line 632 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp0_, 255U);
#line 633 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 633 "../src/WindowManager.vala"
	return result;
#line 4183 "WindowManager.c"
}

static gboolean
____lambda175__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda175_ (self);
#line 631 "../src/WindowManager.vala"
	return result;
#line 4193 "WindowManager.c"
}

static void
__lambda173_ (Block13Data* _data13_,
              MetaWindow* window)
{
	GalaWindowManagerGala* self;
	Block14Data* _data14_;
	Window xwin = 0;
	MetaX11Display* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GObject* _tmp5_;
#line 600 "../src/WindowManager.vala"
	self = _data13_->self;
#line 600 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 600 "../src/WindowManager.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 600 "../src/WindowManager.vala"
	_data14_->_ref_count_ = 1;
#line 600 "../src/WindowManager.vala"
	_data14_->_data13_ = block13_data_ref (_data13_);
#line 602 "../src/WindowManager.vala"
	_tmp0_ = _data13_->x11display;
#line 602 "../src/WindowManager.vala"
	xwin = meta_x11_display_lookup_xwindow (_tmp0_, window);
#line 606 "../src/WindowManager.vala"
	if (xwin == _data13_->bottom_xwin) {
#line 606 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 4225 "WindowManager.c"
	} else {
#line 607 "../src/WindowManager.vala"
		_tmp2_ = !gala_internal_utils_get_window_is_normal (window);
#line 4229 "WindowManager.c"
	}
#line 606 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 606 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 4235 "WindowManager.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 608 "../src/WindowManager.vala"
		g_object_get (window, "minimized", &_tmp3_, NULL);
#line 608 "../src/WindowManager.vala"
		_tmp4_ = _tmp3_;
#line 608 "../src/WindowManager.vala"
		_tmp1_ = _tmp4_;
#line 4245 "WindowManager.c"
	}
#line 606 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 609 "../src/WindowManager.vala"
		block14_data_unref (_data14_);
#line 609 "../src/WindowManager.vala"
		_data14_ = NULL;
#line 609 "../src/WindowManager.vala"
		return;
#line 4255 "WindowManager.c"
	}
#line 612 "../src/WindowManager.vala"
	_tmp5_ = meta_window_get_compositor_private (window);
#line 612 "../src/WindowManager.vala"
	_data14_->actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, meta_window_actor_get_type (), MetaWindowActor);
#line 613 "../src/WindowManager.vala"
	if (meta_prefs_get_gnome_animations ()) {
#line 4263 "WindowManager.c"
		ClutterKeyframeTransition* op_trans = NULL;
		ClutterKeyframeTransition* _tmp6_ = NULL;
		ClutterKeyframeTransition* _tmp7_;
		GValue _tmp8_ = {0};
		ClutterKeyframeTransition* _tmp9_;
		GValue _tmp10_ = {0};
		ClutterKeyframeTransition* _tmp11_;
		gdouble* _tmp12_;
		gint _tmp12__length1;
		ClutterKeyframeTransition* _tmp13_;
		GValue* _tmp14_;
		gint _tmp14__length1;
		MetaWindowActor* _tmp15_;
		ClutterKeyframeTransition* _tmp16_;
#line 614 "../src/WindowManager.vala"
		_tmp6_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new ("opacity");
#line 614 "../src/WindowManager.vala"
		clutter_timeline_set_duration ((ClutterTimeline*) _tmp6_, _data13_->fade_out_duration);
#line 614 "../src/WindowManager.vala"
		clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp6_, TRUE);
#line 614 "../src/WindowManager.vala"
		clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp6_, CLUTTER_EASE_IN_OUT_QUAD);
#line 614 "../src/WindowManager.vala"
		op_trans = _tmp6_;
#line 619 "../src/WindowManager.vala"
		_tmp7_ = op_trans;
#line 619 "../src/WindowManager.vala"
		g_value_init (&_tmp8_, G_TYPE_FLOAT);
#line 619 "../src/WindowManager.vala"
		g_value_set_float (&_tmp8_, 255.0f);
#line 619 "../src/WindowManager.vala"
		clutter_transition_set_from_value ((ClutterTransition*) _tmp7_, &_tmp8_);
#line 619 "../src/WindowManager.vala"
		G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
#line 620 "../src/WindowManager.vala"
		_tmp9_ = op_trans;
#line 620 "../src/WindowManager.vala"
		g_value_init (&_tmp10_, G_TYPE_FLOAT);
#line 620 "../src/WindowManager.vala"
		g_value_set_float (&_tmp10_, 255.0f);
#line 620 "../src/WindowManager.vala"
		clutter_transition_set_to_value ((ClutterTransition*) _tmp9_, &_tmp10_);
#line 620 "../src/WindowManager.vala"
		G_IS_VALUE (&_tmp10_) ? (g_value_unset (&_tmp10_), NULL) : NULL;
#line 621 "../src/WindowManager.vala"
		_tmp11_ = op_trans;
#line 621 "../src/WindowManager.vala"
		_tmp12_ = _data13_->op_keyframes;
#line 621 "../src/WindowManager.vala"
		_tmp12__length1 = _data13_->op_keyframes_length1;
#line 621 "../src/WindowManager.vala"
		clutter_keyframe_transition_set_key_frames (_tmp11_, (guint) _tmp12__length1, _tmp12_);
#line 622 "../src/WindowManager.vala"
		_tmp13_ = op_trans;
#line 622 "../src/WindowManager.vala"
		_tmp14_ = _data13_->opacity;
#line 622 "../src/WindowManager.vala"
		_tmp14__length1 = _data13_->opacity_length1;
#line 622 "../src/WindowManager.vala"
		clutter_keyframe_transition_set_values (_tmp13_, (guint) _tmp14__length1, _tmp14_);
#line 624 "../src/WindowManager.vala"
		_tmp15_ = _data14_->actor;
#line 624 "../src/WindowManager.vala"
		_tmp16_ = op_trans;
#line 624 "../src/WindowManager.vala"
		clutter_actor_add_transition ((ClutterActor*) _tmp15_, "opacity-hide", (ClutterTransition*) _tmp16_);
#line 613 "../src/WindowManager.vala"
		_g_object_unref0 (op_trans);
#line 4332 "WindowManager.c"
	} else {
		gdouble* _tmp17_;
		gint _tmp17__length1;
		gdouble _tmp18_;
		gdouble* _tmp19_;
		gint _tmp19__length1;
		gdouble _tmp20_;
#line 626 "../src/WindowManager.vala"
		_tmp17_ = _data13_->op_keyframes;
#line 626 "../src/WindowManager.vala"
		_tmp17__length1 = _data13_->op_keyframes_length1;
#line 626 "../src/WindowManager.vala"
		_tmp18_ = _tmp17_[0];
#line 626 "../src/WindowManager.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_data13_->fade_out_duration * _tmp18_), ____lambda174__gsource_func, block14_data_ref (_data14_), block14_data_unref);
#line 631 "../src/WindowManager.vala"
		_tmp19_ = _data13_->op_keyframes;
#line 631 "../src/WindowManager.vala"
		_tmp19__length1 = _data13_->op_keyframes_length1;
#line 631 "../src/WindowManager.vala"
		_tmp20_ = _tmp19_[1];
#line 631 "../src/WindowManager.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (_data13_->fade_out_duration * _tmp20_), ____lambda175__gsource_func, block14_data_ref (_data14_), block14_data_unref);
#line 4356 "WindowManager.c"
	}
#line 600 "../src/WindowManager.vala"
	block14_data_unref (_data14_);
#line 600 "../src/WindowManager.vala"
	_data14_ = NULL;
#line 4362 "WindowManager.c"
}

static void
___lambda173__gfunc (gconstpointer data,
                     gpointer self)
{
#line 600 "../src/WindowManager.vala"
	__lambda173_ (self, (MetaWindow*) data);
#line 4371 "WindowManager.c"
}

static void
gala_window_manager_gala_show_bottom_stack_window (GalaWindowManagerGala* self,
                                                   MetaWindow* bottom_window)
{
	Block13Data* _data13_;
	MetaWorkspace* workspace = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	MetaWindowActor* bottom_actor = NULL;
	GObject* _tmp2_;
	gdouble* _tmp4_;
	GValue _tmp5_ = {0};
	GValue _tmp6_ = {0};
	GValue* _tmp7_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp8_;
	MetaDisplay* _tmp9_;
	MetaX11Display* _tmp10_;
	MetaX11Display* _tmp11_;
	MetaWorkspace* _tmp12_;
	GList* _tmp13_;
	GList* _tmp14_;
#line 578 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 578 "../src/WindowManager.vala"
	g_return_if_fail (bottom_window != NULL);
#line 578 "../src/WindowManager.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 578 "../src/WindowManager.vala"
	_data13_->_ref_count_ = 1;
#line 578 "../src/WindowManager.vala"
	_data13_->self = g_object_ref (self);
#line 579 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_workspace (bottom_window);
#line 579 "../src/WindowManager.vala"
	workspace = _tmp0_;
#line 580 "../src/WindowManager.vala"
	_tmp1_ = workspace;
#line 580 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp1_, FALSE, NULL) == ((guint) 0)) {
#line 581 "../src/WindowManager.vala"
		block13_data_unref (_data13_);
#line 581 "../src/WindowManager.vala"
		_data13_ = NULL;
#line 581 "../src/WindowManager.vala"
		return;
#line 4420 "WindowManager.c"
	}
#line 584 "../src/WindowManager.vala"
	_tmp2_ = meta_window_get_compositor_private (bottom_window);
#line 584 "../src/WindowManager.vala"
	bottom_actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, meta_window_actor_get_type (), MetaWindowActor);
#line 585 "../src/WindowManager.vala"
	if (meta_prefs_get_gnome_animations ()) {
#line 4428 "WindowManager.c"
		MetaWindowActor* _tmp3_;
#line 586 "../src/WindowManager.vala"
		_tmp3_ = bottom_actor;
#line 586 "../src/WindowManager.vala"
		gala_window_manager_gala_animate_bottom_window_scale (self, _tmp3_);
#line 4434 "WindowManager.c"
	}
#line 589 "../src/WindowManager.vala"
	_data13_->fade_out_duration = 900U;
#line 590 "../src/WindowManager.vala"
	_tmp4_ = g_new0 (gdouble, 2);
#line 590 "../src/WindowManager.vala"
	_tmp4_[0] = 0.1;
#line 590 "../src/WindowManager.vala"
	_tmp4_[1] = 0.9;
#line 590 "../src/WindowManager.vala"
	_data13_->op_keyframes = _tmp4_;
#line 590 "../src/WindowManager.vala"
	_data13_->op_keyframes_length1 = 2;
#line 590 "../src/WindowManager.vala"
	_data13_->_op_keyframes_size_ = _data13_->op_keyframes_length1;
#line 591 "../src/WindowManager.vala"
	g_value_init (&_tmp5_, G_TYPE_UINT);
#line 591 "../src/WindowManager.vala"
	g_value_set_uint (&_tmp5_, 20U);
#line 591 "../src/WindowManager.vala"
	g_value_init (&_tmp6_, G_TYPE_UINT);
#line 591 "../src/WindowManager.vala"
	g_value_set_uint (&_tmp6_, 20U);
#line 591 "../src/WindowManager.vala"
	_tmp7_ = g_new0 (GValue, 2);
#line 591 "../src/WindowManager.vala"
	_tmp7_[0] = _tmp5_;
#line 591 "../src/WindowManager.vala"
	_tmp7_[1] = _tmp6_;
#line 591 "../src/WindowManager.vala"
	_data13_->opacity = _tmp7_;
#line 591 "../src/WindowManager.vala"
	_data13_->opacity_length1 = 2;
#line 591 "../src/WindowManager.vala"
	_data13_->_opacity_size_ = _data13_->opacity_length1;
#line 593 "../src/WindowManager.vala"
	_tmp8_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 593 "../src/WindowManager.vala"
	display = _tmp8_;
#line 594 "../src/WindowManager.vala"
	_tmp9_ = display;
#line 594 "../src/WindowManager.vala"
	_tmp10_ = meta_display_get_x11_display (_tmp9_);
#line 594 "../src/WindowManager.vala"
	_data13_->x11display = _tmp10_;
#line 595 "../src/WindowManager.vala"
	_tmp11_ = _data13_->x11display;
#line 595 "../src/WindowManager.vala"
	_data13_->bottom_xwin = meta_x11_display_lookup_xwindow (_tmp11_, bottom_window);
#line 600 "../src/WindowManager.vala"
	_tmp12_ = workspace;
#line 600 "../src/WindowManager.vala"
	_tmp13_ = meta_workspace_list_windows (_tmp12_);
#line 600 "../src/WindowManager.vala"
	_tmp14_ = _tmp13_;
#line 600 "../src/WindowManager.vala"
	g_list_foreach (_tmp14_, ___lambda173__gfunc, _data13_);
#line 600 "../src/WindowManager.vala"
	(_tmp14_ == NULL) ? NULL : (_tmp14_ = (g_list_free (_tmp14_), NULL));
#line 578 "../src/WindowManager.vala"
	block13_data_unref (_data13_);
#line 578 "../src/WindowManager.vala"
	_data13_ = NULL;
#line 4498 "WindowManager.c"
}

static void
gala_window_manager_gala_animate_bottom_window_scale (GalaWindowManagerGala* self,
                                                      MetaWindowActor* actor)
{
#line 640 "../src/WindowManager.vala"
	static const gchar* PROPS[2] = {"scale-x", "scale-y"};
#line 639 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 639 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 4511 "WindowManager.c"
	{
		const gchar** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
#line 642 "../src/WindowManager.vala"
		prop_collection = PROPS;
#line 642 "../src/WindowManager.vala"
		prop_collection_length1 = G_N_ELEMENTS (PROPS);
#line 642 "../src/WindowManager.vala"
		for (prop_it = 0; prop_it < prop_collection_length1; prop_it = prop_it + 1) {
#line 4523 "WindowManager.c"
			gchar* _tmp0_;
			gchar* prop = NULL;
#line 642 "../src/WindowManager.vala"
			_tmp0_ = g_strdup (prop_collection[prop_it]);
#line 642 "../src/WindowManager.vala"
			prop = _tmp0_;
#line 4530 "WindowManager.c"
			{
				gdouble* scale_keyframes = NULL;
				gdouble* _tmp1_;
				gint scale_keyframes_length1;
				gint _scale_keyframes_size_;
				GValue* scale = NULL;
				GValue _tmp2_ = {0};
				GValue _tmp3_ = {0};
				GValue _tmp4_ = {0};
				GValue* _tmp5_;
				gint scale_length1;
				gint _scale_size_;
				ClutterKeyframeTransition* scale_trans = NULL;
				const gchar* _tmp6_;
				ClutterKeyframeTransition* _tmp7_ = NULL;
				ClutterKeyframeTransition* _tmp8_;
				GValue _tmp9_ = {0};
				ClutterKeyframeTransition* _tmp10_;
				GValue _tmp11_ = {0};
				ClutterKeyframeTransition* _tmp12_;
				gdouble* _tmp13_;
				gint _tmp13__length1;
				ClutterKeyframeTransition* _tmp14_;
				GValue* _tmp15_;
				gint _tmp15__length1;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				ClutterKeyframeTransition* _tmp19_;
#line 643 "../src/WindowManager.vala"
				_tmp1_ = g_new0 (gdouble, 3);
#line 643 "../src/WindowManager.vala"
				_tmp1_[0] = 0.2;
#line 643 "../src/WindowManager.vala"
				_tmp1_[1] = 0.3;
#line 643 "../src/WindowManager.vala"
				_tmp1_[2] = 0.8;
#line 643 "../src/WindowManager.vala"
				scale_keyframes = _tmp1_;
#line 643 "../src/WindowManager.vala"
				scale_keyframes_length1 = 3;
#line 643 "../src/WindowManager.vala"
				_scale_keyframes_size_ = scale_keyframes_length1;
#line 644 "../src/WindowManager.vala"
				g_value_init (&_tmp2_, G_TYPE_FLOAT);
#line 644 "../src/WindowManager.vala"
				g_value_set_float (&_tmp2_, 1.0f);
#line 644 "../src/WindowManager.vala"
				g_value_init (&_tmp3_, G_TYPE_FLOAT);
#line 644 "../src/WindowManager.vala"
				g_value_set_float (&_tmp3_, 1.07f);
#line 644 "../src/WindowManager.vala"
				g_value_init (&_tmp4_, G_TYPE_FLOAT);
#line 644 "../src/WindowManager.vala"
				g_value_set_float (&_tmp4_, 1.07f);
#line 644 "../src/WindowManager.vala"
				_tmp5_ = g_new0 (GValue, 3);
#line 644 "../src/WindowManager.vala"
				_tmp5_[0] = _tmp2_;
#line 644 "../src/WindowManager.vala"
				_tmp5_[1] = _tmp3_;
#line 644 "../src/WindowManager.vala"
				_tmp5_[2] = _tmp4_;
#line 644 "../src/WindowManager.vala"
				scale = _tmp5_;
#line 644 "../src/WindowManager.vala"
				scale_length1 = 3;
#line 644 "../src/WindowManager.vala"
				_scale_size_ = scale_length1;
#line 646 "../src/WindowManager.vala"
				_tmp6_ = prop;
#line 646 "../src/WindowManager.vala"
				_tmp7_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new (_tmp6_);
#line 646 "../src/WindowManager.vala"
				clutter_timeline_set_duration ((ClutterTimeline*) _tmp7_, (guint) 500);
#line 646 "../src/WindowManager.vala"
				clutter_transition_set_remove_on_complete ((ClutterTransition*) _tmp7_, TRUE);
#line 646 "../src/WindowManager.vala"
				clutter_timeline_set_progress_mode ((ClutterTimeline*) _tmp7_, CLUTTER_EASE_IN_QUAD);
#line 646 "../src/WindowManager.vala"
				scale_trans = _tmp7_;
#line 651 "../src/WindowManager.vala"
				_tmp8_ = scale_trans;
#line 651 "../src/WindowManager.vala"
				g_value_init (&_tmp9_, G_TYPE_FLOAT);
#line 651 "../src/WindowManager.vala"
				g_value_set_float (&_tmp9_, 1.0f);
#line 651 "../src/WindowManager.vala"
				clutter_transition_set_from_value ((ClutterTransition*) _tmp8_, &_tmp9_);
#line 651 "../src/WindowManager.vala"
				G_IS_VALUE (&_tmp9_) ? (g_value_unset (&_tmp9_), NULL) : NULL;
#line 652 "../src/WindowManager.vala"
				_tmp10_ = scale_trans;
#line 652 "../src/WindowManager.vala"
				g_value_init (&_tmp11_, G_TYPE_FLOAT);
#line 652 "../src/WindowManager.vala"
				g_value_set_float (&_tmp11_, 1.0f);
#line 652 "../src/WindowManager.vala"
				clutter_transition_set_to_value ((ClutterTransition*) _tmp10_, &_tmp11_);
#line 652 "../src/WindowManager.vala"
				G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
#line 653 "../src/WindowManager.vala"
				_tmp12_ = scale_trans;
#line 653 "../src/WindowManager.vala"
				_tmp13_ = scale_keyframes;
#line 653 "../src/WindowManager.vala"
				_tmp13__length1 = scale_keyframes_length1;
#line 653 "../src/WindowManager.vala"
				clutter_keyframe_transition_set_key_frames (_tmp12_, (guint) _tmp13__length1, _tmp13_);
#line 654 "../src/WindowManager.vala"
				_tmp14_ = scale_trans;
#line 654 "../src/WindowManager.vala"
				_tmp15_ = scale;
#line 654 "../src/WindowManager.vala"
				_tmp15__length1 = scale_length1;
#line 654 "../src/WindowManager.vala"
				clutter_keyframe_transition_set_values (_tmp14_, (guint) _tmp15__length1, _tmp15_);
#line 656 "../src/WindowManager.vala"
				_tmp16_ = prop;
#line 656 "../src/WindowManager.vala"
				_tmp17_ = g_strdup_printf ("magnify-%s", _tmp16_);
#line 656 "../src/WindowManager.vala"
				_tmp18_ = _tmp17_;
#line 656 "../src/WindowManager.vala"
				_tmp19_ = scale_trans;
#line 656 "../src/WindowManager.vala"
				clutter_actor_add_transition ((ClutterActor*) actor, _tmp18_, (ClutterTransition*) _tmp19_);
#line 656 "../src/WindowManager.vala"
				_g_free0 (_tmp18_);
#line 642 "../src/WindowManager.vala"
				_g_object_unref0 (scale_trans);
#line 642 "../src/WindowManager.vala"
				scale = (_vala_GValue_array_free (scale, scale_length1), NULL);
#line 642 "../src/WindowManager.vala"
				scale_keyframes = (g_free (scale_keyframes), NULL);
#line 642 "../src/WindowManager.vala"
				_g_free0 (prop);
#line 4668 "WindowManager.c"
			}
		}
	}
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_move_window (GalaWindowManager* base,
                                           MetaWindow* window,
                                           MetaWorkspace* workspace,
                                           guint32 timestamp)
{
	GalaWindowManagerGala * self;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	MetaWorkspaceManager* manager = NULL;
	MetaDisplay* _tmp1_;
	MetaWorkspaceManager* _tmp2_;
	MetaWorkspace* active = NULL;
	MetaWorkspaceManager* _tmp3_;
	MetaWorkspace* _tmp4_;
	gboolean _tmp5_ = FALSE;
	MetaWorkspace* _tmp6_;
	MetaWorkspace* _tmp11_;
	GalaMultitaskingView* _tmp13_;
#line 663 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 663 "../src/WindowManager.vala"
	g_return_if_fail (workspace != NULL);
#line 664 "../src/WindowManager.vala"
	if (window == NULL) {
#line 665 "../src/WindowManager.vala"
		return;
#line 4704 "WindowManager.c"
	}
#line 668 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 668 "../src/WindowManager.vala"
	display = _tmp0_;
#line 669 "../src/WindowManager.vala"
	_tmp1_ = display;
#line 669 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_workspace_manager (_tmp1_);
#line 669 "../src/WindowManager.vala"
	manager = _tmp2_;
#line 671 "../src/WindowManager.vala"
	_tmp3_ = manager;
#line 671 "../src/WindowManager.vala"
	_tmp4_ = meta_workspace_manager_get_active_workspace (_tmp3_);
#line 671 "../src/WindowManager.vala"
	active = _tmp4_;
#line 674 "../src/WindowManager.vala"
	_tmp6_ = active;
#line 674 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp6_, FALSE, NULL) == ((guint) 1)) {
#line 4726 "WindowManager.c"
		MetaWorkspaceManager* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 674 "../src/WindowManager.vala"
		_tmp7_ = manager;
#line 674 "../src/WindowManager.vala"
		_tmp8_ = meta_workspace_manager_get_n_workspaces (_tmp7_);
#line 674 "../src/WindowManager.vala"
		_tmp9_ = _tmp8_;
#line 674 "../src/WindowManager.vala"
		_tmp5_ = meta_workspace_index (workspace) == (_tmp9_ - 1);
#line 4738 "WindowManager.c"
	} else {
#line 674 "../src/WindowManager.vala"
		_tmp5_ = FALSE;
#line 4742 "WindowManager.c"
	}
#line 674 "../src/WindowManager.vala"
	if (_tmp5_) {
#line 4746 "WindowManager.c"
		MetaDisplay* _tmp10_;
#line 675 "../src/WindowManager.vala"
		_tmp10_ = display;
#line 675 "../src/WindowManager.vala"
		gala_internal_utils_bell_notify (_tmp10_);
#line 676 "../src/WindowManager.vala"
		return;
#line 4754 "WindowManager.c"
	}
#line 680 "../src/WindowManager.vala"
	_tmp11_ = active;
#line 680 "../src/WindowManager.vala"
	if (_tmp11_ == workspace) {
#line 4760 "WindowManager.c"
		MetaDisplay* _tmp12_;
#line 681 "../src/WindowManager.vala"
		_tmp12_ = display;
#line 681 "../src/WindowManager.vala"
		gala_internal_utils_bell_notify (_tmp12_);
#line 682 "../src/WindowManager.vala"
		return;
#line 4768 "WindowManager.c"
	}
#line 685 "../src/WindowManager.vala"
	_tmp13_ = self->priv->_multitasking_view;
#line 685 "../src/WindowManager.vala"
	gala_multitasking_view_move_window (_tmp13_, window, workspace);
#line 4774 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static GalaModalProxy*
gala_window_manager_gala_real_push_modal (GalaWindowManager* base,
                                          ClutterActor* actor)
{
	GalaWindowManagerGala * self;
	GalaModalProxy* proxy = NULL;
	GalaModalProxy* _tmp0_;
	GeeLinkedList* _tmp1_;
	GalaModalProxy* _tmp2_;
	GeeLinkedList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp6_;
	GalaModalProxy* _tmp7_;
	ClutterStage* _tmp8_;
	ClutterStage* _tmp9_;
	ClutterGrab* _tmp10_;
	ClutterGrab* _tmp11_;
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GalaModalProxy* result;
#line 691 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 691 "../src/WindowManager.vala"
	g_return_val_if_fail (actor != NULL, NULL);
#line 692 "../src/WindowManager.vala"
	_tmp0_ = gala_modal_proxy_new ();
#line 692 "../src/WindowManager.vala"
	proxy = _tmp0_;
#line 694 "../src/WindowManager.vala"
	_tmp1_ = self->priv->modal_stack;
#line 694 "../src/WindowManager.vala"
	_tmp2_ = proxy;
#line 694 "../src/WindowManager.vala"
	gee_deque_offer_head ((GeeDeque*) _tmp1_, _tmp2_);
#line 697 "../src/WindowManager.vala"
	_tmp3_ = self->priv->modal_stack;
#line 697 "../src/WindowManager.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 697 "../src/WindowManager.vala"
	_tmp5_ = _tmp4_;
#line 697 "../src/WindowManager.vala"
	if (_tmp5_ >= 2) {
#line 698 "../src/WindowManager.vala"
		result = proxy;
#line 698 "../src/WindowManager.vala"
		return result;
#line 4829 "WindowManager.c"
	}
#line 700 "../src/WindowManager.vala"
	_tmp6_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 700 "../src/WindowManager.vala"
	display = _tmp6_;
#line 702 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area (self);
#line 703 "../src/WindowManager.vala"
	_tmp7_ = proxy;
#line 703 "../src/WindowManager.vala"
	_tmp8_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 703 "../src/WindowManager.vala"
	_tmp9_ = _tmp8_;
#line 703 "../src/WindowManager.vala"
	_tmp10_ = clutter_stage_grab (_tmp9_, actor);
#line 703 "../src/WindowManager.vala"
	_tmp11_ = _tmp10_;
#line 703 "../src/WindowManager.vala"
	gala_modal_proxy_set_grab (_tmp7_, _tmp11_);
#line 703 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp11_);
#line 705 "../src/WindowManager.vala"
	_tmp12_ = self->priv->modal_stack;
#line 705 "../src/WindowManager.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 705 "../src/WindowManager.vala"
	_tmp14_ = _tmp13_;
#line 705 "../src/WindowManager.vala"
	if (_tmp14_ == 1) {
#line 4859 "WindowManager.c"
		MetaDisplay* _tmp15_;
		MetaCompositor* _tmp16_;
#line 707 "../src/WindowManager.vala"
		_tmp15_ = display;
#line 707 "../src/WindowManager.vala"
		_tmp16_ = meta_display_get_compositor (_tmp15_);
#line 707 "../src/WindowManager.vala"
		meta_compositor_disable_unredirect (_tmp16_);
#line 4868 "WindowManager.c"
	}
#line 713 "../src/WindowManager.vala"
	result = proxy;
#line 713 "../src/WindowManager.vala"
	return result;
#line 4874 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_pop_modal (GalaWindowManager* base,
                                         GalaModalProxy* proxy)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	ClutterGrab* _tmp1_;
	ClutterGrab* _tmp2_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp3_;
	MetaDisplay* _tmp4_;
	MetaCompositor* _tmp5_;
#line 719 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 719 "../src/WindowManager.vala"
	g_return_if_fail (proxy != NULL);
#line 720 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 720 "../src/WindowManager.vala"
	if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, proxy)) {
#line 721 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:721: Attempted to remove a modal proxy that was not" \
" in the stack");
#line 722 "../src/WindowManager.vala"
		return;
#line 4904 "WindowManager.c"
	}
#line 725 "../src/WindowManager.vala"
	_tmp1_ = gala_modal_proxy_get_grab (proxy);
#line 725 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 725 "../src/WindowManager.vala"
	clutter_grab_dismiss (_tmp2_);
#line 727 "../src/WindowManager.vala"
	if (gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 728 "../src/WindowManager.vala"
		return;
#line 4916 "WindowManager.c"
	}
#line 730 "../src/WindowManager.vala"
	gala_window_manager_gala_update_input_area (self);
#line 732 "../src/WindowManager.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 732 "../src/WindowManager.vala"
	display = _tmp3_;
#line 735 "../src/WindowManager.vala"
	_tmp4_ = display;
#line 735 "../src/WindowManager.vala"
	_tmp5_ = meta_display_get_compositor (_tmp4_);
#line 735 "../src/WindowManager.vala"
	meta_compositor_enable_unredirect (_tmp5_);
#line 4930 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
gala_window_manager_gala_real_is_modal (GalaWindowManager* base)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 744 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 745 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 745 "../src/WindowManager.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 745 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 745 "../src/WindowManager.vala"
	result = !_tmp2_;
#line 745 "../src/WindowManager.vala"
	return result;
#line 4956 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
gala_window_manager_gala_real_modal_proxy_valid (GalaWindowManager* base,
                                                 GalaModalProxy* proxy)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	gboolean result;
#line 751 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 751 "../src/WindowManager.vala"
	g_return_val_if_fail (proxy != NULL, FALSE);
#line 752 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 752 "../src/WindowManager.vala"
	result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, proxy);
#line 752 "../src/WindowManager.vala"
	return result;
#line 4979 "WindowManager.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 755 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 755 "../src/WindowManager.vala"
	return _data15_;
#line 4989 "WindowManager.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 755 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 4999 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 755 "../src/WindowManager.vala"
		self = _data15_->self;
#line 755 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 755 "../src/WindowManager.vala"
		g_slice_free (Block15Data, _data15_);
#line 5007 "WindowManager.c"
	}
}

static void
__lambda176_ (Block15Data* _data15_)
{
	GalaWindowManagerGala* self;
	gboolean _tmp0_ = FALSE;
	MetaWindowActor* _tmp1_;
#line 771 "../src/WindowManager.vala"
	self = _data15_->self;
#line 772 "../src/WindowManager.vala"
	_tmp1_ = _data15_->transient_actor;
#line 772 "../src/WindowManager.vala"
	if (_tmp1_ != NULL) {
#line 5023 "WindowManager.c"
		MetaWindowActor* _tmp2_;
		ClutterEffect* _tmp3_;
#line 772 "../src/WindowManager.vala"
		_tmp2_ = _data15_->transient_actor;
#line 772 "../src/WindowManager.vala"
		_tmp3_ = clutter_actor_get_effect ((ClutterActor*) _tmp2_, "dim-parent");
#line 772 "../src/WindowManager.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 5032 "WindowManager.c"
	} else {
#line 772 "../src/WindowManager.vala"
		_tmp0_ = FALSE;
#line 5036 "WindowManager.c"
	}
#line 772 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 5040 "WindowManager.c"
		MetaWindowActor* _tmp4_;
#line 773 "../src/WindowManager.vala"
		_tmp4_ = _data15_->transient_actor;
#line 773 "../src/WindowManager.vala"
		clutter_actor_remove_effect_by_name ((ClutterActor*) _tmp4_, "dim-parent");
#line 5046 "WindowManager.c"
	}
}

static void
___lambda176__meta_window_unmanaged (MetaWindow* _sender,
                                     gpointer self)
{
#line 771 "../src/WindowManager.vala"
	__lambda176_ (self);
#line 5056 "WindowManager.c"
}

static void
gala_window_manager_gala_dim_parent_window (GalaWindowManagerGala* self,
                                            MetaWindow* window)
{
	Block15Data* _data15_;
	MetaWindowType _tmp0_;
	MetaWindowType _tmp1_;
	MetaWindow* transient = NULL;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	MetaWindow* _tmp4_;
	MetaWindow* _tmp6_;
	GObject* _tmp7_;
	ClutterBrightnessContrastEffect* dark_effect = NULL;
	ClutterBrightnessContrastEffect* _tmp8_;
	ClutterBrightnessContrastEffect* _tmp9_;
	MetaWindowActor* _tmp10_;
	ClutterBrightnessContrastEffect* _tmp11_;
#line 755 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 755 "../src/WindowManager.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 755 "../src/WindowManager.vala"
	_data15_->_ref_count_ = 1;
#line 755 "../src/WindowManager.vala"
	_data15_->self = g_object_ref (self);
#line 756 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_window_type (window);
#line 756 "../src/WindowManager.vala"
	_tmp1_ = _tmp0_;
#line 756 "../src/WindowManager.vala"
	if (_tmp1_ != META_WINDOW_MODAL_DIALOG) {
#line 757 "../src/WindowManager.vala"
		block15_data_unref (_data15_);
#line 757 "../src/WindowManager.vala"
		_data15_ = NULL;
#line 757 "../src/WindowManager.vala"
		return;
#line 5099 "WindowManager.c"
	}
#line 760 "../src/WindowManager.vala"
	_tmp2_ = meta_window_get_transient_for (window);
#line 760 "../src/WindowManager.vala"
	transient = _tmp2_;
#line 761 "../src/WindowManager.vala"
	_tmp4_ = transient;
#line 761 "../src/WindowManager.vala"
	if (_tmp4_ == NULL) {
#line 761 "../src/WindowManager.vala"
		_tmp3_ = TRUE;
#line 5111 "WindowManager.c"
	} else {
		MetaWindow* _tmp5_;
#line 761 "../src/WindowManager.vala"
		_tmp5_ = transient;
#line 761 "../src/WindowManager.vala"
		_tmp3_ = _tmp5_ == window;
#line 5118 "WindowManager.c"
	}
#line 761 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 762 "../src/WindowManager.vala"
		g_warning ("WindowManager.vala:762: No transient found");
#line 763 "../src/WindowManager.vala"
		block15_data_unref (_data15_);
#line 763 "../src/WindowManager.vala"
		_data15_ = NULL;
#line 763 "../src/WindowManager.vala"
		return;
#line 5130 "WindowManager.c"
	}
#line 766 "../src/WindowManager.vala"
	_tmp6_ = transient;
#line 766 "../src/WindowManager.vala"
	_tmp7_ = meta_window_get_compositor_private (_tmp6_);
#line 766 "../src/WindowManager.vala"
	_data15_->transient_actor = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, meta_window_actor_get_type (), MetaWindowActor);
#line 767 "../src/WindowManager.vala"
	_tmp8_ = (ClutterBrightnessContrastEffect*) clutter_brightness_contrast_effect_new ();
#line 767 "../src/WindowManager.vala"
	g_object_ref_sink (_tmp8_);
#line 767 "../src/WindowManager.vala"
	dark_effect = _tmp8_;
#line 768 "../src/WindowManager.vala"
	_tmp9_ = dark_effect;
#line 768 "../src/WindowManager.vala"
	clutter_brightness_contrast_effect_set_brightness (_tmp9_, -0.4f);
#line 769 "../src/WindowManager.vala"
	_tmp10_ = _data15_->transient_actor;
#line 769 "../src/WindowManager.vala"
	_tmp11_ = dark_effect;
#line 769 "../src/WindowManager.vala"
	clutter_actor_add_effect_with_name ((ClutterActor*) _tmp10_, "dim-parent", (ClutterEffect*) _tmp11_);
#line 771 "../src/WindowManager.vala"
	g_signal_connect_data (window, "unmanaged", (GCallback) ___lambda176__meta_window_unmanaged, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 755 "../src/WindowManager.vala"
	_g_object_unref0 (dark_effect);
#line 755 "../src/WindowManager.vala"
	block15_data_unref (_data15_);
#line 755 "../src/WindowManager.vala"
	_data15_ = NULL;
#line 5162 "WindowManager.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 778 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 778 "../src/WindowManager.vala"
	return _data16_;
#line 5172 "WindowManager.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 778 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 5182 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 778 "../src/WindowManager.vala"
		self = _data16_->self;
#line 778 "../src/WindowManager.vala"
		_g_object_unref0 (_data16_->proxy);
#line 778 "../src/WindowManager.vala"
		_g_object_unref0 (_data16_->window);
#line 778 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 778 "../src/WindowManager.vala"
		g_slice_free (Block16Data, _data16_);
#line 5194 "WindowManager.c"
	}
}

static gboolean
__lambda177_ (Block16Data* _data16_,
              ClutterEvent* event)
{
	GalaWindowManagerGala* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	ClutterStage* _tmp5_;
	ClutterStage* _tmp6_;
	gboolean result;
#line 782 "../src/WindowManager.vala"
	self = _data16_->self;
#line 782 "../src/WindowManager.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 783 "../src/WindowManager.vala"
	if (clutter_event_type (event) == CLUTTER_MOTION) {
#line 783 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 5217 "WindowManager.c"
	} else {
#line 783 "../src/WindowManager.vala"
		_tmp2_ = clutter_event_type (event) == CLUTTER_ENTER;
#line 5221 "WindowManager.c"
	}
#line 783 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 783 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 5227 "WindowManager.c"
	} else {
#line 784 "../src/WindowManager.vala"
		_tmp1_ = clutter_event_type (event) == CLUTTER_TOUCHPAD_HOLD;
#line 5231 "WindowManager.c"
	}
#line 783 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 783 "../src/WindowManager.vala"
		_tmp0_ = TRUE;
#line 5237 "WindowManager.c"
	} else {
#line 784 "../src/WindowManager.vala"
		_tmp0_ = clutter_event_type (event) == CLUTTER_TOUCH_BEGIN;
#line 5241 "WindowManager.c"
	}
#line 783 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 5245 "WindowManager.c"
		ClutterInputDevice* _tmp3_;
		ClutterEventSequence* _tmp4_;
#line 785 "../src/WindowManager.vala"
		_tmp3_ = clutter_event_get_device (event);
#line 785 "../src/WindowManager.vala"
		_tmp4_ = clutter_event_get_event_sequence (event);
#line 785 "../src/WindowManager.vala"
		meta_window_begin_grab_op (_data16_->window, _data16_->op, _tmp3_, _tmp4_, clutter_event_get_time (event), NULL);
#line 5254 "WindowManager.c"
	} else {
#line 794 "../src/WindowManager.vala"
		if (clutter_event_type (event) == CLUTTER_LEAVE) {
#line 797 "../src/WindowManager.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 797 "../src/WindowManager.vala"
			return result;
#line 5262 "WindowManager.c"
		}
	}
#line 800 "../src/WindowManager.vala"
	gala_window_manager_pop_modal ((GalaWindowManager*) self, _data16_->proxy);
#line 801 "../src/WindowManager.vala"
	_tmp5_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 801 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 801 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _tmp6_, _data16_->handler);
#line 803 "../src/WindowManager.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 803 "../src/WindowManager.vala"
	return result;
#line 5277 "WindowManager.c"
}

static gboolean
___lambda177__clutter_actor_captured_event (ClutterActor* _sender,
                                            ClutterEvent* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda177_ (self, event);
#line 782 "../src/WindowManager.vala"
	return result;
#line 5289 "WindowManager.c"
}

static void
gala_window_manager_gala_set_grab_trigger (GalaWindowManagerGala* self,
                                           MetaWindow* window,
                                           MetaGrabOp op)
{
	Block16Data* _data16_;
	MetaWindow* _tmp0_;
	ClutterStage* _tmp1_;
	ClutterStage* _tmp2_;
	GalaModalProxy* _tmp3_;
	ClutterStage* _tmp4_;
	ClutterStage* _tmp5_;
	gulong _tmp6_;
#line 778 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 778 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 778 "../src/WindowManager.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 778 "../src/WindowManager.vala"
	_data16_->_ref_count_ = 1;
#line 778 "../src/WindowManager.vala"
	_data16_->self = g_object_ref (self);
#line 778 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (window);
#line 778 "../src/WindowManager.vala"
	_g_object_unref0 (_data16_->window);
#line 778 "../src/WindowManager.vala"
	_data16_->window = _tmp0_;
#line 778 "../src/WindowManager.vala"
	_data16_->op = op;
#line 779 "../src/WindowManager.vala"
	_tmp1_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 779 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 779 "../src/WindowManager.vala"
	_tmp3_ = gala_window_manager_push_modal ((GalaWindowManager*) self, (ClutterActor*) _tmp2_);
#line 779 "../src/WindowManager.vala"
	_data16_->proxy = _tmp3_;
#line 781 "../src/WindowManager.vala"
	_data16_->handler = (gulong) 0;
#line 782 "../src/WindowManager.vala"
	_tmp4_ = gala_window_manager_get_stage ((GalaWindowManager*) self);
#line 782 "../src/WindowManager.vala"
	_tmp5_ = _tmp4_;
#line 782 "../src/WindowManager.vala"
	_tmp6_ = g_signal_connect_data ((ClutterActor*) _tmp5_, "captured-event", (GCallback) ___lambda177__clutter_actor_captured_event, block16_data_ref (_data16_), (GClosureNotify) block16_data_unref, 0);
#line 782 "../src/WindowManager.vala"
	_data16_->handler = _tmp6_;
#line 778 "../src/WindowManager.vala"
	block16_data_unref (_data16_);
#line 778 "../src/WindowManager.vala"
	_data16_ = NULL;
#line 5345 "WindowManager.c"
}

/**
         * {@inheritDoc}
         */
static void
gala_window_manager_gala_real_perform_action (GalaWindowManager* base,
                                              GalaActionType type)
{
	GalaWindowManagerGala * self;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp0_;
	MetaWindow* current = NULL;
	MetaDisplay* _tmp1_;
	MetaWindow* _tmp2_;
#line 810 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 811 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 811 "../src/WindowManager.vala"
	display = _tmp0_;
#line 812 "../src/WindowManager.vala"
	_tmp1_ = display;
#line 812 "../src/WindowManager.vala"
	_tmp2_ = meta_display_get_focus_window (_tmp1_);
#line 812 "../src/WindowManager.vala"
	current = _tmp2_;
#line 814 "../src/WindowManager.vala"
	switch (type) {
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SHOW_MULTITASKING_VIEW:
#line 5377 "WindowManager.c"
		{
			GalaMultitaskingView* _tmp3_;
#line 816 "../src/WindowManager.vala"
			_tmp3_ = self->priv->_multitasking_view;
#line 816 "../src/WindowManager.vala"
			if (gala_activatable_component_is_opened ((GalaActivatableComponent*) _tmp3_)) {
#line 5384 "WindowManager.c"
				GalaMultitaskingView* _tmp4_;
#line 817 "../src/WindowManager.vala"
				_tmp4_ = self->priv->_multitasking_view;
#line 817 "../src/WindowManager.vala"
				gala_activatable_component_close ((GalaActivatableComponent*) _tmp4_, NULL);
#line 5390 "WindowManager.c"
			} else {
				GalaMultitaskingView* _tmp5_;
#line 819 "../src/WindowManager.vala"
				_tmp5_ = self->priv->_multitasking_view;
#line 819 "../src/WindowManager.vala"
				gala_activatable_component_open ((GalaActivatableComponent*) _tmp5_, NULL);
#line 5397 "WindowManager.c"
			}
#line 820 "../src/WindowManager.vala"
			break;
#line 5401 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_MAXIMIZE_CURRENT:
#line 5405 "WindowManager.c"
		{
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			MetaWindow* _tmp8_;
			MetaMaximizeFlags maximize_flags = 0U;
			MetaWindow* _tmp13_;
			gboolean _tmp14_ = FALSE;
#line 822 "../src/WindowManager.vala"
			_tmp8_ = current;
#line 822 "../src/WindowManager.vala"
			if (_tmp8_ == NULL) {
#line 822 "../src/WindowManager.vala"
				_tmp7_ = TRUE;
#line 5419 "WindowManager.c"
			} else {
				MetaWindow* _tmp9_;
				MetaWindowType _tmp10_;
				MetaWindowType _tmp11_;
#line 822 "../src/WindowManager.vala"
				_tmp9_ = current;
#line 822 "../src/WindowManager.vala"
				_tmp10_ = meta_window_get_window_type (_tmp9_);
#line 822 "../src/WindowManager.vala"
				_tmp11_ = _tmp10_;
#line 822 "../src/WindowManager.vala"
				_tmp7_ = _tmp11_ != META_WINDOW_NORMAL;
#line 5432 "WindowManager.c"
			}
#line 822 "../src/WindowManager.vala"
			if (_tmp7_) {
#line 822 "../src/WindowManager.vala"
				_tmp6_ = TRUE;
#line 5438 "WindowManager.c"
			} else {
				MetaWindow* _tmp12_;
#line 822 "../src/WindowManager.vala"
				_tmp12_ = current;
#line 822 "../src/WindowManager.vala"
				_tmp6_ = !meta_window_can_maximize (_tmp12_);
#line 5445 "WindowManager.c"
			}
#line 822 "../src/WindowManager.vala"
			if (_tmp6_) {
#line 823 "../src/WindowManager.vala"
				break;
#line 5451 "WindowManager.c"
			}
#line 825 "../src/WindowManager.vala"
			_tmp13_ = current;
#line 825 "../src/WindowManager.vala"
			maximize_flags = meta_window_get_maximized (_tmp13_);
#line 826 "../src/WindowManager.vala"
			if ((maximize_flags & META_MAXIMIZE_VERTICAL) == META_MAXIMIZE_VERTICAL) {
#line 826 "../src/WindowManager.vala"
				_tmp14_ = TRUE;
#line 5461 "WindowManager.c"
			} else {
#line 826 "../src/WindowManager.vala"
				_tmp14_ = (maximize_flags & META_MAXIMIZE_HORIZONTAL) == META_MAXIMIZE_HORIZONTAL;
#line 5465 "WindowManager.c"
			}
#line 826 "../src/WindowManager.vala"
			if (_tmp14_) {
#line 5469 "WindowManager.c"
				MetaWindow* _tmp15_;
#line 827 "../src/WindowManager.vala"
				_tmp15_ = current;
#line 827 "../src/WindowManager.vala"
				meta_window_unmaximize (_tmp15_, META_MAXIMIZE_HORIZONTAL | META_MAXIMIZE_VERTICAL);
#line 5475 "WindowManager.c"
			} else {
				MetaWindow* _tmp16_;
#line 829 "../src/WindowManager.vala"
				_tmp16_ = current;
#line 829 "../src/WindowManager.vala"
				meta_window_maximize (_tmp16_, META_MAXIMIZE_HORIZONTAL | META_MAXIMIZE_VERTICAL);
#line 5482 "WindowManager.c"
			}
#line 830 "../src/WindowManager.vala"
			break;
#line 5486 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_HIDE_CURRENT:
#line 5490 "WindowManager.c"
		{
			gboolean _tmp17_ = FALSE;
			MetaWindow* _tmp18_;
#line 832 "../src/WindowManager.vala"
			_tmp18_ = current;
#line 832 "../src/WindowManager.vala"
			if (_tmp18_ != NULL) {
#line 5498 "WindowManager.c"
				MetaWindow* _tmp19_;
				MetaWindowType _tmp20_;
				MetaWindowType _tmp21_;
#line 832 "../src/WindowManager.vala"
				_tmp19_ = current;
#line 832 "../src/WindowManager.vala"
				_tmp20_ = meta_window_get_window_type (_tmp19_);
#line 832 "../src/WindowManager.vala"
				_tmp21_ = _tmp20_;
#line 832 "../src/WindowManager.vala"
				_tmp17_ = _tmp21_ == META_WINDOW_NORMAL;
#line 5510 "WindowManager.c"
			} else {
#line 832 "../src/WindowManager.vala"
				_tmp17_ = FALSE;
#line 5514 "WindowManager.c"
			}
#line 832 "../src/WindowManager.vala"
			if (_tmp17_) {
#line 5518 "WindowManager.c"
				MetaWindow* _tmp22_;
#line 833 "../src/WindowManager.vala"
				_tmp22_ = current;
#line 833 "../src/WindowManager.vala"
				meta_window_minimize (_tmp22_);
#line 5524 "WindowManager.c"
			}
#line 834 "../src/WindowManager.vala"
			break;
#line 5528 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_START_MOVE_CURRENT:
#line 5532 "WindowManager.c"
		{
			gboolean _tmp23_ = FALSE;
			MetaWindow* _tmp24_;
#line 836 "../src/WindowManager.vala"
			_tmp24_ = current;
#line 836 "../src/WindowManager.vala"
			if (_tmp24_ != NULL) {
#line 5540 "WindowManager.c"
				MetaWindow* _tmp25_;
#line 836 "../src/WindowManager.vala"
				_tmp25_ = current;
#line 836 "../src/WindowManager.vala"
				_tmp23_ = meta_window_allows_move (_tmp25_);
#line 5546 "WindowManager.c"
			} else {
#line 836 "../src/WindowManager.vala"
				_tmp23_ = FALSE;
#line 5550 "WindowManager.c"
			}
#line 836 "../src/WindowManager.vala"
			if (_tmp23_) {
#line 5554 "WindowManager.c"
				MetaWindow* _tmp26_;
#line 838 "../src/WindowManager.vala"
				_tmp26_ = current;
#line 838 "../src/WindowManager.vala"
				gala_window_manager_gala_set_grab_trigger (self, _tmp26_, META_GRAB_OP_KEYBOARD_MOVING);
#line 5560 "WindowManager.c"
			}
#line 842 "../src/WindowManager.vala"
			break;
#line 5564 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_START_RESIZE_CURRENT:
#line 5568 "WindowManager.c"
		{
			gboolean _tmp27_ = FALSE;
			MetaWindow* _tmp28_;
#line 844 "../src/WindowManager.vala"
			_tmp28_ = current;
#line 844 "../src/WindowManager.vala"
			if (_tmp28_ != NULL) {
#line 5576 "WindowManager.c"
				MetaWindow* _tmp29_;
#line 844 "../src/WindowManager.vala"
				_tmp29_ = current;
#line 844 "../src/WindowManager.vala"
				_tmp27_ = meta_window_allows_resize (_tmp29_);
#line 5582 "WindowManager.c"
			} else {
#line 844 "../src/WindowManager.vala"
				_tmp27_ = FALSE;
#line 5586 "WindowManager.c"
			}
#line 844 "../src/WindowManager.vala"
			if (_tmp27_) {
#line 5590 "WindowManager.c"
				MetaWindow* _tmp30_;
#line 846 "../src/WindowManager.vala"
				_tmp30_ = current;
#line 846 "../src/WindowManager.vala"
				gala_window_manager_gala_set_grab_trigger (self, _tmp30_, META_GRAB_OP_KEYBOARD_RESIZING_UNKNOWN);
#line 5596 "WindowManager.c"
			}
#line 850 "../src/WindowManager.vala"
			break;
#line 5600 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_TOP_CURRENT:
#line 5604 "WindowManager.c"
		{
			MetaWindow* _tmp31_;
			MetaWindow* _tmp32_;
#line 852 "../src/WindowManager.vala"
			_tmp31_ = current;
#line 852 "../src/WindowManager.vala"
			if (_tmp31_ == NULL) {
#line 853 "../src/WindowManager.vala"
				break;
#line 5614 "WindowManager.c"
			}
#line 855 "../src/WindowManager.vala"
			_tmp32_ = current;
#line 855 "../src/WindowManager.vala"
			if (meta_window_is_above (_tmp32_)) {
#line 5620 "WindowManager.c"
				MetaWindow* _tmp33_;
#line 856 "../src/WindowManager.vala"
				_tmp33_ = current;
#line 856 "../src/WindowManager.vala"
				meta_window_unmake_above (_tmp33_);
#line 5626 "WindowManager.c"
			} else {
				MetaWindow* _tmp34_;
#line 858 "../src/WindowManager.vala"
				_tmp34_ = current;
#line 858 "../src/WindowManager.vala"
				meta_window_make_above (_tmp34_);
#line 5633 "WindowManager.c"
			}
#line 859 "../src/WindowManager.vala"
			break;
#line 5637 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_TOGGLE_ALWAYS_ON_VISIBLE_WORKSPACE_CURRENT:
#line 5641 "WindowManager.c"
		{
			MetaWindow* _tmp35_;
			MetaWindow* _tmp36_;
			gboolean _tmp37_;
			gboolean _tmp38_;
#line 861 "../src/WindowManager.vala"
			_tmp35_ = current;
#line 861 "../src/WindowManager.vala"
			if (_tmp35_ == NULL) {
#line 862 "../src/WindowManager.vala"
				break;
#line 5653 "WindowManager.c"
			}
#line 864 "../src/WindowManager.vala"
			_tmp36_ = current;
#line 864 "../src/WindowManager.vala"
			g_object_get (_tmp36_, "on-all-workspaces", &_tmp37_, NULL);
#line 864 "../src/WindowManager.vala"
			_tmp38_ = _tmp37_;
#line 864 "../src/WindowManager.vala"
			if (_tmp38_) {
#line 5663 "WindowManager.c"
				MetaWindow* _tmp39_;
#line 865 "../src/WindowManager.vala"
				_tmp39_ = current;
#line 865 "../src/WindowManager.vala"
				meta_window_unstick (_tmp39_);
#line 5669 "WindowManager.c"
			} else {
				MetaWindow* _tmp40_;
#line 867 "../src/WindowManager.vala"
				_tmp40_ = current;
#line 867 "../src/WindowManager.vala"
				meta_window_stick (_tmp40_);
#line 5676 "WindowManager.c"
			}
#line 868 "../src/WindowManager.vala"
			break;
#line 5680 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_PREVIOUS:
#line 5684 "WindowManager.c"
		{
#line 870 "../src/WindowManager.vala"
			gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, META_MOTION_LEFT, (guint32) META_CURRENT_TIME);
#line 871 "../src/WindowManager.vala"
			break;
#line 5690 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_NEXT:
#line 5694 "WindowManager.c"
		{
#line 873 "../src/WindowManager.vala"
			gala_window_manager_switch_to_next_workspace ((GalaWindowManager*) self, META_MOTION_RIGHT, (guint32) META_CURRENT_TIME);
#line 874 "../src/WindowManager.vala"
			break;
#line 5700 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_LEFT:
#line 5704 "WindowManager.c"
		{
			MetaWorkspaceManager* workspace_manager = NULL;
			MetaDisplay* _tmp41_;
			MetaWorkspaceManager* _tmp42_;
			MetaWorkspace* active_workspace = NULL;
			MetaWorkspaceManager* _tmp43_;
			MetaWorkspace* _tmp44_;
			MetaWorkspace* target_workspace = NULL;
			MetaWorkspace* _tmp45_;
			MetaWorkspace* _tmp46_;
			MetaWindow* _tmp47_;
			MetaWorkspace* _tmp48_;
#line 876 "../src/WindowManager.vala"
			_tmp41_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 876 "../src/WindowManager.vala"
			_tmp42_ = meta_display_get_workspace_manager (_tmp41_);
#line 876 "../src/WindowManager.vala"
			workspace_manager = _tmp42_;
#line 877 "../src/WindowManager.vala"
			_tmp43_ = workspace_manager;
#line 877 "../src/WindowManager.vala"
			_tmp44_ = meta_workspace_manager_get_active_workspace (_tmp43_);
#line 877 "../src/WindowManager.vala"
			active_workspace = _tmp44_;
#line 878 "../src/WindowManager.vala"
			_tmp45_ = active_workspace;
#line 878 "../src/WindowManager.vala"
			_tmp46_ = meta_workspace_get_neighbor (_tmp45_, META_MOTION_LEFT);
#line 878 "../src/WindowManager.vala"
			target_workspace = _tmp46_;
#line 879 "../src/WindowManager.vala"
			_tmp47_ = current;
#line 879 "../src/WindowManager.vala"
			_tmp48_ = target_workspace;
#line 879 "../src/WindowManager.vala"
			gala_window_manager_move_window ((GalaWindowManager*) self, _tmp47_, _tmp48_, (guint32) META_CURRENT_TIME);
#line 880 "../src/WindowManager.vala"
			break;
#line 5743 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_MOVE_CURRENT_WORKSPACE_RIGHT:
#line 5747 "WindowManager.c"
		{
			MetaWorkspaceManager* workspace_manager = NULL;
			MetaDisplay* _tmp49_;
			MetaWorkspaceManager* _tmp50_;
			MetaWorkspace* active_workspace = NULL;
			MetaWorkspaceManager* _tmp51_;
			MetaWorkspace* _tmp52_;
			MetaWorkspace* target_workspace = NULL;
			MetaWorkspace* _tmp53_;
			MetaWorkspace* _tmp54_;
			MetaWindow* _tmp55_;
			MetaWorkspace* _tmp56_;
#line 882 "../src/WindowManager.vala"
			_tmp49_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 882 "../src/WindowManager.vala"
			_tmp50_ = meta_display_get_workspace_manager (_tmp49_);
#line 882 "../src/WindowManager.vala"
			workspace_manager = _tmp50_;
#line 883 "../src/WindowManager.vala"
			_tmp51_ = workspace_manager;
#line 883 "../src/WindowManager.vala"
			_tmp52_ = meta_workspace_manager_get_active_workspace (_tmp51_);
#line 883 "../src/WindowManager.vala"
			active_workspace = _tmp52_;
#line 884 "../src/WindowManager.vala"
			_tmp53_ = active_workspace;
#line 884 "../src/WindowManager.vala"
			_tmp54_ = meta_workspace_get_neighbor (_tmp53_, META_MOTION_RIGHT);
#line 884 "../src/WindowManager.vala"
			target_workspace = _tmp54_;
#line 885 "../src/WindowManager.vala"
			_tmp55_ = current;
#line 885 "../src/WindowManager.vala"
			_tmp56_ = target_workspace;
#line 885 "../src/WindowManager.vala"
			gala_window_manager_move_window ((GalaWindowManager*) self, _tmp55_, _tmp56_, (guint32) META_CURRENT_TIME);
#line 886 "../src/WindowManager.vala"
			break;
#line 5786 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_CLOSE_CURRENT:
#line 5790 "WindowManager.c"
		{
			gboolean _tmp57_ = FALSE;
			MetaWindow* _tmp58_;
#line 888 "../src/WindowManager.vala"
			_tmp58_ = current;
#line 888 "../src/WindowManager.vala"
			if (_tmp58_ != NULL) {
#line 5798 "WindowManager.c"
				MetaWindow* _tmp59_;
#line 888 "../src/WindowManager.vala"
				_tmp59_ = current;
#line 888 "../src/WindowManager.vala"
				_tmp57_ = meta_window_can_close (_tmp59_);
#line 5804 "WindowManager.c"
			} else {
#line 888 "../src/WindowManager.vala"
				_tmp57_ = FALSE;
#line 5808 "WindowManager.c"
			}
#line 888 "../src/WindowManager.vala"
			if (_tmp57_) {
#line 5812 "WindowManager.c"
				MetaWindow* _tmp60_;
#line 889 "../src/WindowManager.vala"
				_tmp60_ = current;
#line 889 "../src/WindowManager.vala"
				meta_window_delete (_tmp60_, (guint32) META_CURRENT_TIME);
#line 5818 "WindowManager.c"
			}
#line 890 "../src/WindowManager.vala"
			break;
#line 5822 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_OPEN_LAUNCHER:
#line 5826 "WindowManager.c"
		{
#line 892 "../src/WindowManager.vala"
			gala_window_manager_launch_action ((GalaWindowManager*) self, GALA_ACTION_KEYS_PANEL_MAIN_MENU_ACTION);
#line 893 "../src/WindowManager.vala"
			break;
#line 5832 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_WINDOW_OVERVIEW:
#line 5836 "WindowManager.c"
		{
			GalaActivatableComponent* _tmp61_;
			GalaActivatableComponent* _tmp62_;
#line 895 "../src/WindowManager.vala"
			_tmp61_ = self->priv->_window_overview;
#line 895 "../src/WindowManager.vala"
			if (_tmp61_ == NULL) {
#line 896 "../src/WindowManager.vala"
				break;
#line 5846 "WindowManager.c"
			}
#line 899 "../src/WindowManager.vala"
			_tmp62_ = self->priv->_window_overview;
#line 899 "../src/WindowManager.vala"
			if (gala_activatable_component_is_opened (_tmp62_)) {
#line 5852 "WindowManager.c"
				GalaActivatableComponent* _tmp63_;
#line 900 "../src/WindowManager.vala"
				_tmp63_ = self->priv->_window_overview;
#line 900 "../src/WindowManager.vala"
				gala_activatable_component_close (_tmp63_, NULL);
#line 5858 "WindowManager.c"
			} else {
				GalaActivatableComponent* _tmp64_;
#line 902 "../src/WindowManager.vala"
				_tmp64_ = self->priv->_window_overview;
#line 902 "../src/WindowManager.vala"
				gala_activatable_component_open (_tmp64_, NULL);
#line 5865 "WindowManager.c"
			}
#line 904 "../src/WindowManager.vala"
			g_critical ("WindowManager.vala:904: Window overview is deprecated");
#line 905 "../src/WindowManager.vala"
			break;
#line 5871 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_WINDOW_OVERVIEW_ALL:
#line 5875 "WindowManager.c"
		{
			GalaActivatableComponent* _tmp65_;
			GalaActivatableComponent* _tmp66_;
#line 907 "../src/WindowManager.vala"
			_tmp65_ = self->priv->_window_overview;
#line 907 "../src/WindowManager.vala"
			if (_tmp65_ == NULL) {
#line 908 "../src/WindowManager.vala"
				break;
#line 5885 "WindowManager.c"
			}
#line 911 "../src/WindowManager.vala"
			_tmp66_ = self->priv->_window_overview;
#line 911 "../src/WindowManager.vala"
			if (gala_activatable_component_is_opened (_tmp66_)) {
#line 5891 "WindowManager.c"
				GalaActivatableComponent* _tmp67_;
#line 912 "../src/WindowManager.vala"
				_tmp67_ = self->priv->_window_overview;
#line 912 "../src/WindowManager.vala"
				gala_activatable_component_close (_tmp67_, NULL);
#line 5897 "WindowManager.c"
			} else {
				GalaActivatableComponent* _tmp68_;
#line 914 "../src/WindowManager.vala"
				_tmp68_ = self->priv->_window_overview;
#line 914 "../src/WindowManager.vala"
				gala_activatable_component_open (_tmp68_, NULL);
#line 5904 "WindowManager.c"
			}
#line 916 "../src/WindowManager.vala"
			break;
#line 5908 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SWITCH_TO_WORKSPACE_LAST:
#line 5912 "WindowManager.c"
		{
			MetaWorkspaceManager* manager = NULL;
			MetaDisplay* _tmp69_;
			MetaWorkspaceManager* _tmp70_;
			MetaWorkspace* workspace = NULL;
			MetaWorkspaceManager* _tmp71_;
			MetaWorkspaceManager* _tmp72_;
			MetaWorkspace* _tmp73_;
			MetaWorkspace* _tmp74_;
			MetaDisplay* _tmp75_;
#line 918 "../src/WindowManager.vala"
			_tmp69_ = display;
#line 918 "../src/WindowManager.vala"
			_tmp70_ = meta_display_get_workspace_manager (_tmp69_);
#line 918 "../src/WindowManager.vala"
			manager = _tmp70_;
#line 919 "../src/WindowManager.vala"
			_tmp71_ = manager;
#line 919 "../src/WindowManager.vala"
			_tmp72_ = manager;
#line 919 "../src/WindowManager.vala"
			_tmp73_ = meta_workspace_manager_get_workspace_by_index (_tmp71_, meta_workspace_manager_get_n_workspaces (_tmp72_) - 1);
#line 919 "../src/WindowManager.vala"
			workspace = _tmp73_;
#line 920 "../src/WindowManager.vala"
			_tmp74_ = workspace;
#line 920 "../src/WindowManager.vala"
			_tmp75_ = display;
#line 920 "../src/WindowManager.vala"
			meta_workspace_activate (_tmp74_, meta_display_get_current_time (_tmp75_));
#line 921 "../src/WindowManager.vala"
			break;
#line 5945 "WindowManager.c"
		}
#line 814 "../src/WindowManager.vala"
		case GALA_ACTION_TYPE_SCREENSHOT_CURRENT:
#line 5949 "WindowManager.c"
		{
			GalaScreenshotManager* _tmp76_;
#line 923 "../src/WindowManager.vala"
			_tmp76_ = self->priv->screenshot_manager;
#line 923 "../src/WindowManager.vala"
			gala_screenshot_manager_handle_screenshot_current_window_shortcut (_tmp76_, FALSE, NULL, NULL);
#line 924 "../src/WindowManager.vala"
			break;
#line 5958 "WindowManager.c"
		}
		default:
		{
#line 926 "../src/WindowManager.vala"
			g_warning ("WindowManager.vala:926: Trying to run unknown action");
#line 927 "../src/WindowManager.vala"
			break;
#line 5966 "WindowManager.c"
		}
	}
}

static void
gala_window_manager_gala_real_show_window_menu (MetaPlugin* base,
                                                MetaWindow* window,
                                                MetaWindowMenuType menu,
                                                gint x,
                                                gint y)
{
	GalaWindowManagerGala * self;
#line 931 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 931 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 932 "../src/WindowManager.vala"
	switch (menu) {
#line 932 "../src/WindowManager.vala"
		case META_WINDOW_MENU_WM:
#line 5987 "WindowManager.c"
		{
			GalaWindowFlags flags = 0U;
			MetaMaximizeFlags maximize_flags = 0U;
			gboolean _tmp1_;
			gboolean _tmp2_;
			MetaWorkspace* workspace = NULL;
			MetaWorkspace* _tmp3_;
			MetaWorkspace* _tmp4_;
			GalaDaemonManager* _tmp16_;
#line 934 "../src/WindowManager.vala"
			if (gala_notification_stack_is_notification (window)) {
#line 935 "../src/WindowManager.vala"
				return;
#line 6001 "WindowManager.c"
			}
#line 938 "../src/WindowManager.vala"
			flags = GALA_WINDOW_FLAGS_NONE;
#line 939 "../src/WindowManager.vala"
			if (meta_window_can_minimize (window)) {
#line 940 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_CAN_HIDE;
#line 6009 "WindowManager.c"
			}
#line 942 "../src/WindowManager.vala"
			if (meta_window_can_maximize (window)) {
#line 943 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_CAN_MAXIMIZE;
#line 6015 "WindowManager.c"
			}
#line 945 "../src/WindowManager.vala"
			maximize_flags = meta_window_get_maximized (window);
#line 946 "../src/WindowManager.vala"
			if (maximize_flags > 0) {
#line 6021 "WindowManager.c"
				gboolean _tmp0_ = FALSE;
#line 947 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_IS_MAXIMIZED;
#line 949 "../src/WindowManager.vala"
				if ((maximize_flags & META_MAXIMIZE_VERTICAL) == META_MAXIMIZE_VERTICAL) {
#line 949 "../src/WindowManager.vala"
					_tmp0_ = !((maximize_flags & META_MAXIMIZE_HORIZONTAL) == META_MAXIMIZE_HORIZONTAL);
#line 6029 "WindowManager.c"
				} else {
#line 949 "../src/WindowManager.vala"
					_tmp0_ = FALSE;
#line 6033 "WindowManager.c"
				}
#line 949 "../src/WindowManager.vala"
				if (_tmp0_) {
#line 950 "../src/WindowManager.vala"
					flags |= GALA_WINDOW_FLAGS_IS_TILED;
#line 6039 "WindowManager.c"
				}
			}
#line 954 "../src/WindowManager.vala"
			if (meta_window_allows_move (window)) {
#line 955 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ALLOWS_MOVE;
#line 6046 "WindowManager.c"
			}
#line 957 "../src/WindowManager.vala"
			if (meta_window_allows_resize (window)) {
#line 958 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ALLOWS_RESIZE;
#line 6052 "WindowManager.c"
			}
#line 960 "../src/WindowManager.vala"
			if (meta_window_is_above (window)) {
#line 961 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ALWAYS_ON_TOP;
#line 6058 "WindowManager.c"
			}
#line 963 "../src/WindowManager.vala"
			g_object_get (window, "on-all-workspaces", &_tmp1_, NULL);
#line 963 "../src/WindowManager.vala"
			_tmp2_ = _tmp1_;
#line 963 "../src/WindowManager.vala"
			if (_tmp2_) {
#line 964 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_ON_ALL_WORKSPACES;
#line 6068 "WindowManager.c"
			}
#line 966 "../src/WindowManager.vala"
			if (meta_window_can_close (window)) {
#line 967 "../src/WindowManager.vala"
				flags |= GALA_WINDOW_FLAGS_CAN_CLOSE;
#line 6074 "WindowManager.c"
			}
#line 969 "../src/WindowManager.vala"
			_tmp3_ = meta_window_get_workspace (window);
#line 969 "../src/WindowManager.vala"
			workspace = _tmp3_;
#line 970 "../src/WindowManager.vala"
			_tmp4_ = workspace;
#line 970 "../src/WindowManager.vala"
			if (_tmp4_ != NULL) {
#line 6084 "WindowManager.c"
				MetaWorkspaceManager* manager = NULL;
				MetaDisplay* _tmp5_;
				MetaDisplay* _tmp6_;
				MetaWorkspaceManager* _tmp7_;
				guint workspace_index = 0U;
				MetaWorkspace* _tmp8_;
				guint _tmp9_;
				guint _tmp10_;
				gboolean _tmp11_ = FALSE;
				MetaWorkspaceManager* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 971 "../src/WindowManager.vala"
				_tmp5_ = meta_window_get_display (window);
#line 971 "../src/WindowManager.vala"
				_tmp6_ = _tmp5_;
#line 971 "../src/WindowManager.vala"
				_tmp7_ = meta_display_get_workspace_manager (_tmp6_);
#line 971 "../src/WindowManager.vala"
				manager = _tmp7_;
#line 972 "../src/WindowManager.vala"
				_tmp8_ = workspace;
#line 972 "../src/WindowManager.vala"
				g_object_get (_tmp8_, "workspace-index", &_tmp9_, NULL);
#line 972 "../src/WindowManager.vala"
				_tmp10_ = _tmp9_;
#line 972 "../src/WindowManager.vala"
				workspace_index = _tmp10_;
#line 973 "../src/WindowManager.vala"
				if (workspace_index != ((guint) 0)) {
#line 974 "../src/WindowManager.vala"
					flags |= GALA_WINDOW_FLAGS_ALLOWS_MOVE_LEFT;
#line 6117 "WindowManager.c"
				}
#line 977 "../src/WindowManager.vala"
				_tmp12_ = manager;
#line 977 "../src/WindowManager.vala"
				_tmp13_ = meta_workspace_manager_get_n_workspaces (_tmp12_);
#line 977 "../src/WindowManager.vala"
				_tmp14_ = _tmp13_;
#line 977 "../src/WindowManager.vala"
				if (workspace_index != ((guint) (_tmp14_ - 2))) {
#line 977 "../src/WindowManager.vala"
					_tmp11_ = TRUE;
#line 6129 "WindowManager.c"
				} else {
					MetaWorkspace* _tmp15_;
#line 977 "../src/WindowManager.vala"
					_tmp15_ = workspace;
#line 977 "../src/WindowManager.vala"
					_tmp11_ = gala_utils_get_n_windows (_tmp15_, FALSE, NULL) != ((guint) 1);
#line 6136 "WindowManager.c"
				}
#line 977 "../src/WindowManager.vala"
				if (_tmp11_) {
#line 978 "../src/WindowManager.vala"
					flags |= GALA_WINDOW_FLAGS_ALLOWS_MOVE_RIGHT;
#line 6142 "WindowManager.c"
				}
			}
#line 982 "../src/WindowManager.vala"
			_tmp16_ = self->priv->daemon_manager;
#line 982 "../src/WindowManager.vala"
			gala_daemon_manager_show_window_menu (_tmp16_, flags, x, y, NULL, NULL);
#line 983 "../src/WindowManager.vala"
			break;
#line 6151 "WindowManager.c"
		}
#line 932 "../src/WindowManager.vala"
		case META_WINDOW_MENU_APP:
#line 6155 "WindowManager.c"
		{
#line 986 "../src/WindowManager.vala"
			break;
#line 6159 "WindowManager.c"
		}
		default:
#line 932 "../src/WindowManager.vala"
		break;
#line 6164 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_show_tile_preview (MetaPlugin* base,
                                                 MetaWindow* window,
                                                 MtkRectangle* tile_rect,
                                                 gint tile_monitor_number)
{
	GalaWindowManagerGala * self;
	ClutterActor* _tmp0_;
	MetaWindowActor* window_actor = NULL;
	GObject* _tmp34_;
	ClutterActor* _tmp35_;
	ClutterActor* _tmp36_;
	ClutterActor* _tmp37_;
	MetaWindowActor* _tmp38_;
	guint duration = 0U;
	MtkRectangle rect = {0};
	MtkRectangle _tmp39_ = {0};
	ClutterActor* _tmp40_;
	MtkRectangle _tmp41_;
	MtkRectangle _tmp42_;
	ClutterActor* _tmp43_;
	MtkRectangle _tmp44_;
	MtkRectangle _tmp45_;
	ClutterActor* _tmp46_;
#line 990 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 990 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 990 "../src/WindowManager.vala"
	g_return_if_fail (tile_rect != NULL);
#line 991 "../src/WindowManager.vala"
	_tmp0_ = self->priv->tile_preview;
#line 991 "../src/WindowManager.vala"
	if (_tmp0_ == NULL) {
#line 6202 "WindowManager.c"
		ClutterActor* _tmp1_;
		GdkRGBA rgba = {0};
		GalaDrawingStyleManager* _tmp2_;
		GalaDrawingStyleManager* _tmp3_;
		GdkRGBA _tmp4_ = {0};
		GdkRGBA _tmp5_;
		GdkRGBA _tmp6_;
		ClutterActor* _tmp7_;
		GdkRGBA _tmp8_;
		GdkRGBA _tmp9_;
		GdkRGBA _tmp10_;
		GdkRGBA _tmp11_;
		CoglColor _tmp12_ = {0};
		ClutterActor* _tmp13_;
		ClutterActor* _tmp14_;
		ClutterActor* _tmp15_;
		ClutterActor* _tmp16_;
#line 992 "../src/WindowManager.vala"
		_tmp1_ = clutter_actor_new ();
#line 992 "../src/WindowManager.vala"
		g_object_ref_sink (_tmp1_);
#line 992 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->tile_preview);
#line 992 "../src/WindowManager.vala"
		self->priv->tile_preview = _tmp1_;
#line 993 "../src/WindowManager.vala"
		_tmp2_ = gala_drawing_style_manager_get_instance ();
#line 993 "../src/WindowManager.vala"
		_tmp3_ = _tmp2_;
#line 993 "../src/WindowManager.vala"
		gala_drawing_style_manager_get_theme_accent_color (_tmp3_, &_tmp4_);
#line 993 "../src/WindowManager.vala"
		_tmp5_ = _tmp4_;
#line 993 "../src/WindowManager.vala"
		_tmp6_ = _tmp5_;
#line 993 "../src/WindowManager.vala"
		_g_object_unref0 (_tmp3_);
#line 993 "../src/WindowManager.vala"
		rgba = _tmp6_;
#line 994 "../src/WindowManager.vala"
		_tmp7_ = self->priv->tile_preview;
#line 994 "../src/WindowManager.vala"
		_tmp8_ = rgba;
#line 994 "../src/WindowManager.vala"
		_tmp9_ = rgba;
#line 994 "../src/WindowManager.vala"
		_tmp10_ = rgba;
#line 994 "../src/WindowManager.vala"
		_tmp11_ = rgba;
#line 994 "../src/WindowManager.vala"
		_tmp12_.red = (guint8) (255.0 * _tmp8_.red);
#line 994 "../src/WindowManager.vala"
		_tmp12_.green = (guint8) (255.0 * _tmp9_.green);
#line 994 "../src/WindowManager.vala"
		_tmp12_.blue = (guint8) (255.0 * _tmp10_.blue);
#line 994 "../src/WindowManager.vala"
		_tmp12_.alpha = (guint8) (255.0 * _tmp11_.alpha);
#line 994 "../src/WindowManager.vala"
		clutter_actor_set_background_color (_tmp7_, &_tmp12_);
#line 1000 "../src/WindowManager.vala"
		_tmp13_ = self->priv->tile_preview;
#line 1000 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp13_, 0U);
#line 1002 "../src/WindowManager.vala"
		_tmp14_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 1002 "../src/WindowManager.vala"
		_tmp15_ = _tmp14_;
#line 1002 "../src/WindowManager.vala"
		_tmp16_ = self->priv->tile_preview;
#line 1002 "../src/WindowManager.vala"
		clutter_actor_add_child (_tmp15_, _tmp16_);
#line 6274 "WindowManager.c"
	} else {
		ClutterActor* _tmp17_;
#line 1003 "../src/WindowManager.vala"
		_tmp17_ = self->priv->tile_preview;
#line 1003 "../src/WindowManager.vala"
		if (clutter_actor_is_visible (_tmp17_)) {
#line 6281 "WindowManager.c"
			gfloat width = 0.0F;
			gfloat height = 0.0F;
			gfloat x = 0.0F;
			gfloat y = 0.0F;
			ClutterActor* _tmp18_;
			gfloat _tmp19_ = 0.0F;
			gfloat _tmp20_ = 0.0F;
			ClutterActor* _tmp21_;
			gfloat _tmp22_ = 0.0F;
			gfloat _tmp23_ = 0.0F;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
			gboolean _tmp26_ = FALSE;
			gboolean _tmp27_ = FALSE;
			MtkRectangle _tmp28_;
#line 1005 "../src/WindowManager.vala"
			_tmp18_ = self->priv->tile_preview;
#line 1005 "../src/WindowManager.vala"
			clutter_actor_get_position (_tmp18_, &_tmp19_, &_tmp20_);
#line 1005 "../src/WindowManager.vala"
			x = _tmp19_;
#line 1005 "../src/WindowManager.vala"
			y = _tmp20_;
#line 1006 "../src/WindowManager.vala"
			_tmp21_ = self->priv->tile_preview;
#line 1006 "../src/WindowManager.vala"
			clutter_actor_get_size (_tmp21_, &_tmp22_, &_tmp23_);
#line 1006 "../src/WindowManager.vala"
			width = _tmp22_;
#line 1006 "../src/WindowManager.vala"
			height = _tmp23_;
#line 1008 "../src/WindowManager.vala"
			_tmp28_ = *tile_rect;
#line 1008 "../src/WindowManager.vala"
			if (((gfloat) _tmp28_.width) == width) {
#line 6317 "WindowManager.c"
				MtkRectangle _tmp29_;
#line 1008 "../src/WindowManager.vala"
				_tmp29_ = *tile_rect;
#line 1008 "../src/WindowManager.vala"
				_tmp27_ = ((gfloat) _tmp29_.height) == height;
#line 6323 "WindowManager.c"
			} else {
#line 1008 "../src/WindowManager.vala"
				_tmp27_ = FALSE;
#line 6327 "WindowManager.c"
			}
#line 1008 "../src/WindowManager.vala"
			if (_tmp27_) {
#line 6331 "WindowManager.c"
				MtkRectangle _tmp30_;
#line 1008 "../src/WindowManager.vala"
				_tmp30_ = *tile_rect;
#line 1008 "../src/WindowManager.vala"
				_tmp26_ = ((gfloat) _tmp30_.x) == x;
#line 6337 "WindowManager.c"
			} else {
#line 1008 "../src/WindowManager.vala"
				_tmp26_ = FALSE;
#line 6341 "WindowManager.c"
			}
#line 1008 "../src/WindowManager.vala"
			if (_tmp26_) {
#line 6345 "WindowManager.c"
				MtkRectangle _tmp31_;
#line 1008 "../src/WindowManager.vala"
				_tmp31_ = *tile_rect;
#line 1008 "../src/WindowManager.vala"
				_tmp25_ = ((gfloat) _tmp31_.y) == y;
#line 6351 "WindowManager.c"
			} else {
#line 1008 "../src/WindowManager.vala"
				_tmp25_ = FALSE;
#line 6355 "WindowManager.c"
			}
#line 1008 "../src/WindowManager.vala"
			if (_tmp25_) {
#line 1008 "../src/WindowManager.vala"
				_tmp24_ = TRUE;
#line 6361 "WindowManager.c"
			} else {
				ClutterActor* _tmp32_;
				ClutterTransition* _tmp33_;
#line 1009 "../src/WindowManager.vala"
				_tmp32_ = self->priv->tile_preview;
#line 1009 "../src/WindowManager.vala"
				_tmp33_ = clutter_actor_get_transition (_tmp32_, "size");
#line 1009 "../src/WindowManager.vala"
				_tmp24_ = _tmp33_ != NULL;
#line 6371 "WindowManager.c"
			}
#line 1008 "../src/WindowManager.vala"
			if (_tmp24_) {
#line 1010 "../src/WindowManager.vala"
				return;
#line 6377 "WindowManager.c"
			}
		}
	}
#line 1014 "../src/WindowManager.vala"
	_tmp34_ = meta_window_get_compositor_private (window);
#line 1014 "../src/WindowManager.vala"
	window_actor = G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, meta_window_actor_get_type ()) ? ((MetaWindowActor*) _tmp34_) : NULL;
#line 1015 "../src/WindowManager.vala"
	_tmp35_ = gala_window_manager_get_window_group ((GalaWindowManager*) self);
#line 1015 "../src/WindowManager.vala"
	_tmp36_ = _tmp35_;
#line 1015 "../src/WindowManager.vala"
	_tmp37_ = self->priv->tile_preview;
#line 1015 "../src/WindowManager.vala"
	_tmp38_ = window_actor;
#line 1015 "../src/WindowManager.vala"
	clutter_actor_set_child_below_sibling (_tmp36_, _tmp37_, (ClutterActor*) _tmp38_);
#line 1017 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_SNAP / 2U;
#line 1019 "../src/WindowManager.vala"
	meta_window_get_frame_rect (window, &_tmp39_);
#line 1019 "../src/WindowManager.vala"
	rect = _tmp39_;
#line 1020 "../src/WindowManager.vala"
	_tmp40_ = self->priv->tile_preview;
#line 1020 "../src/WindowManager.vala"
	_tmp41_ = rect;
#line 1020 "../src/WindowManager.vala"
	_tmp42_ = rect;
#line 1020 "../src/WindowManager.vala"
	clutter_actor_set_position (_tmp40_, (gfloat) _tmp41_.x, (gfloat) _tmp42_.y);
#line 1021 "../src/WindowManager.vala"
	_tmp43_ = self->priv->tile_preview;
#line 1021 "../src/WindowManager.vala"
	_tmp44_ = rect;
#line 1021 "../src/WindowManager.vala"
	_tmp45_ = rect;
#line 1021 "../src/WindowManager.vala"
	clutter_actor_set_size (_tmp43_, (gfloat) _tmp44_.width, (gfloat) _tmp45_.height);
#line 1022 "../src/WindowManager.vala"
	_tmp46_ = self->priv->tile_preview;
#line 1022 "../src/WindowManager.vala"
	clutter_actor_show (_tmp46_);
#line 1024 "../src/WindowManager.vala"
	if (meta_prefs_get_gnome_animations ()) {
#line 6423 "WindowManager.c"
		ClutterActor* _tmp47_;
		ClutterActor* _tmp48_;
		ClutterActor* _tmp49_;
		ClutterActor* _tmp50_;
		ClutterActor* _tmp51_;
		MtkRectangle _tmp52_;
		MtkRectangle _tmp53_;
		ClutterActor* _tmp54_;
		MtkRectangle _tmp55_;
		MtkRectangle _tmp56_;
		ClutterActor* _tmp57_;
#line 1025 "../src/WindowManager.vala"
		_tmp47_ = self->priv->tile_preview;
#line 1025 "../src/WindowManager.vala"
		clutter_actor_save_easing_state (_tmp47_);
#line 1026 "../src/WindowManager.vala"
		_tmp48_ = self->priv->tile_preview;
#line 1026 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode (_tmp48_, CLUTTER_EASE_IN_OUT_QUAD);
#line 1027 "../src/WindowManager.vala"
		_tmp49_ = self->priv->tile_preview;
#line 1027 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration (_tmp49_, duration);
#line 1028 "../src/WindowManager.vala"
		_tmp50_ = self->priv->tile_preview;
#line 1028 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp50_, 255U);
#line 1029 "../src/WindowManager.vala"
		_tmp51_ = self->priv->tile_preview;
#line 1029 "../src/WindowManager.vala"
		_tmp52_ = *tile_rect;
#line 1029 "../src/WindowManager.vala"
		_tmp53_ = *tile_rect;
#line 1029 "../src/WindowManager.vala"
		clutter_actor_set_position (_tmp51_, (gfloat) _tmp52_.x, (gfloat) _tmp53_.y);
#line 1030 "../src/WindowManager.vala"
		_tmp54_ = self->priv->tile_preview;
#line 1030 "../src/WindowManager.vala"
		_tmp55_ = *tile_rect;
#line 1030 "../src/WindowManager.vala"
		_tmp56_ = *tile_rect;
#line 1030 "../src/WindowManager.vala"
		clutter_actor_set_size (_tmp54_, (gfloat) _tmp55_.width, (gfloat) _tmp56_.height);
#line 1031 "../src/WindowManager.vala"
		_tmp57_ = self->priv->tile_preview;
#line 1031 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state (_tmp57_);
#line 6471 "WindowManager.c"
	} else {
		ClutterActor* _tmp58_;
#line 1033 "../src/WindowManager.vala"
		_tmp58_ = self->priv->tile_preview;
#line 1033 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp58_, 255U);
#line 6478 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_hide_tile_preview (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	ClutterActor* _tmp0_;
#line 1037 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1038 "../src/WindowManager.vala"
	_tmp0_ = self->priv->tile_preview;
#line 1038 "../src/WindowManager.vala"
	if (_tmp0_ != NULL) {
#line 6493 "WindowManager.c"
		ClutterActor* _tmp1_;
		ClutterActor* _tmp2_;
		ClutterActor* _tmp3_;
#line 1039 "../src/WindowManager.vala"
		_tmp1_ = self->priv->tile_preview;
#line 1039 "../src/WindowManager.vala"
		clutter_actor_remove_all_transitions (_tmp1_);
#line 1040 "../src/WindowManager.vala"
		_tmp2_ = self->priv->tile_preview;
#line 1040 "../src/WindowManager.vala"
		clutter_actor_set_opacity (_tmp2_, 0U);
#line 1041 "../src/WindowManager.vala"
		_tmp3_ = self->priv->tile_preview;
#line 1041 "../src/WindowManager.vala"
		clutter_actor_hide (_tmp3_);
#line 1042 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->tile_preview);
#line 1042 "../src/WindowManager.vala"
		self->priv->tile_preview = NULL;
#line 6513 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_show_window_menu_for_rect (MetaPlugin* base,
                                                         MetaWindow* window,
                                                         MetaWindowMenuType menu,
                                                         MtkRectangle* rect)
{
	GalaWindowManagerGala * self;
	MtkRectangle _tmp0_;
	MtkRectangle _tmp1_;
#line 1046 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1046 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1046 "../src/WindowManager.vala"
	g_return_if_fail (rect != NULL);
#line 1047 "../src/WindowManager.vala"
	_tmp0_ = *rect;
#line 1047 "../src/WindowManager.vala"
	_tmp1_ = *rect;
#line 1047 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->show_window_menu ((MetaPlugin*) self, window, menu, _tmp0_.x, _tmp1_.y);
#line 6538 "WindowManager.c"
}

static void
gala_window_manager_gala_check_shell_window (GalaWindowManagerGala* self,
                                             MetaWindowActor* actor)
{
	MetaWindow* window = NULL;
	MetaWindow* _tmp0_;
	GalaShellClientsManager* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp4_;
#line 1050 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1050 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1051 "../src/WindowManager.vala"
	_tmp0_ = meta_window_actor_get_meta_window (actor);
#line 1051 "../src/WindowManager.vala"
	window = _tmp0_;
#line 1052 "../src/WindowManager.vala"
	_tmp1_ = gala_shell_clients_manager_get_instance ();
#line 1052 "../src/WindowManager.vala"
	_tmp2_ = window;
#line 1052 "../src/WindowManager.vala"
	if (gala_shell_clients_manager_is_positioned_window (_tmp1_, _tmp2_)) {
#line 6564 "WindowManager.c"
		ClutterActor* _tmp3_;
#line 1053 "../src/WindowManager.vala"
		_tmp3_ = self->priv->_shell_group;
#line 1053 "../src/WindowManager.vala"
		gala_internal_utils_clutter_actor_reparent ((ClutterActor*) actor, _tmp3_);
#line 6570 "WindowManager.c"
	}
#line 1056 "../src/WindowManager.vala"
	_tmp4_ = window;
#line 1056 "../src/WindowManager.vala"
	if (gala_notification_stack_is_notification (_tmp4_)) {
#line 6576 "WindowManager.c"
		GalaNotificationStack* _tmp5_;
#line 1057 "../src/WindowManager.vala"
		_tmp5_ = self->priv->notification_stack;
#line 1057 "../src/WindowManager.vala"
		gala_notification_stack_show_notification (_tmp5_, actor);
#line 6582 "WindowManager.c"
	}
}

static MetaSizeChange*
_meta_size_change_dup (MetaSizeChange* self)
{
	MetaSizeChange* dup;
#line 1068 "../src/WindowManager.vala"
	dup = g_new0 (MetaSizeChange, 1);
#line 1068 "../src/WindowManager.vala"
	memcpy (dup, self, sizeof (MetaSizeChange));
#line 1068 "../src/WindowManager.vala"
	return dup;
#line 6596 "WindowManager.c"
}

static gpointer
__meta_size_change_dup0 (gpointer self)
{
#line 1068 "../src/WindowManager.vala"
	return self ? _meta_size_change_dup (self) : NULL;
#line 6604 "WindowManager.c"
}

static void
gala_window_manager_gala_real_size_change (MetaPlugin* base,
                                           MetaWindowActor* actor,
                                           MetaSizeChange which_change_local,
                                           MtkRectangle* old_frame_rect,
                                           MtkRectangle* old_buffer_rect)
{
	GalaWindowManagerGala * self;
	MetaSizeChange* _tmp0_;
	MtkRectangle _tmp1_;
#line 1067 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1067 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1067 "../src/WindowManager.vala"
	g_return_if_fail (old_frame_rect != NULL);
#line 1067 "../src/WindowManager.vala"
	g_return_if_fail (old_buffer_rect != NULL);
#line 1068 "../src/WindowManager.vala"
	_tmp0_ = __meta_size_change_dup0 (&which_change_local);
#line 1068 "../src/WindowManager.vala"
	_g_free0 (self->priv->which_change);
#line 1068 "../src/WindowManager.vala"
	self->priv->which_change = _tmp0_;
#line 1069 "../src/WindowManager.vala"
	_tmp1_ = *old_frame_rect;
#line 1069 "../src/WindowManager.vala"
	self->priv->old_rect_size_change = _tmp1_;
#line 1071 "../src/WindowManager.vala"
	if (meta_prefs_get_gnome_animations ()) {
#line 6637 "WindowManager.c"
		MtkRectangle _tmp2_;
		ClutterActor* _tmp3_;
#line 1072 "../src/WindowManager.vala"
		_tmp2_ = *old_frame_rect;
#line 1072 "../src/WindowManager.vala"
		_tmp3_ = gala_utils_get_window_actor_snapshot (actor, &_tmp2_);
#line 1072 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->latest_window_snapshot);
#line 1072 "../src/WindowManager.vala"
		self->priv->latest_window_snapshot = _tmp3_;
#line 6648 "WindowManager.c"
	}
}

static void
gala_window_manager_gala_real_size_changed (MetaPlugin* base,
                                            MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	MetaSizeChange* _tmp0_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp1_;
	MtkRectangle new_rect = {0};
	MetaWindow* _tmp2_;
	MtkRectangle _tmp3_ = {0};
	MetaSizeChange* _tmp4_;
#line 1077 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1077 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1078 "../src/WindowManager.vala"
	_tmp0_ = self->priv->which_change;
#line 1078 "../src/WindowManager.vala"
	if (_tmp0_ == NULL) {
#line 1079 "../src/WindowManager.vala"
		return;
#line 6674 "WindowManager.c"
	}
#line 1082 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (actor);
#line 1082 "../src/WindowManager.vala"
	window = _tmp1_;
#line 1083 "../src/WindowManager.vala"
	_tmp2_ = window;
#line 1083 "../src/WindowManager.vala"
	meta_window_get_frame_rect (_tmp2_, &_tmp3_);
#line 1083 "../src/WindowManager.vala"
	new_rect = _tmp3_;
#line 1085 "../src/WindowManager.vala"
	_tmp4_ = self->priv->which_change;
#line 1085 "../src/WindowManager.vala"
	switch (*_tmp4_) {
#line 1085 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_MAXIMIZE:
#line 1085 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_FULLSCREEN:
#line 6694 "WindowManager.c"
		{
			gboolean _tmp5_ = FALSE;
			MetaWindow* _tmp6_;
			MetaWindow* _tmp7_;
			MtkRectangle _tmp18_;
			MtkRectangle _tmp19_;
			MtkRectangle _tmp20_;
			MtkRectangle _tmp21_;
#line 1089 "../src/WindowManager.vala"
			_tmp6_ = window;
#line 1089 "../src/WindowManager.vala"
			_tmp7_ = meta_window_get_tile_match (_tmp6_);
#line 1089 "../src/WindowManager.vala"
			if (_tmp7_ != NULL) {
#line 6709 "WindowManager.c"
				MetaWindow* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
#line 1089 "../src/WindowManager.vala"
				_tmp8_ = window;
#line 1089 "../src/WindowManager.vala"
				g_object_get (_tmp8_, "maximized-horizontally", &_tmp9_, NULL);
#line 1089 "../src/WindowManager.vala"
				_tmp10_ = _tmp9_;
#line 1089 "../src/WindowManager.vala"
				_tmp5_ = !_tmp10_;
#line 6721 "WindowManager.c"
			} else {
#line 1089 "../src/WindowManager.vala"
				_tmp5_ = FALSE;
#line 6725 "WindowManager.c"
			}
#line 1089 "../src/WindowManager.vala"
			if (_tmp5_) {
#line 6729 "WindowManager.c"
				gint old_end = 0;
				MtkRectangle _tmp11_;
				MtkRectangle _tmp12_;
				gint new_end = 0;
				MtkRectangle _tmp13_;
				MtkRectangle _tmp14_;
				gboolean _tmp15_ = FALSE;
				MtkRectangle _tmp16_;
				MtkRectangle _tmp17_;
#line 1090 "../src/WindowManager.vala"
				_tmp11_ = self->priv->old_rect_size_change;
#line 1090 "../src/WindowManager.vala"
				_tmp12_ = self->priv->old_rect_size_change;
#line 1090 "../src/WindowManager.vala"
				old_end = _tmp11_.x + _tmp12_.width;
#line 1091 "../src/WindowManager.vala"
				_tmp13_ = new_rect;
#line 1091 "../src/WindowManager.vala"
				_tmp14_ = new_rect;
#line 1091 "../src/WindowManager.vala"
				new_end = _tmp13_.x + _tmp14_.width;
#line 1094 "../src/WindowManager.vala"
				_tmp16_ = self->priv->old_rect_size_change;
#line 1094 "../src/WindowManager.vala"
				_tmp17_ = new_rect;
#line 1094 "../src/WindowManager.vala"
				if (_tmp16_.x == _tmp17_.x) {
#line 1094 "../src/WindowManager.vala"
					_tmp15_ = TRUE;
#line 6759 "WindowManager.c"
				} else {
#line 1094 "../src/WindowManager.vala"
					_tmp15_ = old_end == new_end;
#line 6763 "WindowManager.c"
				}
#line 1094 "../src/WindowManager.vala"
				if (_tmp15_) {
#line 1095 "../src/WindowManager.vala"
					break;
#line 6769 "WindowManager.c"
				}
			}
#line 1099 "../src/WindowManager.vala"
			_tmp18_ = new_rect;
#line 1099 "../src/WindowManager.vala"
			_tmp19_ = new_rect;
#line 1099 "../src/WindowManager.vala"
			_tmp20_ = new_rect;
#line 1099 "../src/WindowManager.vala"
			_tmp21_ = new_rect;
#line 1099 "../src/WindowManager.vala"
			gala_window_manager_gala_maximize (self, actor, _tmp18_.x, _tmp19_.y, _tmp20_.width, _tmp21_.height);
#line 1100 "../src/WindowManager.vala"
			break;
#line 6784 "WindowManager.c"
		}
#line 1085 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_UNMAXIMIZE:
#line 1085 "../src/WindowManager.vala"
		case META_SIZE_CHANGE_UNFULLSCREEN:
#line 6790 "WindowManager.c"
		{
			MtkRectangle _tmp22_;
			MtkRectangle _tmp23_;
			MtkRectangle _tmp24_;
			MtkRectangle _tmp25_;
#line 1103 "../src/WindowManager.vala"
			_tmp22_ = new_rect;
#line 1103 "../src/WindowManager.vala"
			_tmp23_ = new_rect;
#line 1103 "../src/WindowManager.vala"
			_tmp24_ = new_rect;
#line 1103 "../src/WindowManager.vala"
			_tmp25_ = new_rect;
#line 1103 "../src/WindowManager.vala"
			gala_window_manager_gala_unmaximize (self, actor, _tmp22_.x, _tmp23_.y, _tmp24_.width, _tmp25_.height);
#line 1104 "../src/WindowManager.vala"
			break;
#line 6808 "WindowManager.c"
		}
		default:
		{
#line 1106 "../src/WindowManager.vala"
			break;
#line 6814 "WindowManager.c"
		}
	}
#line 1109 "../src/WindowManager.vala"
	_g_free0 (self->priv->which_change);
#line 1109 "../src/WindowManager.vala"
	self->priv->which_change = NULL;
#line 1110 "../src/WindowManager.vala"
	meta_plugin_size_change_completed ((MetaPlugin*) self, actor);
#line 6823 "WindowManager.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 1113 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 1113 "../src/WindowManager.vala"
	return _data17_;
#line 6833 "WindowManager.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 1113 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 6843 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1113 "../src/WindowManager.vala"
		self = _data17_->self;
#line 1113 "../src/WindowManager.vala"
		_g_object_unref0 (_data17_->actor);
#line 1113 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1113 "../src/WindowManager.vala"
		g_slice_free (Block17Data, _data17_);
#line 6853 "WindowManager.c"
	}
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 1129 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 1129 "../src/WindowManager.vala"
	return _data18_;
#line 6864 "WindowManager.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 1129 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 6874 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1129 "../src/WindowManager.vala"
		self = _data18_->_data17_->self;
#line 1129 "../src/WindowManager.vala"
		block17_data_unref (_data18_->_data17_);
#line 1129 "../src/WindowManager.vala"
		_data18_->_data17_ = NULL;
#line 1129 "../src/WindowManager.vala"
		g_slice_free (Block18Data, _data18_);
#line 6884 "WindowManager.c"
	}
}

static void
___lambda183_ (Block18Data* _data18_)
{
	Block17Data* _data17_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1151 "../src/WindowManager.vala"
	_data17_ = _data18_->_data17_;
#line 1151 "../src/WindowManager.vala"
	self = _data17_->self;
#line 1152 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data17_->actor, _data18_->minimize_handler_id);
#line 1153 "../src/WindowManager.vala"
	meta_plugin_minimize_completed ((MetaPlugin*) self, _data17_->actor);
#line 1154 "../src/WindowManager.vala"
	_tmp0_ = self->priv->minimizing;
#line 1154 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data17_->actor);
#line 6906 "WindowManager.c"
}

static void
____lambda183__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1151 "../src/WindowManager.vala"
	___lambda183_ (self);
#line 6915 "WindowManager.c"
}

static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 1129 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 1129 "../src/WindowManager.vala"
	return _data19_;
#line 6925 "WindowManager.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 1129 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 6935 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1129 "../src/WindowManager.vala"
		self = _data19_->_data17_->self;
#line 1129 "../src/WindowManager.vala"
		block17_data_unref (_data19_->_data17_);
#line 1129 "../src/WindowManager.vala"
		_data19_->_data17_ = NULL;
#line 1129 "../src/WindowManager.vala"
		g_slice_free (Block19Data, _data19_);
#line 6945 "WindowManager.c"
	}
}

static void
___lambda184_ (Block19Data* _data19_)
{
	Block17Data* _data17_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1168 "../src/WindowManager.vala"
	_data17_ = _data19_->_data17_;
#line 1168 "../src/WindowManager.vala"
	self = _data17_->self;
#line 1169 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data17_->actor, _data19_->minimize_handler_id);
#line 1170 "../src/WindowManager.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _data17_->actor, 0.0f, 0.0f);
#line 1171 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) _data17_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1172 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _data17_->actor, 255U);
#line 1173 "../src/WindowManager.vala"
	meta_plugin_minimize_completed ((MetaPlugin*) self, _data17_->actor);
#line 1174 "../src/WindowManager.vala"
	_tmp0_ = self->priv->minimizing;
#line 1174 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data17_->actor);
#line 6973 "WindowManager.c"
}

static void
____lambda184__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1168 "../src/WindowManager.vala"
	___lambda184_ (self);
#line 6982 "WindowManager.c"
}

static void
gala_window_manager_gala_real_minimize (MetaPlugin* base,
                                        MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block17Data* _data17_;
	MetaWindowActor* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GalaAnimationDuration duration = 0;
	GeeHashSet* _tmp5_;
	gint width = 0;
	gint height = 0;
	MetaDisplay* _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	MtkRectangle icon = {0};
	MtkRectangle _tmp9_ = {0};
	MetaWindow* _tmp10_;
	MtkRectangle _tmp11_ = {0};
	gboolean _tmp12_;
#line 1113 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1113 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1113 "../src/WindowManager.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 1113 "../src/WindowManager.vala"
	_data17_->_ref_count_ = 1;
#line 1113 "../src/WindowManager.vala"
	_data17_->self = g_object_ref (self);
#line 1113 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1113 "../src/WindowManager.vala"
	_g_object_unref0 (_data17_->actor);
#line 1113 "../src/WindowManager.vala"
	_data17_->actor = _tmp0_;
#line 1114 "../src/WindowManager.vala"
	if (!meta_prefs_get_gnome_animations ()) {
#line 1114 "../src/WindowManager.vala"
		_tmp1_ = TRUE;
#line 7025 "WindowManager.c"
	} else {
		MetaWindow* _tmp2_;
		MetaWindowType _tmp3_;
		MetaWindowType _tmp4_;
#line 1115 "../src/WindowManager.vala"
		_tmp2_ = meta_window_actor_get_meta_window (_data17_->actor);
#line 1115 "../src/WindowManager.vala"
		_tmp3_ = meta_window_get_window_type (_tmp2_);
#line 1115 "../src/WindowManager.vala"
		_tmp4_ = _tmp3_;
#line 1115 "../src/WindowManager.vala"
		_tmp1_ = _tmp4_ != META_WINDOW_NORMAL;
#line 7038 "WindowManager.c"
	}
#line 1114 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1116 "../src/WindowManager.vala"
		meta_plugin_minimize_completed ((MetaPlugin*) self, _data17_->actor);
#line 1117 "../src/WindowManager.vala"
		block17_data_unref (_data17_);
#line 1117 "../src/WindowManager.vala"
		_data17_ = NULL;
#line 1117 "../src/WindowManager.vala"
		return;
#line 7050 "WindowManager.c"
	}
#line 1120 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_HIDE;
#line 1122 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _data17_->actor);
#line 1123 "../src/WindowManager.vala"
	_tmp5_ = self->priv->minimizing;
#line 1123 "../src/WindowManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _data17_->actor);
#line 1126 "../src/WindowManager.vala"
	_tmp6_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1126 "../src/WindowManager.vala"
	meta_display_get_size (_tmp6_, &_tmp7_, &_tmp8_);
#line 1126 "../src/WindowManager.vala"
	width = _tmp7_;
#line 1126 "../src/WindowManager.vala"
	height = _tmp8_;
#line 1128 "../src/WindowManager.vala"
	icon = _tmp9_;
#line 1129 "../src/WindowManager.vala"
	_tmp10_ = meta_window_actor_get_meta_window (_data17_->actor);
#line 1129 "../src/WindowManager.vala"
	_tmp12_ = meta_window_get_icon_geometry (_tmp10_, &_tmp11_);
#line 1129 "../src/WindowManager.vala"
	icon = _tmp11_;
#line 1129 "../src/WindowManager.vala"
	if (_tmp12_) {
#line 7078 "WindowManager.c"
		Block18Data* _data18_;
		gfloat ui_scale = 0.0F;
		MetaDisplay* _tmp13_;
		MetaDisplay* _tmp14_;
		MtkRectangle _tmp15_;
		MtkRectangle _tmp16_;
		MtkRectangle _tmp17_;
		MtkRectangle _tmp18_;
		MtkRectangle _tmp19_;
		gfloat scale_x = 0.0F;
		MtkRectangle _tmp20_;
		gfloat _tmp21_;
		gfloat _tmp22_;
		gfloat scale_y = 0.0F;
		MtkRectangle _tmp23_;
		gfloat _tmp24_;
		gfloat _tmp25_;
		gfloat anchor_x = 0.0F;
		gfloat _tmp26_;
		gfloat _tmp27_;
		MtkRectangle _tmp28_;
		MtkRectangle _tmp29_;
		gfloat _tmp30_;
		gfloat _tmp31_;
		gfloat anchor_y = 0.0F;
		gfloat _tmp32_;
		gfloat _tmp33_;
		MtkRectangle _tmp34_;
		MtkRectangle _tmp35_;
		gfloat _tmp36_;
		gfloat _tmp37_;
		gulong _tmp38_;
#line 1129 "../src/WindowManager.vala"
		_data18_ = g_slice_new0 (Block18Data);
#line 1129 "../src/WindowManager.vala"
		_data18_->_ref_count_ = 1;
#line 1129 "../src/WindowManager.vala"
		_data18_->_data17_ = block17_data_ref (_data17_);
#line 1131 "../src/WindowManager.vala"
		_tmp13_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1131 "../src/WindowManager.vala"
		_tmp14_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1131 "../src/WindowManager.vala"
		_tmp15_ = icon;
#line 1131 "../src/WindowManager.vala"
		ui_scale = meta_display_get_monitor_scale (_tmp13_, meta_display_get_monitor_index_for_rect (_tmp14_, &_tmp15_));
#line 1132 "../src/WindowManager.vala"
		_tmp16_ = icon;
#line 1132 "../src/WindowManager.vala"
		icon.x = gala_utils_scale_to_int (_tmp16_.x, ui_scale);
#line 1133 "../src/WindowManager.vala"
		_tmp17_ = icon;
#line 1133 "../src/WindowManager.vala"
		icon.y = gala_utils_scale_to_int (_tmp17_.y, ui_scale);
#line 1134 "../src/WindowManager.vala"
		_tmp18_ = icon;
#line 1134 "../src/WindowManager.vala"
		icon.width = gala_utils_scale_to_int (_tmp18_.width, ui_scale);
#line 1135 "../src/WindowManager.vala"
		_tmp19_ = icon;
#line 1135 "../src/WindowManager.vala"
		icon.height = gala_utils_scale_to_int (_tmp19_.height, ui_scale);
#line 1137 "../src/WindowManager.vala"
		_tmp20_ = icon;
#line 1137 "../src/WindowManager.vala"
		_tmp21_ = clutter_actor_get_width ((ClutterActor*) _data17_->actor);
#line 1137 "../src/WindowManager.vala"
		_tmp22_ = _tmp21_;
#line 1137 "../src/WindowManager.vala"
		scale_x = ((gfloat) _tmp20_.width) / _tmp22_;
#line 1138 "../src/WindowManager.vala"
		_tmp23_ = icon;
#line 1138 "../src/WindowManager.vala"
		_tmp24_ = clutter_actor_get_height ((ClutterActor*) _data17_->actor);
#line 1138 "../src/WindowManager.vala"
		_tmp25_ = _tmp24_;
#line 1138 "../src/WindowManager.vala"
		scale_y = ((gfloat) _tmp23_.height) / _tmp25_;
#line 1139 "../src/WindowManager.vala"
		_tmp26_ = clutter_actor_get_x ((ClutterActor*) _data17_->actor);
#line 1139 "../src/WindowManager.vala"
		_tmp27_ = _tmp26_;
#line 1139 "../src/WindowManager.vala"
		_tmp28_ = icon;
#line 1139 "../src/WindowManager.vala"
		_tmp29_ = icon;
#line 1139 "../src/WindowManager.vala"
		_tmp30_ = clutter_actor_get_width ((ClutterActor*) _data17_->actor);
#line 1139 "../src/WindowManager.vala"
		_tmp31_ = _tmp30_;
#line 1139 "../src/WindowManager.vala"
		anchor_x = ((gfloat) (_tmp27_ - _tmp28_.x)) / (_tmp29_.width - _tmp31_);
#line 1140 "../src/WindowManager.vala"
		_tmp32_ = clutter_actor_get_y ((ClutterActor*) _data17_->actor);
#line 1140 "../src/WindowManager.vala"
		_tmp33_ = _tmp32_;
#line 1140 "../src/WindowManager.vala"
		_tmp34_ = icon;
#line 1140 "../src/WindowManager.vala"
		_tmp35_ = icon;
#line 1140 "../src/WindowManager.vala"
		_tmp36_ = clutter_actor_get_height ((ClutterActor*) _data17_->actor);
#line 1140 "../src/WindowManager.vala"
		_tmp37_ = _tmp36_;
#line 1140 "../src/WindowManager.vala"
		anchor_y = ((gfloat) (_tmp33_ - _tmp34_.y)) / (_tmp35_.height - _tmp37_);
#line 1141 "../src/WindowManager.vala"
		clutter_actor_set_pivot_point ((ClutterActor*) _data17_->actor, anchor_x, anchor_y);
#line 1143 "../src/WindowManager.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _data17_->actor);
#line 1144 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _data17_->actor, CLUTTER_EASE_IN_EXPO);
#line 1145 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _data17_->actor, (guint) duration);
#line 1146 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data17_->actor, (gdouble) scale_x, (gdouble) scale_y);
#line 1147 "../src/WindowManager.vala"
		clutter_actor_set_opacity ((ClutterActor*) _data17_->actor, 0U);
#line 1148 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _data17_->actor);
#line 1150 "../src/WindowManager.vala"
		_data18_->minimize_handler_id = 0UL;
#line 1151 "../src/WindowManager.vala"
		_tmp38_ = g_signal_connect_data ((ClutterActor*) _data17_->actor, "transitions-completed", (GCallback) ____lambda183__clutter_actor_transitions_completed, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 1151 "../src/WindowManager.vala"
		_data18_->minimize_handler_id = _tmp38_;
#line 1129 "../src/WindowManager.vala"
		block18_data_unref (_data18_);
#line 1129 "../src/WindowManager.vala"
		_data18_ = NULL;
#line 7209 "WindowManager.c"
	} else {
		Block19Data* _data19_;
		gulong _tmp39_;
#line 1129 "../src/WindowManager.vala"
		_data19_ = g_slice_new0 (Block19Data);
#line 1129 "../src/WindowManager.vala"
		_data19_->_ref_count_ = 1;
#line 1129 "../src/WindowManager.vala"
		_data19_->_data17_ = block17_data_ref (_data17_);
#line 1158 "../src/WindowManager.vala"
		clutter_actor_set_pivot_point ((ClutterActor*) _data17_->actor, 0.5f, 1.0f);
#line 1160 "../src/WindowManager.vala"
		clutter_actor_save_easing_state ((ClutterActor*) _data17_->actor);
#line 1161 "../src/WindowManager.vala"
		clutter_actor_set_easing_mode ((ClutterActor*) _data17_->actor, CLUTTER_EASE_IN_EXPO);
#line 1162 "../src/WindowManager.vala"
		clutter_actor_set_easing_duration ((ClutterActor*) _data17_->actor, (guint) duration);
#line 1163 "../src/WindowManager.vala"
		clutter_actor_set_scale ((ClutterActor*) _data17_->actor, (gdouble) 0.0f, (gdouble) 0.0f);
#line 1164 "../src/WindowManager.vala"
		clutter_actor_set_opacity ((ClutterActor*) _data17_->actor, 0U);
#line 1165 "../src/WindowManager.vala"
		clutter_actor_restore_easing_state ((ClutterActor*) _data17_->actor);
#line 1167 "../src/WindowManager.vala"
		_data19_->minimize_handler_id = 0UL;
#line 1168 "../src/WindowManager.vala"
		_tmp39_ = g_signal_connect_data ((ClutterActor*) _data17_->actor, "transitions-completed", (GCallback) ____lambda184__clutter_actor_transitions_completed, block19_data_ref (_data19_), (GClosureNotify) block19_data_unref, 0);
#line 1168 "../src/WindowManager.vala"
		_data19_->minimize_handler_id = _tmp39_;
#line 1129 "../src/WindowManager.vala"
		block19_data_unref (_data19_);
#line 1129 "../src/WindowManager.vala"
		_data19_ = NULL;
#line 7243 "WindowManager.c"
	}
#line 1113 "../src/WindowManager.vala"
	block17_data_unref (_data17_);
#line 1113 "../src/WindowManager.vala"
	_data17_ = NULL;
#line 7249 "WindowManager.c"
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 1179 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 1179 "../src/WindowManager.vala"
	return _data20_;
#line 7259 "WindowManager.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 1179 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 7269 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1179 "../src/WindowManager.vala"
		self = _data20_->self;
#line 1179 "../src/WindowManager.vala"
		_g_object_unref0 (_data20_->actor);
#line 1179 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1179 "../src/WindowManager.vala"
		g_slice_free (Block20Data, _data20_);
#line 7279 "WindowManager.c"
	}
}

static gboolean
___lambda178_ (Block20Data* _data20_)
{
	GalaWindowManagerGala* self;
	gboolean result;
#line 1213 "../src/WindowManager.vala"
	self = _data20_->self;
#line 1214 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, (guint) 255);
#line 1215 "../src/WindowManager.vala"
	result = FALSE;
#line 1215 "../src/WindowManager.vala"
	return result;
#line 7296 "WindowManager.c"
}

static gboolean
____lambda178__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda178_ (self);
#line 1213 "../src/WindowManager.vala"
	return result;
#line 7306 "WindowManager.c"
}

static void
__lambda179_ (Block20Data* _data20_,
              ClutterActor* snapshot,
              const gchar* name,
              gboolean is_finished)
{
	GalaWindowManagerGala* self;
	ClutterActor* parent = NULL;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 1238 "../src/WindowManager.vala"
	self = _data20_->self;
#line 1238 "../src/WindowManager.vala"
	g_return_if_fail (snapshot != NULL);
#line 1238 "../src/WindowManager.vala"
	g_return_if_fail (name != NULL);
#line 1239 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) snapshot, _data20_->maximize_old_handler_id);
#line 1241 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _data20_->actor, 0.0f, 0.0f, 0.0f);
#line 1243 "../src/WindowManager.vala"
	_tmp0_ = clutter_actor_get_parent (snapshot);
#line 1243 "../src/WindowManager.vala"
	parent = _tmp0_;
#line 1244 "../src/WindowManager.vala"
	_tmp1_ = parent;
#line 1244 "../src/WindowManager.vala"
	if (_tmp1_ != NULL) {
#line 7337 "WindowManager.c"
		ClutterActor* _tmp2_;
#line 1245 "../src/WindowManager.vala"
		_tmp2_ = parent;
#line 1245 "../src/WindowManager.vala"
		clutter_actor_remove_child (_tmp2_, snapshot);
#line 7343 "WindowManager.c"
	}
}

static void
___lambda179__clutter_actor_transition_stopped (ClutterActor* _sender,
                                                const gchar* name,
                                                gboolean is_finished,
                                                gpointer self)
{
#line 1238 "../src/WindowManager.vala"
	__lambda179_ (self, _sender, name, is_finished);
#line 7355 "WindowManager.c"
}

static void
__lambda180_ (Block20Data* _data20_)
{
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1263 "../src/WindowManager.vala"
	self = _data20_->self;
#line 1264 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data20_->actor, _data20_->handler_id);
#line 1265 "../src/WindowManager.vala"
	_tmp0_ = self->priv->maximizing;
#line 1265 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data20_->actor);
#line 7371 "WindowManager.c"
}

static void
___lambda180__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                   gpointer self)
{
#line 1263 "../src/WindowManager.vala"
	__lambda180_ (self);
#line 7380 "WindowManager.c"
}

static void
gala_window_manager_gala_maximize (GalaWindowManagerGala* self,
                                   MetaWindowActor* actor,
                                   gint ex,
                                   gint ey,
                                   gint ew,
                                   gint eh)
{
	Block20Data* _data20_;
	MetaWindowActor* _tmp0_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	MetaWindow* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GalaAnimationDuration duration = 0;
	GeeHashSet* _tmp20_;
	ClutterActor* _tmp21_;
	MtkRectangle _tmp22_;
	MtkRectangle _tmp23_;
	ClutterActor* _tmp24_;
	ClutterActor* _tmp25_;
	ClutterActor* _tmp26_;
#line 1208 "../src/WindowManager.vala"
	static const gint FLASH_PREVENT_TIMEOUT = 80;
#line 7412 "WindowManager.c"
	gint delay = 0;
	gdouble scale_x = 0.0;
	MtkRectangle _tmp27_;
	gdouble scale_y = 0.0;
	MtkRectangle _tmp28_;
	ClutterActor* _tmp29_;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	ClutterActor* _tmp32_;
	ClutterActor* _tmp33_;
	ClutterActor* _tmp34_;
	ClutterActor* _tmp35_;
	ClutterActor* _tmp36_;
	ClutterActor* _tmp37_;
	ClutterActor* _tmp38_;
	ClutterActor* _tmp39_;
	ClutterActor* _tmp40_;
	gulong _tmp41_;
	MtkRectangle _tmp42_;
	MtkRectangle _tmp43_;
	gulong _tmp44_;
#line 1179 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1179 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1179 "../src/WindowManager.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 1179 "../src/WindowManager.vala"
	_data20_->_ref_count_ = 1;
#line 1179 "../src/WindowManager.vala"
	_data20_->self = g_object_ref (self);
#line 1179 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1179 "../src/WindowManager.vala"
	_g_object_unref0 (_data20_->actor);
#line 1179 "../src/WindowManager.vala"
	_data20_->actor = _tmp0_;
#line 1180 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data20_->actor);
#line 1180 "../src/WindowManager.vala"
	window = _tmp1_;
#line 1181 "../src/WindowManager.vala"
	_tmp4_ = window;
#line 1181 "../src/WindowManager.vala"
	g_object_get (_tmp4_, "maximized-horizontally", &_tmp5_, NULL);
#line 1181 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 1181 "../src/WindowManager.vala"
	if (_tmp6_) {
#line 7462 "WindowManager.c"
		GSettings* _tmp7_;
#line 1181 "../src/WindowManager.vala"
		_tmp7_ = self->priv->behavior_settings;
#line 1181 "../src/WindowManager.vala"
		_tmp3_ = g_settings_get_boolean (_tmp7_, "move-maximized-workspace");
#line 7468 "WindowManager.c"
	} else {
#line 1181 "../src/WindowManager.vala"
		_tmp3_ = FALSE;
#line 7472 "WindowManager.c"
	}
#line 1181 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 1181 "../src/WindowManager.vala"
		_tmp2_ = TRUE;
#line 7478 "WindowManager.c"
	} else {
		gboolean _tmp8_ = FALSE;
		MetaWindow* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 1182 "../src/WindowManager.vala"
		_tmp9_ = window;
#line 1182 "../src/WindowManager.vala"
		g_object_get (_tmp9_, "fullscreen", &_tmp10_, NULL);
#line 1182 "../src/WindowManager.vala"
		_tmp11_ = _tmp10_;
#line 1182 "../src/WindowManager.vala"
		if (_tmp11_) {
#line 7492 "WindowManager.c"
			GSettings* _tmp12_;
#line 1182 "../src/WindowManager.vala"
			_tmp12_ = self->priv->behavior_settings;
#line 1182 "../src/WindowManager.vala"
			_tmp8_ = g_settings_get_boolean (_tmp12_, "move-fullscreened-workspace");
#line 7498 "WindowManager.c"
		} else {
#line 1182 "../src/WindowManager.vala"
			_tmp8_ = FALSE;
#line 7502 "WindowManager.c"
		}
#line 1182 "../src/WindowManager.vala"
		_tmp2_ = _tmp8_;
#line 7506 "WindowManager.c"
	}
#line 1181 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 7510 "WindowManager.c"
		MetaWindow* _tmp13_;
#line 1183 "../src/WindowManager.vala"
		_tmp13_ = window;
#line 1183 "../src/WindowManager.vala"
		gala_window_manager_gala_move_window_to_next_ws (self, _tmp13_);
#line 7516 "WindowManager.c"
	}
#line 1186 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _data20_->actor);
#line 1188 "../src/WindowManager.vala"
	if (!meta_prefs_get_gnome_animations ()) {
#line 1188 "../src/WindowManager.vala"
		_tmp15_ = TRUE;
#line 7524 "WindowManager.c"
	} else {
		ClutterActor* _tmp16_;
#line 1189 "../src/WindowManager.vala"
		_tmp16_ = self->priv->latest_window_snapshot;
#line 1189 "../src/WindowManager.vala"
		_tmp15_ = _tmp16_ == NULL;
#line 7531 "WindowManager.c"
	}
#line 1188 "../src/WindowManager.vala"
	if (_tmp15_) {
#line 1188 "../src/WindowManager.vala"
		_tmp14_ = TRUE;
#line 7537 "WindowManager.c"
	} else {
		MetaWindow* _tmp17_;
		MetaWindowType _tmp18_;
		MetaWindowType _tmp19_;
#line 1190 "../src/WindowManager.vala"
		_tmp17_ = window;
#line 1190 "../src/WindowManager.vala"
		_tmp18_ = meta_window_get_window_type (_tmp17_);
#line 1190 "../src/WindowManager.vala"
		_tmp19_ = _tmp18_;
#line 1190 "../src/WindowManager.vala"
		_tmp14_ = _tmp19_ != META_WINDOW_NORMAL;
#line 7550 "WindowManager.c"
	}
#line 1188 "../src/WindowManager.vala"
	if (_tmp14_) {
#line 1191 "../src/WindowManager.vala"
		block20_data_unref (_data20_);
#line 1191 "../src/WindowManager.vala"
		_data20_ = NULL;
#line 1191 "../src/WindowManager.vala"
		return;
#line 7560 "WindowManager.c"
	}
#line 1194 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_SNAP;
#line 1196 "../src/WindowManager.vala"
	_tmp20_ = self->priv->maximizing;
#line 1196 "../src/WindowManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _data20_->actor);
#line 1197 "../src/WindowManager.vala"
	_tmp21_ = self->priv->latest_window_snapshot;
#line 1197 "../src/WindowManager.vala"
	_tmp22_ = self->priv->old_rect_size_change;
#line 1197 "../src/WindowManager.vala"
	_tmp23_ = self->priv->old_rect_size_change;
#line 1197 "../src/WindowManager.vala"
	clutter_actor_set_position (_tmp21_, (gfloat) _tmp22_.x, (gfloat) _tmp23_.y);
#line 1199 "../src/WindowManager.vala"
	_tmp24_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 1199 "../src/WindowManager.vala"
	_tmp25_ = _tmp24_;
#line 1199 "../src/WindowManager.vala"
	_tmp26_ = self->priv->latest_window_snapshot;
#line 1199 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp25_, _tmp26_);
#line 1209 "../src/WindowManager.vala"
	delay = 0;
#line 1210 "../src/WindowManager.vala"
	if (FLASH_PREVENT_TIMEOUT <= ((gint) (duration / 3))) {
#line 1211 "../src/WindowManager.vala"
		clutter_actor_set_opacity ((ClutterActor*) _data20_->actor, (guint) 0);
#line 1212 "../src/WindowManager.vala"
		delay = FLASH_PREVENT_TIMEOUT;
#line 1213 "../src/WindowManager.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) FLASH_PREVENT_TIMEOUT, ____lambda178__gsource_func, block20_data_ref (_data20_), block20_data_unref);
#line 7594 "WindowManager.c"
	}
#line 1219 "../src/WindowManager.vala"
	_tmp27_ = self->priv->old_rect_size_change;
#line 1219 "../src/WindowManager.vala"
	scale_x = ((gdouble) ew) / _tmp27_.width;
#line 1220 "../src/WindowManager.vala"
	_tmp28_ = self->priv->old_rect_size_change;
#line 1220 "../src/WindowManager.vala"
	scale_y = ((gdouble) eh) / _tmp28_.height;
#line 1222 "../src/WindowManager.vala"
	_tmp29_ = self->priv->latest_window_snapshot;
#line 1222 "../src/WindowManager.vala"
	clutter_actor_save_easing_state (_tmp29_);
#line 1223 "../src/WindowManager.vala"
	_tmp30_ = self->priv->latest_window_snapshot;
#line 1223 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode (_tmp30_, CLUTTER_EASE_IN_OUT_QUAD);
#line 1224 "../src/WindowManager.vala"
	_tmp31_ = self->priv->latest_window_snapshot;
#line 1224 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration (_tmp31_, (guint) duration);
#line 1225 "../src/WindowManager.vala"
	_tmp32_ = self->priv->latest_window_snapshot;
#line 1225 "../src/WindowManager.vala"
	clutter_actor_set_position (_tmp32_, (gfloat) ex, (gfloat) ey);
#line 1226 "../src/WindowManager.vala"
	_tmp33_ = self->priv->latest_window_snapshot;
#line 1226 "../src/WindowManager.vala"
	clutter_actor_set_scale (_tmp33_, scale_x, scale_y);
#line 1227 "../src/WindowManager.vala"
	_tmp34_ = self->priv->latest_window_snapshot;
#line 1227 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state (_tmp34_);
#line 1231 "../src/WindowManager.vala"
	_tmp35_ = self->priv->latest_window_snapshot;
#line 1231 "../src/WindowManager.vala"
	clutter_actor_save_easing_state (_tmp35_);
#line 1232 "../src/WindowManager.vala"
	_tmp36_ = self->priv->latest_window_snapshot;
#line 1232 "../src/WindowManager.vala"
	clutter_actor_set_easing_delay (_tmp36_, (guint) delay);
#line 1233 "../src/WindowManager.vala"
	_tmp37_ = self->priv->latest_window_snapshot;
#line 1233 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration (_tmp37_, (guint) (duration - delay));
#line 1234 "../src/WindowManager.vala"
	_tmp38_ = self->priv->latest_window_snapshot;
#line 1234 "../src/WindowManager.vala"
	clutter_actor_set_opacity (_tmp38_, (guint) 0);
#line 1235 "../src/WindowManager.vala"
	_tmp39_ = self->priv->latest_window_snapshot;
#line 1235 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state (_tmp39_);
#line 1237 "../src/WindowManager.vala"
	_data20_->maximize_old_handler_id = (gulong) 0;
#line 1238 "../src/WindowManager.vala"
	_tmp40_ = self->priv->latest_window_snapshot;
#line 1238 "../src/WindowManager.vala"
	_tmp41_ = g_signal_connect_data (_tmp40_, "transition-stopped", (GCallback) ___lambda179__clutter_actor_transition_stopped, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
#line 1238 "../src/WindowManager.vala"
	_data20_->maximize_old_handler_id = _tmp41_;
#line 1249 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->latest_window_snapshot);
#line 1249 "../src/WindowManager.vala"
	self->priv->latest_window_snapshot = NULL;
#line 1251 "../src/WindowManager.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _data20_->actor, 0.0f, 0.0f);
#line 1252 "../src/WindowManager.vala"
	_tmp42_ = self->priv->old_rect_size_change;
#line 1252 "../src/WindowManager.vala"
	_tmp43_ = self->priv->old_rect_size_change;
#line 1252 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _data20_->actor, (gfloat) (_tmp42_.x - ex), (gfloat) (_tmp43_.y - ey), 0.0f);
#line 1253 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) _data20_->actor, 1.0f / scale_x, 1.0f / scale_y);
#line 1255 "../src/WindowManager.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _data20_->actor);
#line 1256 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) _data20_->actor, CLUTTER_EASE_IN_OUT_QUAD);
#line 1257 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _data20_->actor, (guint) duration);
#line 1258 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) _data20_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1259 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _data20_->actor, 0.0f, 0.0f, 0.0f);
#line 1260 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _data20_->actor);
#line 1262 "../src/WindowManager.vala"
	_data20_->handler_id = 0UL;
#line 1263 "../src/WindowManager.vala"
	_tmp44_ = g_signal_connect_data ((ClutterActor*) _data20_->actor, "transitions-completed", (GCallback) ___lambda180__clutter_actor_transitions_completed, block20_data_ref (_data20_), (GClosureNotify) block20_data_unref, 0);
#line 1263 "../src/WindowManager.vala"
	_data20_->handler_id = _tmp44_;
#line 1179 "../src/WindowManager.vala"
	block20_data_unref (_data20_);
#line 1179 "../src/WindowManager.vala"
	_data20_ = NULL;
#line 7692 "WindowManager.c"
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 1269 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 1269 "../src/WindowManager.vala"
	return _data21_;
#line 7702 "WindowManager.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 1269 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 7712 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1269 "../src/WindowManager.vala"
		self = _data21_->self;
#line 1269 "../src/WindowManager.vala"
		_g_object_unref0 (_data21_->actor);
#line 1269 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1269 "../src/WindowManager.vala"
		g_slice_free (Block21Data, _data21_);
#line 7722 "WindowManager.c"
	}
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 1282 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 1282 "../src/WindowManager.vala"
	return _data22_;
#line 7733 "WindowManager.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 1282 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 7743 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1282 "../src/WindowManager.vala"
		self = _data22_->_data21_->self;
#line 1282 "../src/WindowManager.vala"
		block21_data_unref (_data22_->_data21_);
#line 1282 "../src/WindowManager.vala"
		_data22_->_data21_ = NULL;
#line 1282 "../src/WindowManager.vala"
		g_slice_free (Block22Data, _data22_);
#line 7753 "WindowManager.c"
	}
}

static void
___lambda185_ (Block22Data* _data22_)
{
	Block21Data* _data21_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1298 "../src/WindowManager.vala"
	_data21_ = _data22_->_data21_;
#line 1298 "../src/WindowManager.vala"
	self = _data21_->self;
#line 1299 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data21_->actor, _data22_->unminimize_handler_id);
#line 1300 "../src/WindowManager.vala"
	_tmp0_ = self->priv->unminimizing;
#line 1300 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data21_->actor);
#line 1301 "../src/WindowManager.vala"
	meta_plugin_unminimize_completed ((MetaPlugin*) self, _data21_->actor);
#line 7775 "WindowManager.c"
}

static void
____lambda185__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1298 "../src/WindowManager.vala"
	___lambda185_ (self);
#line 7784 "WindowManager.c"
}

static void
gala_window_manager_gala_real_unminimize (MetaPlugin* base,
                                          MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block21Data* _data21_;
	MetaWindowActor* _tmp0_;
	GalaAnimationDuration duration = 0;
	MetaWindow* window = NULL;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindowType _tmp3_;
	MetaWindowType _tmp4_;
#line 1269 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1269 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1269 "../src/WindowManager.vala"
	_data21_ = g_slice_new0 (Block21Data);
#line 1269 "../src/WindowManager.vala"
	_data21_->_ref_count_ = 1;
#line 1269 "../src/WindowManager.vala"
	_data21_->self = g_object_ref (self);
#line 1269 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1269 "../src/WindowManager.vala"
	_g_object_unref0 (_data21_->actor);
#line 1269 "../src/WindowManager.vala"
	_data21_->actor = _tmp0_;
#line 1270 "../src/WindowManager.vala"
	if (!meta_prefs_get_gnome_animations ()) {
#line 1271 "../src/WindowManager.vala"
		clutter_actor_show ((ClutterActor*) _data21_->actor);
#line 1272 "../src/WindowManager.vala"
		meta_plugin_unminimize_completed ((MetaPlugin*) self, _data21_->actor);
#line 1273 "../src/WindowManager.vala"
		block21_data_unref (_data21_);
#line 1273 "../src/WindowManager.vala"
		_data21_ = NULL;
#line 1273 "../src/WindowManager.vala"
		return;
#line 7828 "WindowManager.c"
	}
#line 1276 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_HIDE;
#line 1277 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data21_->actor);
#line 1277 "../src/WindowManager.vala"
	window = _tmp1_;
#line 1279 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data21_->actor);
#line 1280 "../src/WindowManager.vala"
	clutter_actor_show ((ClutterActor*) _data21_->actor);
#line 1282 "../src/WindowManager.vala"
	_tmp2_ = window;
#line 1282 "../src/WindowManager.vala"
	_tmp3_ = meta_window_get_window_type (_tmp2_);
#line 1282 "../src/WindowManager.vala"
	_tmp4_ = _tmp3_;
#line 1282 "../src/WindowManager.vala"
	switch (_tmp4_) {
#line 1282 "../src/WindowManager.vala"
		case META_WINDOW_NORMAL:
#line 7850 "WindowManager.c"
		{
			Block22Data* _data22_;
			GeeHashSet* _tmp5_;
			gulong _tmp6_;
#line 1282 "../src/WindowManager.vala"
			_data22_ = g_slice_new0 (Block22Data);
#line 1282 "../src/WindowManager.vala"
			_data22_->_ref_count_ = 1;
#line 1282 "../src/WindowManager.vala"
			_data22_->_data21_ = block21_data_ref (_data21_);
#line 1284 "../src/WindowManager.vala"
			_tmp5_ = self->priv->unminimizing;
#line 1284 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _data21_->actor);
#line 1286 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data21_->actor, 0.5f, 1.0f);
#line 1287 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data21_->actor, (gdouble) 0.01f, (gdouble) 0.1f);
#line 1288 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data21_->actor, 0U);
#line 1290 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data21_->actor);
#line 1291 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data21_->actor, CLUTTER_EASE_OUT_EXPO);
#line 1292 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data21_->actor, (guint) duration);
#line 1293 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data21_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1294 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data21_->actor, 255U);
#line 1295 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data21_->actor);
#line 1297 "../src/WindowManager.vala"
			_data22_->unminimize_handler_id = 0UL;
#line 1298 "../src/WindowManager.vala"
			_tmp6_ = g_signal_connect_data ((ClutterActor*) _data21_->actor, "transitions-completed", (GCallback) ____lambda185__clutter_actor_transitions_completed, block22_data_ref (_data22_), (GClosureNotify) block22_data_unref, 0);
#line 1298 "../src/WindowManager.vala"
			_data22_->unminimize_handler_id = _tmp6_;
#line 1304 "../src/WindowManager.vala"
			block22_data_unref (_data22_);
#line 1304 "../src/WindowManager.vala"
			_data22_ = NULL;
#line 1304 "../src/WindowManager.vala"
			break;
#line 7895 "WindowManager.c"
		}
		default:
		{
#line 1306 "../src/WindowManager.vala"
			meta_plugin_unminimize_completed ((MetaPlugin*) self, _data21_->actor);
#line 1307 "../src/WindowManager.vala"
			break;
#line 7903 "WindowManager.c"
		}
	}
#line 1269 "../src/WindowManager.vala"
	block21_data_unref (_data21_);
#line 1269 "../src/WindowManager.vala"
	_data21_ = NULL;
#line 7910 "WindowManager.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 1311 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 1311 "../src/WindowManager.vala"
	return _data23_;
#line 7920 "WindowManager.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 1311 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 7930 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1311 "../src/WindowManager.vala"
		self = _data23_->self;
#line 1311 "../src/WindowManager.vala"
		_g_object_unref0 (_data23_->actor);
#line 1311 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1311 "../src/WindowManager.vala"
		g_slice_free (Block23Data, _data23_);
#line 7940 "WindowManager.c"
	}
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 1340 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 1340 "../src/WindowManager.vala"
	return _data24_;
#line 7951 "WindowManager.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 1340 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 7961 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1340 "../src/WindowManager.vala"
		self = _data24_->_data23_->self;
#line 1340 "../src/WindowManager.vala"
		block23_data_unref (_data24_->_data23_);
#line 1340 "../src/WindowManager.vala"
		_data24_->_data23_ = NULL;
#line 1340 "../src/WindowManager.vala"
		g_slice_free (Block24Data, _data24_);
#line 7971 "WindowManager.c"
	}
}

static void
___lambda186_ (Block24Data* _data24_)
{
	Block23Data* _data23_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
	MetaWindow* _tmp1_;
#line 1367 "../src/WindowManager.vala"
	_data23_ = _data24_->_data23_;
#line 1367 "../src/WindowManager.vala"
	self = _data23_->self;
#line 1368 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data23_->actor, _data24_->map_handler_id);
#line 1369 "../src/WindowManager.vala"
	_tmp0_ = self->priv->mapping;
#line 1369 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data23_->actor);
#line 1370 "../src/WindowManager.vala"
	meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1372 "../src/WindowManager.vala"
	_tmp1_ = _data23_->window;
#line 1372 "../src/WindowManager.vala"
	if (meta_window_get_layer (_tmp1_) == META_LAYER_BOTTOM) {
#line 7998 "WindowManager.c"
		MetaWindow* _tmp2_;
#line 1373 "../src/WindowManager.vala"
		_tmp2_ = _data23_->window;
#line 1373 "../src/WindowManager.vala"
		gala_window_manager_gala_show_bottom_stack_window (self, _tmp2_);
#line 8004 "WindowManager.c"
	}
}

static void
____lambda186__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1367 "../src/WindowManager.vala"
	___lambda186_ (self);
#line 8014 "WindowManager.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 1340 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 1340 "../src/WindowManager.vala"
	return _data25_;
#line 8024 "WindowManager.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 1340 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 8034 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1340 "../src/WindowManager.vala"
		self = _data25_->_data23_->self;
#line 1340 "../src/WindowManager.vala"
		block23_data_unref (_data25_->_data23_);
#line 1340 "../src/WindowManager.vala"
		_data25_->_data23_ = NULL;
#line 1340 "../src/WindowManager.vala"
		g_slice_free (Block25Data, _data25_);
#line 8044 "WindowManager.c"
	}
}

static void
___lambda187_ (Block25Data* _data25_)
{
	Block23Data* _data23_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1397 "../src/WindowManager.vala"
	_data23_ = _data25_->_data23_;
#line 1397 "../src/WindowManager.vala"
	self = _data23_->self;
#line 1398 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data23_->actor, _data25_->map_handler_id);
#line 1399 "../src/WindowManager.vala"
	_tmp0_ = self->priv->mapping;
#line 1399 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data23_->actor);
#line 1400 "../src/WindowManager.vala"
	meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 8066 "WindowManager.c"
}

static void
____lambda187__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1397 "../src/WindowManager.vala"
	___lambda187_ (self);
#line 8075 "WindowManager.c"
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 1340 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 1340 "../src/WindowManager.vala"
	return _data26_;
#line 8085 "WindowManager.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 1340 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 8095 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1340 "../src/WindowManager.vala"
		self = _data26_->_data23_->self;
#line 1340 "../src/WindowManager.vala"
		block23_data_unref (_data26_->_data23_);
#line 1340 "../src/WindowManager.vala"
		_data26_->_data23_ = NULL;
#line 1340 "../src/WindowManager.vala"
		g_slice_free (Block26Data, _data26_);
#line 8105 "WindowManager.c"
	}
}

static void
___lambda188_ (Block26Data* _data26_)
{
	Block23Data* _data23_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
	MetaWindow* _tmp1_;
#line 1420 "../src/WindowManager.vala"
	_data23_ = _data26_->_data23_;
#line 1420 "../src/WindowManager.vala"
	self = _data23_->self;
#line 1421 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data23_->actor, _data26_->map_handler_id);
#line 1422 "../src/WindowManager.vala"
	_tmp0_ = self->priv->mapping;
#line 1422 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data23_->actor);
#line 1423 "../src/WindowManager.vala"
	meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1425 "../src/WindowManager.vala"
	_tmp1_ = _data23_->window;
#line 1425 "../src/WindowManager.vala"
	if (meta_window_get_layer (_tmp1_) == META_LAYER_BOTTOM) {
#line 8132 "WindowManager.c"
		MetaWindow* _tmp2_;
#line 1426 "../src/WindowManager.vala"
		_tmp2_ = _data23_->window;
#line 1426 "../src/WindowManager.vala"
		gala_window_manager_gala_show_bottom_stack_window (self, _tmp2_);
#line 8138 "WindowManager.c"
	}
}

static void
____lambda188__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1420 "../src/WindowManager.vala"
	___lambda188_ (self);
#line 8148 "WindowManager.c"
}

static void
gala_window_manager_gala_real_map (MetaPlugin* base,
                                   MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block23Data* _data23_;
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	MetaWindow* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	MetaWindow* _tmp17_;
	MetaWindow* _tmp22_;
	MetaWindowType _tmp23_;
	MetaWindowType _tmp24_;
#line 1311 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1311 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1311 "../src/WindowManager.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 1311 "../src/WindowManager.vala"
	_data23_->_ref_count_ = 1;
#line 1311 "../src/WindowManager.vala"
	_data23_->self = g_object_ref (self);
#line 1311 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1311 "../src/WindowManager.vala"
	_g_object_unref0 (_data23_->actor);
#line 1311 "../src/WindowManager.vala"
	_data23_->actor = _tmp0_;
#line 1312 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data23_->actor);
#line 1312 "../src/WindowManager.vala"
	_data23_->window = _tmp1_;
#line 1314 "../src/WindowManager.vala"
	_tmp2_ = _data23_->window;
#line 1314 "../src/WindowManager.vala"
	gala_window_state_saver_on_map (_tmp2_);
#line 1316 "../src/WindowManager.vala"
	_tmp5_ = _data23_->window;
#line 1316 "../src/WindowManager.vala"
	g_object_get (_tmp5_, "maximized-horizontally", &_tmp6_, NULL);
#line 1316 "../src/WindowManager.vala"
	_tmp7_ = _tmp6_;
#line 1316 "../src/WindowManager.vala"
	if (_tmp7_) {
#line 8201 "WindowManager.c"
		GSettings* _tmp8_;
#line 1316 "../src/WindowManager.vala"
		_tmp8_ = self->priv->behavior_settings;
#line 1316 "../src/WindowManager.vala"
		_tmp4_ = g_settings_get_boolean (_tmp8_, "move-maximized-workspace");
#line 8207 "WindowManager.c"
	} else {
#line 1316 "../src/WindowManager.vala"
		_tmp4_ = FALSE;
#line 8211 "WindowManager.c"
	}
#line 1316 "../src/WindowManager.vala"
	if (_tmp4_) {
#line 1316 "../src/WindowManager.vala"
		_tmp3_ = TRUE;
#line 8217 "WindowManager.c"
	} else {
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		MetaWindow* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 1317 "../src/WindowManager.vala"
		_tmp11_ = _data23_->window;
#line 1317 "../src/WindowManager.vala"
		g_object_get (_tmp11_, "fullscreen", &_tmp12_, NULL);
#line 1317 "../src/WindowManager.vala"
		_tmp13_ = _tmp12_;
#line 1317 "../src/WindowManager.vala"
		if (_tmp13_) {
#line 8232 "WindowManager.c"
			MetaWindow* _tmp14_;
#line 1317 "../src/WindowManager.vala"
			_tmp14_ = _data23_->window;
#line 1317 "../src/WindowManager.vala"
			_tmp10_ = meta_window_is_on_primary_monitor (_tmp14_);
#line 8238 "WindowManager.c"
		} else {
#line 1317 "../src/WindowManager.vala"
			_tmp10_ = FALSE;
#line 8242 "WindowManager.c"
		}
#line 1317 "../src/WindowManager.vala"
		if (_tmp10_) {
#line 8246 "WindowManager.c"
			GSettings* _tmp15_;
#line 1317 "../src/WindowManager.vala"
			_tmp15_ = self->priv->behavior_settings;
#line 1317 "../src/WindowManager.vala"
			_tmp9_ = g_settings_get_boolean (_tmp15_, "move-fullscreened-workspace");
#line 8252 "WindowManager.c"
		} else {
#line 1317 "../src/WindowManager.vala"
			_tmp9_ = FALSE;
#line 8256 "WindowManager.c"
		}
#line 1317 "../src/WindowManager.vala"
		_tmp3_ = _tmp9_;
#line 8260 "WindowManager.c"
	}
#line 1316 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 8264 "WindowManager.c"
		MetaWindow* _tmp16_;
#line 1318 "../src/WindowManager.vala"
		_tmp16_ = _data23_->window;
#line 1318 "../src/WindowManager.vala"
		gala_window_manager_gala_move_window_to_next_ws (self, _tmp16_);
#line 8270 "WindowManager.c"
	}
#line 1321 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data23_->actor);
#line 1322 "../src/WindowManager.vala"
	clutter_actor_show ((ClutterActor*) _data23_->actor);
#line 1325 "../src/WindowManager.vala"
	_tmp17_ = _data23_->window;
#line 1325 "../src/WindowManager.vala"
	if (gala_notification_stack_is_notification (_tmp17_)) {
#line 1326 "../src/WindowManager.vala"
		meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1327 "../src/WindowManager.vala"
		block23_data_unref (_data23_);
#line 1327 "../src/WindowManager.vala"
		_data23_ = NULL;
#line 1327 "../src/WindowManager.vala"
		return;
#line 8288 "WindowManager.c"
	}
#line 1330 "../src/WindowManager.vala"
	if (!meta_prefs_get_gnome_animations ()) {
#line 8292 "WindowManager.c"
		gboolean _tmp18_ = FALSE;
		MetaWindow* _tmp19_;
#line 1331 "../src/WindowManager.vala"
		meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1333 "../src/WindowManager.vala"
		_tmp19_ = _data23_->window;
#line 1333 "../src/WindowManager.vala"
		if (gala_internal_utils_get_window_is_normal (_tmp19_)) {
#line 8301 "WindowManager.c"
			MetaWindow* _tmp20_;
#line 1333 "../src/WindowManager.vala"
			_tmp20_ = _data23_->window;
#line 1333 "../src/WindowManager.vala"
			_tmp18_ = meta_window_get_layer (_tmp20_) == META_LAYER_BOTTOM;
#line 8307 "WindowManager.c"
		} else {
#line 1333 "../src/WindowManager.vala"
			_tmp18_ = FALSE;
#line 8311 "WindowManager.c"
		}
#line 1333 "../src/WindowManager.vala"
		if (_tmp18_) {
#line 8315 "WindowManager.c"
			MetaWindow* _tmp21_;
#line 1334 "../src/WindowManager.vala"
			_tmp21_ = _data23_->window;
#line 1334 "../src/WindowManager.vala"
			gala_window_manager_gala_show_bottom_stack_window (self, _tmp21_);
#line 8321 "WindowManager.c"
		}
#line 1337 "../src/WindowManager.vala"
		block23_data_unref (_data23_);
#line 1337 "../src/WindowManager.vala"
		_data23_ = NULL;
#line 1337 "../src/WindowManager.vala"
		return;
#line 8329 "WindowManager.c"
	}
#line 1340 "../src/WindowManager.vala"
	_tmp22_ = _data23_->window;
#line 1340 "../src/WindowManager.vala"
	_tmp23_ = meta_window_get_window_type (_tmp22_);
#line 1340 "../src/WindowManager.vala"
	_tmp24_ = _tmp23_;
#line 1340 "../src/WindowManager.vala"
	switch (_tmp24_) {
#line 1340 "../src/WindowManager.vala"
		case META_WINDOW_NORMAL:
#line 8341 "WindowManager.c"
		{
			Block24Data* _data24_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp25_;
			gboolean _tmp26_ = FALSE;
			MetaWindow* _tmp27_;
			gboolean _tmp28_;
			gboolean _tmp29_;
			gulong _tmp37_;
#line 1340 "../src/WindowManager.vala"
			_data24_ = g_slice_new0 (Block24Data);
#line 1340 "../src/WindowManager.vala"
			_data24_->_ref_count_ = 1;
#line 1340 "../src/WindowManager.vala"
			_data24_->_data23_ = block23_data_ref (_data23_);
#line 1342 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_HIDE;
#line 1343 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1344 "../src/WindowManager.vala"
				meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1345 "../src/WindowManager.vala"
				block24_data_unref (_data24_);
#line 1345 "../src/WindowManager.vala"
				_data24_ = NULL;
#line 1345 "../src/WindowManager.vala"
				block23_data_unref (_data23_);
#line 1345 "../src/WindowManager.vala"
				_data23_ = NULL;
#line 1345 "../src/WindowManager.vala"
				return;
#line 8373 "WindowManager.c"
			}
#line 1348 "../src/WindowManager.vala"
			_tmp25_ = self->priv->mapping;
#line 1348 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _data23_->actor);
#line 1350 "../src/WindowManager.vala"
			_tmp27_ = _data23_->window;
#line 1350 "../src/WindowManager.vala"
			g_object_get (_tmp27_, "maximized-vertically", &_tmp28_, NULL);
#line 1350 "../src/WindowManager.vala"
			_tmp29_ = _tmp28_;
#line 1350 "../src/WindowManager.vala"
			if (_tmp29_) {
#line 1350 "../src/WindowManager.vala"
				_tmp26_ = TRUE;
#line 8389 "WindowManager.c"
			} else {
				MetaWindow* _tmp30_;
				gboolean _tmp31_;
				gboolean _tmp32_;
#line 1350 "../src/WindowManager.vala"
				_tmp30_ = _data23_->window;
#line 1350 "../src/WindowManager.vala"
				g_object_get (_tmp30_, "maximized-horizontally", &_tmp31_, NULL);
#line 1350 "../src/WindowManager.vala"
				_tmp32_ = _tmp31_;
#line 1350 "../src/WindowManager.vala"
				_tmp26_ = _tmp32_;
#line 8402 "WindowManager.c"
			}
#line 1350 "../src/WindowManager.vala"
			if (_tmp26_) {
#line 8406 "WindowManager.c"
				MtkRectangle outer_rect = {0};
				MetaWindow* _tmp33_;
				MtkRectangle _tmp34_ = {0};
				MtkRectangle _tmp35_;
				MtkRectangle _tmp36_;
#line 1351 "../src/WindowManager.vala"
				_tmp33_ = _data23_->window;
#line 1351 "../src/WindowManager.vala"
				meta_window_get_frame_rect (_tmp33_, &_tmp34_);
#line 1351 "../src/WindowManager.vala"
				outer_rect = _tmp34_;
#line 1352 "../src/WindowManager.vala"
				_tmp35_ = outer_rect;
#line 1352 "../src/WindowManager.vala"
				_tmp36_ = outer_rect;
#line 1352 "../src/WindowManager.vala"
				clutter_actor_set_position ((ClutterActor*) _data23_->actor, (gfloat) _tmp35_.x, (gfloat) _tmp36_.y);
#line 8424 "WindowManager.c"
			}
#line 1355 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data23_->actor, 0.5f, 1.0f);
#line 1356 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data23_->actor, (gdouble) 0.01f, (gdouble) 0.1f);
#line 1357 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data23_->actor, (guint) 0);
#line 1359 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data23_->actor);
#line 1360 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data23_->actor, CLUTTER_EASE_OUT_EXPO);
#line 1361 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data23_->actor, (guint) duration);
#line 1362 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data23_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1363 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data23_->actor, 255U);
#line 1364 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data23_->actor);
#line 1366 "../src/WindowManager.vala"
			_data24_->map_handler_id = 0UL;
#line 1367 "../src/WindowManager.vala"
			_tmp37_ = g_signal_connect_data ((ClutterActor*) _data23_->actor, "transitions-completed", (GCallback) ____lambda186__clutter_actor_transitions_completed, block24_data_ref (_data24_), (GClosureNotify) block24_data_unref, 0);
#line 1367 "../src/WindowManager.vala"
			_data24_->map_handler_id = _tmp37_;
#line 1376 "../src/WindowManager.vala"
			block24_data_unref (_data24_);
#line 1376 "../src/WindowManager.vala"
			_data24_ = NULL;
#line 1376 "../src/WindowManager.vala"
			break;
#line 8456 "WindowManager.c"
		}
#line 1340 "../src/WindowManager.vala"
		case META_WINDOW_MENU:
#line 1340 "../src/WindowManager.vala"
		case META_WINDOW_DROPDOWN_MENU:
#line 1340 "../src/WindowManager.vala"
		case META_WINDOW_POPUP_MENU:
#line 8464 "WindowManager.c"
		{
			Block25Data* _data25_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp38_;
			gulong _tmp39_;
#line 1340 "../src/WindowManager.vala"
			_data25_ = g_slice_new0 (Block25Data);
#line 1340 "../src/WindowManager.vala"
			_data25_->_ref_count_ = 1;
#line 1340 "../src/WindowManager.vala"
			_data25_->_data23_ = block23_data_ref (_data23_);
#line 1380 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_MENU_MAP;
#line 1381 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1382 "../src/WindowManager.vala"
				meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1383 "../src/WindowManager.vala"
				block25_data_unref (_data25_);
#line 1383 "../src/WindowManager.vala"
				_data25_ = NULL;
#line 1383 "../src/WindowManager.vala"
				block23_data_unref (_data23_);
#line 1383 "../src/WindowManager.vala"
				_data23_ = NULL;
#line 1383 "../src/WindowManager.vala"
				return;
#line 8492 "WindowManager.c"
			}
#line 1386 "../src/WindowManager.vala"
			_tmp38_ = self->priv->mapping;
#line 1386 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _data23_->actor);
#line 1388 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data23_->actor, (guint) 0);
#line 1390 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data23_->actor);
#line 1391 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data23_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1392 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data23_->actor, (guint) duration);
#line 1393 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data23_->actor, (guint) 255);
#line 1394 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data23_->actor);
#line 1396 "../src/WindowManager.vala"
			_data25_->map_handler_id = 0UL;
#line 1397 "../src/WindowManager.vala"
			_tmp39_ = g_signal_connect_data ((ClutterActor*) _data23_->actor, "transitions-completed", (GCallback) ____lambda187__clutter_actor_transitions_completed, block25_data_ref (_data25_), (GClosureNotify) block25_data_unref, 0);
#line 1397 "../src/WindowManager.vala"
			_data25_->map_handler_id = _tmp39_;
#line 1402 "../src/WindowManager.vala"
			block25_data_unref (_data25_);
#line 1402 "../src/WindowManager.vala"
			_data25_ = NULL;
#line 1402 "../src/WindowManager.vala"
			break;
#line 8522 "WindowManager.c"
		}
#line 1340 "../src/WindowManager.vala"
		case META_WINDOW_MODAL_DIALOG:
#line 1340 "../src/WindowManager.vala"
		case META_WINDOW_DIALOG:
#line 8528 "WindowManager.c"
		{
			Block26Data* _data26_;
			GeeHashSet* _tmp40_;
			gulong _tmp41_;
			MetaWindow* _tmp42_;
#line 1340 "../src/WindowManager.vala"
			_data26_ = g_slice_new0 (Block26Data);
#line 1340 "../src/WindowManager.vala"
			_data26_->_ref_count_ = 1;
#line 1340 "../src/WindowManager.vala"
			_data26_->_data23_ = block23_data_ref (_data23_);
#line 1406 "../src/WindowManager.vala"
			_tmp40_ = self->priv->mapping;
#line 1406 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp40_, _data23_->actor);
#line 1408 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data23_->actor, 0.5f, 0.5f);
#line 1409 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data23_->actor, (gdouble) 1.05f, (gdouble) 1.05f);
#line 1410 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data23_->actor, (guint) 0);
#line 1412 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data23_->actor);
#line 1413 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data23_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1414 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data23_->actor, (guint) 200);
#line 1415 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data23_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1416 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data23_->actor, 255U);
#line 1417 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data23_->actor);
#line 1419 "../src/WindowManager.vala"
			_data26_->map_handler_id = 0UL;
#line 1420 "../src/WindowManager.vala"
			_tmp41_ = g_signal_connect_data ((ClutterActor*) _data23_->actor, "transitions-completed", (GCallback) ____lambda188__clutter_actor_transitions_completed, block26_data_ref (_data26_), (GClosureNotify) block26_data_unref, 0);
#line 1420 "../src/WindowManager.vala"
			_data26_->map_handler_id = _tmp41_;
#line 1430 "../src/WindowManager.vala"
			_tmp42_ = _data23_->window;
#line 1430 "../src/WindowManager.vala"
			gala_window_manager_gala_dim_parent_window (self, _tmp42_);
#line 1432 "../src/WindowManager.vala"
			block26_data_unref (_data26_);
#line 1432 "../src/WindowManager.vala"
			_data26_ = NULL;
#line 1432 "../src/WindowManager.vala"
			break;
#line 8578 "WindowManager.c"
		}
		default:
		{
#line 1434 "../src/WindowManager.vala"
			meta_plugin_map_completed ((MetaPlugin*) self, _data23_->actor);
#line 1435 "../src/WindowManager.vala"
			break;
#line 8586 "WindowManager.c"
		}
	}
#line 1311 "../src/WindowManager.vala"
	block23_data_unref (_data23_);
#line 1311 "../src/WindowManager.vala"
	_data23_ = NULL;
#line 8593 "WindowManager.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 1439 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 1439 "../src/WindowManager.vala"
	return _data27_;
#line 8603 "WindowManager.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 1439 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 8613 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1439 "../src/WindowManager.vala"
		self = _data27_->self;
#line 1439 "../src/WindowManager.vala"
		_g_object_unref0 (_data27_->actor);
#line 1439 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1439 "../src/WindowManager.vala"
		g_slice_free (Block27Data, _data27_);
#line 8623 "WindowManager.c"
	}
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 1451 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 1451 "../src/WindowManager.vala"
	return _data28_;
#line 8634 "WindowManager.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 1451 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 8644 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1451 "../src/WindowManager.vala"
		self = _data28_->_data27_->self;
#line 1451 "../src/WindowManager.vala"
		block27_data_unref (_data28_->_data27_);
#line 1451 "../src/WindowManager.vala"
		_data28_->_data27_ = NULL;
#line 1451 "../src/WindowManager.vala"
		g_slice_free (Block28Data, _data28_);
#line 8654 "WindowManager.c"
	}
}

static void
____lambda189_ (Block28Data* _data28_)
{
	Block27Data* _data27_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1453 "../src/WindowManager.vala"
	_data27_ = _data28_->_data27_;
#line 1453 "../src/WindowManager.vala"
	self = _data27_->self;
#line 1454 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data27_->actor, _data28_->destroy_handler_id);
#line 1455 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1455 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data27_->actor);
#line 1456 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 8676 "WindowManager.c"
}

static void
_____lambda189__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                     gpointer self)
{
#line 1453 "../src/WindowManager.vala"
	____lambda189_ (self);
#line 8685 "WindowManager.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 1475 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 1475 "../src/WindowManager.vala"
	return _data29_;
#line 8695 "WindowManager.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 1475 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 8705 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1475 "../src/WindowManager.vala"
		self = _data29_->_data27_->self;
#line 1475 "../src/WindowManager.vala"
		block27_data_unref (_data29_->_data27_);
#line 1475 "../src/WindowManager.vala"
		_data29_->_data27_ = NULL;
#line 1475 "../src/WindowManager.vala"
		g_slice_free (Block29Data, _data29_);
#line 8715 "WindowManager.c"
	}
}

static void
___lambda190_ (Block29Data* _data29_)
{
	Block27Data* _data27_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
	MetaWindow* _tmp1_;
#line 1496 "../src/WindowManager.vala"
	_data27_ = _data29_->_data27_;
#line 1496 "../src/WindowManager.vala"
	self = _data27_->self;
#line 1497 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data27_->actor, _data29_->destroy_handler_id);
#line 1498 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1498 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data27_->actor);
#line 1499 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 1500 "../src/WindowManager.vala"
	_tmp1_ = _data27_->window;
#line 1500 "../src/WindowManager.vala"
	gala_utils_clear_window_cache (_tmp1_);
#line 8742 "WindowManager.c"
}

static void
____lambda190__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1496 "../src/WindowManager.vala"
	___lambda190_ (self);
#line 8751 "WindowManager.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 1475 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 1475 "../src/WindowManager.vala"
	return _data30_;
#line 8761 "WindowManager.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 1475 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 8771 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1475 "../src/WindowManager.vala"
		self = _data30_->_data27_->self;
#line 1475 "../src/WindowManager.vala"
		block27_data_unref (_data30_->_data27_);
#line 1475 "../src/WindowManager.vala"
		_data30_->_data27_ = NULL;
#line 1475 "../src/WindowManager.vala"
		g_slice_free (Block30Data, _data30_);
#line 8781 "WindowManager.c"
	}
}

static void
___lambda191_ (Block30Data* _data30_)
{
	Block27Data* _data27_;
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1516 "../src/WindowManager.vala"
	_data27_ = _data30_->_data27_;
#line 1516 "../src/WindowManager.vala"
	self = _data27_->self;
#line 1517 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data27_->actor, _data30_->destroy_handler_id);
#line 1518 "../src/WindowManager.vala"
	_tmp0_ = self->priv->destroying;
#line 1518 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data27_->actor);
#line 1519 "../src/WindowManager.vala"
	meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 8803 "WindowManager.c"
}

static void
____lambda191__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                    gpointer self)
{
#line 1516 "../src/WindowManager.vala"
	___lambda191_ (self);
#line 8812 "WindowManager.c"
}

static void
gala_window_manager_gala_real_destroy (MetaPlugin* base,
                                       MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	Block27Data* _data27_;
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp10_;
	MetaWindowType _tmp11_;
	MetaWindowType _tmp12_;
#line 1439 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1439 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1439 "../src/WindowManager.vala"
	_data27_ = g_slice_new0 (Block27Data);
#line 1439 "../src/WindowManager.vala"
	_data27_->_ref_count_ = 1;
#line 1439 "../src/WindowManager.vala"
	_data27_->self = g_object_ref (self);
#line 1439 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1439 "../src/WindowManager.vala"
	_g_object_unref0 (_data27_->actor);
#line 1439 "../src/WindowManager.vala"
	_data27_->actor = _tmp0_;
#line 1440 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data27_->actor);
#line 1440 "../src/WindowManager.vala"
	_data27_->window = _tmp1_;
#line 1442 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) _data27_->actor);
#line 1444 "../src/WindowManager.vala"
	_tmp2_ = _data27_->window;
#line 1444 "../src/WindowManager.vala"
	if (gala_notification_stack_is_notification (_tmp2_)) {
#line 8853 "WindowManager.c"
		GalaNotificationStack* _tmp4_;
#line 1445 "../src/WindowManager.vala"
		if (meta_prefs_get_gnome_animations ()) {
#line 8857 "WindowManager.c"
			GeeHashSet* _tmp3_;
#line 1446 "../src/WindowManager.vala"
			_tmp3_ = self->priv->destroying;
#line 1446 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _data27_->actor);
#line 8863 "WindowManager.c"
		}
#line 1449 "../src/WindowManager.vala"
		_tmp4_ = self->priv->notification_stack;
#line 1449 "../src/WindowManager.vala"
		gala_notification_stack_destroy_notification (_tmp4_, _data27_->actor);
#line 1451 "../src/WindowManager.vala"
		if (meta_prefs_get_gnome_animations ()) {
#line 8871 "WindowManager.c"
			Block28Data* _data28_;
			gulong _tmp5_;
#line 1451 "../src/WindowManager.vala"
			_data28_ = g_slice_new0 (Block28Data);
#line 1451 "../src/WindowManager.vala"
			_data28_->_ref_count_ = 1;
#line 1451 "../src/WindowManager.vala"
			_data28_->_data27_ = block27_data_ref (_data27_);
#line 1452 "../src/WindowManager.vala"
			_data28_->destroy_handler_id = 0UL;
#line 1453 "../src/WindowManager.vala"
			_tmp5_ = g_signal_connect_data ((ClutterActor*) _data27_->actor, "transitions-completed", (GCallback) _____lambda189__clutter_actor_transitions_completed, block28_data_ref (_data28_), (GClosureNotify) block28_data_unref, 0);
#line 1453 "../src/WindowManager.vala"
			_data28_->destroy_handler_id = _tmp5_;
#line 1451 "../src/WindowManager.vala"
			block28_data_unref (_data28_);
#line 1451 "../src/WindowManager.vala"
			_data28_ = NULL;
#line 8890 "WindowManager.c"
		} else {
#line 1459 "../src/WindowManager.vala"
			meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 8894 "WindowManager.c"
		}
#line 1462 "../src/WindowManager.vala"
		block27_data_unref (_data27_);
#line 1462 "../src/WindowManager.vala"
		_data27_ = NULL;
#line 1462 "../src/WindowManager.vala"
		return;
#line 8902 "WindowManager.c"
	}
#line 1465 "../src/WindowManager.vala"
	if (!meta_prefs_get_gnome_animations ()) {
#line 8906 "WindowManager.c"
		MetaWindow* _tmp6_;
		MetaWindowType _tmp7_;
		MetaWindowType _tmp8_;
#line 1466 "../src/WindowManager.vala"
		meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 1468 "../src/WindowManager.vala"
		_tmp6_ = _data27_->window;
#line 1468 "../src/WindowManager.vala"
		_tmp7_ = meta_window_get_window_type (_tmp6_);
#line 1468 "../src/WindowManager.vala"
		_tmp8_ = _tmp7_;
#line 1468 "../src/WindowManager.vala"
		if (_tmp8_ == META_WINDOW_NORMAL) {
#line 8920 "WindowManager.c"
			MetaWindow* _tmp9_;
#line 1469 "../src/WindowManager.vala"
			_tmp9_ = _data27_->window;
#line 1469 "../src/WindowManager.vala"
			gala_utils_clear_window_cache (_tmp9_);
#line 8926 "WindowManager.c"
		}
#line 1472 "../src/WindowManager.vala"
		block27_data_unref (_data27_);
#line 1472 "../src/WindowManager.vala"
		_data27_ = NULL;
#line 1472 "../src/WindowManager.vala"
		return;
#line 8934 "WindowManager.c"
	}
#line 1475 "../src/WindowManager.vala"
	_tmp10_ = _data27_->window;
#line 1475 "../src/WindowManager.vala"
	_tmp11_ = meta_window_get_window_type (_tmp10_);
#line 1475 "../src/WindowManager.vala"
	_tmp12_ = _tmp11_;
#line 1475 "../src/WindowManager.vala"
	switch (_tmp12_) {
#line 1475 "../src/WindowManager.vala"
		case META_WINDOW_NORMAL:
#line 8946 "WindowManager.c"
		{
			Block29Data* _data29_;
			GalaAnimationDuration duration = 0;
			GeeHashSet* _tmp13_;
			gulong _tmp14_;
#line 1475 "../src/WindowManager.vala"
			_data29_ = g_slice_new0 (Block29Data);
#line 1475 "../src/WindowManager.vala"
			_data29_->_ref_count_ = 1;
#line 1475 "../src/WindowManager.vala"
			_data29_->_data27_ = block27_data_ref (_data27_);
#line 1477 "../src/WindowManager.vala"
			duration = GALA_ANIMATION_DURATION_CLOSE;
#line 1478 "../src/WindowManager.vala"
			if (duration == 0) {
#line 1479 "../src/WindowManager.vala"
				meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 1480 "../src/WindowManager.vala"
				block29_data_unref (_data29_);
#line 1480 "../src/WindowManager.vala"
				_data29_ = NULL;
#line 1480 "../src/WindowManager.vala"
				block27_data_unref (_data27_);
#line 1480 "../src/WindowManager.vala"
				_data27_ = NULL;
#line 1480 "../src/WindowManager.vala"
				return;
#line 8974 "WindowManager.c"
			}
#line 1483 "../src/WindowManager.vala"
			_tmp13_ = self->priv->destroying;
#line 1483 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _data27_->actor);
#line 1485 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data27_->actor, 0.5f, 0.5f);
#line 1486 "../src/WindowManager.vala"
			clutter_actor_show ((ClutterActor*) _data27_->actor);
#line 1488 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data27_->actor);
#line 1489 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data27_->actor, CLUTTER_LINEAR);
#line 1490 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data27_->actor, (guint) duration);
#line 1491 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data27_->actor, (gdouble) 0.8f, (gdouble) 0.8f);
#line 1492 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data27_->actor, 0U);
#line 1493 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data27_->actor);
#line 1495 "../src/WindowManager.vala"
			_data29_->destroy_handler_id = 0UL;
#line 1496 "../src/WindowManager.vala"
			_tmp14_ = g_signal_connect_data ((ClutterActor*) _data27_->actor, "transitions-completed", (GCallback) ____lambda190__clutter_actor_transitions_completed, block29_data_ref (_data29_), (GClosureNotify) block29_data_unref, 0);
#line 1496 "../src/WindowManager.vala"
			_data29_->destroy_handler_id = _tmp14_;
#line 1502 "../src/WindowManager.vala"
			block29_data_unref (_data29_);
#line 1502 "../src/WindowManager.vala"
			_data29_ = NULL;
#line 1502 "../src/WindowManager.vala"
			break;
#line 9008 "WindowManager.c"
		}
#line 1475 "../src/WindowManager.vala"
		case META_WINDOW_MODAL_DIALOG:
#line 1475 "../src/WindowManager.vala"
		case META_WINDOW_DIALOG:
#line 9014 "WindowManager.c"
		{
			Block30Data* _data30_;
			GeeHashSet* _tmp15_;
			gulong _tmp16_;
#line 1475 "../src/WindowManager.vala"
			_data30_ = g_slice_new0 (Block30Data);
#line 1475 "../src/WindowManager.vala"
			_data30_->_ref_count_ = 1;
#line 1475 "../src/WindowManager.vala"
			_data30_->_data27_ = block27_data_ref (_data27_);
#line 1505 "../src/WindowManager.vala"
			_tmp15_ = self->priv->destroying;
#line 1505 "../src/WindowManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _data27_->actor);
#line 1507 "../src/WindowManager.vala"
			clutter_actor_set_pivot_point ((ClutterActor*) _data27_->actor, 0.5f, 0.5f);
#line 1508 "../src/WindowManager.vala"
			clutter_actor_save_easing_state ((ClutterActor*) _data27_->actor);
#line 1509 "../src/WindowManager.vala"
			clutter_actor_set_easing_mode ((ClutterActor*) _data27_->actor, CLUTTER_EASE_OUT_QUAD);
#line 1510 "../src/WindowManager.vala"
			clutter_actor_set_easing_duration ((ClutterActor*) _data27_->actor, (guint) 150);
#line 1511 "../src/WindowManager.vala"
			clutter_actor_set_scale ((ClutterActor*) _data27_->actor, (gdouble) 1.05f, (gdouble) 1.05f);
#line 1512 "../src/WindowManager.vala"
			clutter_actor_set_opacity ((ClutterActor*) _data27_->actor, 0U);
#line 1513 "../src/WindowManager.vala"
			clutter_actor_restore_easing_state ((ClutterActor*) _data27_->actor);
#line 1515 "../src/WindowManager.vala"
			_data30_->destroy_handler_id = 0UL;
#line 1516 "../src/WindowManager.vala"
			_tmp16_ = g_signal_connect_data ((ClutterActor*) _data27_->actor, "transitions-completed", (GCallback) ____lambda191__clutter_actor_transitions_completed, block30_data_ref (_data30_), (GClosureNotify) block30_data_unref, 0);
#line 1516 "../src/WindowManager.vala"
			_data30_->destroy_handler_id = _tmp16_;
#line 1521 "../src/WindowManager.vala"
			block30_data_unref (_data30_);
#line 1521 "../src/WindowManager.vala"
			_data30_ = NULL;
#line 1521 "../src/WindowManager.vala"
			break;
#line 9055 "WindowManager.c"
		}
		default:
		{
#line 1523 "../src/WindowManager.vala"
			meta_plugin_destroy_completed ((MetaPlugin*) self, _data27_->actor);
#line 1524 "../src/WindowManager.vala"
			break;
#line 9063 "WindowManager.c"
		}
	}
#line 1439 "../src/WindowManager.vala"
	block27_data_unref (_data27_);
#line 1439 "../src/WindowManager.vala"
	_data27_ = NULL;
#line 9070 "WindowManager.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 1528 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 1528 "../src/WindowManager.vala"
	return _data31_;
#line 9080 "WindowManager.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 1528 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 9090 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1528 "../src/WindowManager.vala"
		self = _data31_->self;
#line 1528 "../src/WindowManager.vala"
		_g_object_unref0 (_data31_->actor);
#line 1528 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1528 "../src/WindowManager.vala"
		g_slice_free (Block31Data, _data31_);
#line 9100 "WindowManager.c"
	}
}

static void
__lambda181_ (Block31Data* _data31_,
              ClutterActor* snapshot,
              const gchar* name,
              gboolean is_finished)
{
	GalaWindowManagerGala* self;
	ClutterActor* parent = NULL;
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
#line 1571 "../src/WindowManager.vala"
	self = _data31_->self;
#line 1571 "../src/WindowManager.vala"
	g_return_if_fail (snapshot != NULL);
#line 1571 "../src/WindowManager.vala"
	g_return_if_fail (name != NULL);
#line 1572 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) snapshot, _data31_->unmaximize_old_handler_id);
#line 1574 "../src/WindowManager.vala"
	_tmp0_ = clutter_actor_get_parent (snapshot);
#line 1574 "../src/WindowManager.vala"
	parent = _tmp0_;
#line 1575 "../src/WindowManager.vala"
	_tmp1_ = parent;
#line 1575 "../src/WindowManager.vala"
	if (_tmp1_ != NULL) {
#line 9130 "WindowManager.c"
		ClutterActor* _tmp2_;
#line 1576 "../src/WindowManager.vala"
		_tmp2_ = parent;
#line 1576 "../src/WindowManager.vala"
		clutter_actor_remove_child (_tmp2_, snapshot);
#line 9136 "WindowManager.c"
	}
}

static void
___lambda181__clutter_actor_transition_stopped (ClutterActor* _sender,
                                                const gchar* name,
                                                gboolean is_finished,
                                                gpointer self)
{
#line 1571 "../src/WindowManager.vala"
	__lambda181_ (self, _sender, name, is_finished);
#line 9148 "WindowManager.c"
}

static void
__lambda182_ (Block31Data* _data31_)
{
	GalaWindowManagerGala* self;
	GeeHashSet* _tmp0_;
#line 1600 "../src/WindowManager.vala"
	self = _data31_->self;
#line 1601 "../src/WindowManager.vala"
	g_signal_handler_disconnect ((GObject*) _data31_->actor, _data31_->handler_id);
#line 1602 "../src/WindowManager.vala"
	_tmp0_ = self->priv->unmaximizing;
#line 1602 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, _data31_->actor);
#line 9164 "WindowManager.c"
}

static void
___lambda182__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                   gpointer self)
{
#line 1600 "../src/WindowManager.vala"
	__lambda182_ (self);
#line 9173 "WindowManager.c"
}

static void
gala_window_manager_gala_unmaximize (GalaWindowManagerGala* self,
                                     MetaWindowActor* actor,
                                     gint ex,
                                     gint ey,
                                     gint ew,
                                     gint eh)
{
	Block31Data* _data31_;
	MetaWindowActor* _tmp0_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GalaAnimationDuration duration = 0;
	gfloat offset_x = 0.0F;
	gfloat offset_y = 0.0F;
	GalaWindowListenerWindowGeometry* unmaximized_window_geometry = NULL;
	GalaWindowListener* _tmp9_;
	MetaWindow* _tmp10_;
	GalaWindowListenerWindowGeometry* _tmp11_;
	GalaWindowListenerWindowGeometry* _tmp12_;
	GeeHashSet* _tmp21_;
	ClutterActor* _tmp22_;
	MtkRectangle _tmp23_;
	MtkRectangle _tmp24_;
	ClutterActor* _tmp25_;
	ClutterActor* _tmp26_;
	ClutterActor* _tmp27_;
	gfloat scale_x = 0.0F;
	MtkRectangle _tmp28_;
	gfloat scale_y = 0.0F;
	MtkRectangle _tmp29_;
	ClutterActor* _tmp30_;
	ClutterActor* _tmp31_;
	ClutterActor* _tmp32_;
	ClutterActor* _tmp33_;
	ClutterActor* _tmp34_;
	ClutterActor* _tmp35_;
	ClutterActor* _tmp36_;
	ClutterActor* _tmp37_;
	gulong _tmp38_;
	MtkRectangle buffer_rect = {0};
	MetaWindow* _tmp39_;
	MtkRectangle _tmp40_ = {0};
	MtkRectangle frame_rect = {0};
	MetaWindow* _tmp41_;
	MtkRectangle _tmp42_ = {0};
	gint real_actor_offset_x = 0;
	MtkRectangle _tmp43_;
	MtkRectangle _tmp44_;
	gint real_actor_offset_y = 0;
	MtkRectangle _tmp45_;
	MtkRectangle _tmp46_;
	MtkRectangle _tmp47_;
	MtkRectangle _tmp48_;
	gulong _tmp49_;
#line 1528 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1528 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1528 "../src/WindowManager.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 1528 "../src/WindowManager.vala"
	_data31_->_ref_count_ = 1;
#line 1528 "../src/WindowManager.vala"
	_data31_->self = g_object_ref (self);
#line 1528 "../src/WindowManager.vala"
	_tmp0_ = _g_object_ref0 (actor);
#line 1528 "../src/WindowManager.vala"
	_g_object_unref0 (_data31_->actor);
#line 1528 "../src/WindowManager.vala"
	_data31_->actor = _tmp0_;
#line 1529 "../src/WindowManager.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_data31_->actor);
#line 1529 "../src/WindowManager.vala"
	window = _tmp1_;
#line 1530 "../src/WindowManager.vala"
	_tmp2_ = window;
#line 1530 "../src/WindowManager.vala"
	gala_window_manager_gala_move_window_to_old_ws (self, _tmp2_);
#line 1532 "../src/WindowManager.vala"
	G_TYPE_INSTANCE_GET_CLASS ((MetaPlugin*) self, meta_plugin_get_type (), MetaPluginClass)->kill_window_effects ((MetaPlugin*) self, _data31_->actor);
#line 1534 "../src/WindowManager.vala"
	if (!meta_prefs_get_gnome_animations ()) {
#line 1534 "../src/WindowManager.vala"
		_tmp4_ = TRUE;
#line 9264 "WindowManager.c"
	} else {
		ClutterActor* _tmp5_;
#line 1535 "../src/WindowManager.vala"
		_tmp5_ = self->priv->latest_window_snapshot;
#line 1535 "../src/WindowManager.vala"
		_tmp4_ = _tmp5_ == NULL;
#line 9271 "WindowManager.c"
	}
#line 1534 "../src/WindowManager.vala"
	if (_tmp4_) {
#line 1534 "../src/WindowManager.vala"
		_tmp3_ = TRUE;
#line 9277 "WindowManager.c"
	} else {
		MetaWindow* _tmp6_;
		MetaWindowType _tmp7_;
		MetaWindowType _tmp8_;
#line 1536 "../src/WindowManager.vala"
		_tmp6_ = window;
#line 1536 "../src/WindowManager.vala"
		_tmp7_ = meta_window_get_window_type (_tmp6_);
#line 1536 "../src/WindowManager.vala"
		_tmp8_ = _tmp7_;
#line 1536 "../src/WindowManager.vala"
		_tmp3_ = _tmp8_ != META_WINDOW_NORMAL;
#line 9290 "WindowManager.c"
	}
#line 1534 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 1537 "../src/WindowManager.vala"
		block31_data_unref (_data31_);
#line 1537 "../src/WindowManager.vala"
		_data31_ = NULL;
#line 1537 "../src/WindowManager.vala"
		return;
#line 9300 "WindowManager.c"
	}
#line 1540 "../src/WindowManager.vala"
	duration = GALA_ANIMATION_DURATION_SNAP;
#line 1543 "../src/WindowManager.vala"
	_tmp9_ = gala_window_listener_get_default ();
#line 1543 "../src/WindowManager.vala"
	_tmp10_ = window;
#line 1543 "../src/WindowManager.vala"
	_tmp11_ = gala_window_listener_get_unmaximized_state_geometry (_tmp9_, _tmp10_);
#line 1543 "../src/WindowManager.vala"
	unmaximized_window_geometry = _tmp11_;
#line 1545 "../src/WindowManager.vala"
	_tmp12_ = unmaximized_window_geometry;
#line 1545 "../src/WindowManager.vala"
	if (_tmp12_ != NULL) {
#line 9316 "WindowManager.c"
		GalaWindowListenerWindowGeometry* _tmp13_;
		MtkRectangle _tmp14_;
		GalaWindowListenerWindowGeometry* _tmp15_;
		MtkRectangle _tmp16_;
		GalaWindowListenerWindowGeometry* _tmp17_;
		MtkRectangle _tmp18_;
		GalaWindowListenerWindowGeometry* _tmp19_;
		MtkRectangle _tmp20_;
#line 1546 "../src/WindowManager.vala"
		_tmp13_ = unmaximized_window_geometry;
#line 1546 "../src/WindowManager.vala"
		_tmp14_ = (*_tmp13_).outer;
#line 1546 "../src/WindowManager.vala"
		_tmp15_ = unmaximized_window_geometry;
#line 1546 "../src/WindowManager.vala"
		_tmp16_ = (*_tmp15_).inner;
#line 1546 "../src/WindowManager.vala"
		offset_x = (gfloat) (_tmp14_.x - _tmp16_.x);
#line 1547 "../src/WindowManager.vala"
		_tmp17_ = unmaximized_window_geometry;
#line 1547 "../src/WindowManager.vala"
		_tmp18_ = (*_tmp17_).outer;
#line 1547 "../src/WindowManager.vala"
		_tmp19_ = unmaximized_window_geometry;
#line 1547 "../src/WindowManager.vala"
		_tmp20_ = (*_tmp19_).inner;
#line 1547 "../src/WindowManager.vala"
		offset_y = (gfloat) (_tmp18_.y - _tmp20_.y);
#line 9345 "WindowManager.c"
	} else {
#line 1549 "../src/WindowManager.vala"
		offset_x = (gfloat) 0;
#line 1550 "../src/WindowManager.vala"
		offset_y = (gfloat) 0;
#line 9351 "WindowManager.c"
	}
#line 1553 "../src/WindowManager.vala"
	_tmp21_ = self->priv->unmaximizing;
#line 1553 "../src/WindowManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _data31_->actor);
#line 1555 "../src/WindowManager.vala"
	_tmp22_ = self->priv->latest_window_snapshot;
#line 1555 "../src/WindowManager.vala"
	_tmp23_ = self->priv->old_rect_size_change;
#line 1555 "../src/WindowManager.vala"
	_tmp24_ = self->priv->old_rect_size_change;
#line 1555 "../src/WindowManager.vala"
	clutter_actor_set_position (_tmp22_, (gfloat) _tmp23_.x, (gfloat) _tmp24_.y);
#line 1557 "../src/WindowManager.vala"
	_tmp25_ = gala_window_manager_get_ui_group ((GalaWindowManager*) self);
#line 1557 "../src/WindowManager.vala"
	_tmp26_ = _tmp25_;
#line 1557 "../src/WindowManager.vala"
	_tmp27_ = self->priv->latest_window_snapshot;
#line 1557 "../src/WindowManager.vala"
	clutter_actor_add_child (_tmp26_, _tmp27_);
#line 1559 "../src/WindowManager.vala"
	_tmp28_ = self->priv->old_rect_size_change;
#line 1559 "../src/WindowManager.vala"
	scale_x = ((gfloat) ew) / _tmp28_.width;
#line 1560 "../src/WindowManager.vala"
	_tmp29_ = self->priv->old_rect_size_change;
#line 1560 "../src/WindowManager.vala"
	scale_y = ((gfloat) eh) / _tmp29_.height;
#line 1562 "../src/WindowManager.vala"
	_tmp30_ = self->priv->latest_window_snapshot;
#line 1562 "../src/WindowManager.vala"
	clutter_actor_save_easing_state (_tmp30_);
#line 1563 "../src/WindowManager.vala"
	_tmp31_ = self->priv->latest_window_snapshot;
#line 1563 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode (_tmp31_, CLUTTER_EASE_IN_OUT_QUAD);
#line 1564 "../src/WindowManager.vala"
	_tmp32_ = self->priv->latest_window_snapshot;
#line 1564 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration (_tmp32_, (guint) duration);
#line 1565 "../src/WindowManager.vala"
	_tmp33_ = self->priv->latest_window_snapshot;
#line 1565 "../src/WindowManager.vala"
	clutter_actor_set_position (_tmp33_, (gfloat) ex, (gfloat) ey);
#line 1566 "../src/WindowManager.vala"
	_tmp34_ = self->priv->latest_window_snapshot;
#line 1566 "../src/WindowManager.vala"
	clutter_actor_set_scale (_tmp34_, (gdouble) scale_x, (gdouble) scale_y);
#line 1567 "../src/WindowManager.vala"
	_tmp35_ = self->priv->latest_window_snapshot;
#line 1567 "../src/WindowManager.vala"
	clutter_actor_set_opacity (_tmp35_, 0U);
#line 1568 "../src/WindowManager.vala"
	_tmp36_ = self->priv->latest_window_snapshot;
#line 1568 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state (_tmp36_);
#line 1570 "../src/WindowManager.vala"
	_data31_->unmaximize_old_handler_id = (gulong) 0;
#line 1571 "../src/WindowManager.vala"
	_tmp37_ = self->priv->latest_window_snapshot;
#line 1571 "../src/WindowManager.vala"
	_tmp38_ = g_signal_connect_data (_tmp37_, "transition-stopped", (GCallback) ___lambda181__clutter_actor_transition_stopped, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 1571 "../src/WindowManager.vala"
	_data31_->unmaximize_old_handler_id = _tmp38_;
#line 1580 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->latest_window_snapshot);
#line 1580 "../src/WindowManager.vala"
	self->priv->latest_window_snapshot = NULL;
#line 1582 "../src/WindowManager.vala"
	_tmp39_ = window;
#line 1582 "../src/WindowManager.vala"
	meta_window_get_buffer_rect (_tmp39_, &_tmp40_);
#line 1582 "../src/WindowManager.vala"
	buffer_rect = _tmp40_;
#line 1583 "../src/WindowManager.vala"
	_tmp41_ = window;
#line 1583 "../src/WindowManager.vala"
	meta_window_get_frame_rect (_tmp41_, &_tmp42_);
#line 1583 "../src/WindowManager.vala"
	frame_rect = _tmp42_;
#line 1584 "../src/WindowManager.vala"
	_tmp43_ = frame_rect;
#line 1584 "../src/WindowManager.vala"
	_tmp44_ = buffer_rect;
#line 1584 "../src/WindowManager.vala"
	real_actor_offset_x = _tmp43_.x - _tmp44_.x;
#line 1585 "../src/WindowManager.vala"
	_tmp45_ = frame_rect;
#line 1585 "../src/WindowManager.vala"
	_tmp46_ = buffer_rect;
#line 1585 "../src/WindowManager.vala"
	real_actor_offset_y = _tmp45_.y - _tmp46_.y;
#line 1587 "../src/WindowManager.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) _data31_->actor, 0.0f, 0.0f);
#line 1588 "../src/WindowManager.vala"
	clutter_actor_set_position ((ClutterActor*) _data31_->actor, (gfloat) (ex - real_actor_offset_x), (gfloat) (ey - real_actor_offset_y));
#line 1589 "../src/WindowManager.vala"
	_tmp47_ = self->priv->old_rect_size_change;
#line 1589 "../src/WindowManager.vala"
	_tmp48_ = self->priv->old_rect_size_change;
#line 1589 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _data31_->actor, ((-ex) + (offset_x * ((1.0f / scale_x) - 1.0f))) + _tmp47_.x, ((-ey) + (offset_y * ((1.0f / scale_y) - 1.0f))) + _tmp48_.y, 0.0f);
#line 1590 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) _data31_->actor, (gdouble) (1.0f / scale_x), (gdouble) (1.0f / scale_y));
#line 1592 "../src/WindowManager.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _data31_->actor);
#line 1593 "../src/WindowManager.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) _data31_->actor, CLUTTER_EASE_IN_OUT_QUAD);
#line 1594 "../src/WindowManager.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _data31_->actor, (guint) duration);
#line 1595 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) _data31_->actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1596 "../src/WindowManager.vala"
	clutter_actor_set_translation ((ClutterActor*) _data31_->actor, 0.0f, 0.0f, 0.0f);
#line 1597 "../src/WindowManager.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _data31_->actor);
#line 1599 "../src/WindowManager.vala"
	_data31_->handler_id = 0UL;
#line 1600 "../src/WindowManager.vala"
	_tmp49_ = g_signal_connect_data ((ClutterActor*) _data31_->actor, "transitions-completed", (GCallback) ___lambda182__clutter_actor_transitions_completed, block31_data_ref (_data31_), (GClosureNotify) block31_data_unref, 0);
#line 1600 "../src/WindowManager.vala"
	_data31_->handler_id = _tmp49_;
#line 1528 "../src/WindowManager.vala"
	_gala_window_listener_window_geometry_free0 (unmaximized_window_geometry);
#line 1528 "../src/WindowManager.vala"
	block31_data_unref (_data31_);
#line 1528 "../src/WindowManager.vala"
	_data31_ = NULL;
#line 9481 "WindowManager.c"
}

static void
_gala_window_manager_gala_move_window_to_old_ws_meta_window_unmanaged (MetaWindow* _sender,
                                                                       gpointer self)
{
#line 1630 "../src/WindowManager.vala"
	gala_window_manager_gala_move_window_to_old_ws ((GalaWindowManagerGala*) self, _sender);
#line 9490 "WindowManager.c"
}

static void
gala_window_manager_gala_move_window_to_next_ws (GalaWindowManagerGala* self,
                                                 MetaWindow* window)
{
	MetaWorkspace* win_ws = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	gint old_ws_index = 0;
	MetaWorkspace* _tmp2_;
	gint new_ws_index = 0;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp3_;
	guint32 time = 0U;
	MetaDisplay* _tmp4_;
	MetaWorkspace* new_ws = NULL;
	MetaDisplay* _tmp5_;
	MetaWorkspaceManager* _tmp6_;
	MetaWorkspace* _tmp7_;
	MetaWorkspace* _tmp8_;
	MetaWorkspace* _tmp9_;
	GHashTable* _tmp10_;
	GHashTable* _tmp11_;
	MetaWindow* _tmp12_;
#line 1606 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1606 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1607 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_workspace (window);
#line 1607 "../src/WindowManager.vala"
	win_ws = _tmp0_;
#line 1610 "../src/WindowManager.vala"
	_tmp1_ = win_ws;
#line 1610 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp1_, FALSE, NULL) <= ((guint) 1)) {
#line 1611 "../src/WindowManager.vala"
		return;
#line 9530 "WindowManager.c"
	}
#line 1615 "../src/WindowManager.vala"
	if (!meta_window_is_on_primary_monitor (window)) {
#line 1616 "../src/WindowManager.vala"
		return;
#line 9536 "WindowManager.c"
	}
#line 1619 "../src/WindowManager.vala"
	_tmp2_ = win_ws;
#line 1619 "../src/WindowManager.vala"
	old_ws_index = meta_workspace_index (_tmp2_);
#line 1620 "../src/WindowManager.vala"
	new_ws_index = old_ws_index + 1;
#line 1621 "../src/WindowManager.vala"
	gala_internal_utils_insert_workspace_with_window (new_ws_index, window);
#line 1623 "../src/WindowManager.vala"
	_tmp3_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1623 "../src/WindowManager.vala"
	display = _tmp3_;
#line 1624 "../src/WindowManager.vala"
	_tmp4_ = display;
#line 1624 "../src/WindowManager.vala"
	time = meta_display_get_current_time (_tmp4_);
#line 1625 "../src/WindowManager.vala"
	_tmp5_ = display;
#line 1625 "../src/WindowManager.vala"
	_tmp6_ = meta_display_get_workspace_manager (_tmp5_);
#line 1625 "../src/WindowManager.vala"
	_tmp7_ = meta_workspace_manager_get_workspace_by_index (_tmp6_, new_ws_index);
#line 1625 "../src/WindowManager.vala"
	new_ws = _tmp7_;
#line 1626 "../src/WindowManager.vala"
	_tmp8_ = new_ws;
#line 1626 "../src/WindowManager.vala"
	meta_window_change_workspace (window, _tmp8_);
#line 1627 "../src/WindowManager.vala"
	_tmp9_ = new_ws;
#line 1627 "../src/WindowManager.vala"
	meta_workspace_activate_with_focus (_tmp9_, window, time);
#line 1629 "../src/WindowManager.vala"
	_tmp10_ = self->priv->ws_assoc;
#line 1629 "../src/WindowManager.vala"
	if (!g_hash_table_contains (_tmp10_, window)) {
#line 1630 "../src/WindowManager.vala"
		g_signal_connect_object (window, "unmanaged", (GCallback) _gala_window_manager_gala_move_window_to_old_ws_meta_window_unmanaged, self, 0);
#line 9576 "WindowManager.c"
	}
#line 1633 "../src/WindowManager.vala"
	_tmp11_ = self->priv->ws_assoc;
#line 1633 "../src/WindowManager.vala"
	_tmp12_ = _g_object_ref0 (window);
#line 1633 "../src/WindowManager.vala"
	g_hash_table_insert (_tmp11_, _tmp12_, (gpointer) ((gintptr) old_ws_index));
#line 9584 "WindowManager.c"
}

static void
gala_window_manager_gala_move_window_to_old_ws (GalaWindowManagerGala* self,
                                                MetaWindow* window)
{
	MetaWorkspace* win_ws = NULL;
	MetaWorkspace* _tmp0_;
	MetaWorkspace* _tmp1_;
	GHashTable* _tmp2_;
	gint old_ws_index = 0;
	GHashTable* _tmp3_;
	gconstpointer _tmp4_;
	gint new_ws_index = 0;
	MetaWorkspace* _tmp5_;
	MetaDisplay* display = NULL;
	MetaDisplay* _tmp6_;
	MetaWorkspaceManager* workspace_manager = NULL;
	MetaDisplay* _tmp7_;
	MetaWorkspaceManager* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GHashTable* _tmp16_;
	guint _tmp17_;
#line 1636 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 1636 "../src/WindowManager.vala"
	g_return_if_fail (window != NULL);
#line 1637 "../src/WindowManager.vala"
	_tmp0_ = meta_window_get_workspace (window);
#line 1637 "../src/WindowManager.vala"
	win_ws = _tmp0_;
#line 1640 "../src/WindowManager.vala"
	_tmp1_ = win_ws;
#line 1640 "../src/WindowManager.vala"
	if (gala_utils_get_n_windows (_tmp1_, FALSE, NULL) > ((guint) 1)) {
#line 1641 "../src/WindowManager.vala"
		return;
#line 9622 "WindowManager.c"
	}
#line 1644 "../src/WindowManager.vala"
	_tmp2_ = self->priv->ws_assoc;
#line 1644 "../src/WindowManager.vala"
	if (!g_hash_table_contains (_tmp2_, window)) {
#line 1645 "../src/WindowManager.vala"
		return;
#line 9630 "WindowManager.c"
	}
#line 1648 "../src/WindowManager.vala"
	_tmp3_ = self->priv->ws_assoc;
#line 1648 "../src/WindowManager.vala"
	_tmp4_ = g_hash_table_lookup (_tmp3_, window);
#line 1648 "../src/WindowManager.vala"
	old_ws_index = (gint) ((gintptr) _tmp4_);
#line 1649 "../src/WindowManager.vala"
	_tmp5_ = win_ws;
#line 1649 "../src/WindowManager.vala"
	new_ws_index = meta_workspace_index (_tmp5_);
#line 1651 "../src/WindowManager.vala"
	_tmp6_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1651 "../src/WindowManager.vala"
	display = _tmp6_;
#line 1652 "../src/WindowManager.vala"
	_tmp7_ = display;
#line 1652 "../src/WindowManager.vala"
	_tmp8_ = meta_display_get_workspace_manager (_tmp7_);
#line 1652 "../src/WindowManager.vala"
	workspace_manager = _tmp8_;
#line 1653 "../src/WindowManager.vala"
	if (new_ws_index != old_ws_index) {
#line 9654 "WindowManager.c"
		MetaWorkspaceManager* _tmp10_;
#line 1653 "../src/WindowManager.vala"
		_tmp10_ = workspace_manager;
#line 1653 "../src/WindowManager.vala"
		_tmp9_ = old_ws_index < meta_workspace_manager_get_n_workspaces (_tmp10_);
#line 9660 "WindowManager.c"
	} else {
#line 1653 "../src/WindowManager.vala"
		_tmp9_ = FALSE;
#line 9664 "WindowManager.c"
	}
#line 1653 "../src/WindowManager.vala"
	if (_tmp9_) {
#line 9668 "WindowManager.c"
		guint time = 0U;
		MetaDisplay* _tmp11_;
		MetaWorkspace* old_ws = NULL;
		MetaWorkspaceManager* _tmp12_;
		MetaWorkspace* _tmp13_;
		MetaWorkspace* _tmp14_;
		MetaWorkspace* _tmp15_;
#line 1654 "../src/WindowManager.vala"
		_tmp11_ = display;
#line 1654 "../src/WindowManager.vala"
		time = (guint) meta_display_get_current_time (_tmp11_);
#line 1655 "../src/WindowManager.vala"
		_tmp12_ = workspace_manager;
#line 1655 "../src/WindowManager.vala"
		_tmp13_ = meta_workspace_manager_get_workspace_by_index (_tmp12_, old_ws_index);
#line 1655 "../src/WindowManager.vala"
		old_ws = _tmp13_;
#line 1656 "../src/WindowManager.vala"
		_tmp14_ = old_ws;
#line 1656 "../src/WindowManager.vala"
		meta_window_change_workspace (window, _tmp14_);
#line 1657 "../src/WindowManager.vala"
		_tmp15_ = old_ws;
#line 1657 "../src/WindowManager.vala"
		meta_workspace_activate_with_focus (_tmp15_, window, (guint32) time);
#line 9694 "WindowManager.c"
	}
#line 1660 "../src/WindowManager.vala"
	_tmp16_ = self->priv->ws_assoc;
#line 1660 "../src/WindowManager.vala"
	g_hash_table_remove (_tmp16_, window);
#line 1662 "../src/WindowManager.vala"
	g_signal_parse_name ("unmanaged", meta_window_get_type (), &_tmp17_, NULL, FALSE);
#line 1662 "../src/WindowManager.vala"
	g_signal_handlers_disconnect_matched (window, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _gala_window_manager_gala_move_window_to_old_ws_meta_window_unmanaged, self);
#line 9704 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_end_animation (GalaWindowManagerGala* self,
                                        GeeHashSet** list,
                                        MetaWindowActor* actor)
{
	gboolean result;
#line 1666 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1666 "../src/WindowManager.vala"
	g_return_val_if_fail (*list != NULL, FALSE);
#line 1666 "../src/WindowManager.vala"
	g_return_val_if_fail (actor != NULL, FALSE);
#line 1667 "../src/WindowManager.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) (*list), actor)) {
#line 1668 "../src/WindowManager.vala"
		result = FALSE;
#line 1668 "../src/WindowManager.vala"
		return result;
#line 9725 "WindowManager.c"
	}
#line 1670 "../src/WindowManager.vala"
	if (meta_window_actor_is_destroyed (actor)) {
#line 1671 "../src/WindowManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) (*list), actor);
#line 1672 "../src/WindowManager.vala"
		result = FALSE;
#line 1672 "../src/WindowManager.vala"
		return result;
#line 9735 "WindowManager.c"
	}
#line 1675 "../src/WindowManager.vala"
	clutter_actor_remove_all_transitions ((ClutterActor*) actor);
#line 1676 "../src/WindowManager.vala"
	clutter_actor_set_opacity ((ClutterActor*) actor, 255U);
#line 1677 "../src/WindowManager.vala"
	clutter_actor_set_scale ((ClutterActor*) actor, (gdouble) 1.0f, (gdouble) 1.0f);
#line 1678 "../src/WindowManager.vala"
	g_object_set ((ClutterActor*) actor, "rotation-angle-x", (gdouble) 0.0f, NULL);
#line 1679 "../src/WindowManager.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) actor, 0.0f, 0.0f);
#line 1681 "../src/WindowManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) (*list), actor);
#line 1682 "../src/WindowManager.vala"
	result = TRUE;
#line 1682 "../src/WindowManager.vala"
	return result;
#line 9753 "WindowManager.c"
}

static void
gala_window_manager_gala_real_kill_window_effects (MetaPlugin* base,
                                                   MetaWindowActor* actor)
{
	GalaWindowManagerGala * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 1685 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1685 "../src/WindowManager.vala"
	g_return_if_fail (actor != NULL);
#line 1686 "../src/WindowManager.vala"
	_tmp0_ = gala_window_manager_gala_end_animation (self, &self->priv->mapping, actor);
#line 1686 "../src/WindowManager.vala"
	if (_tmp0_) {
#line 1687 "../src/WindowManager.vala"
		meta_plugin_map_completed ((MetaPlugin*) self, actor);
#line 9775 "WindowManager.c"
	}
#line 1688 "../src/WindowManager.vala"
	_tmp1_ = gala_window_manager_gala_end_animation (self, &self->priv->unminimizing, actor);
#line 1688 "../src/WindowManager.vala"
	if (_tmp1_) {
#line 1689 "../src/WindowManager.vala"
		meta_plugin_unminimize_completed ((MetaPlugin*) self, actor);
#line 9783 "WindowManager.c"
	}
#line 1690 "../src/WindowManager.vala"
	_tmp2_ = gala_window_manager_gala_end_animation (self, &self->priv->minimizing, actor);
#line 1690 "../src/WindowManager.vala"
	if (_tmp2_) {
#line 1691 "../src/WindowManager.vala"
		meta_plugin_minimize_completed ((MetaPlugin*) self, actor);
#line 9791 "WindowManager.c"
	}
#line 1692 "../src/WindowManager.vala"
	_tmp3_ = gala_window_manager_gala_end_animation (self, &self->priv->destroying, actor);
#line 1692 "../src/WindowManager.vala"
	if (_tmp3_) {
#line 1693 "../src/WindowManager.vala"
		meta_plugin_destroy_completed ((MetaPlugin*) self, actor);
#line 9799 "WindowManager.c"
	}
#line 1695 "../src/WindowManager.vala"
	gala_window_manager_gala_end_animation (self, &self->priv->unmaximizing, actor);
#line 1696 "../src/WindowManager.vala"
	gala_window_manager_gala_end_animation (self, &self->priv->maximizing, actor);
#line 9805 "WindowManager.c"
}

static void
gala_window_manager_gala_real_switch_workspace (MetaPlugin* base,
                                                gint from,
                                                gint to,
                                                MetaMotionDirection direction)
{
	GalaWindowManagerGala * self;
#line 1699 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1700 "../src/WindowManager.vala"
	meta_plugin_switch_workspace_completed ((MetaPlugin*) self);
#line 9819 "WindowManager.c"
}

static void
gala_window_manager_gala_real_kill_switch_workspace (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	GalaMultitaskingView* _tmp0_;
#line 1703 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1704 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_multitasking_view;
#line 1704 "../src/WindowManager.vala"
	gala_multitasking_view_kill_switch_workspace (_tmp0_);
#line 9833 "WindowManager.c"
}

static void
gala_window_manager_gala_real_locate_pointer (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	GalaPointerLocator* _tmp0_;
#line 1707 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1708 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_pointer_locator;
#line 1708 "../src/WindowManager.vala"
	gala_pointer_locator_show_ripple (_tmp0_);
#line 9847 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_real_keybinding_filter (MetaPlugin* base,
                                                 MetaKeyBinding* binding)
{
	GalaWindowManagerGala * self;
	MetaKeyBindingAction action = 0;
	const gchar* _tmp0_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GQuark _tmp8_ = 0U;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label0 = 0;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label1 = 0;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label2 = 0;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label3 = 0;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label4 = 0;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label5 = 0;
#line 1750 "../src/WindowManager.vala"
	static GQuark _tmp7_label6 = 0;
#line 9874 "WindowManager.c"
	GalaModalProxy* modal_proxy = NULL;
	GeeLinkedList* _tmp9_;
	gpointer _tmp10_;
	GalaModalProxy* _tmp11_;
	GalaKeybindingFilter filter = NULL;
	GalaModalProxy* _tmp12_;
	gpointer _tmp13_ = NULL;
	GalaKeybindingFilter _tmp14_;
	gpointer filter_target;
	GalaKeybindingFilter _tmp15_;
	gpointer _tmp15__target;
	GalaKeybindingFilter _tmp16_;
	gpointer _tmp16__target;
	gboolean result;
#line 1711 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1711 "../src/WindowManager.vala"
	g_return_val_if_fail (binding != NULL, FALSE);
#line 1712 "../src/WindowManager.vala"
	if (!gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 1713 "../src/WindowManager.vala"
		result = FALSE;
#line 1713 "../src/WindowManager.vala"
		return result;
#line 9899 "WindowManager.c"
	}
#line 1716 "../src/WindowManager.vala"
	_tmp0_ = meta_key_binding_get_name (binding);
#line 1716 "../src/WindowManager.vala"
	action = meta_prefs_get_keybinding_action (_tmp0_);
#line 1718 "../src/WindowManager.vala"
	switch (action) {
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_OVERLAY_KEY:
#line 9909 "WindowManager.c"
		{
			GSettings* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
			gboolean _tmp4_;
#line 1720 "../src/WindowManager.vala"
			_tmp1_ = self->priv->behavior_settings;
#line 1720 "../src/WindowManager.vala"
			_tmp2_ = g_settings_get_string (_tmp1_, "overlay-action");
#line 1720 "../src/WindowManager.vala"
			_tmp3_ = _tmp2_;
#line 1720 "../src/WindowManager.vala"
			_tmp4_ = g_strcmp0 (_tmp3_, GALA_WINDOW_MANAGER_GALA_OPEN_MULTITASKING_VIEW) == 0;
#line 1720 "../src/WindowManager.vala"
			_g_free0 (_tmp3_);
#line 1720 "../src/WindowManager.vala"
			if (_tmp4_) {
#line 1721 "../src/WindowManager.vala"
				result = gala_window_manager_filter_action ((GalaWindowManager*) self, GALA_GESTURE_ACTION_MULTITASKING_VIEW);
#line 1721 "../src/WindowManager.vala"
				return result;
#line 9931 "WindowManager.c"
			}
#line 1723 "../src/WindowManager.vala"
			break;
#line 9935 "WindowManager.c"
		}
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_1:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_2:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_3:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_4:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_5:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_6:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_7:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_8:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_9:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_10:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_11:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_12:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_LEFT:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_WORKSPACE_RIGHT:
#line 9965 "WindowManager.c"
		{
#line 1738 "../src/WindowManager.vala"
			result = gala_window_manager_filter_action ((GalaWindowManager*) self, GALA_GESTURE_ACTION_SWITCH_WORKSPACE);
#line 1738 "../src/WindowManager.vala"
			return result;
#line 9971 "WindowManager.c"
		}
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_SWITCH_APPLICATIONS_BACKWARD:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_SWITCH_WINDOWS_BACKWARD:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP:
#line 1718 "../src/WindowManager.vala"
		case META_KEYBINDING_ACTION_SWITCH_GROUP_BACKWARD:
#line 9985 "WindowManager.c"
		{
#line 1745 "../src/WindowManager.vala"
			result = gala_window_manager_filter_action ((GalaWindowManager*) self, GALA_GESTURE_ACTION_SWITCH_WINDOWS);
#line 1745 "../src/WindowManager.vala"
			return result;
#line 9991 "WindowManager.c"
		}
		default:
		{
#line 1747 "../src/WindowManager.vala"
			break;
#line 9997 "WindowManager.c"
		}
	}
#line 1750 "../src/WindowManager.vala"
	_tmp5_ = meta_key_binding_get_name (binding);
#line 1750 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 1750 "../src/WindowManager.vala"
	_tmp8_ = (NULL == _tmp6_) ? 0 : g_quark_from_string (_tmp6_);
#line 1750 "../src/WindowManager.vala"
	if ((((_tmp8_ == ((0 != _tmp7_label0) ? _tmp7_label0 : (_tmp7_label0 = g_quark_from_static_string ("cycle-workspaces-next")))) || (_tmp8_ == ((0 != _tmp7_label1) ? _tmp7_label1 : (_tmp7_label1 = g_quark_from_static_string ("cycle-workspaces-previous"))))) || (_tmp8_ == ((0 != _tmp7_label2) ? _tmp7_label2 : (_tmp7_label2 = g_quark_from_static_string ("switch-to-workspace-first"))))) || (_tmp8_ == ((0 != _tmp7_label3) ? _tmp7_label3 : (_tmp7_label3 = g_quark_from_static_string ("switch-to-workspace-last"))))) {
#line 1750 "../src/WindowManager.vala"
		switch (0) {
#line 10010 "WindowManager.c"
			default:
			{
#line 1755 "../src/WindowManager.vala"
				result = gala_window_manager_filter_action ((GalaWindowManager*) self, GALA_GESTURE_ACTION_SWITCH_WORKSPACE);
#line 1755 "../src/WindowManager.vala"
				return result;
#line 10017 "WindowManager.c"
			}
		}
	} else if ((_tmp8_ == ((0 != _tmp7_label4) ? _tmp7_label4 : (_tmp7_label4 = g_quark_from_static_string ("zoom-in")))) || (_tmp8_ == ((0 != _tmp7_label5) ? _tmp7_label5 : (_tmp7_label5 = g_quark_from_static_string ("zoom-out"))))) {
#line 1750 "../src/WindowManager.vala"
		switch (0) {
#line 10023 "WindowManager.c"
			default:
			{
#line 1758 "../src/WindowManager.vala"
				result = gala_window_manager_filter_action ((GalaWindowManager*) self, GALA_GESTURE_ACTION_ZOOM);
#line 1758 "../src/WindowManager.vala"
				return result;
#line 10030 "WindowManager.c"
			}
		}
	} else if (_tmp8_ == ((0 != _tmp7_label6) ? _tmp7_label6 : (_tmp7_label6 = g_quark_from_static_string ("toggle-multitasking-view")))) {
#line 1750 "../src/WindowManager.vala"
		switch (0) {
#line 10036 "WindowManager.c"
			default:
			{
#line 1760 "../src/WindowManager.vala"
				result = gala_window_manager_filter_action ((GalaWindowManager*) self, GALA_GESTURE_ACTION_MULTITASKING_VIEW);
#line 1760 "../src/WindowManager.vala"
				return result;
#line 10043 "WindowManager.c"
			}
		}
	} else {
#line 1750 "../src/WindowManager.vala"
		switch (0) {
#line 10049 "WindowManager.c"
			default:
			{
#line 1762 "../src/WindowManager.vala"
				break;
#line 10054 "WindowManager.c"
			}
		}
	}
#line 1765 "../src/WindowManager.vala"
	_tmp9_ = self->priv->modal_stack;
#line 1765 "../src/WindowManager.vala"
	_tmp10_ = gee_deque_peek_head ((GeeDeque*) _tmp9_);
#line 1765 "../src/WindowManager.vala"
	modal_proxy = (GalaModalProxy*) _tmp10_;
#line 1766 "../src/WindowManager.vala"
	_tmp11_ = modal_proxy;
#line 1766 "../src/WindowManager.vala"
	if (_tmp11_ == NULL) {
#line 1767 "../src/WindowManager.vala"
		result = FALSE;
#line 1767 "../src/WindowManager.vala"
		_g_object_unref0 (modal_proxy);
#line 1767 "../src/WindowManager.vala"
		return result;
#line 10074 "WindowManager.c"
	}
#line 1770 "../src/WindowManager.vala"
	_tmp12_ = modal_proxy;
#line 1770 "../src/WindowManager.vala"
	_tmp14_ = gala_modal_proxy_get_keybinding_filter (_tmp12_, &_tmp13_);
#line 1770 "../src/WindowManager.vala"
	filter = _tmp14_;
#line 1770 "../src/WindowManager.vala"
	filter_target = _tmp13_;
#line 1771 "../src/WindowManager.vala"
	_tmp15_ = filter;
#line 1771 "../src/WindowManager.vala"
	_tmp15__target = filter_target;
#line 1771 "../src/WindowManager.vala"
	if (_tmp15_ == NULL) {
#line 1772 "../src/WindowManager.vala"
		result = FALSE;
#line 1772 "../src/WindowManager.vala"
		_g_object_unref0 (modal_proxy);
#line 1772 "../src/WindowManager.vala"
		return result;
#line 10096 "WindowManager.c"
	}
#line 1775 "../src/WindowManager.vala"
	_tmp16_ = filter;
#line 1775 "../src/WindowManager.vala"
	_tmp16__target = filter_target;
#line 1775 "../src/WindowManager.vala"
	result = _tmp16_ (binding, _tmp16__target);
#line 1775 "../src/WindowManager.vala"
	_g_object_unref0 (modal_proxy);
#line 1775 "../src/WindowManager.vala"
	return result;
#line 10108 "WindowManager.c"
}

static gboolean
gala_window_manager_gala_real_filter_action (GalaWindowManager* base,
                                             GalaGestureAction action)
{
	GalaWindowManagerGala * self;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	GalaModalProxy* _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 1778 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1779 "../src/WindowManager.vala"
	if (!gala_window_manager_is_modal ((GalaWindowManager*) self)) {
#line 1780 "../src/WindowManager.vala"
		result = FALSE;
#line 1780 "../src/WindowManager.vala"
		return result;
#line 10129 "WindowManager.c"
	}
#line 1783 "../src/WindowManager.vala"
	_tmp0_ = self->priv->modal_stack;
#line 1783 "../src/WindowManager.vala"
	_tmp1_ = gee_deque_peek_head ((GeeDeque*) _tmp0_);
#line 1783 "../src/WindowManager.vala"
	_tmp2_ = (GalaModalProxy*) _tmp1_;
#line 1783 "../src/WindowManager.vala"
	_tmp3_ = gala_modal_proxy_filter_action (_tmp2_, action);
#line 1783 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp2_);
#line 1783 "../src/WindowManager.vala"
	result = _tmp3_;
#line 1783 "../src/WindowManager.vala"
	return result;
#line 10145 "WindowManager.c"
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 1786 "../src/WindowManager.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 1786 "../src/WindowManager.vala"
	return _data32_;
#line 10155 "WindowManager.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 1786 "../src/WindowManager.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 10165 "WindowManager.c"
		GalaWindowManagerGala* self;
#line 1786 "../src/WindowManager.vala"
		self = _data32_->self;
#line 1786 "../src/WindowManager.vala"
		_g_object_unref0 (_data32_->dialog);
#line 1786 "../src/WindowManager.vala"
		_g_object_unref0 (self);
#line 1786 "../src/WindowManager.vala"
		g_slice_free (Block32Data, _data32_);
#line 10175 "WindowManager.c"
	}
}

static gboolean
__lambda193_ (Block32Data* _data32_)
{
	GalaWindowManagerGala* self;
	gboolean result;
#line 1806 "../src/WindowManager.vala"
	self = _data32_->self;
#line 1807 "../src/WindowManager.vala"
	_data32_->dialog_timeout_id = (guint) 0;
#line 1808 "../src/WindowManager.vala"
	gala_access_dialog_close (_data32_->dialog);
#line 1810 "../src/WindowManager.vala"
	result = G_SOURCE_REMOVE;
#line 1810 "../src/WindowManager.vala"
	return result;
#line 10194 "WindowManager.c"
}

static gboolean
___lambda193__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda193_ (self);
#line 1806 "../src/WindowManager.vala"
	return result;
#line 10204 "WindowManager.c"
}

static void
__lambda192_ (Block32Data* _data32_)
{
	GalaWindowManagerGala* self;
#line 1805 "../src/WindowManager.vala"
	self = _data32_->self;
#line 1806 "../src/WindowManager.vala"
	_data32_->dialog_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) _data32_->timeout, ___lambda193__gsource_func, block32_data_ref (_data32_), block32_data_unref);
#line 10215 "WindowManager.c"
}

static void
___lambda192__gala_access_dialog_show (GalaAccessDialog* _sender,
                                       gpointer self)
{
#line 1805 "../src/WindowManager.vala"
	__lambda192_ (self);
#line 10224 "WindowManager.c"
}

static void
__lambda194_ (Block32Data* _data32_,
              guint res)
{
	GalaWindowManagerGala* self;
#line 1814 "../src/WindowManager.vala"
	self = _data32_->self;
#line 1815 "../src/WindowManager.vala"
	if (_data32_->dialog_timeout_id != ((guint) 0)) {
#line 1816 "../src/WindowManager.vala"
		g_source_remove (_data32_->dialog_timeout_id);
#line 1817 "../src/WindowManager.vala"
		_data32_->dialog_timeout_id = (guint) 0;
#line 10240 "WindowManager.c"
	}
#line 1820 "../src/WindowManager.vala"
	meta_plugin_complete_display_change ((MetaPlugin*) self, res == ((guint) 0));
#line 10244 "WindowManager.c"
}

static void
___lambda194__gala_access_dialog_response (GalaAccessDialog* _sender,
                                           guint response,
                                           gpointer self)
{
#line 1814 "../src/WindowManager.vala"
	__lambda194_ (self, response);
#line 10254 "WindowManager.c"
}

static void
gala_window_manager_gala_real_confirm_display_change (MetaPlugin* base)
{
	GalaWindowManagerGala * self;
	Block32Data* _data32_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp0_;
	MetaContext* _tmp1_;
	MetaBackend* _tmp2_;
	MetaMonitorManager* _tmp3_;
	gchar* summary = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GalaAccessDialog* _tmp9_ = NULL;
	GalaAccessDialog* _tmp10_;
#line 1786 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1786 "../src/WindowManager.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 1786 "../src/WindowManager.vala"
	_data32_->_ref_count_ = 1;
#line 1786 "../src/WindowManager.vala"
	_data32_->self = g_object_ref (self);
#line 1787 "../src/WindowManager.vala"
	_tmp0_ = meta_plugin_get_display ((MetaPlugin*) self);
#line 1787 "../src/WindowManager.vala"
	_tmp1_ = meta_display_get_context (_tmp0_);
#line 1787 "../src/WindowManager.vala"
	_tmp2_ = meta_context_get_backend (_tmp1_);
#line 1787 "../src/WindowManager.vala"
	_tmp3_ = meta_backend_get_monitor_manager (_tmp2_);
#line 1787 "../src/WindowManager.vala"
	monitor_manager = _tmp3_;
#line 1788 "../src/WindowManager.vala"
	_data32_->timeout = meta_monitor_manager_get_display_configuration_timeout (monitor_manager);
#line 1789 "../src/WindowManager.vala"
	_tmp4_ = g_strdup (ngettext ("Changes will automatically revert after %i second.", "Changes will automatically revert after %i seconds.", (gulong) _data32_->timeout));
#line 1789 "../src/WindowManager.vala"
	summary = _tmp4_;
#line 1794 "../src/WindowManager.vala"
	_data32_->dialog_timeout_id = (guint) 0;
#line 1796 "../src/WindowManager.vala"
	_tmp5_ = g_strdup_printf (summary, _data32_->timeout);
#line 1796 "../src/WindowManager.vala"
	_tmp6_ = _tmp5_;
#line 1796 "../src/WindowManager.vala"
	_tmp7_ = g_strdup (_ ("Keep Settings"));
#line 1796 "../src/WindowManager.vala"
	_tmp8_ = g_strdup (_ ("Use Previous Settings"));
#line 1796 "../src/WindowManager.vala"
	_tmp9_ = gala_access_dialog_new (_ ("Keep new display settings?"), _tmp6_, "preferences-desktop-display");
#line 1796 "../src/WindowManager.vala"
	gala_access_dialog_set_accept_label (_tmp9_, _tmp7_);
#line 1796 "../src/WindowManager.vala"
	_g_free0 (_tmp7_);
#line 1796 "../src/WindowManager.vala"
	gala_access_dialog_set_deny_label (_tmp9_, _tmp8_);
#line 1796 "../src/WindowManager.vala"
	_g_free0 (_tmp8_);
#line 1796 "../src/WindowManager.vala"
	_tmp10_ = _tmp9_;
#line 1796 "../src/WindowManager.vala"
	_g_free0 (_tmp6_);
#line 1796 "../src/WindowManager.vala"
	_data32_->dialog = _tmp10_;
#line 1805 "../src/WindowManager.vala"
	g_signal_connect_data (_data32_->dialog, "show", (GCallback) ___lambda192__gala_access_dialog_show, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 1814 "../src/WindowManager.vala"
	g_signal_connect_data (_data32_->dialog, "response", (GCallback) ___lambda194__gala_access_dialog_response, block32_data_ref (_data32_), (GClosureNotify) block32_data_unref, 0);
#line 1823 "../src/WindowManager.vala"
	g_signal_emit_by_name (_data32_->dialog, "show");
#line 1786 "../src/WindowManager.vala"
	_g_free0 (summary);
#line 1786 "../src/WindowManager.vala"
	block32_data_unref (_data32_);
#line 1786 "../src/WindowManager.vala"
	_data32_ = NULL;
#line 10337 "WindowManager.c"
}

static MetaCloseDialog*
gala_window_manager_gala_real_create_close_dialog (MetaPlugin* base,
                                                   MetaWindow* window)
{
	GalaWindowManagerGala * self;
	GalaWindowTracker* _tmp0_;
	GalaApp* _tmp1_;
	GalaApp* _tmp2_;
	GalaCloseDialog* _tmp3_;
	MetaCloseDialog* _tmp4_;
	MetaCloseDialog* result;
#line 1826 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1826 "../src/WindowManager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 1827 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_tracker;
#line 1827 "../src/WindowManager.vala"
	_tmp1_ = gala_window_tracker_get_app_for_window (_tmp0_, window);
#line 1827 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 1827 "../src/WindowManager.vala"
	_tmp3_ = gala_close_dialog_new (_tmp2_, window);
#line 1827 "../src/WindowManager.vala"
	_tmp4_ = (MetaCloseDialog*) _tmp3_;
#line 1827 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp2_);
#line 1827 "../src/WindowManager.vala"
	result = _tmp4_;
#line 1827 "../src/WindowManager.vala"
	return result;
#line 10371 "WindowManager.c"
}

static MetaInhibitShortcutsDialog*
gala_window_manager_gala_real_create_inhibit_shortcuts_dialog (MetaPlugin* base,
                                                               MetaWindow* window)
{
	GalaWindowManagerGala * self;
	GalaWindowTracker* _tmp0_;
	GalaApp* _tmp1_;
	GalaApp* _tmp2_;
	GalaInhibitShortcutsDialog* _tmp3_;
	MetaInhibitShortcutsDialog* _tmp4_;
	MetaInhibitShortcutsDialog* result;
#line 1830 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 1830 "../src/WindowManager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 1831 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_tracker;
#line 1831 "../src/WindowManager.vala"
	_tmp1_ = gala_window_tracker_get_app_for_window (_tmp0_, window);
#line 1831 "../src/WindowManager.vala"
	_tmp2_ = _tmp1_;
#line 1831 "../src/WindowManager.vala"
	_tmp3_ = gala_inhibit_shortcuts_dialog_new (_tmp2_, window);
#line 1831 "../src/WindowManager.vala"
	_tmp4_ = (MetaInhibitShortcutsDialog*) _tmp3_;
#line 1831 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp2_);
#line 1831 "../src/WindowManager.vala"
	result = _tmp4_;
#line 1831 "../src/WindowManager.vala"
	return result;
#line 10405 "WindowManager.c"
}

GalaWindowManagerGala*
gala_window_manager_gala_construct (GType object_type)
{
	GalaWindowManagerGala * self = NULL;
#line 20 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) g_object_new (object_type, NULL);
#line 20 "../src/WindowManager.vala"
	return self;
#line 10416 "WindowManager.c"
}

GalaWindowManagerGala*
gala_window_manager_gala_new (void)
{
#line 20 "../src/WindowManager.vala"
	return gala_window_manager_gala_construct (GALA_TYPE_WINDOW_MANAGER_GALA);
#line 10424 "WindowManager.c"
}

static ClutterActor*
gala_window_manager_gala_real_get_ui_group (GalaWindowManager* base)
{
	ClutterActor* result;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
#line 26 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 26 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_ui_group;
#line 26 "../src/WindowManager.vala"
	result = _tmp0_;
#line 26 "../src/WindowManager.vala"
	return result;
#line 10441 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_ui_group (GalaWindowManager* base,
                                            ClutterActor* value)
{
	GalaWindowManagerGala* self;
	ClutterActor* old_value;
#line 26 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 26 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_ui_group (base);
#line 26 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10456 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 26 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_ui_group);
#line 26 "../src/WindowManager.vala"
		self->priv->_ui_group = _tmp0_;
#line 26 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY]);
#line 10466 "WindowManager.c"
	}
}

static ClutterStage*
gala_window_manager_gala_real_get_stage (GalaWindowManager* base)
{
	ClutterStage* result;
	GalaWindowManagerGala* self;
	ClutterStage* _tmp0_;
#line 31 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 31 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_stage;
#line 31 "../src/WindowManager.vala"
	result = _tmp0_;
#line 31 "../src/WindowManager.vala"
	return result;
#line 10484 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_stage (GalaWindowManager* base,
                                         ClutterStage* value)
{
	GalaWindowManagerGala* self;
	ClutterStage* old_value;
#line 31 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 31 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_stage (base);
#line 31 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10499 "WindowManager.c"
		ClutterStage* _tmp0_;
#line 31 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 31 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_stage);
#line 31 "../src/WindowManager.vala"
		self->priv->_stage = _tmp0_;
#line 31 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY]);
#line 10509 "WindowManager.c"
	}
}

static ClutterActor*
gala_window_manager_gala_real_get_window_group (GalaWindowManager* base)
{
	ClutterActor* result;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
#line 36 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 36 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_group;
#line 36 "../src/WindowManager.vala"
	result = _tmp0_;
#line 36 "../src/WindowManager.vala"
	return result;
#line 10527 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_window_group (GalaWindowManager* base,
                                                ClutterActor* value)
{
	GalaWindowManagerGala* self;
	ClutterActor* old_value;
#line 36 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 36 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_window_group (base);
#line 36 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10542 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 36 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_window_group);
#line 36 "../src/WindowManager.vala"
		self->priv->_window_group = _tmp0_;
#line 36 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY]);
#line 10552 "WindowManager.c"
	}
}

static ClutterActor*
gala_window_manager_gala_real_get_top_window_group (GalaWindowManager* base)
{
	ClutterActor* result;
	GalaWindowManagerGala* self;
	ClutterActor* _tmp0_;
#line 41 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 41 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_top_window_group;
#line 41 "../src/WindowManager.vala"
	result = _tmp0_;
#line 41 "../src/WindowManager.vala"
	return result;
#line 10570 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_top_window_group (GalaWindowManager* base,
                                                    ClutterActor* value)
{
	GalaWindowManagerGala* self;
	ClutterActor* old_value;
#line 41 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 41 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_top_window_group (base);
#line 41 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10585 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 41 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_top_window_group);
#line 41 "../src/WindowManager.vala"
		self->priv->_top_window_group = _tmp0_;
#line 41 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY]);
#line 10595 "WindowManager.c"
	}
}

ClutterActor*
gala_window_manager_gala_get_shell_group (GalaWindowManagerGala* self)
{
	ClutterActor* result;
	ClutterActor* _tmp0_;
#line 49 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_shell_group;
#line 49 "../src/WindowManager.vala"
	result = _tmp0_;
#line 49 "../src/WindowManager.vala"
	return result;
#line 10612 "WindowManager.c"
}

static void
gala_window_manager_gala_set_shell_group (GalaWindowManagerGala* self,
                                          ClutterActor* value)
{
	ClutterActor* old_value;
#line 49 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_shell_group (self);
#line 49 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10626 "WindowManager.c"
		ClutterActor* _tmp0_;
#line 49 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_shell_group);
#line 49 "../src/WindowManager.vala"
		self->priv->_shell_group = _tmp0_;
#line 49 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SHELL_GROUP_PROPERTY]);
#line 10636 "WindowManager.c"
	}
}

static MetaBackgroundGroup*
gala_window_manager_gala_real_get_background_group (GalaWindowManager* base)
{
	MetaBackgroundGroup* result;
	GalaWindowManagerGala* self;
	MetaBackgroundGroup* _tmp0_;
#line 54 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 54 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_background_group;
#line 54 "../src/WindowManager.vala"
	result = _tmp0_;
#line 54 "../src/WindowManager.vala"
	return result;
#line 10654 "WindowManager.c"
}

static void
gala_window_manager_gala_real_set_background_group (GalaWindowManager* base,
                                                    MetaBackgroundGroup* value)
{
	GalaWindowManagerGala* self;
	MetaBackgroundGroup* old_value;
#line 54 "../src/WindowManager.vala"
	self = (GalaWindowManagerGala*) base;
#line 54 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_real_get_background_group (base);
#line 54 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10669 "WindowManager.c"
		MetaBackgroundGroup* _tmp0_;
#line 54 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 54 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_background_group);
#line 54 "../src/WindowManager.vala"
		self->priv->_background_group = _tmp0_;
#line 54 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY]);
#line 10679 "WindowManager.c"
	}
}

GalaMultitaskingView*
gala_window_manager_gala_get_multitasking_view (GalaWindowManagerGala* self)
{
	GalaMultitaskingView* result;
	GalaMultitaskingView* _tmp0_;
#line 59 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_multitasking_view;
#line 59 "../src/WindowManager.vala"
	result = _tmp0_;
#line 59 "../src/WindowManager.vala"
	return result;
#line 10696 "WindowManager.c"
}

void
gala_window_manager_gala_set_multitasking_view (GalaWindowManagerGala* self,
                                                GalaMultitaskingView* value)
{
	GalaMultitaskingView* old_value;
#line 59 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_multitasking_view (self);
#line 59 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10710 "WindowManager.c"
		GalaMultitaskingView* _tmp0_;
#line 59 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 59 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_multitasking_view);
#line 59 "../src/WindowManager.vala"
		self->priv->_multitasking_view = _tmp0_;
#line 59 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_MULTITASKING_VIEW_PROPERTY]);
#line 10720 "WindowManager.c"
	}
}

GalaPointerLocator*
gala_window_manager_gala_get_pointer_locator (GalaWindowManagerGala* self)
{
	GalaPointerLocator* result;
	GalaPointerLocator* _tmp0_;
#line 61 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_pointer_locator;
#line 61 "../src/WindowManager.vala"
	result = _tmp0_;
#line 61 "../src/WindowManager.vala"
	return result;
#line 10737 "WindowManager.c"
}

static void
gala_window_manager_gala_set_pointer_locator (GalaWindowManagerGala* self,
                                              GalaPointerLocator* value)
{
	GalaPointerLocator* old_value;
#line 61 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_pointer_locator (self);
#line 61 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10751 "WindowManager.c"
		GalaPointerLocator* _tmp0_;
#line 61 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_pointer_locator);
#line 61 "../src/WindowManager.vala"
		self->priv->_pointer_locator = _tmp0_;
#line 61 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY]);
#line 10761 "WindowManager.c"
	}
}

GalaActivatableComponent*
gala_window_manager_gala_get_window_overview (GalaWindowManagerGala* self)
{
	GalaActivatableComponent* result;
	GalaActivatableComponent* _tmp0_;
#line 71 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_overview;
#line 71 "../src/WindowManager.vala"
	result = _tmp0_;
#line 71 "../src/WindowManager.vala"
	return result;
#line 10778 "WindowManager.c"
}

static void
gala_window_manager_gala_set_window_overview (GalaWindowManagerGala* self,
                                              GalaActivatableComponent* value)
{
	GalaActivatableComponent* old_value;
#line 71 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_window_overview (self);
#line 71 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10792 "WindowManager.c"
		GalaActivatableComponent* _tmp0_;
#line 71 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 71 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_window_overview);
#line 71 "../src/WindowManager.vala"
		self->priv->_window_overview = _tmp0_;
#line 71 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_OVERVIEW_PROPERTY]);
#line 10802 "WindowManager.c"
	}
}

GalaScreenSaverManager*
gala_window_manager_gala_get_screensaver (GalaWindowManagerGala* self)
{
	GalaScreenSaverManager* result;
	GalaScreenSaverManager* _tmp0_;
#line 73 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_screensaver;
#line 73 "../src/WindowManager.vala"
	result = _tmp0_;
#line 73 "../src/WindowManager.vala"
	return result;
#line 10819 "WindowManager.c"
}

static void
gala_window_manager_gala_set_screensaver (GalaWindowManagerGala* self,
                                          GalaScreenSaverManager* value)
{
	GalaScreenSaverManager* old_value;
#line 73 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_screensaver (self);
#line 73 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10833 "WindowManager.c"
		GalaScreenSaverManager* _tmp0_;
#line 73 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_screensaver);
#line 73 "../src/WindowManager.vala"
		self->priv->_screensaver = _tmp0_;
#line 73 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY]);
#line 10843 "WindowManager.c"
	}
}

GalaWindowTracker*
gala_window_manager_gala_get_window_tracker (GalaWindowManagerGala* self)
{
	GalaWindowTracker* result;
	GalaWindowTracker* _tmp0_;
#line 79 "../src/WindowManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/WindowManager.vala"
	_tmp0_ = self->priv->_window_tracker;
#line 79 "../src/WindowManager.vala"
	result = _tmp0_;
#line 79 "../src/WindowManager.vala"
	return result;
#line 10860 "WindowManager.c"
}

static void
gala_window_manager_gala_set_window_tracker (GalaWindowManagerGala* self,
                                             GalaWindowTracker* value)
{
	GalaWindowTracker* old_value;
#line 79 "../src/WindowManager.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/WindowManager.vala"
	old_value = gala_window_manager_gala_get_window_tracker (self);
#line 79 "../src/WindowManager.vala"
	if (old_value != value) {
#line 10874 "WindowManager.c"
		GalaWindowTracker* _tmp0_;
#line 79 "../src/WindowManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 79 "../src/WindowManager.vala"
		_g_object_unref0 (self->priv->_window_tracker);
#line 79 "../src/WindowManager.vala"
		self->priv->_window_tracker = _tmp0_;
#line 79 "../src/WindowManager.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY]);
#line 10884 "WindowManager.c"
	}
}

static GObject *
gala_window_manager_gala_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowManagerGala * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GalaDrawingStyleManager* _tmp2_;
	GalaDrawingStyleManager* _tmp3_;
#line 112 "../src/WindowManager.vala"
	parent_class = G_OBJECT_CLASS (gala_window_manager_gala_parent_class);
#line 112 "../src/WindowManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 112 "../src/WindowManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 118 "../src/WindowManager.vala"
	_tmp0_ = g_settings_new ("io.elementary.desktop.wm.behavior");
#line 118 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->behavior_settings);
#line 118 "../src/WindowManager.vala"
	self->priv->behavior_settings = _tmp0_;
#line 119 "../src/WindowManager.vala"
	_tmp1_ = g_settings_new ("io.elementary.desktop.wm.behavior");
#line 119 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->new_behavior_settings);
#line 119 "../src/WindowManager.vala"
	self->priv->new_behavior_settings = _tmp1_;
#line 122 "../src/WindowManager.vala"
	_tmp2_ = gala_drawing_style_manager_get_instance ();
#line 122 "../src/WindowManager.vala"
	_tmp3_ = _tmp2_;
#line 122 "../src/WindowManager.vala"
	_g_object_unref0 (_tmp3_);
#line 112 "../src/WindowManager.vala"
	return obj;
#line 10926 "WindowManager.c"
}

static void
gala_window_manager_gala_class_init (GalaWindowManagerGalaClass * klass,
                                     gpointer klass_data)
{
#line 20 "../src/WindowManager.vala"
	gala_window_manager_gala_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/WindowManager.vala"
	g_type_class_adjust_private_offset (klass, &GalaWindowManagerGala_private_offset);
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->start = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_start;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->show_window_menu = (void (*) (MetaPlugin*, MetaWindow*, MetaWindowMenuType, gint, gint)) gala_window_manager_gala_real_show_window_menu;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->show_tile_preview = (void (*) (MetaPlugin*, MetaWindow*, MtkRectangle*, gint)) gala_window_manager_gala_real_show_tile_preview;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->hide_tile_preview = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_hide_tile_preview;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->show_window_menu_for_rect = (void (*) (MetaPlugin*, MetaWindow*, MetaWindowMenuType, MtkRectangle*)) gala_window_manager_gala_real_show_window_menu_for_rect;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->size_change = (void (*) (MetaPlugin*, MetaWindowActor*, MetaSizeChange, MtkRectangle*, MtkRectangle*)) gala_window_manager_gala_real_size_change;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->size_changed = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_size_changed;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->minimize = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_minimize;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->unminimize = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_unminimize;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->map = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_map;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->destroy = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_destroy;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->kill_window_effects = (void (*) (MetaPlugin*, MetaWindowActor*)) gala_window_manager_gala_real_kill_window_effects;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->switch_workspace = (void (*) (MetaPlugin*, gint, gint, MetaMotionDirection)) gala_window_manager_gala_real_switch_workspace;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->kill_switch_workspace = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_kill_switch_workspace;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->locate_pointer = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_locate_pointer;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->keybinding_filter = (gboolean (*) (MetaPlugin*, MetaKeyBinding*)) gala_window_manager_gala_real_keybinding_filter;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->confirm_display_change = (void (*) (MetaPlugin*)) gala_window_manager_gala_real_confirm_display_change;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->create_close_dialog = (MetaCloseDialog* (*) (MetaPlugin*, MetaWindow*)) gala_window_manager_gala_real_create_close_dialog;
#line 20 "../src/WindowManager.vala"
	((MetaPluginClass *) klass)->create_inhibit_shortcuts_dialog = (MetaInhibitShortcutsDialog* (*) (MetaPlugin*, MetaWindow*)) gala_window_manager_gala_real_create_inhibit_shortcuts_dialog;
#line 20 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_manager_gala_get_property;
#line 20 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_manager_gala_set_property;
#line 20 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_window_manager_gala_constructor;
#line 20 "../src/WindowManager.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_window_manager_gala_finalize;
#line 10983 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY] = g_param_spec_object ("ui-group", "ui-group", "ui-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10989 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY] = g_param_spec_object ("stage", "stage", "stage", clutter_stage_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 10995 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY] = g_param_spec_object ("window-group", "window-group", "window-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11001 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY] = g_param_spec_object ("top-window-group", "top-window-group", "top-window-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11007 "WindowManager.c"
	/**
	         * The group that contains all WindowActors that make shell elements, that is all windows reported as
	         * ShellClientsManager.is_positioned_window.
	         * It will (eventually) never be hidden by other components and is always on top of everything. Therefore elements are
	         * responsible themselves for hiding depending on the state we are currently in (e.g. normal desktop, open multitasking view, fullscreen, etc.).
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_SHELL_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SHELL_GROUP_PROPERTY] = g_param_spec_object ("shell-group", "shell-group", "shell-group", clutter_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 11016 "WindowManager.c"
	/**
	         * {@inheritDoc}
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY] = g_param_spec_object ("background-group", "background-group", "background-group", meta_background_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 11022 "WindowManager.c"
	/**
	         * View that allows to see and manage all your windows and desktops.
	         */
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_MULTITASKING_VIEW_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_MULTITASKING_VIEW_PROPERTY] = g_param_spec_object ("multitasking-view", "multitasking-view", "multitasking-view", GALA_TYPE_MULTITASKING_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY] = g_param_spec_object ("pointer-locator", "pointer-locator", "pointer-locator", GALA_TYPE_POINTER_LOCATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_WINDOW_OVERVIEW_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_OVERVIEW_PROPERTY] = g_param_spec_object ("window-overview", "window-overview", "window-overview", GALA_TYPE_ACTIVATABLE_COMPONENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY] = g_param_spec_object ("screensaver", "screensaver", "screensaver", GALA_TYPE_SCREEN_SAVER_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/WindowManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY, gala_window_manager_gala_properties[GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY] = g_param_spec_object ("window-tracker", "window-tracker", "window-tracker", GALA_TYPE_WINDOW_TRACKER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 11036 "WindowManager.c"
}

static void
gala_window_manager_gala_gala_window_manager_interface_init (GalaWindowManagerIface * iface,
                                                             gpointer iface_data)
{
#line 20 "../src/WindowManager.vala"
	gala_window_manager_gala_gala_window_manager_parent_iface = g_type_interface_peek_parent (iface);
#line 20 "../src/WindowManager.vala"
	iface->launch_action = (void (*) (GalaWindowManager*, const gchar*)) gala_window_manager_gala_real_launch_action;
#line 20 "../src/WindowManager.vala"
	iface->switch_to_next_workspace = (void (*) (GalaWindowManager*, MetaMotionDirection, guint32)) gala_window_manager_gala_real_switch_to_next_workspace;
#line 20 "../src/WindowManager.vala"
	iface->move_window = (void (*) (GalaWindowManager*, MetaWindow*, MetaWorkspace*, guint32)) gala_window_manager_gala_real_move_window;
#line 20 "../src/WindowManager.vala"
	iface->push_modal = (GalaModalProxy* (*) (GalaWindowManager*, ClutterActor*)) gala_window_manager_gala_real_push_modal;
#line 20 "../src/WindowManager.vala"
	iface->pop_modal = (void (*) (GalaWindowManager*, GalaModalProxy*)) gala_window_manager_gala_real_pop_modal;
#line 20 "../src/WindowManager.vala"
	iface->is_modal = (gboolean (*) (GalaWindowManager*)) gala_window_manager_gala_real_is_modal;
#line 20 "../src/WindowManager.vala"
	iface->modal_proxy_valid = (gboolean (*) (GalaWindowManager*, GalaModalProxy*)) gala_window_manager_gala_real_modal_proxy_valid;
#line 20 "../src/WindowManager.vala"
	iface->perform_action = (void (*) (GalaWindowManager*, GalaActionType)) gala_window_manager_gala_real_perform_action;
#line 20 "../src/WindowManager.vala"
	iface->filter_action = (gboolean (*) (GalaWindowManager*, GalaGestureAction)) gala_window_manager_gala_real_filter_action;
#line 20 "../src/WindowManager.vala"
	iface->get_ui_group = gala_window_manager_gala_real_get_ui_group;
#line 20 "../src/WindowManager.vala"
	iface->set_ui_group = gala_window_manager_gala_real_set_ui_group;
#line 20 "../src/WindowManager.vala"
	iface->get_stage = gala_window_manager_gala_real_get_stage;
#line 20 "../src/WindowManager.vala"
	iface->set_stage = gala_window_manager_gala_real_set_stage;
#line 20 "../src/WindowManager.vala"
	iface->get_window_group = gala_window_manager_gala_real_get_window_group;
#line 20 "../src/WindowManager.vala"
	iface->set_window_group = gala_window_manager_gala_real_set_window_group;
#line 20 "../src/WindowManager.vala"
	iface->get_top_window_group = gala_window_manager_gala_real_get_top_window_group;
#line 20 "../src/WindowManager.vala"
	iface->set_top_window_group = gala_window_manager_gala_real_set_top_window_group;
#line 20 "../src/WindowManager.vala"
	iface->get_background_group = gala_window_manager_gala_real_get_background_group;
#line 20 "../src/WindowManager.vala"
	iface->set_background_group = gala_window_manager_gala_real_set_background_group;
#line 11083 "WindowManager.c"
}

static void
gala_window_manager_gala_instance_init (GalaWindowManagerGala * self,
                                        gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeHashSet* _tmp4_;
	GeeHashSet* _tmp5_;
	GeeHashSet* _tmp6_;
	GHashFunc _tmp7_;
	GEqualFunc _tmp8_;
	GHashTable* _tmp9_;
#line 20 "../src/WindowManager.vala"
	self->priv = gala_window_manager_gala_get_instance_private (self);
#line 69 "../src/WindowManager.vala"
	self->priv->window_switcher = NULL;
#line 75 "../src/WindowManager.vala"
	self->priv->hot_corner_manager = NULL;
#line 88 "../src/WindowManager.vala"
	self->priv->zoom = NULL;
#line 96 "../src/WindowManager.vala"
	_tmp0_ = gee_linked_list_new (GALA_TYPE_MODAL_PROXY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 96 "../src/WindowManager.vala"
	self->priv->modal_stack = _tmp0_;
#line 98 "../src/WindowManager.vala"
	_tmp1_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 98 "../src/WindowManager.vala"
	self->priv->minimizing = _tmp1_;
#line 99 "../src/WindowManager.vala"
	_tmp2_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 99 "../src/WindowManager.vala"
	self->priv->maximizing = _tmp2_;
#line 100 "../src/WindowManager.vala"
	_tmp3_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 100 "../src/WindowManager.vala"
	self->priv->unmaximizing = _tmp3_;
#line 101 "../src/WindowManager.vala"
	_tmp4_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 101 "../src/WindowManager.vala"
	self->priv->mapping = _tmp4_;
#line 102 "../src/WindowManager.vala"
	_tmp5_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 102 "../src/WindowManager.vala"
	self->priv->destroying = _tmp5_;
#line 103 "../src/WindowManager.vala"
	_tmp6_ = gee_hash_set_new (meta_window_actor_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 103 "../src/WindowManager.vala"
	self->priv->unminimizing = _tmp6_;
#line 104 "../src/WindowManager.vala"
	_tmp7_ = g_direct_hash;
#line 104 "../src/WindowManager.vala"
	_tmp8_ = g_direct_equal;
#line 104 "../src/WindowManager.vala"
	_tmp9_ = g_hash_table_new_full (_tmp7_, _tmp8_, _g_object_unref0_, NULL);
#line 104 "../src/WindowManager.vala"
	self->priv->ws_assoc = _tmp9_;
#line 105 "../src/WindowManager.vala"
	self->priv->which_change = NULL;
#line 11146 "WindowManager.c"
}

static void
gala_window_manager_gala_finalize (GObject * obj)
{
	GalaWindowManagerGala * self;
#line 20 "../src/WindowManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 26 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_ui_group);
#line 31 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_stage);
#line 36 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_window_group);
#line 41 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_top_window_group);
#line 49 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_shell_group);
#line 54 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_background_group);
#line 59 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_multitasking_view);
#line 61 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_pointer_locator);
#line 63 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->system_background);
#line 69 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->window_switcher);
#line 71 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_window_overview);
#line 73 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_screensaver);
#line 75 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->hot_corner_manager);
#line 77 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->keyboard_manager);
#line 79 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->_window_tracker);
#line 81 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->notifications_manager);
#line 83 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->screenshot_manager);
#line 88 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->zoom);
#line 90 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->tile_preview);
#line 92 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->daemon_manager);
#line 94 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->notification_stack);
#line 96 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->modal_stack);
#line 98 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->minimizing);
#line 99 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->maximizing);
#line 100 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->unmaximizing);
#line 101 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->mapping);
#line 102 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->destroying);
#line 103 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->unminimizing);
#line 104 "../src/WindowManager.vala"
	_g_hash_table_unref0 (self->priv->ws_assoc);
#line 105 "../src/WindowManager.vala"
	_g_free0 (self->priv->which_change);
#line 107 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->latest_window_snapshot);
#line 109 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->behavior_settings);
#line 110 "../src/WindowManager.vala"
	_g_object_unref0 (self->priv->new_behavior_settings);
#line 20 "../src/WindowManager.vala"
	G_OBJECT_CLASS (gala_window_manager_gala_parent_class)->finalize (obj);
#line 11223 "WindowManager.c"
}

 G_GNUC_NO_INLINE static GType
gala_window_manager_gala_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowManagerGalaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_manager_gala_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowManagerGala), 0, (GInstanceInitFunc) gala_window_manager_gala_instance_init, NULL };
	static const GInterfaceInfo gala_window_manager_info = { (GInterfaceInitFunc) gala_window_manager_gala_gala_window_manager_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType gala_window_manager_gala_type_id;
	gala_window_manager_gala_type_id = g_type_register_static (meta_plugin_get_type (), "GalaWindowManagerGala", &g_define_type_info, 0);
	g_type_add_interface_static (gala_window_manager_gala_type_id, GALA_TYPE_WINDOW_MANAGER, &gala_window_manager_info);
	GalaWindowManagerGala_private_offset = g_type_add_instance_private (gala_window_manager_gala_type_id, sizeof (GalaWindowManagerGalaPrivate));
	return gala_window_manager_gala_type_id;
}

GType
gala_window_manager_gala_get_type (void)
{
	static gsize gala_window_manager_gala_type_id__once = 0;
	if (g_once_init_enter (&gala_window_manager_gala_type_id__once)) {
		GType gala_window_manager_gala_type_id;
		gala_window_manager_gala_type_id = gala_window_manager_gala_get_type_once ();
		g_once_init_leave (&gala_window_manager_gala_type_id__once, gala_window_manager_gala_type_id);
	}
	return gala_window_manager_gala_type_id__once;
}

static void
_vala_gala_window_manager_gala_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GalaWindowManagerGala * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 20 "../src/WindowManager.vala"
	switch (property_id) {
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_ui_group ((GalaWindowManager*) self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_stage ((GalaWindowManager*) self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_window_group ((GalaWindowManager*) self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_top_window_group ((GalaWindowManager*) self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SHELL_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_shell_group (self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_get_background_group ((GalaWindowManager*) self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_MULTITASKING_VIEW_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_multitasking_view (self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_pointer_locator (self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_OVERVIEW_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_window_overview (self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_screensaver (self));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY:
#line 20 "../src/WindowManager.vala"
		g_value_set_object (value, gala_window_manager_gala_get_window_tracker (self));
#line 20 "../src/WindowManager.vala"
		break;
#line 11326 "WindowManager.c"
		default:
#line 20 "../src/WindowManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/WindowManager.vala"
		break;
#line 11332 "WindowManager.c"
	}
}

static void
_vala_gala_window_manager_gala_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GalaWindowManagerGala * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_MANAGER_GALA, GalaWindowManagerGala);
#line 20 "../src/WindowManager.vala"
	switch (property_id) {
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_UI_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_set_ui_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_STAGE_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_set_stage ((GalaWindowManager*) self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_set_window_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_TOP_WINDOW_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_set_top_window_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SHELL_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_gala_set_shell_group (self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_BACKGROUND_GROUP_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_set_background_group ((GalaWindowManager*) self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_MULTITASKING_VIEW_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_gala_set_multitasking_view (self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_POINTER_LOCATOR_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_gala_set_pointer_locator (self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_OVERVIEW_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_gala_set_window_overview (self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_SCREENSAVER_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_gala_set_screensaver (self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 20 "../src/WindowManager.vala"
		case GALA_WINDOW_MANAGER_GALA_WINDOW_TRACKER_PROPERTY:
#line 20 "../src/WindowManager.vala"
		gala_window_manager_gala_set_window_tracker (self, g_value_get_object (value));
#line 20 "../src/WindowManager.vala"
		break;
#line 11412 "WindowManager.c"
		default:
#line 20 "../src/WindowManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/WindowManager.vala"
		break;
#line 11418 "WindowManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 7 "../src/PluginManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 11429 "WindowManager.c"
		gssize i;
#line 7 "../src/PluginManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 7 "../src/PluginManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 7 "../src/PluginManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 11437 "WindowManager.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 7 "../src/PluginManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 7 "../src/PluginManager.vala"
	g_free (array);
#line 11452 "WindowManager.c"
}

